<?php
require_once(APPLICATION_PATH . "/abc.php");
class Admin_ConfigController extends WebReport_Controller_Action
{

    public function init()
    {
        parent::init();

        $module = $this->getRequest()->module;
        $controller = $this->getRequest()->controller;
        $action = $this->getRequest()->action;
        $items = array();
        $identity = Zend_Auth::getInstance()->getIdentity();

        if($identity->multi_company){
            $items[] = array("urlOptions" => array('module' => $module, "controller" => $controller, "action" => "view"), "text" => _T('VIEW_CONFIGURATION'), "tooltip" => _T("INSTANCE_VIEW_CONFIGURATION_TOOLTIP"));
            $items[] = array("urlOptions" => array('module' => $module, "controller" => $controller, "action" => "edit"), "text" => _T('EDIT_CONFIGURATION'), "tooltip" => _T("INSTANCE_EDIT_CONFIGURATION_TOOLTIP"));
            $items[] = array("urlOptions" => array('module' => $module, "controller" => $controller, "action" => "logo"), "text" => _T('LOGO'), "tooltip" => _T("INSTANCE_LOGO_TOOLTIP"));
            $items[] = array("urlOptions" => array('module' => $module, "controller" => $controller, "action" => "license"), "text" => _T('LICENSE'), "tooltip" => _T("INSTANCE_LICENSE_TOOLTIP"));
            $items[] = array("urlOptions" => array('module' => $module, "controller" => $controller, "action" => "edit-license"), "text" => _T('EDIT_LICENSE'), "tooltip" => _T("INSTANCE_EDIT_LICENSE_TOOLTIP"));
        }
        //$items[] = array("urlOptions" => array('module' => 'admin', "controller" => 'acl', "action" => "browse-roles"), "text" => 'ACL');
        //$items = WebReport_Module_MenuItems_Abstract::filterNotAllowedItems($items);
        $this->view->submenu = WebReport_Module_MenuItems_Abstract::translate($items);
        $this->view->headTitle("SERVER_CONFIGURATION", Zend_View_Helper_Placeholder_Container_Abstract::PREPEND);

    }

    public function backupCompletedAction() {
        $this->_helper->layout->disableLayout();    
        $this->_helper->viewRenderer->setNoRender(); 
        $backupReminder = Core_Model_ConfigurationsList::setBackupCompleted();
    }

    public function viewAction()
    {
        $config = Zend_Registry::get('config');
        $identity = Zend_Auth::getInstance()->getIdentity();
        $this->view->config = $config;
        $this->view->allowTestSendMail = $identity->multi_company;
        if ($this->_flashMessenger->hasMessages())
            $this->view->messages = $this->_flashMessenger->getMessages();
        try {
            $config = new Zend_Config_Ini(APPLICATION_PATH . "/../data/poll.ini", APPLICATION_ENVIRONMENT);
            if (!isset($cofig->poll->lastIteration)) {
                $this->view->pollAlive = time() - $config->poll->lastIteration < 60*60*24 ? _T("YES") : _T("NO");
            } else {
                $this->view->pollAlive = _T("NO");
            }
        } catch( Exception $e) {
            $this->view->pollAlive = _T("NO");
        }
    }

    public function editAction()
    {
        if(!Zend_Auth::getInstance()->getIdentity()->multi_company)
            throw new WebReport_Exception("YOU_DONT_HAVE_PERMISSION_TO_EDIT_THE_CONFIGURATION");

        $this->view->headTitle("EDIT", Zend_View_Helper_Placeholder_Container_Abstract::PREPEND);

        $form = new Admin_Form_EditConfig();
        $config = Zend_Registry::get('config');

        if ($this->getRequest()->isPost()) {
            if ($form->isValid($_POST)) {
                $values = $form->getValues();

                //$config->resources->frontController->baseUrl = $values['resources_frontController_baseUrl'];

                //$config->database->params->host = $values['database_params_host'];
                //$config->database->params->username = $values['database_params_username'];
                //if ($values['database_params_password'] != '')
                //    $config->database->params->password = $values['database_params_password'];
                //$config->database->params->dbname = $values['database_params_dbname'];
                $config->mail->host = $values['mail_host'];
                $config->mail->from->address = $values['mail_from_address'];
                $config->mail->from->name = $values['mail_from_name'];
                $config->mail->params->ssl = $values['mail_params_ssl'];
                $config->mail->params->port = $values['mail_params_port'];
                $config->mail->params->auth = $values['mail_params_auth'];
                $config->mail->params->username = $values['mail_params_username'];
                $config->mail->params->service = $values['mail_service'];
                
                if ($values['mail_params_password'] != '')
                    $config->mail->params->password = $values['mail_params_password'];

                //$config->report->coglogo_enabled = $values['coglogo_enabled'];

                //$cmonths = intval($values['cogadmin_channel_months']);
                //$config->cogadmin->channel_months = ($cmonths > 0) ? $cmonths : 2;

                $config->general->defaultTimezone = $values['timezone'];

                //$config->weather = array("use_service" => $values['use_weather_service'],
                //     "key" => $values['weather_service_api_key']);
                $writer = new Zend_Config_Writer_IniNice();
                $writer->setConfig($config)->setFilename(APPLICATION_PATH . '/config.ini');
                try {
                    $writer->write();
                    $this->_flashMessenger->addMessage($this->_translate->_('SERVER_CONFIGURATION_UPDATED.'));

                    $this->_helper->redirector('view');
                } catch (Exception $e) {
                    $form->addError($this->_translate->_("COULD_NOT_WRITE_TO_CONFIGURATION_FILE._MAKE_SURE_IT_HAS_CORRECT_PERMISSIONS."));
                }

            } else {
                $form->populate($_POST);
            }
        } else {
            $values = array();
            $values['resources_frontController_baseUrl'] = $config->resources->frontController->baseUrl;
            $values['database_params_host'] = $config->database->params->host;
            $values['database_params_username'] = $config->database->params->username;
            $values['database_params_password'] = $config->database->params->password;
            $values['database_params_dbname'] = $config->database->params->dbname;
            $values['mail_host'] = $config->mail->host;
            $values['mail_from_address'] = $config->mail->from->address;
            $values['mail_from_name'] = $config->mail->from->name;
            $values['mail_params_ssl'] = $config->mail->params->ssl;
            $values['mail_params_port'] = $config->mail->params->port;
            $values['mail_params_auth'] = $config->mail->params->auth;
            $values['mail_params_username'] = $config->mail->params->username;
            $values['mail_params_password'] = $config->mail->params->password;
            $values['mail_service'] = $config->mail->params->service ? $config->mail->params->service : 'custom';
            //$values['cogadmin_channel_months'] = $config->cogadmin->channel_months;

            $values['timezone'] = $config->general->defaultTimezone;

            $values['use_weather_service'] = $config->weather->use_service;
            $values['weather_service_api_key'] = $config->weather->key;

            $values['coglogo_enabled'] = $config->report->coglogo_enabled;

            $form->populate($values);
        }

        $this->view->form = $form;
    }

    public function testWeatherAction() {
        $this->_helper->layout->disableLayout();
        $this->_helper->viewRenderer->setNoRender();

        try {
            $service = Reports_Model_WeatherServiceAbstract::GetWeatherService();
            $service->testService();
        } catch(WebReport_Exception_WeatherError $e) {
            $msg = $e->getMessage();
        }

        if(!$msg)
            $msg = $this->_translate->_("SUCCESS");

        $this->_helper->Json->sendJson($msg);
    }

    public function mailTestAjaxAction() {
        $this->_helper->layout->disableLayout();
        $this->_helper->viewRenderer->setNoRender();

        if(!$this->getRequest()->isPost()) {
            echo Zend_Json::encode(array("sent" => false,"message" => "invalid post"));
            return;
        }

        try {
            $config = Zend_Registry::get('config');

            $mailParams = $config->mail->params->toArray();

            if($mailParams['auth'] == 'none')
                $mailParams = array('port' => $mailParams['port']);

            $transport = new Zend_Mail_Transport_Smtp($config->mail->host, $mailParams);
            $mail = new WebReport_Mail();

            $mail->addTo( $_POST['email']);
            $mail->setFrom($config->mail->from->address, $config->mail->from->name);
            $mail->setSubject('DataManager - Test');
            $mail->setBodyText('Test mail from Datamanager successful.');
            $mail->setCaller(WebReport_Mail::Config);
            $mail->send($transport);

        } catch(Exception $e) {
            echo Zend_Json::encode(array("sent"=>false, "message" => $e->getMessage()));
            return;
        }

        echo Zend_Json::encode(array("sent" => true, "message" => "success"));
    }

    public function logoAction()
    {
        $form = new Admin_Form_Config_Logo();

        $config = Zend_Registry::get('config');

        if (!isset($config->logo)) {
            $config->logo = array();
        }

        $uploadDir = APPLICATION_PATH . "/../public/logos";

        if (!is_writable($uploadDir)) {
            $form->addError($this->_translate->_("THE_LOGO_DIRECTORY_IS_NOT_WRITABLE._FIX_THIS_TO_UPLOAD_LOGOS."));

            foreach ($form->getElements() as $element) {
                $form->removeElement($element->getName());
            }
        }

        if ($this->_request->isPost()) {
            $config->logo->login_logo_enable = $_POST['login_logo_enable'];
            $config->logo->logo_enable = $_POST['logo_enable'];
            $config->logo->logo_in_reports = $_POST['logo_in_reports'];

            $upload = new Zend_File_Transfer_Adapter_Http();
            $upload//->addValidator('MimeType', true, 'image')
                ->addValidator('ImageSize', false,
                    array('minwidth' => 0,
                    'maxwidth' => 600,
                    'minheight' => 0,
                    'maxheight' => 600)
                )
                ->addValidator('MimeType', false, array('image/png', 'image/jpeg'));
            //->setDestination($uploadDir);
            $files = $upload->getFileInfo();

            $error = false;

            foreach ($files as $file => $info) {
                if (!$upload->isUploaded($file)) {
                    continue;
                }

                $orgFileName = $upload->getFilename($file);

                $element = $form->getElement($file);
                $extension = end(explode('.', $orgFileName));
                if (strlen($extension) > 9) {
                    $element->addError(sprintf($this->_translate->_('INVALID_FILE_EXTENSION_%1$s_FOR_FILE_%2$s.'), $extension, $upload->getFileName($file, false)));
                    continue;
                }

                $newFileName = '';
                do {
                    // random file name
                    $newFileName = $uploadDir . "/" . preg_replace("/([0-9])/e","chr((\\1+112))",rand(10000000,99999999)) . "." . $extension;
                } while (file_exists($newFileName));

                $upload->addFilter('Rename',
                    array('target' => $newFileName,
                    'overwrite' => true), $file);

                if (!$upload->isValid($file)) {

                    foreach ($upload->getMessages() as $error) {
                        $element->addError($error);
                        $element->markAsError();
                        $dec = $element->getDecorator('HtmlTag');
                        $dec->setOption('class', $dec->getOption('class') . " error");
                    }
                    continue;
                }

                try {
                    $upload->receive($file);
                    $this->_flashMessenger->addMessage(sprintf($this->_translate->_('FILE_%1$s_IS_UPLOADED.'), basename($orgFileName)));
                    $config->logo->$file = basename($newFileName);
                    $form->getElement($file . "_image")->setImage($this->view->baseUrl("public/logos/" . basename($newFileName)));
                } catch (Zend_File_Transfer_Exception $e) {
                    $form->addError($e->getMessage());
                }

            }

            $logoFile = $uploadDir . '/' . $config->logo->logo;

            if(!is_file($logoFile)) {
                $config->logo->logo_enable = false;
                $config->logo->logo_in_reports = false;                    
            }

            $form->populate(array(
                "login_logo_enable" => $config->logo->login_logo_enable, 
                "logo_in_reports" => $config->logo->logo_in_reports,
                "logo_enable" => $config->logo->logo_enable
            ));

            $writer = new Zend_Config_Writer_IniNice();
            $writer->setConfig($config)
                ->setFilename(APPLICATION_PATH . '/config.ini');

            try {
                $writer->write();
                //				$this->_flashMessenger->addMessage('CONFIGURATION_UPDATED.');
            } catch (Exception $e) {
                $form->addError($this->_translate->_("COULD_NOT_WRITE_TO_CONFIGURATION_FILE._MAKE_SURE_IT_HAS_CORRECT_PERMISSIONS."));
            }

            //	    $this->_helper->redirector('logo');

        } else {
            $values = array();
            $values['login_logo_enable'] = false;
            $values['logo_enable'] = false;
            if (isset($config->logo->login_logo_enable)) {
                $values['login_logo_enable'] = $config->logo->login_logo_enable;
            }

            if (isset($config->logo->logo_enable)) {
                $values['logo_enable'] = $config->logo->logo_enable;
            }
            $values['logo_in_reports'] = isset($config->logo->logo_in_reports) ? $config->logo->logo_in_reports : 0;

            $form->populate($values);
        }

        $this->view->form = $form;

        if ($this->_flashMessenger->hasCurrentMessages()) {
            $this->view->messages = $this->_flashMessenger->getCurrentMessages();
        }

    }

    public function licenseAction() {
        $t = Zend_Registry::get("Zend_Translate");
        if(!extension_loaded("curl")) {
            $form = new UniForm_Form();
            $form->addError($this->_translate->_("THE_PHP_EXTENSION_CURL_IS_NOT_LOADED."));
            $this->view->form = $form;
        }
        /*if (!extension_loaded("cmwebreport")) {
            throw new WebReport_Api_Exception("PHP Extension cmwebreport not loaded.", WebReport_Api::CODE_CMDECRYPT_ERROR);
        }*/

        $this->view->url = "http://" . $_SERVER['SERVER_NAME'] .  $_SERVER['REQUEST_URI'];

        $lic = Zend_Registry::get('config-license');
        $this->view->lic = $lic;

        if ($this->_flashMessenger->hasMessages())
            $this->view->messages = $this->_flashMessenger->getMessages();

        /*$this->view->macaddr = $this->_translate->_("COULD_NOT_DETERMINE_MAC._COULD_BE_THAT_YOU_ARE_RUNNING_AN_OLD_PHP_EXTENSION.");
        if( function_exists("cm_getmac") )
        $this->view->macaddr = substr(chunk_split(cm_getmac(), 2, ':'),0,-1);*/

        if (cm_isvalid_registrationcode2($lic->registrationCode)){
            $this->view->reg_valid = $t->translate("OK");
            $this->view->reg_isred = False;
        } else{
            $this->view->reg_valid = $t->translate("FAILED");
            $this->view->reg_isred = True;
        }
        if(cm_isvalid_activation2($lic->registrationCode, $lic->activationCode)) {
            $this->view->act_valid = $t->translate("OK");
            $this->view->act_isred = False;
        } else {
            $this->view->act_valid = $t->translate("NO");
            $this->view->act_isred = True;
        }

        $realiid = cm_installid2($lic->registrationCode);
        if($realiid === $lic->installationId ) {
            $this->view->iid_valid = $t->translate("OK");
            $this->view->iid_isred = False;
        } else {
            $this->view->iid_valid = $t->translate("FAILED,_SHOULD_BE") . ": ".$realiid;
            $this->view->iid_isred = True;
        }

        $string = "This is just a test string";
        $dec = cm_decrypt2($lic->registrationCode,
            $lic->activationCode,
            $string);
        if( $dec != null ) {
            $this->view->enc_test = $t->translate("OK");
            $this->view->reg_valid = $t->translate("OK");
            $this->view->enc_isred = False;
        } else {
            $this->view->enc_test = $t->translate("FAILED_FATAL");
            $this->view->enc_isred = True;
        }

        $camerasDb = Core_Model_Cameras::getInstance();
        $cameras = $camerasDb->fetchActiveCameras();
        $this->view->active_channels = count($cameras);
        $this->view->logger = $this->_helper->loggers('synchronization');


        $features = new Core_Model_Features();


        $select = $camerasDb->select()
                            ->from($camerasDb, array("unique" => 'COUNT(DISTINCT serial)'));
        $unique = $camerasDb->fetchRow($select)->unique;
        $this->view->dynamic_channels = $features->dynamicChannels();
        $this->view->nbr_of_cameras_connected = $unique;
        $this->view->nbr_of_cameras_allowed = $features->nbrOfCamerasAllowed();
        $this->view->too_many_cameras = $this->view->nbr_of_cameras_connected > $this->view->nbr_of_cameras_allowed;
    }

    public function editLicenseAction() {
        if(!Zend_Auth::getInstance()->getIdentity()->multi_company)
            throw new WebReport_Exception("YOU_DONT_HAVE_PERMISSION_TO_EDIT_THE_LICENSE");
        $this->view->headTitle("EDIT_LICENSE", Zend_View_Helper_Placeholder_Container_Abstract::PREPEND);

        $form = new Admin_Form_EditLicense();

        if ($this->_flashMessenger->hasMessages())
            $this->view->messages = $this->_flashMessenger->getMessages();

        $lic = Zend_Registry::get('config-license');
        if ($this->getRequest()->isPost()) {
            if ($form->isValid($_POST)) {
                $values = $form->getValues();
                $lic->registrationCode = $values['registrationCode'];
                $lic->activationCode = str_replace("-", "", $values['activationCode']);
                $lic->installationId = $values['installationId'];
                $license_writer = new Zend_Config_Writer_IniNice();
                $license_writer->setConfig($lic)
                    ->setFileName(APPLICATION_PATH . '/license.ini');
                $license_writer->write();
                $this->_helper->redirector('license','config','admin'); 
            } else {
                $form->populate($_POST);
            }
        } else {
            $form->populate($lic->toArray());
        }
        $this->view->form = $form;
    }


    private function _translatableStrings() {
        $this->_translate->_('VIEW_CONFIGURATION');
        $this->_translate->_('EDIT_CONFIGURATION');
        $this->_translate->_('CONFIGURATION_UPDATED.');
        $this->_translate->_('FAILED_SHOULD_BE:');
        $this->_translate->_('EDIT_CONFIGURATION');
        $this->_translate->_('ENABLE');
    }




}
