<?php

class Admin_ProfileController extends WebReport_Controller_Action
{

	protected $_user;

	public function init() {
		parent::init();

		$userId = Zend_Auth::getInstance()->getIdentity()->user_id;

		$users = new Core_Model_Users();
		$this->_user = $users->find($userId)->current();


		$module = $this->getRequest()->module;
		$controller = $this->getRequest()->controller;
		$action = $this->getRequest()->action;

		$items = array();
		$items[] = array("urlOptions" => array('module' => $module, "controller" => $controller, "action" => "index"), "text" => _T("SHOW_PROFILE"), "tooltip" => _T("SHOW_PROFILE_TOOLTIP"));
		$items[] = array("urlOptions" => array('module' => $module, "controller" => $controller, "action" => "change-password"), "text" => _T("CHANGE_PASSWORD"), "tooltip" => _T("CHANGE_PASSWORD_TOOLTIP"));
        //$items[] = array("urlOptions" => array('module' => $module, "controller" => $controller, "action" => "apikey"), "text" => "MANAGE_API_KEY");

		//$items = WebReport_Module_MenuItems_Abstract::filterNotAllowedItems($items);
		$this->view->submenu = WebReport_Module_MenuItems_Abstract::translate($items);
		$this->view->headTitle('PROFILE', Zend_View_Helper_Placeholder_Container_Abstract::PREPEND);

	}

	public function indexAction() {

		$user = $this->_user;

		$this->view->lastLogin = $user->last_login;
		$this->view->created = $user->created_date;

		$this->view->user = $user;

	}

    private function _genapikey()
    {
        $apikey = strtoupper(md5(rand()));
        $apikey = substr($apikey, 2, 15);
        $apikey[4] = '-';
        $apikey[4+5] = '-';
        return $apikey;
    }

    public function apikeyAction()
    {
        $form = new Admin_Form_ApiKey();
        $this->view->headTitle('MANAGE_APIKEY', Zend_View_Helper_Placeholder_Container_Abstract::PREPEND);

        $user = $this->_user;
        $defaultvalues = array();
        $defaultvalues["apikeyenable"] = $user->enableapikey;
        $defaultvalues["apikey"] = empty($user->apikey)?$this->_genapikey():$user->apikey;

        if ($this->getRequest()->isPost()) {
            if ($form->isValid($_POST)) {
                $values = $_POST;
                $user->setApiKey($values['apikey']);
                $user->setApiKeyEnable($values['apikeyenable']);
                $user->save();
                $this->_flashMessenger->addMessage($this->_translate->_('APIKEY_SETTINGS_CHANGED.'));
				$this->_helper->redirector('index','profile','admin');
            }
            $form->populate($_POST);
        } else {
            $form->populate($defaultvalues);
        }
        
        $this->view->form = $form;

        $this->view->headScript()->captureStart();
?>
function genkey() {
    var chars = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXTZ";
    var string_length = 15;
	var randomstring = '';
	for (var i=0; i<string_length; i++) {
        var nextchar = '-';
        if( (i != 4) && (i != 9) ) {
            var rnum = Math.floor(Math.random() * chars.length);
            nextchar = chars.substring(rnum,rnum+1);
        }
		randomstring += nextchar;
	}
    return randomstring;
}

$(function() {
  $('button#newkey').click(function(){
  newkey =
  $('input#apikey').val(genkey());
  })
});
<?php
        $this->view->headScript()->captureEnd();

    }

	public function changePasswordAction()
	{
        if ($this->_flashMessenger->hasMessages())
            $this->view->messages = $this->_flashMessenger->getMessages();

		$form = new Admin_Form_ChangeUserPassword();

		$this->view->headTitle('CHANGE_PASSWORD', Zend_View_Helper_Placeholder_Container_Abstract::PREPEND);

		$user = $this->_user;

		$this->view->headTitle(sprintf($this->_translate->_('CHANGE_PASSWORD_FOR_"%1$s"'), $user->forename . ' ' . $user->surname), Zend_View_Helper_Placeholder_Container_Abstract::PREPEND);
		if ($this->getRequest()->isPost()) {

			if ($form->isValid($_POST)) {
				$values = $form->getValues();

				$user->setPassword($values['password']);
				$user->save();
				$this->_flashMessenger->addMessage($this->_translate->_('YOUR_PASSWORD_IS_CHANGED.'));
				$this->_helper->redirector('index','profile','admin');

			}
		}

		$this->view->form = $form;
	}

	private function _translatableStrings()
	{
		$this->_translate->_('SHOW_PROFILE');

	}


}
