<?php

class Admin_Form_AddCountDataSetStep1 extends UniForm_Form
{

    protected $_action;

    /**
     * Constructor
     *
     * @see Zend_Form
     * @param string $action Can be new or edit
     * @param mixed $options
     * @return void
     */
    public function __construct($action = "add", $options = null)
    {
        $this->_action = $action;
        parent::__construct($options);
    }

    public function init()
    {
        parent::init();

        $action = $this->_action;

        $name = new UniForm_Form_Element_Text('name');
        $name->setLabel('NAME')
            ->setRequired()
            ->addFilter('StringTrim');

        $applicationsModel = new Core_Model_Applications();
        $application_id = new UniForm_Form_Element_Select("application_id");
        $application_id->setRequired()
            ->setLabel("TRUEVIEW_APPLICATION");
        $applications = $applicationsModel->fetchAllWithCountData();

        $genderApp = new Core_Model_Application_Gender();
        $posApp = new Core_Model_Application_Pos();
        foreach ($applications as $application) {
            if ( $application->getId() == $genderApp->getId() ) continue;
            if ( $application->getId() == $posApp->getId() ) continue;

            $application_id->addMultiOption($application->getId(), $application->getName());
        }

        $description = new UniForm_Form_Element_Textarea('description');
        $description->setLabel('DESCRIPTION')
            ->addFilter('StringTrim');


        $step = new UniForm_Form_Element_Hidden('step');
        $step->setValue(1);

        $submit = new UniForm_Form_Element_Submit('submit');
        $submit->setLabel('SUBMIT');

        $this->addElements(array($name, $application_id, $description, $step));

        $this->addDisplayGroup(array('name', 'application_id', 'description', 'step'), 'chart-group');

        $this->addElements(array($submit));
    }

}
