<?php

class Admin_Form_AddTestCamera extends Uniform_Form
{
    public function init()
    {
        parent::init();

        $user = new UniForm_Form_Element_Text('user');
        $user->setLabel('USERNAME');

        $pass = new UniForm_Form_Element_Text('pass');
        $pass->setLabel('PASSWORD');

        $camera_name = new UniForm_Form_Element_Text('camera_name');
        $camera_name->setLabel('CAMERA_NAME');

        $product = new UniForm_Form_Element_Select('product');
        $product->setLabel('PRODUCT')
                ->addMultiOption(0,'PEOPLE_COUNTER')
                ->addMultiOption(1,'GENDER')
                ->addMultiOption(2,'QUEUE')
                ->addMultiOption(3,'OCCUPANCY')
                ->setValue(0);

        $submit = new UniForm_Form_Element_Submit('submit');
        $submit->setLabel('SUBMIT');

        $this->addElements(array($user, $pass, $camera_name, $product));
        $this->addDisplayGroup(array('user', 'pass', 'camera_name', 'product'), 'camera-group');

        $this->addElements(array($submit));

        $this->setAttrib('id', 'add-camera-form');

        return $this;
    }
}
