<?php

class Admin_Form_AddVirtualCamera extends UniForm_Form
{

	/**
	 * Constructor
	 *
	 * @see Zend_Form
	 * @param mixed $options
	 * @return void
	 */
	public function __construct($options = null)
	{
		parent::__construct($options);
	}

	public function init()
	{
		parent::init();

		$step = new UniForm_Form_Element_Hidden('step');
		$step->setValue(1);

		$name = new UniForm_Form_Element_Text('name');
		$name->setLabel('VIRTUAL_CAMERA_NAME')
			->setRequired()
			->addFilter('StringTrim');

		$applicationsModel = new Core_Model_Applications();
		$applications = $applicationsModel->fetchAllWithInOut();

		$application_id = new UniForm_Form_Element_Select('application_id');
		$application_id->setLabel('TRUEVIEW_APPLICATION')
			->setRequired()
			->addValidator(new Zend_Validate_GreaterThan(0)) // check if user belongs to company
			->setErrorMessages(array($this->getView()->translate("YOU_MUST_CHOOSE_ONE_OF_THE_TRUEVIEW_APPLICATIONS.")));

		$application_id->addMultiOption(0, "SELECT_AN_APPLICATION_FOR_THE_VIRTUAL_CAMERA.");
		foreach ($applications as $app) {
			$application_id->addMultiOption($app->getId(), $app->getName());
		}

		$description = new UniForm_Form_Element_Textarea('description');
		$description->setLabel('DESCRIPTION');

		$submit = new UniForm_Form_Element_Submit('submit');
		$submit->setLabel('NEXT_STEP');

		$this->addElements(array($step,$name, $application_id, $description));
		$this->addDisplayGroup(array('step','name','application_id','description'),'virtual-camera-info');

		$this->addElements(array($submit));

	}

}
