<?php

class Admin_Form_ChangeUserPassword extends UniForm_Form
{

	public function init()
	{
		parent::init();

		$this->addElementPrefixPath('CM_Validate_User', 'CM/Validate/User/', 'validate');
		$this->addElementPrefixPath('WebReport_Validate_User', 'WebReport/Validate/User/', 'validate');

		$current_password = new UniForm_Form_Element_Password('current_password');
		$current_password->setLabel('CURRENT_PASSWORD')
			->addValidator('OldPasswordConfirmation', true);

		$password = new UniForm_Form_Element_Password('password');
		$password->setLabel('NEW_PASSWORD')
			->addValidator('PasswordStrength',true)
			->addValidator('PasswordConfirmation')
			->setRequired();

		$password_confirm = new UniForm_Form_Element_Password('password_confirm');
		$password_confirm->setLabel('CONFIRM_PASSWORD')
			->setRequired();

		$this->addElements(array($current_password, $password, $password_confirm));
		$this->addDisplayGroup(array('current_password', 'password', 'password_confirm'), 'password-group');


		$submit = new UniForm_Form_Element_Submit('submit');
		$submit->setLabel('SUBMIT');
		$this->addElements(array($submit));

	}

}



