<?php

class Admin_Form_Company_Logo extends UniForm_Form
{

    protected $_company;
    
    function __construct($company) {
        $this->_company = $company;
        parent::__construct();
    }

	public function init()
	{
		parent::init();

		$logo_enable = new UniForm_Form_Element_Checkbox('logo_enable');
		$logo_enable->setLabel('ENABLE_COMPANY_SPECIFIC_LOGO_IN_PAGE_FOOTER')
		    ->setDescription("IF_CHECKED_AND_A_COMPANY_SPECIFIC_LOGO_IS_UPLOADED_IT_WILL_BE_SHOWN_IN_THE_PAGE_FOOTER.");

		$logo = new UniForm_Form_Element_File('logo');
		$logo->setLabel('FOOTER_LOGO')
		    ->setDescription("AN_IMAGE_THAT_WILL_BE_PLACED_ON_THE_BOTTOM_RIGHT_OF_EACH_PAGE._MAXIMUM_HEIGHT_IS_50PX._IF_IT_IS_TOO_LARGE_IT_WILL_BE_DOWNSCALED._RECOMMENDED_FORMAT_IS_.PNG_WITH_TRANSPARENT_BACKGROUND.");

        $logo_im = new UniForm_Form_Element_Image('logo_image');
        $logo_im->setLabel('CURRENT_COMPANY_LOGO');

        $logoFilename = $this->_company->logo_filename;

        if (!$logoFilename || !file_exists(APPLICATION_PATH . "/../public/logos/" . $logoFilename)) {
            $logoFilename = "templates/" . $this->getView()->template() . "/images/nologo.png";
        } else {
            $logoFilename = "public/logos/" . $logoFilename;   
        }

        $logo_im->setImage($this->getView()->baseUrl($logoFilename));

		$this->addElements(array($logo_enable, $logo, $logo_im));

		$this->addDisplayGroup(array('logo_image', 'logo', 'logo_enable'), 'logo-upload');

		$submit = new UniForm_Form_Element_Submit('submit');
		$submit->setLabel('SUBMIT');

		$this->addElements(array($submit));

		return $this;
	}

    protected function _translatableStrings()
    {
        $t = Zend_Registry::get('Zend_Translate');
        $t->_('ENABLE_COMPANY_SPECIFIC_LOGO_IN_PAGE_FOOTER');
        $t->_("IF_CHECKED_AND_A_COMPANY_SPECIFIC_LOGO_IS_UPLOADED_IT_WILL_BE_SHOWN_IN_THE_PAGE_FOOTER.");
        $t->_('FOOTER_LOGO');
        $t->_("THE_LOGO_WILL_GO_INTO_THE_FOOTER._RECOMMENDED_SIZE_IS_135x50_PIXELS._IF_ITS_TOO_LARGE_IT_WILL_BE_SCALED_DOWN.");
        $t->_('CURRENT_COMPANY_LOGO');
    }

}
