<?php

class Admin_Form_Config_Logo extends UniForm_Form
{

	public function init()
	{
		parent::init();

        $config = Zend_Registry::get('config');

        $loginFilename = false;
        $logoFilename = false;
        if ($config->logo) {
            $loginFilename = $config->logo->login_logo;
            $logoFilename = $config->logo->logo;
        }

		$login_logo_enable = new UniForm_Form_Element_Checkbox('login_logo_enable');
		$login_logo_enable->setLabel('ENABLE_LOGO_ON_LOGIN_PAGE')
		    ->setDescription(_T("IF_CHECKED_AND_A_LOGO_IS_UPLOADED_IT_WILL_BE_SHOWN_ON_THE_LOGIN_PAGE."));

		$login_logo = new UniForm_Form_Element_File('login_logo');
		$login_logo->setLabel('LOGO_ON_LOGIN_PAGE')
		    ->setDescription(_T("AN_IMAGE_THAT_WILL_BE_PLACED_ON_THE_BOTTOM_RIGHT_CORNER_OF_THE_LOGIN_PAGE._IT_WILL_NOT_BE_DOWNSCALED_IF_IT_IS_TOO_LARGE._RECOMMENDED_FORMAT_IS_.PNG_WITH_TRANSPARENT_BACKGROUND."));

        $login_logo_im = new UniForm_Form_Element_Image('login_logo_image');
        $login_logo_im->setLabel('CURRENT_LOGIN_LOGO');

        if (!$loginFilename || !file_exists(APPLICATION_PATH . "/../public/logos/" . $loginFilename)) {
            $loginFilename = "templates/" . $this->getView()->template() . "/images/nologo.png";
        } else {
            $loginFilename = "public/logos/" . $loginFilename;   
        }
        $login_logo_im->setImage($this->getView()->baseUrl($loginFilename));

		$logo_enable = new UniForm_Form_Element_Checkbox('logo_enable');
		$logo_enable->setLabel(_T('ENABLE_LOGO_IN_PAGE_FOOTER'))
		    ->setDescription(_T("IF_CHECKED_AND_A_FOOTER_LOGO_IS_UPLOADED_IT_WILL_BE_SHOWN_IN_THE_PAGE_FOOTER."));

		$logo = new UniForm_Form_Element_File('logo');
		$logo->setLabel('FOOTER_LOGO')
		    ->setDescription("AN_IMAGE_THAT_WILL_BE_PLACED_ON_THE_BOTTOM_RIGHT_OF_EACH_PAGE._MAXIMUM_HEIGHT_IS_50PX._IF_IT_IS_TOO_LARGE_IT_WILL_BE_DOWNSCALED._RECOMMENDED_FORMAT_IS_.PNG_WITH_TRANSPARENT_BACKGROUND.");

        $logo_im = new UniForm_Form_Element_Image('logo_image');
        $logo_im->setLabel('CURRENT_FOOTER_LOGO');

        if (!$logoFilename || !file_exists(APPLICATION_PATH . "/../public/logos/" . $logoFilename)) {
            $logoFilename = "templates/" . $this->getView()->template() . "/images/nologo.png";
        } else {
            $logoFilename = "public/logos/" . $logoFilename;   
        }
        $logo_im->setImage($this->getView()->baseUrl($logoFilename));

		$this->addElements(array($login_logo_enable, $login_logo, $login_logo_im, $logo_enable, $logo, $logo_im));

		$this->addDisplayGroup(array('login_logo_enable', 'login_logo', 'login_logo_image'), 'login-logo', array("legend" => "LOGIN_LOGO"));
		$this->addDisplayGroup(array('logo_enable', 'logo', 'logo_image'), 'footer-logo', array("legend" => "FOOTER_LOGO"));

		$submit = new UniForm_Form_Element_Submit('submit');
		$submit->setLabel('SUBMIT');

		$this->addElements(array($submit));

		return $this;

	}
	
    protected function _translatableStrings()
    {
        $t = Zend_Registry::get('Zend_Translate');
		$t->_('ENABLE_LOGO_ON_LOGIN_PAGE');
		$t->_("IF_CHECKED_AND_A_LOGO_IS_UPLOADED_IT_WILL_BE_SHOWN_ON_THE_LOGIN_PAGE.");
		$t->_('LOGO_ON_LOGIN_PAGE');
		$t->_("AN_IMAGE_THAT_WILL_BE_PLACED_ON_THE_BOTTOM_RIGHT_CORNER_OF_THE_LOGIN_PAGE._IT_WILL_NOT_BE_DOWNSCALED_IF_IT_IS_TOO_LARGE._RECOMMENDED_FORMAT_IS_.PNG_WITH_TRANSPARENT_BACKGROUND.");
        $t->_('CURRENT_LOGIN_LOGO');
		$t->_('ENABLE_LOGO_IN_PAGE_FOOTER');
		$t->_("IF_CHECKED_AND_A_FOOTER_LOGO_IS_UPLOADED_IT_WILL_BE_SHOWN_IN_THE_PAGE_FOOTER.");
        $t->_('FOOTER_LOGO');
		$t->_("AN_IMAGE_THAT_WILL_BE_PLACED_ON_THE_BOTTOM_RIGHT_OF_EACH_PAGE._MAXIMUM_HEIGHT_IS_50PX._IF_IT_IS_TOO_LARGE_IT_WILL_BE_DOWNSCALED._RECOMMENDED_FORMAT_IS_.PNG_WITH_TRANSPARENT_BACKGROUND.");
        $t->_('CURRENT_FOOTER_LOGO');
    }

}
