<?php

class Admin_Form_EditConfig extends UniForm_Form
{

    public function isValid($vals) {

        $service = $this->getElement("mail_service")->getValue();
        if ( $service != "custom" ) {
            $this->getElement("mail_from_address")->removeValidator("emailaddress");
        }
        return parent::isValid($vals);
    }

	public function init()
	{
		parent::init();

		/*$resources_frontController_baseUrl = new UniForm_Form_Element_Text('resources_frontController_baseUrl');
		$resources_frontController_baseUrl->setLabel('BASE_URL')
                                  ->setAttrib('readonly',true)
			->setRequired();

		$this->addElements(array($resources_frontController_baseUrl));
		$this->addDisplayGroup(array('resources_frontController_baseUrl'), 'general-group', array('legend' => 'GENERAL'));

		$database_params_host = new UniForm_Form_Element_Text('database_params_host');
		$database_params_host->setLabel('HOST')
                             ->setAttrib('readonly',true)
                             ->setRequired();

		$database_params_username = new UniForm_Form_Element_Text('database_params_username');
		$database_params_username->setLabel('USERNAME')
                                  ->setAttrib('readonly',true)
                                  ->setRequired();

		$database_params_password = new UniForm_Form_Element_Password('database_params_password');
		$database_params_password->setLabel('PASSWORD')
                                 ->setAttrib('readonly',true);

		$database_params_dbname = new UniForm_Form_Element_Text('database_params_dbname');
		$database_params_dbname->setLabel('DATABASE')
                        ->setAttrib('readonly',true)
                        ->setRequired();

		$this->addElements(array($database_params_host, $database_params_username, $database_params_password, $database_params_dbname));

                $this->addDisplayGroup(array('database_params_host', 'database_params_username', 'database_params_password', 'database_params_dbname'),
                                        'web-report-database-group',
                                        array('legend' => 'WEB_REPORT_DATABASE')
                                );*/


                $mail_service_autofill = new UniForm_Form_Element_Select('mail_service');
                $mail_service_autofill 
                        ->setLabel(_T('EMAIL_SERVICE'))
                        ->addMultiOption('gmail',_T('GMAIL.COM'))
                        ->addMultiOption('outlook',_T('OUTLOOK.COM'))
                        ->addMultiOption('zoho',_T('ZOHO.COM'))
                        ->addMultiOption('custom',_T('CUSTOM'));


                $mail_host = new UniForm_Form_Element_Text('mail_host');
                $mail_host->setLabel('EMAIL_HOST');

                $mail_from_name = new UniForm_Form_Element_Text('mail_from_name');
                $mail_from_name->setLabel('SEND_MAIL_FROM_NAME');

                $mail_from_address = new UniForm_Form_Element_Email('mail_from_address');
                $mail_from_address->setLabel('SEND_MAIL_FROM_EMAIL');

                $mail_params_auth = new UniForm_Form_Element_Select('mail_params_auth');
                //http://framework.zend.com/manual/en/zend.mail.smtp-authentication.html
                $mail_params_auth->setLabel('AUTHENTICATION_PROTOCOL')
                    ->addMultiOption('login', 'LOGIN')
                    ->addMultiOption('plain', 'PLAIN')
                    ->addMultiOption('crammd5', 'cram-md5')
                    ->addMultiOption('none', 'none');

                $mail_params_username = new UniForm_Form_Element_Text('mail_params_username');
                $mail_params_username->setLabel('MAIL_AUTHENTICATION_USERNAME');

                $mail_params_password = new UniForm_Form_Element_Password('mail_params_password');
                $mail_params_password->setLabel('MAIL_AUTHENTICATION_PASSWORD')
                        ->setDescription('IF_PASSWORD_IS_LEFT_BLANK_IT_WILL_NOT_BE_UPDATED.');

                $mail_params_port = new UniForm_Form_Element_Text('mail_params_port');
                $mail_params_port->setLabel('MAIL_HOST_PORT')
                        ->addValidator(new Zend_Validate_Int());

                $mail_params_ssl = new UniForm_Form_Element_Select('mail_params_ssl');
                $mail_params_ssl
                    ->setLabel('TRANSPORT_ENCRYPTION')
                    ->addMultiOption('tls','TLS_(DEFAULT)')
                    ->addMultiOption('ssl','SSL')
                    ->addMultiOption('none', 'None');


                $this->addElements(array($mail_service_autofill, $mail_host, $mail_from_name, $mail_from_address, $mail_params_auth, $mail_params_username,
                    $mail_params_password, $mail_params_port, $mail_params_ssl));
                $this->addDisplayGroup(array('mail_service','mail_host','mail_params_port','mail_from_name','mail_from_address','mail_params_auth',
                    'mail_params_username','mail_params_password','mail_params_ssl'),
                        'email-group',
                        array('legend' => 'SEND_EMAIL_PROPERTIES')
                );


                $timezone = new Uniform_Form_Element_Select('timezone');
                $timezone->setLabel(_T('TIMEZONE:'))
                    ->setRequired();
                foreach(DateTimeZone::listIdentifiers() as $zone){
                    $timezone->addMultiOption($zone,$zone);
                }

                $this->addElements(array($timezone));
                $this->addDisplayGroup(array('timezone'), 'datetime-group', array('legend' => 'DATE_AND_TIME_SETTINGS'));

                /*$use_weather_service = (new UniForm_Form_Element_Select('use_weather_service'));
                $use_weather_service->setLabel('USE_WEATHER_SERVICE')
                    ->addMultiOption('none','NONE')
                    ->addMultiOption('www.worldweatheronline.com','www.worldweatheronline.com')
                    ->addMultiOption('demonstration', 'DEMONSTRATION_(FICTITIOUS_DATA)');

                $weather_service_api_key  = new UniForm_Form_Element_Text('weather_service_api_key');
                $weather_service_api_key->setLabel('WEATHER_SERVICE_API_KEY(S)');

                $this->addElements(array($weather_service_api_key, $use_weather_service));
                $this->addDisplayGroup(
                    array('use_weather_service','weather_service_api_key'),
                          'weather_group', array('legend' => 'WEATHER_SERVICE_SETTINGS'));*/

		$submit = new UniForm_Form_Element_Submit('submit');
		$submit->setLabel('SUBMIT');

		$this->addElements(array($submit));


		return $this;

	}
	
	public function translatableStrings(){
		$this->_translate->_("SEND_EMAIL_PROPERTIES");
		$this->_translate->_("PLAIN");
		$this->_translate->_("LOGIN_LOGO");
		$this->_translate->_("TLS_(DEFAULT)");
		$this->_translate->_("CONFIGURATION_UPDATED.");
		$this->_translate->_("WEATHER_SERVICE_API_KEY(S)");
		$this->_translate->_("DEMONSTRATION_(FICTITIOUS_DATA)");
		$this->_translate->_("NO");
		$this->_translate->_("WEATHER_SERVICE_SETTINGS");
		$this->_translate->_("WEATHER_SERVICE");
		$this->_translate->_("USE_WEATHER_SERIVCE");
	}

}
