<?php

class Admin_Form_EditCountDataSet extends UniForm_Form
{

	protected $_application;
	protected $_user;

	/**
	 * Constructor
	 *
	 * @see Zend_Form
	 * @param string $action Can be new or edit
	 * @param mixed $options
	 * @return void
	 */
	public function __construct($application, Core_Model_User $user, $options = null)
	{
		$this->_application = $application;
        $this->_user = $user;
		parent::__construct($options);
	}

	public function init()
	{
		parent::init();


		$application = $this->_application;

		$name = new UniForm_Form_Element_Text('name');
		$name->setLabel('CHART_NAME')
			->setRequired()
			->addFilter('StringTrim');

		$camerasDb = new Core_Model_Cameras();
		$formulaSetsDb = new Core_Model_CountData_FormulaSets();
		$virtualCamerasDb = new Core_Model_VirtualCameras();


		$applicationsModel = new Core_Model_Applications();


		$description = new UniForm_Form_Element_Textarea('description');
		$description->setLabel('DESCRIPTION')
			->addFilter('StringTrim');

		$submit = new UniForm_Form_Element_Submit('submit');
		$submit->setLabel('SUBMIT');

		$this->addElements(array($name, $description));
		$this->addDisplayGroup(array('name', 'description'), 'chart-group', array('legend' => "GENERAL"));


		$camera_id = new UniForm_Form_Element_MultiCheckbox('camera_id');
		$camera_id->setLabel('CAMERAS');

		$include = false;
		$includeCameras = false;
		$cameras = $camerasDb->fetchAllVisibleNames($this->_user, $application);

		foreach ($cameras as $cameraId => $cameraName) {
			$camera_id->addMultiOption($cameraId, $cameraName . " (" . $application->getShortName() . ")");
			$includeCameras = true;
		}
		if ($includeCameras) {
			$this->addElements(array($camera_id));
		}

		$include = false;
		$virtual_camera_id = new UniForm_Form_Element_MultiCheckbox('virtual_camera_id');
		$virtual_camera_id->setLabel('VIRTUAL_CAMERAS');
		$virtualCameras = $virtualCamerasDb->fetchAllVisibleNames($this->_user, $application);
		foreach ($virtualCameras as $cameraId => $cameraName) {
			$include = true;
			$virtual_camera_id->addMultiOption($cameraId, $cameraName . " (" . $application->getShortName() . ")");
		}

		if ($include) {
			$this->addElements(array($virtual_camera_id));
			$this->addDisplayGroup(array('camera_id', 'virtual_camera_id'), 'camera-group',array("legend" => "CAMERAS"));
		} else if ($includeCameras) {
			$this->addDisplayGroup(array('camera_id'), 'camera-group',array("legend" => "CAMERAS"));
		}

		$count_data_formula_set_id = new UniForm_Form_Element_MultiCheckbox('count_data_formula_set_id');
		$count_data_formula_set_id->setLabel('FORMULA_SETS');
		$include = false;
		$formulaSets = $formulaSetsDb->fetchAllVisibleNames($this->_user, $application);
		foreach ($formulaSets as $formulaSetId => $formulaSetName) {
			$include = true;
			$count_data_formula_set_id->addMultiOption($formulaSetId, $formulaSetName . " (" . $application->getShortName() . ")");
		}
		if ($include) {
			$this->addElements(array($count_data_formula_set_id));
			$this->addDisplayGroup(array('count_data_formula_set_id'), 'formula-set-group', array("legend" => "FORMULAS"));
		}


		$this->addElements(array($submit));
	}

}