<?php

class Admin_Form_EditFilterGroup extends UniForm_Form
{

	/**
	 * Constructor
	 *
	 * @see Zend_Form
	 * @param mixed $options
	 * @return void
	 */
	public function __construct($options = null)
	{
		parent::__construct($options);
	}

	public function init()
	{
		parent::init();

		$name = new UniForm_Form_Element_Text('name');
		$name->setLabel('NAME')
			->setRequired()
			->addFilter('StringTrim');

		$identity = Zend_Auth::getInstance()->getIdentity();

		if ($identity->multi_company) {
			$company = new UniForm_Form_Element_Text('company');
			$company->setLabel('COMPANY')
				->setAttrib("disabled", true);
		} else {
			$company = new UniForm_Form_Element_Hidden('company');
			$company->setValue($identity->company_id);
		}

		$application = new UniForm_Form_Element_Text('application');
		$application->setLabel('TRUEVIEW_APPLICATION')
			->setAttrib("disabled", true);

		$description = new UniForm_Form_Element_Textarea('description');
		$description->setLabel('DESCRIPTION');

		$submit = new UniForm_Form_Element_Submit('submit');
		$submit->setLabel('SUBMIT');

		$this->addElements(array($name, $company, $application, $description));
		$this->addDisplayGroup(array('name','company','application','description'),'filter-info', array("legend" => "GENERAL_INFORMATION"));

		$this->addElements(array($submit));

	}

}