<?php

class Admin_Form_ImportCntFilesToCameraGroup extends UniForm_Form
{

    /**
     * Constructor
     *
     * @see Zend_Form
     * @param mixed $options
     * @return void
     */
    public function __construct($options = null)
    {
        parent::__construct($options);
    }

    public function init()
    {
        parent::init();

        $this->setAttrib('enctype', 'multipart/form-data');

        //$this->addElementPrefixPath('WebReport_Validate_File_', 'WebReport/Validate/File/', 'validate');

        $type = new UniForm_Form_Element_Select('type');
        $type->setLabel(_T('FILE_TYPE'))
            ->addMultiOption("json",_T("JSON"))
            ->addMultiOption("cnt",_T("CNT"))
            ->setDescription(_T('SPECIFY_WHICH_TYPE_OF_FILE_YOU_WOULD_LIKE_TO_IMPORT'));

        $serial = new UniForm_Form_Element_Text('serial');
        $serial->setLabel(_T('SERIAL'))
            ->addFilter('StringTrim')
            ->setDescription(_T("ALSO_KNOWN_AS_THE_MAC_ADDRESS_OF_THE_CAMERA."));

        $timezone = Reports_Form_AddEditSubscription::GetTimeZoneSelect("timezone", _T("TIMEZONE"));

        $unique = new UniForm_Form_Element_Hidden('unique');
        $unique->setValue(uniqid());

        $file1 = new UniForm_Form_Element_File('file1');
        $file1->setLabel(_T('FILE'))
            ->setRequired()
            ->addValidator('Extension', true, 'cnt,json,gz');
        $this->addElements(array($type, $serial, $timezone, $file1, $unique));
        $this->addDisplayGroup(array('type', 'serial', 'timezone', 'file1','unique'),'importcnt-files');

        $submit = new UniForm_Form_Element_Submit('submit');
        $submit->setLabel('IMPORT');

        $this->addElements(array($submit));

    }

}
