<?


class Admin_Form_MoveDocument extends UniForm_Form{
    protected $_group = NULL;

    const MAX_DEPTH = 10;

    public function __construct($group){
        $this->_group = $group;
        parent::__construct();
    }

    /*
     * Generate a tree.
     */
    public function getTree($root, &$tree, $depth, $editableGroupIds = array())
    {
        if($depth >= self::MAX_DEPTH)
            return;

        foreach($root as $folder) {
            $disable = !in_array($folder->group_id,$editableGroupIds);
            $tree[$folder->group_id] = ($disable ? "d " : "e ") . $depth . ' ' . $folder->name;
            $this->getTree($folder->getChildren(), $tree, $depth+1, $editableGroupIds);
        }
    }

    public function init() {
        parent::init();
        $userDb = new Core_Model_Users();
        $groupDb = new Core_Model_Folders();
        $user = $userDb->find(Zend_Auth::getInstance()->getIdentity()->user_id)->current();
        
        //$folders = $groupDb->getEditableGroups($user, gettype($this->_group) != "string" ? $this->_group->company_id: NULL);
        
        if($this->_group != WebReport_View_Helper_GenericListView::ROOT_FOLDER)
          $folders = $groupDb->getRootGroups($user, $this->_group->company_id);
        else
          $folders = array();

        $editableGroupIds = array();
        foreach($groupDb->getEditableGroups($user) as $group)
            $editableGroupIds[] = $group->group_id;

        $viewable = array();
        if($this->_group != WebReport_View_Helper_GenericListView::ROOT_FOLDER)
            $this->getTree($folders, $viewable, 0, $editableGroupIds);
        
        $folder = new UniForm_Form_Element_Select('folder');
        $folder->setLabel("DESTINATION_FOLDER:");
        $folder->addMultiOptions($viewable);
        $this->addElement($folder);
        $primary = new UniForm_Form_Element_Submit('primary');
        $primary->setLabel(_T("MOVE"));
        $this->addElement($primary);
        if(count($viewable) == 0) $this->_group = NULL;
    }

    public function isEmpty(){
        return $this->_group == NULL;
    }
}
