<?php

class Admin_Model_Api_Method_Admin_Registration extends WebReport_Api_Method_Abstract
{
    public function userIsAllowed(Core_Model_User $user)
    {
        return $user->multi_company == TRUE;
    }

    public function needsAuthentication()
    {
        return false;
    }

    protected function checkRegistration()
    {
        $registration = new Core_Model_Registration();
        return $registration->isRegistered();
    }

    protected function verifyKey()
    {
        $registration = new Core_Model_Registration();
        return $registration->keyIsValid();
    }

    protected function checkOnline()
    {
        $registration = new Core_Model_Registration();
        return $registration->isOnline();
    }

    protected function registerWebReport(array $args)
    {
        $registration = new Core_Model_Registration();
        $api_key = $args[0];
        return $registration->register($api_key);
    }

    public function call(array $params)
    {
        $call = $params['params']['call'];

        if(array_key_exists('args', $params['params']))
            $args = explode(',', $params['params']['args']);
        else
            $args = array();

        $helper = Zend_Controller_Action_HelperBroker::getStaticHelper('Json');

        $calls = array(
            'registered' => 'checkRegistration',
            'verified' => 'verifyKey',
            'online' => 'checkOnline',
            'register' => 'registerWebReport',
        );

        if(isset($calls[$call])) {
            $fun = $calls[$call];

            $helper->sendJson(self::$fun($args));
        } else {
            $helper->sendJson(array('available_calls' => array_keys($calls)));
        }
    }
}

