<?php

class Admin_Model_CameraGroupListGenerator extends Core_Model_Generic_AbstractListView {
    public function getHeaders(){
        return array(_T("NAME"),_T("USER"),_T("DESCRIPTION"),_T("NUMBER_OF_CAMERAS"));
    }

    protected function _dataRowToTableRow($row){
        $ret = array();
        $ret[] = $row->name;
        $ret[] = $row->username;
        $ret[] = $row->description;

        $ret[] = (string)count($row->getCameras());

        $ret['_document_id'] = Core_Model_DocumentFactory::getId($row->camera_group_id, "camera_group");

        return $ret;
    }

    protected function _dataRowToRowId($row){
        return $row->camera_group_id;
    }

    public function noDataInformation(){
        return _T("NO_CAMERA_GROUPS.");
    }

    public function removeText(){
        return _T('DO_YOU_REALLY_WANT_TO_REMOVE_THE_CAMERA_GROUP_"%1$s"?');
    }

    public function getActions($row){
        $folder = $this->_group->group_id;

        $creator = $this->_group->canEdit($this->_user);

        $actions = array();

        $actions[] = parent::CreateAction(_T('VIEW_CAMERA_GROUP'),'browse-cameras', 'view', $folder);

        if($creator) {
            $actions[] = parent::CreateAction(_T('EDIT_CAMERA_GROUP'),'edit-camera-group', 'edit', $folder);
            $actions[] = parent::CreateAction(_T('CHANGE_PASSWORD'), 'change-camera-group-password', 'changepassword', $folder);
            $actions[] = parent::CreateAction(_T('DELETE_CAMERA_GROUP'),'delete-camera-group', 'delete', $folder);
            $actions[] = parent::CreateAction(_T('IMPORT_DATA_FROM_FILE'),'import-cnt-files', 'import-cnt-files', $folder);
        }

        return $actions;
    }
}
