<?php
class Admin_Model_CameraQuery{
	
	private static function getX($con,$argus,$acap){
		if($con["type"] == "Argus")
			$adr = "http://".$con["ip"].$argus;
		else if($con["type"] == "ACAP")
			$adr = "http://".$con["ip"].$acap;
		else return "<no connection>";
		$data = Admin_Model_CameraQuery::downloadData($adr,$con);
		if(strlen($data) == 0) return "";
		$val = explode("=",$data);
		
		if (count($val) < 2) return "<no value>";

		return trim($val[1]);
		
	}
	
	private static function setX($con,$argus,$acap){
		if($con["type"] == "Argus")
			$adr = "http://".$con["ip"].$argus;
		else if($con["type"] == "ACAP")
			$adr = "http://".$con["ip"].$acap;
		else return "<no connection>";
		$data = Admin_Model_CameraQuery::downloadData($adr, $con);
		return strlen($data) > 0;
	}

	public static function getName($con){
		return Admin_Model_CameraQuery::getX($con,
			"/axis-cgi/admin/param.cgi?action=list&group=root.Counter.Name",
			"/axis-cgi/param.cgi?action=list&group=root.Tvpc.Counter0Name");
	}
	
	public static function getProductName($con){
		return Admin_Model_CameraQuery::getX($con,
			"/axis-cgi/admin/param.cgi?action=list&group=root.CounterBuild.Name",
			"/axis-cgi/param.cgi?action=list&group=root.Tvpc.Build0Name");
	}
	
	public static function getCameraModel($con){
		$acapArgus = "/axis-cgi/admin/param.cgi?action=list&group=root.Brand.ProdFullName";
		return Admin_Model_CameraQuery::getX($con, $acapArgus,$acapArgus);
	}
	
	public static function setName($con,$name){
		return Admin_Model_CameraQuery::setX($con,
			"/axis-cgi/admin/param.cgi?action=update&root.Counter.Name=".$name,
			"/axis-cgi/param.cgi?action=update&root.Tvpc.Counter0Name=".$name);
		
	}
	
	public static function getPreview($con){
		$argus = $con["type"] == "argus";
		if($argus){
			$adr = "http://".$con["ip"]."/jpg/image.jpg";
			$context = stream_context_create(array(
			    'http' => array(
			        'header'  => "Authorization: Basic " . base64_encode($con["user"].":". $con["pass"])
			    )
			));
			$data = file_get_contents($adr,false,$context);
			return $data;
		}
	}
	
	public static function downloadData($adr,$user,$pass=null){
		// If $user is actually a connection.
		if(is_array($user)){
			$pass = $user["pass"];
			$user = $user["user"];
		}
		$context = stream_context_create(array(
		    'http' => array(
		        'header'  => "Authorization: Basic " . base64_encode($user.":". $pass)
		    )
		));
		try{
			$data = @file_get_contents($adr,false,$context);
		}catch(Exception $e){
			return "";
		}
		return $data;
	}
	
	public static function initCameraQuery($ip,$user,$pass,$type = null){
		$withAdmin = Admin_Model_CameraQuery::canConnect("http://".$ip."/axis-cgi/admin/param.cgi?action=list&group=root.Notify.AtBoot","root.Notify.AtBoot=",$user,$pass);
		$withoutAdmin = Admin_Model_CameraQuery::canConnect("http://".$ip."/axis-cgi/param.cgi?action=list&group=root.Notify.AtBoot","root.Notify.AtBoot=",$user,$pass);
		$type = "unknown";
		$status = "";
		if($withAdmin === true && $withoutAdmin === false){
			$type = "Argus";
			$status = "Created interface for Argus @ ".$ip;
		}else if($withAdmin === true && $withoutAdmin === true){
			$type = "ACAP";
			$status = "Created interface for ACAP @ ".$ip;
		}else{
			$status = "invalid model";
		}
		
		return array("ip" => $ip, "type" => $type,"user" => $user,"pass" => $pass, "status" => $status);
	}
	
	public static function canConnect($adr,$contains,$user,$pass){
		$data = Admin_Model_CameraQuery::downloadData($adr,$user,$pass);
		return !(strpos($data,$contains) === false);
	}
}
