<?php

class Admin_Model_CompanyListGenerator extends Core_Model_Generic_AbstractListView {

    public function getHeaders(){
        return array(_T("NAME"),_T("E-MAIL"),_T("NUMBER_OF_COMPANY_USERS"),_T("NUMBER_OF_COMPANY_SOURCES"),_T("COMPANY_OWNER"));
    }

    protected function _dataRowToTableRow($row){
        $ret = array();
        $ret[] = $row->name;
        $ret[] = $row->email;
        $ret[] = $row->getNumberOfUsers();
        $ret[] = strval($row->getNumberOfCameras());
        $owner = $row->getOwner();
        $ret[] = $owner ? $owner : $this->translate("NO_COMPANY_OWNER.");
        return $ret;
    }

    public function removeText(){
        return _T('DO_YOU_REALLY_WANT_TO_INACTIVATE_THE_COMPANY_"%1$s"?');
    }

    protected function _dataRowToRowId($row){
        return $row->company_id;
    }

    public function noDataInformation(){
        return _T("NO_ACTIVE_COMPANIES.");
    }

    public function getActions($row){
        $actions = array();
        $actions[] = parent::CreateAction(_T('VIEW_COMPANY_INFORMATION'), 'view', 'view', null, null, null, 'admin', 'companies');
        $actions[] = parent::CreateAction(_T('EDIT_COMPANY'), 'edit', 'edit', null, null, null, 'admin', 'companies');
        $actions[] = parent::CreateAction(_T('INACTIVATE_COMPANY'), 'inactivate', 'delete', null, null, null, 'admin', 'companies');
        $actions[] = parent::CreateAction(_T('COMPANY_LOGO'), 'logo', 'company-logo', null, null, null, 'admin', 'companies');
        return $actions;
    }
}
