<?php

class Admin_Model_GroupListGenerator extends Core_Model_Generic_AbstractListView {
    public function getHeaders(){
        if($this->_isMultiCompany){
            return array(_T("NAME"),_T("DESCRIPTION"),_T("COMPANY"),_T("MEMBERS"));
        } else {
            return array(_T("NAME"),_T("DESCRIPTION"),_T("MEMBERS"));
        }
    }

    protected function _dataRowToTableRow($row){
        $ret = array();
        $ret[] = $row->name;
        $ret[] = $row->description;
        
        if($this->_isMultiCompany)
            $ret[] = $row->getCompany()->name;

        $ret[] = (string) $row->getNumberOfUsers();

        return $ret;
    }

    protected function _dataRowToRowId($row){
        return $row->group_id;
    }

    public function noDataInformation(){
        return _T("NO_GROUPS.");
    }

    public function removeText(){
        return _T('DO_YOU_REALLY_WANT_TO_REMOVE_THE_GROUP_"%1$s"?');
    }

    public function getActions($row){
        $actions = array();
        $actions[] = parent::CreateAction('VIEW_GROUP','view', 'view');
        $actions[] = parent::CreateAction('EDIT_GROUP', 'edit', 'edit');
        $actions[] = parent::CreateAction('DELETE_GROUP','delete', 'delete');
        return $actions;
    }
}
