<?php

class Admin_Model_MenuItems extends WebReport_Module_MenuItems_Abstract {

    /**
     * Get admin module menu items.
     *
     * @return array 
     */
    public function getAll() {
        $acl = WebReport_Acl::getInstance();
        $items = array();

        $view = Zend_Controller_Action_HelperBroker::getStaticHelper('ViewRenderer')->view;

        // @todo Check with ACL
        $identity = Zend_Auth::getInstance()->getIdentity();

        if ($identity->multi_company) {

            // company link
            $items['companies'] = array(
                'text' => 'MOD_ADMIN_MENU_COMPANIES',
                'class' => 'company',
                'urlOptions' => array('module' => 'admin', 'controller' => 'companies', 'action' => 'browse'),
                'title' => "MANAGE_COMPANIES"
            );
        } else {
            $companyId = $identity->company_id;
            $companiesDb = new Core_Model_Companies();
            $company = $companiesDb->find($companyId)->current();
            $items['companies'] = array(
                'text' => $company->name,
                'class' => 'company',
                'urlOptions' => array('module' => 'admin', 'controller' => 'companies', 'action' => 'view', 'id' => $companyId),
                'title' => "MANAGE_YOUR_COMPANY"
            );
        }

        $folders = $view->aclUrl(array('module' => 'admin', 'controller' => 'folders', 'action' => 'browse'));
        if($folders) {
            $items['folders'] = array(
                'text' => 'FOLDERS',
                'class' => 'folders',
                'urlOptions' => array('module' => 'admin', 'controller' => 'folders', 'action' => 'browse'),
                'title' => "MANAGE_YOUR_FOLDERS"
                );
        }

        // users link
        $items['users'] = array(
            'text' => 'MOD_ADMIN_MENU_USERS',
            'class' => 'user',
            'urlOptions' => array('module' => 'admin', 'controller' => 'users', 'action' => 'browse'),
            'title' => "MANAGE_USERS"
        );
/*
        $items['modules'] = array(
            'text' => 'MOD_ADMIN_MENU_MODULES',
            'class' => 'module',
            'urlOptions' => array('module' => 'admin', 'controller' => 'modules', 'action' => 'browse'),
            'title' => "SEE_WHAT_MODULES_ARE_AVAILABLE"
        );
 */
        $dataStorage = $view->aclUrl(array('module' => 'admin', 'controller' => 'data-storage-management', 'action' => 'browse-camera-groups'));
        $cameraManagement = $view->aclUrl(array('module' => 'admin', 'controller' => 'data-storage-management', 'action' => 'browse-cameras'));
        $class = "database";
        $include = false;
        $key = '';


        if ($dataStorage && $cameraManagement) {
            $text = _T('MOD_ADMIN_MENU_CAMERAS');
            $title = 'HANDLE_WHERE_TO_STORE_THE_DATA_AND_BROWSE_AVAILABLE_CAMERAS';
            #$urlOptions = array('module' => 'admin', 'controller' => 'data-storage-management', 'action' => 'browse-camera-groups');
            $urlOptions = array('module' => 'admin', 'controller' => 'data-storage-management', 'action' => 'browse-cameras');
            $include = true;
            $key = 'data-storage-management';
        } /*elseif ($dataStorage) {
            $text = 'MOD_ADMIN_MENU_DATA_STORAGE';
            $title = 'HANDLE_WHERE_TO_SAVE_THE_COUNT_DATA_FROM_YOUR_CAMERAS';
            $urlOptions = array('module' => 'admin', 'controller' => 'data-storage-management', 'action' => 'browse-camera-groups');
            $include = true;
            $key = 'data-storage';
        } elseif ($cameraManagement) {
            $text = 'MOD_ADMIN_MENU_DATA_MANAGEMENT';
            $title = 'BROWSE_AVAILABLE_CAMERAS';
            $urlOptions = array('module' => 'admin', 'controller' => 'data-storage-management', 'action' => 'browse-cameras');
            $class = "data-management";
            $include = true;
            $key = 'data-management';
        }*/
        if ($include) {
            $items[$key] = array(
                'text' => $text,
                'class' => $class,
                'urlOptions' => $urlOptions,
                'title' => $title
            );
        }
/* has moved to its own module count-data
        $items['count-data-sets'] = array(
            'text' => 'MOD_ADMIN_MENU_COUNT_DATA_SETS',
            'class' => 'count-data-sets',
            'urlOptions' => array('module' => 'admin', 'controller' => 'count-data-sets', 'action' => 'browse'),
            'title' => "MANAGE_COUNT_DATA_SETS"
        );

        $items['virtual-cameras'] = array(
            'text' => 'MOD_ADMIN_MENU_VIRTUAL_CAMERAS',
            'class' => 'virtual-cameras',
            'urlOptions' => array('module' => 'admin', 'controller' => 'virtual-cameras', 'action' => 'browse'),
            'title' => "MANAGE_VIRTUAL_CAMERAS"
        );

        $items['filter-groups'] = array(
            'text' => 'MOD_ADMIN_MENU_FILTER_GROUPS',
            'class' => 'filter-group',
            'urlOptions' => array('module' => 'admin', 'controller' => 'filter-groups', 'action' => 'browse'),
            'title' => "MANAGE_FILTER_GROUPS_FOR_FILTERING_OUT_THE_DATA_YOU_WANT"
        );
        $items['formulas'] = array(
            'text' => 'MOD_ADMIN_MENU_FORMULAS',
            'class' => 'formula',
            'urlOptions' => array('module' => 'admin', 'controller' => 'formulas', 'action' => 'browse'),
            'title' => "MANAGE_FORMULAS_FOR_ADVANCED_DATA_MINING"
        );
        $items['acl'] = array(
            'text' => 'MOD_ADMIN_MENU_ACL',
            'class' => 'acl',
            'urlOptions' => array('module' => 'admin', 'controller' => 'acl', 'action' => 'browse-roles'),
            'title' => "MANAGE_USERS_ACCESS_CONTROL_LISTS"
        );
*/

        $items['logs'] = array(
            'text' => 'MOD_ADMIN_MENU_LOGS',
            'class' => 'log',
            'urlOptions' => array('module' => 'admin', 'controller' => 'logs', 'action' => 'browse'),
            'title' => "INSPECT_THE_WEB_REPORT_LOGS"
        );

        $config = Zend_Registry::get('config');
        /*
          if ($config->eventListener->enabled) {
          $items['event-listener'] = array(
          'text' => 'MOD_ADMIN_MENU_EVENT_LISTENER',
          'class' => 'event-listener',
          'urlOptions' => array('module' => 'admin', 'controller' => 'event-listener', 'action' => 'index'),
          'title' => "SEE_IF_THE_EVENT_LISTENER_IS_RUNNING"
          );
          }
         */
        $items['config'] = array(
            'text' => 'MOD_ADMIN_MENU_CONFIG',
            'class' => 'config',
            'urlOptions' => array('module' => 'admin', 'controller' => 'config', 'action' => 'view'),
            'title' => "MANAGE_WEB_REPORT_CONFIGURATION"
        );

        $items = $this->filterNotAllowedItems($items);

        return $this->translate($items);
    }

    public static function getDescription($item) {
        $t = Zend_Registry::get("Zend_Translate");
        $items = array();

        $items['users'] = $t->_("USER_ADMINISTRATION.");
        $items['folders'] = $t->_("FOLDERS_AND_PRIVILEGES.");
        $items['modules'] = $t->_("INSTALLED_WEB_REPORT_MODULES.");
        $items['formulas'] = $t->_("MANAGE_FORMULAS_FOR_ADVANCED_DATA_MINING.");
        $items['virtual-cameras'] = $t->_("CREATE_VIRTUAL_CAMERAS_AS_COMBINATIONS_OF_COUNT_DATA_FROM_REAL_CAMERAS.");
        $items['filter-groups'] = $t->_("MANAGE_FILTERS_FOR_GROUPING_DATA_BY_CAMERA,_CAMERA_NAME_AND_COUNT_TYPE.");
        $items['count-data-sets'] = $t->_("CREATE_SETS_OF_CAMERAS_AND_FORMULAS_FOR_FAST_CREATION_OF_CHARTS,_REPORTS_ETC.");
        $items['data-storage-management'] = $t->_("CREATE_DATA_STORAGE_FOR_CAMERAS_TO_PUT_THEIR_DATA_IN_AND_MANAGE_THE_CAMERAS.");
        $items['data-storage'] = $t->_("CREATE_DATA_STORAGE_FOR_CAMERAS_TO_PUT_THEIR_DATA_IN.");
        $items['data-management'] = $t->_("MANAGE_CAMERAS_WHERE_THE_COUNT_DATA_COME_FROM.");
        $items['acl'] = $t->_("MANAGE_USER_ROLES.");
        $items['logs'] = $t->_("INSPECT_THE_WEB_REPORT_LOGS.");
        $items['event-listener'] = $t->_("CHECK_IF_THE_EVENT_LISTENER_IS_RUNNING.");
        $items['config'] = $t->_("TRUEVIEW_WEB_REPORT_SETTINGS.");

        if ($item == 'companies') {
            if (Zend_Auth::getInstance()->getIdentity()->multi_company) {
                return $t->_("COMPANY_ADMINISTRATION.");
            } else {
                return $t->_("CONTACT_INFORMATION_FOR_THE_ADMINISTRATOR.");
            }
        } else {
            return $items[$item];
        }
    }

    private function _translatableStrings() {
	$this->_translate->_('FOLDERS_AND_PRIVILEGES');
        $this->_translate->_('MANAGE_COMPANIES');
        $this->_translate->_('MANAGE_YOUR_FOLDERS');
        $this->_translate->_('FOLDERS');
        $this->_translate->_('MANAGE_YOUR_COMPANY');
        $this->_translate->_('MANAGE_USERS');
        $this->_translate->_('SEE_WHAT_MODULES_ARE_AVAILABLE');
        $this->_translate->_('MANAGE_FORMULAS_FOR_ADVANCED_DATA_MINING');
        $this->_translate->_('MANAGE_VIRTUAL_CAMERAS');
        $this->_translate->_('MANAGE_COUNT_DATA_SETS');
        $this->_translate->_('MANAGE_FILTER_GROUPS_FOR_FILTERING_OUT_THE_DATA_YOU_WANT');
        $this->_translate->_('HANDLE_WHERE_TO_SAVE_THE_COUNT_DATA_FROM_YOUR_CAMERAS');
        $this->_translate->_('MANAGE_USERS_ACCESS_CONTROL_LISTS');
        $this->_translate->_('INSPECT_THE_WEB_REPORT_LOGS');
        $this->_translate->_('SEE_IF_THE_EVENT_LISTENER_IS_RUNNING');
        $this->_translate->_('SHOW_ALL_COMPANIES');
        $this->_translate->_('MANAGE_WEB_REPORT_CONFIGURATION');
        $this->_translate->_('BROWSE_AVAILABLE_CAMERAS');
        $this->_translate->_('HANDLE_WHERE_TO_STORE_THE_DATA_AND_BROWSE_AVAILABLE_CAMERAS');
    }

}
