<?php

class Admin_Model_UserListGenerator extends Core_Model_Generic_AbstractListView {

    public function getHeaders(){
        $headers = array(_T("FORENAME"),_T("SURNAME"),_T("E-MAIL"),_T("TIMES_LOGGED_IN"),_T("LAST_LOGIN"));
        if ($this->_isMultiCompany) {
            $headers[] = _T("COMPANY");
        }
        return $headers;
    }

    protected function _dataRowToTableRow($row){
        $last_login = new DateTime($row->last_login, new DateTimeZone("UTC"));
        $last_login = $last_login->format('U');
        $ret = array();
        $ret[] = $row->forename;
        $ret[] = $row->surname;
        $ret[] = $row->email;
        $ret[] = $row->logincount;
        $ret[] = WebReport_Time::readableTimeAgo($last_login, time(), true);
        if($this->_isMultiCompany) $ret[] = $row->company;
        return $ret;
    }

    public function removeText(){
        return _T('DO_YOU_REALLY_WANT_TO_DELETE_THE_USER_"%1$s"?');
    }

    protected function _dataRowToRowId($row){
        return $row->user_id;
    }

    public function noDataInformation(){
        return _T("THERE_EXIST_NO_ACTIVE_USERS.");
    }

    public function getActions($row){
        $actions = array();
        $actions[] = parent::CreateAction(_T('EDIT_USER'),'edit', 'edit', null, null, null, 'admin', 'users');
        if($this->_isMultiCompany || !$row->multi_company) {
            $actions[] = parent::CreateAction(_T("CHANGE_USERS_PASSWORD"), 'change-password', 'changepassword', null, null, null, 'admin', 'users');
            if($this->_user->user_id != $row->user_id) {
                $actions[] = parent::CreateAction(_T('DELETE_USER'),'inactivate', 'delete', null, null, null, 'admin', 'users');
            } else {
                $actions[] = parent::CreateAction(_T('YOU_ARE_LOGGED_IN_AS_THIS_USER'), null, 'user', null, null, null, null, null);
            }
        }
        return $actions;
    }
}
