<?php

class Admin_Plugin_ChangeLanguage extends Zend_Controller_Plugin_Abstract
{
	public function routeShutdown(Zend_Controller_Request_Abstract $request)
	{

		$request = $this->getRequest();

		$moduleName = $request->getModuleName();
		$controllerName = $request->getControllerName();
		$actionName = $request->getActionName();

		$language = (string)$request->getParam('language');
		$auth = Zend_Auth::getInstance();
		// check if language is set, then change language and
		// reload the same page to make the language change take effect
		if ($language != '' && $auth->hasIdentity()) {
			// @todo check if $language is valid language

			$data = $auth->getStorage()->read();
			$data->language = $language;
			$auth->getStorage()->write($data);
			$users = new Core_Model_Users();
			$user = $users->find($data->user_id)->current();
			$user->setLanguage($language);
			$user->save();
			$requestParams = $request->getParams();

			$locale = new Zend_Locale($user->getLocale());
			$translate = Zend_Registry::get('Zend_Translate');
			$translate->setLocale($locale);
			
			Zend_Registry::set('Zend_Locale', $locale);
			Zend_Registry::set('Zend_Translate', $translate);

			$request->setModuleName($request->getModuleName());
			$request->setControllerName($request->getControllerName());
			$request->setActionName($request->getActionName());
			$request->setParam('language', null);
			$request->setDispatched(false);


		}


	}

}

