<?php

class Admin_Plugin_CheckAuth extends Zend_Controller_Plugin_Abstract
{
	public function preDispatch(Zend_Controller_Request_Abstract $request)
	{
		//ACL-CLEAN: This file needs a major cleanup as it no longer checks user rights more than basic login.
		$logger = Zend_Registry::get('Zend_Logger_FireBug');
		$request = $this->getRequest();
		$moduleName = $request->getModuleName();
		$controllerName = $request->getControllerName();
		$actionName = $request->getActionName();

    $user = Zend_Auth::getInstance()->getIdentity();

    $lastPg = new Zend_Session_Namespace('history');
    $lastPg->unsetAll();
    if (!$user && 
      !($moduleName == 'api' || 
      ($moduleName == 'admin' && $controllerName == 'login') ||
      ($moduleName == 'admin' && $controllerName == 'users' && $actionName == 'superapiadd') ||
      ($moduleName == 'admin' && $controllerName == 'companies' && $actionName == 'superapiadd') ||
      ($moduleName == 'admin' && $controllerName == 'companies' && $actionName == 'superapiedit'))) {
      $request->setModuleName('admin');
      $request->setControllerName('login');
      $request->setActionName('index');

      $lastPg->uri = $_SERVER['REQUEST_URI'];
      $this->getResponse()->setHttpResponseCode(401); // Unauthorized
      $request->setDispatched(true);
      return;
    }
    if ($user && $moduleName == 'admin' && $controllerName == 'validate') {
      return;	
    }

    // If hosted dont allow to enter the config menues
    if ($moduleName == 'admin' && $controllerName == 'config') {
      // Check if hosted
      $config = Zend_Registry::get('config');
      $superapi_hash = $config->general->channelAdminHash;
      if (strlen($superapi_hash)>5) { // This minimum length is defined in modules/admin/plugins/AuperApi.php, probably 20. This must ofc be less or equal...
        // Prevent user from entering
        $request->setModuleName('admin');
        $request->setControllerName('login');
        $request->setActionName('index');
        $lastPg->uri = $_SERVER['REQUEST_URI'];
        $this->getResponse()->setHttpResponseCode(401); // Unauthorized
        $request->setDispatched(true);
        return;
      }
    }

    $roleId = 0;
    if ($user) {
      //$roleId = (int)$user->acl_role_id;
      $usersDb = new Core_Model_Users();
      $userFromDb = $usersDb->find($user->user_id)->current();
      //if ($userFromDb->acl_role_id != $roleId) {
      if (!$userFromDb) {
        Zend_Auth::getInstance()->clearIdentity();
        $request->setModuleName('admin');
        $request->setControllerName('login');
        $request->setActionName('index');
        $request->setDispatched(true);
        return;
      }
		}



		//$acl = WebReport_Acl::getInstance();

		/*if (!$acl->hasRole($roleId)) {
			$error = "Sorry, the requested user role '$roleId' does not exist";
		} elseif (!$acl->has($moduleName . ':' . $controllerName)) {
			$error = "Sorry, the requested resource '$moduleName:$controllerName' does not exist as an ACL resource";
		}*/

		if (!isset($error)) {
			$errorAll = false;
			
			/*if ($acl->isAllowed($roleId, $moduleName . ':' . $controllerName, $actionName)) {
				$errorAll = false;
			}*/

			if ($errorAll) {

				$params = $request->getParams();
				if (isset($params['module'])) unset($params['module']);
				if (isset($params['controller'])) unset($params['controller']);
				if (isset($params['action'])) unset($params['action']);
				$params = array_diff($params, $_POST); // delete all $_POST-entries, maybe there is a better way

				$nbrOfPars = count($params);
				if ($nbrOfPars > 0) {
					ksort($params);
					$urlOptions = $params;
					$total = $nbrOfPars;
					for ($i = $nbrOfPars; $i >= 1; --$i) {

						$choose = $i;
						$c = new WebReport_Combination($total,$choose);
						$nbrOfCombs = WebReport_Combination::choose($total,$choose);
						$optKeys = array_keys($urlOptions);

						for ($j = 0; $j < $nbrOfCombs; ++$j) {
							$testStr = $actionName;
							foreach ($c->data as $number) {
								$key = $optKeys[$number];
								$value = $urlOptions[$key];
								$testStr .= ':' . $key . ':' . $value;
							}

							/*if ($acl->isAllowed($roleId, $moduleName . ':' . $controllerName, $testStr)) {
								return true;
							}*/
							$c = $c->successor();
						}

					}


				}

			}
//check if this is the api module, delegate the error handling to that module
			if ($errorAll && $moduleName != "api")
				$error = "Sorry, the page you requested does not exist or you do not have access";
		}
		if (isset($error)) {
			$logger->err($error);
			$request->setModuleName('default')
				->setControllerName('error')
				->setActionName('error')
				->setDispatched(false);
                        
                        $helper = Zend_Controller_Action_HelperBroker::getStaticHelper('ViewRenderer');
                        if ($helper->view != null) {
                            $helper->view->message = $error;
                        }
			//throw new WebReport_Exception($error);
						
		}




	}

}

