<?php

class Admin_Plugin_RegisterLoggers extends Zend_Controller_Plugin_Abstract
{
	public function preDispatch(Zend_Controller_Request_Abstract $request)
	{

		$columnMapping = array("date" => "timestamp", "priority_id" => "priority", "message" => "message");

		$loggers = array();

		$auth = Zend_Auth::getInstance();
		if ($auth->hasIdentity()) {
			$identity = $auth->getIdentity();
			$companyId = $identity->company_id;
		} else {
			$companyId = 0;
		}

		//if ($companyId == NULL) $companyId = 0;


		$logs = new Core_Model_Logs();
		$logsObject = $logs->fetchAll();
		$db = Zend_Registry::get('db');
		foreach ($logsObject as $log) {
			$loggers[$log->alias] = new Zend_Log(new WebReport_Log_Writer_Db($db, $log->name, $companyId, 'log_message', $columnMapping));
		}

		Zend_Registry::set('loggers', (object)$loggers);

	}
}