<?php

class Admin_Plugin_SuperApi extends Zend_Controller_Plugin_Abstract
{
  const RET_ERROR = -2;
  const RET_NOT_LOGGED_IN = -1;
  const RET_LOGGED_IN = 0;

  const MIN_HASH_LENGTH = 20;

  var $status = true;
  var $msgs = [];

  public function checkAuth($key, $config){
    if (!isset($config))
      return SELF::RET_ERROR;
    if (!isset($key))
      return SELF::RET_NOT_LOGGED_IN;
    $hash = $config->general->channelAdminHash;
    if (!isset($hash)) {
        $this->answer("FAILED","No channel admin hash has been configured");
        return SELF::RET_ERROR;
    }
    if (strlen($hash)<SELF::MIN_HASH_LENGTH) { 
        $this->answer("FAILED","The channel admin hash has to be atleast " . SELF::MIN_HASH_LENGTH . " chars long");
        return SELF::RET_ERROR;
    }
    if ($hash!=$key) {
        $this->answer("FAILED","Wrong authorization");
        return SELF::RET_NOT_LOGGED_IN;
    }
    return SELF::RET_LOGGED_IN;
  }

  public function answer($status, $message){
    $this->status &= $status;
    $this->msgs[] = $message;
  }

  public function getFullAnswer() {
    return array("status"=>$this->status?"OK":"FAILED", "msg"=>$this->msgs);
  }

}
