<?php
require_once(APPLICATION_PATH . "/abc.php");
class Api_IndexController extends Zend_Controller_Action {

    protected $_format = WebReport_Api::FORMAT_JSON;

    protected $_jsonpCallback;

    protected $_logger;

    protected $_params = array();

    public function init()
    {
        parent::init();

        $front = Zend_Controller_Front::getInstance();
        if ($front->hasPlugin('Zend_Controller_Plugin_ErrorHandler')) {
            $front->unregisterPlugin('Zend_Controller_Plugin_ErrorHandler');
        }

        $this->_logger = Zend_Registry::get("Zend_Logger_FireBug");

        $this->_helper->viewRenderer->setNoRender();

    }

    public function indexAction()
    {
        try {
            $params = $this->_getApiParameters();
            $this->_params = $params;
        } catch (Exception $e) {
            $this->_error($e->getCode(), $e->getMessage());
            return;
        }

        //r_log($params);
        $module = $params['module'];
        $method = $params['method'];
        if($method == 'getLastSavedDataTime'){
            $poller = new Core_Model_Poller();
            if($poller->isAlone()){
                $poller->requestApi();
            }
        }

        // webreport/api/?method=countData.xxx
        if ($module == 'countData') {
            // webreport/api/?method=countData.add
            if ($method == 'add') {
                try {
                    $this->_addCountData();
                    echo "ok";
                } catch (WebReport_Exception $e) {
                    echo $e->getMessage();
                    $this->_helper->loggers(WebReport_Log::COUNT_DATA_UPLOAD)->notice($e->getMessage());
                }
                return;
                // webreport/api/?method=getLastSavedDataTime.add
            } else if ($method == 'getLastSavedDataTime') {
                try {

                    $date = $this->_getLastSavedDataTimeForCameraName();

                    if (!$date) {
                        $date = date("Y", time() - 31536000) . "0101000000";
                    }
                    echo $date;
                } catch (WebReport_Exception $e) {
                    echo $e->getMessage() . "\n";
                    $this->_helper->loggers(WebReport_Log::COUNT_DATA_UPLOAD)->notice($e->getMessage());
                }
                return;
                // webreport/api/?method=countData.addTestCamera
            } else if ($method == 'addTestCamera') {
                $this->_addTestCamera($params);
                return;
            }



            // webreport/api/?method=heatmapData.xxx
        } else if ($module == "heatmapData") {

            // webreport/api/?method=heatmapData.add
            if ($method == 'add') {
                try {
                    $this->_addHeatmapData();
                    echo "ok";
                } catch (WebReport_Exception $e) {
                    echo $e->getMessage();
                    $this->_helper->loggers(WebReport_Log::COUNT_DATA_UPLOAD)->notice($e->getMessage());
                }
                return;
                // webreport/api/?method=heatmapData.getLastSavedDataTime
            } elseif ($method == 'getLastSavedDataTime') {
                try {
                    $date = $this->_getLastSavedDataTimeForCameraName();

                    if (!$date) {
                        $date = date("Y", time() - 31536000) . "0101000000";
                    }
                    echo $date;
                } catch (WebReport_Exception $e) {
                    echo $e->getMessage() . "\n";
                    $this->_helper->loggers(WebReport_Log::COUNT_DATA_UPLOAD)->notice($e->getMessage());
                }
                return;
            }

            // webreport/api/?method=camera.xxx
        } else if ($module == 'camera') {

            // webreport/api/?method=camera.uploadImage
            if ($method == 'uploadImage') {

                try {
                    $this->_uploadCameraImage();
                    echo "ok";
                } catch (WebReport_Exception $e) {
                    echo $e->getMessage();
                    $this->_helper->loggers(WebReport_Log::COUNT_DATA_UPLOAD)->notice($e->getMessage());
                }
                return;
            } else if ($method == 'ping') {
                $credentials = false;
                $camera_exist = false;
                $contact = true;
                $license = true;
                $posted_input = false;

                try {
                    $decrypted = $this->_readFromInputAndDecrypt();
                    $posted_input = true;
                } catch (WebReport_Exception $e) {
                    $decrypted = NULL;
                    $posted_input = false;
                }

                if(is_null($decrypted)) {
                    $license = false;
                }

                if($posted_input)
                    try {
                        $data = explode("##", $decrypted);
                        $username = $data[0];
                        $pass = $data[1];

                        $cameraGroupsDb = new Core_Model_CameraGroups();
                        $cameraGroup = $cameraGroupsDb->fetchRow(
                                $cameraGroupsDb->select()->where("username = ?", $username)
                                );
                        if($cameraGroup &&
                                md5(STATIC_SALT . $pass . $cameraGroup->password_salt) == $cameraGroup->password)
                            $credentials = true;
                    } catch (WebReport_Exception $e) {
                        $credentials = false;
                    }


                if($posted_input) {
                    try {
                        $date = Core_Model_Cameras::getLastSavedTimeForSeperatedString($decrypted);
                        if($date)
                            $camera_exist = true;
                    } catch (WebReport_Exception $e) {
                        $camera_exist = false;
                    }
                }


                $this->_print(array(
                            "contact" => true,
                            "input" => $posted_input,
                            "license" => $license,
                            "credentials" => $credentials,
                            "camera-exist" => $camera_exist
                            ));
                return;
            }



            // webreport/api/?method=camera.addError
            /*
               else if ($params == "addError") {
               try {
               $this->_addCameraError();
               echo "ok";
               } catch (WebReport_Exception $e) {
               echo $e->getMessage();
            //	$this->_helper->loggers(WebReport_Log::COUNT_DATA_UPLOAD)->notice($e->getMessage());
            }
            return;
            }
             */
        }
        // webreport/api/?method=camera.xxx
        else if ($module == 'company') {
            if ($method == 'hasFolderManager') {
                if(isset($params['params']['companyId']))
                    $company_id = (int) $params['params']['companyId'];
                else
                    $company_id = 0;

                $usersDb = new Core_Model_Users();

                $select = $usersDb->select()
                    ->from($usersDb, array('count(*) as amount'))
                    ->where('company_id = ?', $company_id)
                    ->where('administrator = 1');

                $rows = $usersDb->fetchAll($select);

                echo json_encode($rows[0]->amount > 0);
                return;
            }
        }

        $api = new WebReport_Api();
        $front = Zend_Controller_Front::getInstance();
        $modules = array_keys($front->getControllerDirectory());
        foreach ($modules as $m) {
            $className = ucfirst($m) . '_Model_Api_Resource';
            if (Zend_Loader_Autoloader::autoload($className)) {
                $apiResource = new $className();
                $api->register($apiResource);
            }
        }

        try {
            $apiMethod = $api->getMethod($module, $method);

            if (!$apiMethod) {
                throw new WebReport_Exception("Invalid method.", WebReport_Api::CODE_INVALID_METHOD);
            } else {

                $userIsAllowed = true;
                if ($apiMethod->needsAuthentication()) {
                    $user = $this->_checkAuthentication();
                    $userIsAllowed = $apiMethod->userIsAllowed($user);
                }

                if (!$userIsAllowed) {
                    throw new WebReport_Exception("User not allowed to call this method.", WebReport_Api::CODE_PERMISSION_DENIED);
                }

                $data = $apiMethod->call($params);

                if ($data != NULL) {
                    $this->_print($data);
                }


            }
        } catch (Exception $e) {
            $this->_error($e->getCode(), $e->getMessage());
            return;
        }

    }

    protected function _addTestCamera($params)
    {
        $return = array(
            'status' => 'success',
            'message' => 'operation completed successfully');
        if (!$params['params']['user'] || !$params['params']['pass']) {
            $return['status'] = 'error';
            $return['message'] = 'username or password not specified.';
            print json_encode($return);
            return;
        } elseif (!$params['params']['to'] || !$params['params']['from']) {
            $return['status'] = 'error';
            $return['message'] = 'no time interval specified';
            print json_encode($return);
            return;
        } elseif (!$params['params']['camera_name']) {
            $return['status'] = 'error';
            $return['message'] = 'no camera name specified';
            print json_encode($return);
            return;
        }
        $product = $params['params']['product'];
        $user = $params['params']['user'];
        $pass = $params['params']['pass'];
        //r_log("##############NEW ADD TEST CAMERA API CALL################");
        $from = new Zend_Date($params['params']['from'], "yyyyMMddHHmm00");
        $to = new Zend_Date($params['params']['to'], "yyyyMMddHHmm00");

        $openingHoursParams = explode(",", $params['params']['opening_hours']);
        $nbr_of_opening_hours = count($openingHoursParams);
        if (!$openingHoursParams[0]) {
            r_log("No opening hour parameter found, setting default opening hours!");
            $oh_arr = explode("-", $oh);
            $openingHours[0]["open"] = strtotime("05:00");
            $openingHours[0]["close"] = strtotime("22:00");
            $openingHours[0]["whole_15_min_periods"] = floor(($openingHours[0]["close"]-$openingHours[0]["open"])/60/15);
        }
        if ($nbr_of_opening_hours == 1) {
            r_log("Using single opening hours for all weekdays!");
        } elseif ($nbr_of_opening_hours != 7) {
            r_log("Invalid opening hours in api call. - opening_hours parameter needs to contain 1 or 7 comma separted values.");
            $return['status'] = 'error';
            $return['message'] = 'invalid opening hours - opening_hours parameter needs to contain 1 or 7 comma separted values.';
            print json_encode($return);
            return;
        }
        foreach ($openingHoursParams as $key => $oh) {
            $oh_arr = explode("-", $oh);
            //Transform to weekday (0-6 sunday to saturday.)
            if ($nbr_of_opening_hours == 1) {
                $weekday = 0;
            } else {
                if ($key == 6) {
                    $weekday = 0;
                } else {
                    $weekday = $key+1;
                }
            }
            $openingHours[$weekday]["open"] = strtotime($oh_arr[0]);
            $openingHours[$weekday]["close"] = strtotime($oh_arr[1]);
            $openingHours[$weekday]["whole_15_min_periods"] = floor(($openingHours[$weekday]["close"]-$openingHours[$weekday]["open"])/60/15);
        }
        for ($i=0; $i<sizeof($openingHours); $i++) {
            if ($openingHours[$i]["whole_15_min_periods"] <= 0) {
                r_log("Invalid opening hours in api call.");
                $return['status'] = 'error';
                $return['message'] = 'invalid opening hours - no full quarter within opening hour';
                print json_encode($return);
                return;
            }
        }
        $camera_name = $params['params']['camera_name'];
        $flow_factor = $params['params']['flow_factor'];
        if (!isset($flow_factor)) {
            r_log("Flow factor missing from params. Setting it to 1.");
            $flow_factor = 1;
        } else {
            if (!is_numeric($flow_factor) || $flow_factor <= 0) {
                $return['status'] = 'error';
                $return['message'] = 'invalid flow factor, must be numeric > 0';
                print json_encode($return);
                return;
            }
        }
        /*
         * create and report dummy data for that time interval.
         */
        //Round from and to times to floored quarter.
        if ($from->get(Zend_Date::MINUTE)<15) {
            $from->set(0, Zend_Date::MINUTE);
        } elseif ($from->get(Zend_Date::MINUTE) > 15 && $from->get(Zend_Date::MINUTE) < 30) {
            $from->set(15, Zend_Date::MINUTE);
        } elseif ($from->get(Zend_Date::MINUTE) > 30 && $from->get(Zend_Date::MINUTE) < 45) {
            $from->set(30, Zend_Date::MINUTE);
        } elseif ($from->get(Zend_Date::MINUTE) > 45) {
            $from->set(45, Zend_Date::MINUTE);
        }
        if ($to->get(Zend_Date::MINUTE)<15) {
            $to->set(0, Zend_Date::MINUTE);
        } elseif ($to->get(Zend_Date::MINUTE) > 15 && $to->get(Zend_Date::MINUTE) < 30) {
            $to->set(15, Zend_Date::MINUTE);
        } elseif ($to->get(Zend_Date::MINUTE) > 30 && $to->get(Zend_Date::MINUTE) < 45) {
            $to->set(30, Zend_Date::MINUTE);
        } elseif ($to->get(Zend_Date::MINUTE) > 45) {
            $to->set(45, Zend_Date::MINUTE);
        }

        $time_strs = array();
        for (; $from->compare($to) < 0; $from->add(15, Zend_Date::MINUTE)) {
            $time_strs[] = $from->toString("yyyyMMddHHmm00");
        }
        foreach ($time_strs as $time_str) {
            try {
                //$time = strtotime(substr($time_str, -6, 6));
                $t = new Zend_Date($time_str, "yyyyMMddHHmmss");
                $stats = Core_Model_DummyData::getDataForTimeAndDay($product, $t, $openingHours, $flow_factor);
                $data = (object) array(
                        "username" => $user,
                        "pass" => $pass,
                        "version" => '3', //Doesn't matter now as long as it's >=3.
                        "cameraName" => $camera_name,
                        "serial" => "000000",
                        "regcode" => "000000",
                        "fields" => "10", //Doesn't matter now as long as it's >=10.
                        "stats" => $stats,
                        "nbrOfTypes" => count($stats),
                        "cnttime" => $time_str
                );
                Core_Model_CountData::addDataForSeparatedString($data, null, false, false, true);
            } catch (WebReport_Exception $e) {
                $return['status'] = 'error';
                $return['message'] = $e->getMessage();
                print json_encode($return);
                return;
            }
        }
        print json_encode($return);
        return;
    }

    protected function _checkAuthentication() {

        $response = $this->getResponse();

        if (empty($_SERVER['PHP_AUTH_DIGEST'])) {
            $response->setHttpResponseCode(401);
            $response->setHeader("WWW-Authenticate", 'Digest realm="' . APPLICATION_REALM . '",qop="auth",nonce="' . uniqid() . '",opaque="' . md5(APPLICATION_REALM) . '"');
            $response->sendResponse();
            throw new WebReport_Api_Exception("Not authenticated.", WebReport_Api::CODE_AUTH_FAILED);
        }

        $data = $this->_httpDigestParse($_SERVER['PHP_AUTH_DIGEST']);

        $usersDb = new Core_Model_Users();
        $user = $usersDb->fetchWithEmail($data['username']);

        if (!$data || !$user) {
            $response->setHttpResponseCode(401);
            $response->sendResponse();
            throw new WebReport_Api_Exception("Invalid credentials.", WebReport_Api::CODE_AUTH_FAILED);
        }

        // generate the valid response
        $A1 = $user->digest_helper_password;
        $A2 = md5($_SERVER['REQUEST_METHOD'] . ':' . $data['uri']);
        $validResponse = md5($A1 . ':' . $data['nonce'] . ':' . $data['nc'] . ':' . $data['cnonce'] . ':' . $data['qop'] . ':' . $A2);

        if ($validResponse != $data['response']) {
            $response->setHttpResponseCode(401);
            $response->sendResponse();
            throw new WebReport_Api_Exception("Not authenticated.", WebReport_Api::CODE_AUTH_FAILED);
        }

        return $user;
    }

    protected function _getApiParameters()
    {
        // default values
        $return = array('format' => WebReport_Api::FORMAT_JSON);

        $params = $this->_request->getParams();
        unset($params['controller'], $params['action'], $params['module']);

        // check method
        if (!array_key_exists("method", $params)) {
            throw new WebReport_Api_Exception("No method.", WebReport_Api::CODE_INVALID_METHOD);
        } else {
            $moduleMethod = $params['method'];
            unset($params['method']);

            $tmp = explode(".", $moduleMethod, 2);
            if (count($tmp) == 1) {
                throw new WebReport_Api_Exception("Invalid method.", WebReport_Api::CODE_INVALID_METHOD);
            }

            $module = $tmp[0];
            $method = $tmp[1];

            $return['module'] = $module;
            $return['method'] = $method;
        }

        // check format
        if (array_key_exists('format', $params)) {
            if ($params['format'] == WebReport_Api::FORMAT_JSON ||
                    $params['format'] == WebReport_Api::FORMAT_JSONP ||
                    $params['format'] == WebReport_Api::FORMAT_PRETTY_JSON) {
                $this->_format = $params['format'];
                $return['format'] = $params['format'];
            } else {
                throw new WebReport_Api_Exception("Invalid format.", WebReport_Api::CODE_INVALID_FORMAT);
            }
        } else {
            $return['format'] = WebReport_Api::FORMAT_JSON;
            unset($params['format']);
        }

        // check jsonp callback
        if ($return['format'] == WebReport_Api::FORMAT_JSONP && !array_key_exists('jsonpcallback', $params)) {
            echo "he1";
            throw new WebReport_Api_Exception("No JSONP callback.", WebReport_Api::CODE_INVALID_FORMAT);
        } else if ($return['format'] == WebReport_Api::FORMAT_JSONP) {
            $this->_jsonpCallback = $params['jsonpcallback'];
            unset($params['jsonpcallback']);
        }

        $return['params'] = $params;

        return $return;
    }

    protected function _error($errorCode, $errorMessage, $responseCode = 400)
    {
        $error = array("code" => $errorCode, "message" => $errorMessage);
        $response = $this->getResponse();

        if ($response->getHttpResponseCode() == 200) {
            $response->setHttpResponseCode(400);
        }
        $this->_print($error);
    }

    protected function _print(array $arr)
    {
        $format = $this->_format;
        $this->_response->setHeader("Content-type", "text/plain", true);

        switch ($format) {
            case WebReport_Api::FORMAT_JSON :
                echo Zend_Json::encode($arr);
                break;
            case WebReport_Api::FORMAT_JSONP :
                echo $this->_jsonpCallback . "(" . Zend_Json::encode($arr) . ")";
                break;
            case WebReport_Api::FORMAT_PRETTY_JSON:
                echo Zend_Json::prettyPrint(Zend_Json::encode($arr), array("indent" => " "));
                break;
            default:
                $this->_format = WebReport_Api::FORMAT_JSON;
                $this->_error(WebReport_Api::CODE_INVALID_FORMAT, "Invalid parameter format.");
                break;
        }
    }

    protected function _httpDigestParse($digest)
    {
        // edit needed parts, as you  want
        preg_match_all('@(username|nonce|uri|nc|cnonce|qop|response)' .
                '=[\'"]?([^\'",]+)@', $digest, $t);
        $data = array_combine($t[1], $t[2]);
        // all parts found?
        return (count($data) == 7) ? $data : false;
    }

    protected function _getLastSavedDataTimeForCameraName()
    {
        $decrypted = $this->_readFromInputAndDecrypt();
        if($decrypted == null) {
            throw new WebReport_Api_Exception("cm_decrypt error, invalid license", WebReport_Api::CODE_CMDECRYPT_ERROR);
        }
        $s = Core_Model_Cameras::getLastSavedTimeForSeperatedString($decrypted,true);
        return $s;
    }

    private function _readFromInputAndDecrypt($binary = false)
    {
        $inputStream = fopen('php://input', 'r');
        if (!$inputStream) {
            throw new WebReport_Api_Exception("Failed to open input post stream.", WebReport_Api::CODE_OTHER_ERROR);
        }
        $encrypted = '';
        while (!feof($inputStream)) {
            $encrypted .= fgets($inputStream);
        }
        fclose($inputStream);

        if ($encrypted == "") {
            throw new WebReport_Api_Exception("Input is empty.", WebReport_Api::CODE_OTHER_ERROR);
        }

        $license = Zend_Registry::get('config-license');


        /*if (!extension_loaded("cmwebreport")) {
          throw new WebReport_Api_Exception("PHP Extension cmwebreport not loaded.", WebReport_Api::CODE_CMDECRYPT_ERROR);
          }*/

        $encrypted = base64_decode(str_replace(" ", "+", $encrypted));

        if ($binary) {
            $decrypted = cm_decrypt_binary2(
                    $license->registrationCode, $license->activationCode, $encrypted
                    );
        } else {
            $decrypted = cm_decrypt2(
                    $license->registrationCode, $license->activationCode, $encrypted
                    );
        }
        return $decrypted;
    }

    protected function _addCountData()
    {
        $decrypted = $this->_readFromInputAndDecrypt();
        if ($decrypted == null) {
            throw new WebReport_Api_Exception("cm_decrypt failed, invalid license", WebReport_Api::CODE_CMDECRYPT_ERROR);
        }
        return Core_Model_CountData::addDataForSeparatedString($decrypted);
    }

    protected function _addHeatmapData()
    {
        $decrypted = $this->_readFromInputAndDecrypt(true);

        if ($decrypted == null) {
            throw new WebReport_Api_Exception("cm_decrypt failed, invalid license", WebReport_Api::CODE_CMDECRYPT_ERROR);
        }

        $data = explode("##", $decrypted, 11);

        if (count($data) != 11) {
            throw new WebReport_Exception("Invalid data. Not in the correct format.", WebReport_Api::CODE_INVALID_PARAMETERS);
        }

        $username = $data[0];
        $pass = $data[1];
        $version = $data[2];
        $cameraName = $data[3];
        $serial = $data[4];
        $cnttime = $data[5];
        $delta = $data[6];
        $imDims = explode("x", $data[7]);
        $hmpDims = explode("x", $data[8]);
        if (count($imDims) != 2 || count($hmpDims) != 2) {
            throw new WebReport_Exception("Invalid data. Not in the correct format. imDims: " . $imDims . ", hmpDims: " . $hmpDims, WebReport_Api::CODE_INVALID_PARAMETERS);
        }
        $max = $data[9];
        //check if we have mask-data and n_frames
        $hmpExtraData = explode("x", $max);
        $hasMask = false;
        if(count($hmpExtraData) == 4 )
        {
            $max = $hmpExtraData[0];
            $maskw = $hmpExtraData[1];
            $maskh = $hmpExtraData[2];
            $n_frames = $hmpExtraData[3];
            $hasMask = true;
        }

        $hmp = $data[10];
        $hmpValues = unpack("C*", $hmp); // unpack as many unsigned chars as possible
        //old version
        if( !$hasMask )
        {
            if (count($hmpValues) != $hmpDims[0] * $hmpDims[1]) {
                throw new WebReport_Exception("Invalid data. Not in the correct format. count(hmpValues)=" . count($hmpValues) . "!=" . $hmpDims[0] * $hmpDims[1] . '=$hmpDims[0]*$hmpDims[1]', WebReport_Api::CODE_INVALID_PARAMETERS);
            }
        } else {
            if (count($hmpValues) != ($hmpDims[0] * $hmpDims[1] + $maskw*$maskh/8) ) {
                throw new WebReport_Exception("MAP: Invalid data. Not in the correct format. count(hmpValues)=" . count($hmpValues) . "!=" . $hmpDims[0] * $hmpDims[1] + $maskw*$maskh/8 . '=$hmpDims[0]*$hmpDims[1]', WebReport_Api::CODE_INVALID_PARAMETERS);
            }
            //pull all data after the heatmap
            $hmpMask = array_slice($hmpValues, $hmpDims[0] * $hmpDims[1]);
            //remove the mask
            $hmpValues = array_slice($hmpValues, 0, $hmpDims[0] * $hmpDims[1]);
        }

        if ($version == '4') {
            throw new WebReport_Exception("Web Report does not support this feature yet.", WebReport_Api::CODE_INVALID_PARAMETERS);
        }

        if ($version != '3') {
            throw new WebReport_Exception("The version is $version. Should be 3.", WebReport_Api::CODE_INVALID_PARAMETERS);
        }

        if (strtotime($cnttime) === false) {
            throw new WebReport_Exception("Invalid date and time sent, expecting yyyy-mm-dd HH:MM:SS", WebReport_Api::CODE_INVALID_PARAMETERS);
        }

        $cameraGroupsDb = new Core_Model_CameraGroups();
        $cameraGroup = $cameraGroupsDb->fetchRow($cameraGroupsDb->select()->where("username = ?", $username));
        if (!$cameraGroup) {
            throw new WebReport_Exception("No camera group with username '$username'.", WebReport_Api::CODE_INVALID_PARAMETERS);
        } elseif (md5(STATIC_SALT . $pass . $cameraGroup->password_salt) != $cameraGroup->password) {
            throw new WebReport_Exception('Invalid username for camera group "' . $cameraGroup->name . '" (user $username).', WebReport_Api::CODE_INVALID_PARAMETERS);
        }

        $camerasDb = new Core_Model_Cameras();

        $select = $camerasDb->select();
        $select
            ->where('name = ?', $cameraName)
            ->where('camera_group_id = ?', $cameraGroup->camera_group_id)
            ->order("last_date DESC")
            ->limit(1);

        $camera = $camerasDb->fetchRow($select);

        $db = Zend_Registry::get('db');

        $dbTime = date('Y-m-d H:i:s', strtotime($cnttime));

        if (!$camera) {
            $application = new Core_Model_Application_Heatmap();

            // @todo What if the camera changes the application but keeps the name?
            if (array_key_exists('HTTP_X_FORWARDED_FOR', $_SERVER)) {
                $IParray=array_values(array_filter(explode(',',$_SERVER['HTTP_X_FORWARDED_FOR'])));
                $CAM_IP=reset($IParray);
            } else if (array_key_exists('REMOTE_ADDR', $_SERVER)) {
                $CAM_IP=$_SERVER["REMOTE_ADDR"];
            } else {
                $CAM_IP="";
            }
            $IP_clean = filter_var($CAM_IP, FILTER_VALIDATE_IP, FILTER_FLAG_IPV4);
            if (!strlen($IP_clean))
                $IP_clean = "Unknown";
            $cameraData = array(
                    'name' => $cameraName,
                    'ip' => $IP_clean,
                    'serial' => $serial,
                    'camera_group_id' => $cameraGroup->camera_group_id,
                    'application_id' => $application->getId(),
                    'first_date' => $dbTime
                    );
            $camera = $camerasDb->createRow($cameraData);
            $camera->save();
        }

        $cameraId = $camera->camera_id;

        $heatmapsDb = new Heatmap_Model_Heatmaps();
        $select = $heatmapsDb->select()
            ->where('time = ?', $dbTime)
            ->where('delta = ?', $delta)
            ->where('camera_id = ?', $cameraId);
        $heatmap = $heatmapsDb->fetchRow($select);

        $dataAll = "";
        $dataOddRows = "";
        $dataEvenRows = "";
        $dataDown4 = "";

        $ds = 4;
        $hmpArray = array_values($hmpValues);
        // simple resize with 4x4 block mean
        for ($y = 0; $y < $hmpDims[1]/$ds; $y++) {
            for ($x = 0; $x < $hmpDims[0]/$ds; $x++) {
                $summed = 0;
                for ($y1 = 0; $y1 < $ds; $y1++) {
                    for ($x1 = 0; $x1 < $ds; $x1++) {
                        $ind = $x*$ds + $x1 + ($y*$ds*$hmpDims[0] + $y1);
                        $summed = $summed + $hmpArray[$ind];
                    }
                }
                $summed = $summed/($ds*$ds);
                $dataDown4 .= str_pad(dechex($summed), 2, "0", STR_PAD_LEFT);
            }
        }

        $count = 0;
        foreach ($hmpValues as $value) {
            $value = str_pad(dechex($value), 2, "0", STR_PAD_LEFT);
            $dataAll .= $value;
            if ((int) floor($count / $hmpDims[0]) % 2 == 0) {
                $dataOddRows .= $value;
            } else {
                $dataEvenRows .= $value;
            }
            $count++;
        }

        $heatmap_mask_id = NULL;
        if($hasMask) {
            $maskDb = new Heatmap_Model_Masks();
            $heatmap_mask_id = $maskDb->insertUniqueAutoMask($camera, $hmpMask);
        }

        if (!$heatmap) {
            $heatmapData = array(
                    'camera_id' => $cameraId,
                    'time' => $dbTime,
                    'width' => $hmpDims[0],
                    'height' => $hmpDims[1],
                    'image_width' => $imDims[0],
                    'image_height' => $imDims[1],
                    'max' => $max,
                    'num_sum' => 1,
                    'delta' => $delta,
                    'data' => $dataAll,
                    'data_ds4' => $dataDown4,
                    'heatmap_mask_id' => $heatmap_mask_id
                    );
            $heatmap = $heatmapsDb->createRow($heatmapData);
            $heatmap->save();
        } else {
            $heatmap->data = $dataAll;
            $heatmap->data_ds4 = $dataDown4;

            $heatmap->save();
        }

        $camera->last_date = $dbTime;
        $camera->save();



        $hours = substr($cnttime, 8, 2);
        $minutes = substr($cnttime, 10, 2);

        $mapBaseSelect = $heatmapsDb->select()
            ->where("camera_id = ?", $cameraId)
            ->where("delta = :delta")
            ->where("time = ?", $dbTime);


        // ready with a quarter
        if ($minutes == "00" || $minutes == "15" || $minutes == "30" || $minutes == "45") {

            $map = $heatmapsDb->fetchRow($mapBaseSelect->bind(array(":delta" => 15*60)));

            if (!$map) {
                $map = $heatmapsDb->createRow();
                $map->time = $dbTime;
                $map->delta = 60*15;
                $map->camera_id = $cameraId;
            }

            $maps = $heatmapsDb->fetchAll($heatmapsDb->select()
                    ->where("camera_id = ?", $cameraId)
                    ->where("time > DATE_SUB(STR_TO_DATE(?,'%Y%m%d%H%i%s'), INTERVAL '15' MINUTE)", $cnttime)
                    ->where("time <= STR_TO_DATE(?,'%Y%m%d%H%i%s')", $cnttime)
                    ->where("delta = ?", 5*60)
                    ->order("time")
                    );

            $map->mean($maps);
            $map->heatmap_mask_id = $heatmap_mask_id;
            $map->save();

            // ready with half hour
            if ($minutes == "00" || $minutes == "30") {

                $map = $heatmapsDb->fetchRow($mapBaseSelect->bind(array(":delta" => 30*60)));

                if (!$map) {
                    $map = $heatmapsDb->createRow();
                    $map->time = $dbTime;
                    $map->delta = 60*30;
                    $map->camera_id = $cameraId;
                }

                $maps = $heatmapsDb->fetchAll($heatmapsDb->select()
                        ->where("camera_id = ?", $cameraId)
                        ->where("time > DATE_SUB(STR_TO_DATE(?,'%Y%m%d%H%i%s'), INTERVAL '30' MINUTE)", $cnttime)
                        ->where("time <= STR_TO_DATE(?,'%Y%m%d%H%i%s')", $cnttime)
                        ->where("delta = ?", 15*60)
                        ->order("time")
                        );

                $map->mean($maps);
                $map->heatmap_mask_id = $heatmap_mask_id;
                $map->save();

                // ready with hour
                if ($minutes == "00") {

                    $map = $heatmapsDb->fetchRow($mapBaseSelect->bind(array(":delta" => 60*60)));

                    if (!$map) {
                        $map = $heatmapsDb->createRow();
                        $map->time = $dbTime;
                        $map->delta = 60*60;
                        $map->camera_id = $cameraId;
                    }

                    $maps = $heatmapsDb->fetchAll($heatmapsDb->select()
                            ->where("camera_id = ?", $cameraId)
                            ->where("time > DATE_SUB(STR_TO_DATE(?,'%Y%m%d%H%i%s'), INTERVAL '1' HOUR)", $cnttime)
                            ->where("time <= STR_TO_DATE(?,'%Y%m%d%H%i%s')", $cnttime)
                            ->where("delta = ?", 30*60)
                            ->order("time")
                            );

                    $map->mean($maps);
                    $map->heatmap_mask_id = $heatmap_mask_id;
                    $map->save();
                }

            }
        }

        // ready with 3 hours
        if ($minutes == "00" &&
                in_array($hours, array("00", "03", "06", "09", "12", "15", "18", "21")))
        {

            $map = $heatmapsDb->fetchRow($mapBaseSelect->bind(array(":delta" => 60*60*3)));

            if (!$map) {
                $map = $heatmapsDb->createRow();
                $map->time = $dbTime;
                $map->delta = 60*60*3;
                $map->camera_id = $cameraId;
            }

            $maps = $heatmapsDb->fetchAll($heatmapsDb->select()
                    ->where("camera_id = ?", $cameraId)
                    ->where("time > DATE_SUB(STR_TO_DATE(?,'%Y%m%d%H%i%s'), INTERVAL '3' HOUR)", $cnttime)
                    ->where("time <= STR_TO_DATE(?,'%Y%m%d%H%i%s')", $cnttime)
                    ->where("delta = ?", 60*60)
                    ->order("time")
                    );

            $map->mean($maps);
            $map->heatmap_mask_id = $heatmap_mask_id;
            $map->save();

            // ready with 6 hours
            if ($minutes == "00" &&
                    in_array($hours, array("00", "06", "12", "18")))
            {


                $map = $heatmapsDb->fetchRow($mapBaseSelect->bind(array(":delta" => 60*60*6)));

                if (!$map) {
                    $map = $heatmapsDb->createRow();
                    $map->time = $dbTime;
                    $map->delta = 60*60*6;
                    $map->camera_id = $cameraId;
                }

                $maps = $heatmapsDb->fetchAll($heatmapsDb->select()
                        ->where("camera_id = ?", $cameraId)
                        ->where("time > DATE_SUB(STR_TO_DATE(?,'%Y%m%d%H%i%s'), INTERVAL '6' HOUR)", $cnttime)
                        ->where("time <= STR_TO_DATE(?,'%Y%m%d%H%i%s')", $cnttime)
                        ->where("delta = ?", 60*60*3)
                        ->order("time")
                        );

                $map->mean($maps);
                $map->heatmap_mask_id = $heatmap_mask_id;
                $map->save();


                // ready with 12 hours
                if ($minutes == "00" &&
                        in_array($hours, array("00", "12")))
                {

                    $map = $heatmapsDb->fetchRow($mapBaseSelect->bind(array(":delta" => 60*60*12)));

                    if (!$map) {
                        $map = $heatmapsDb->createRow();
                        $map->time = $dbTime;
                        $map->delta = 60*60*12;
                        $map->camera_id = $cameraId;
                    }

                    $maps = $heatmapsDb->fetchAll($heatmapsDb->select()
                            ->where("camera_id = ?", $cameraId)
                            ->where("time > DATE_SUB(STR_TO_DATE(?,'%Y%m%d%H%i%s'), INTERVAL '12' HOUR)", $cnttime)
                            ->where("time <= STR_TO_DATE(?,'%Y%m%d%H%i%s')", $cnttime)
                            ->where("delta = ?", 60*60*6)
                            ->order("time")
                            );

                    $map->mean($maps);
                    $map->heatmap_mask_id = $heatmap_mask_id;
                    $map->save();


                    // ready with 1 day
                    if ($minutes == "00" && $hours == "00")
                    {

                        $map = $heatmapsDb->fetchRow($mapBaseSelect->bind(array(":delta" => 60*60*24)));

                        if (!$map) {
                            $map = $heatmapsDb->createRow();
                            $map->time = $dbTime;
                            $map->delta = 60*60*24;
                            $map->camera_id = $cameraId;
                        }

                        $maps = $heatmapsDb->fetchAll($heatmapsDb->select()
                                ->where("camera_id = ?", $cameraId)
                                ->where("time > DATE_SUB(STR_TO_DATE(?,'%Y%m%d%H%i%s'), INTERVAL '24' HOUR)", $cnttime)
                                ->where("time <= STR_TO_DATE(?,'%Y%m%d%H%i%s')", $cnttime)
                                ->where("delta = ?", 60*60*12)
                                ->order("time")
                                );

                        $map->mean($maps);
                        $map->heatmap_mask_id = $heatmap_mask_id;
                        $map->save();

                    }
                }
            }

        }

    }

    protected function _uploadCameraImage()
    {
        $decrypted = $this->_readFromInputAndDecrypt();
        if ($decrypted == null) {
            throw new WebReport_Api_Exception("cm_decrypt failed, invalid license");
        }

        $header = "";
        $body = "";
        $boundary = "webreport-1337"; // @todo: parse boundary
        Zend_Mime_Decode::splitMessage($decrypted, $header, $body);
        $parts = Zend_Mime_Decode::splitMessageStruct($body, $boundary);
        if (count($parts) != 2) {
            throw new WebReport_Api_Exception("There must be two parts in mime", WebReport_Api::CODE_INVALID_PARAMETERS);
        }

        $groupInfo = $parts[0]['body'];

        $groupParts = explode("##", $groupInfo);
        if (count($groupParts) != 6) {
            throw new WebReport_Api_Exception("Invalid data: " + $groupInfo, WebReport_Api::CODE_INVALID_PARAMETERS);
        }

        $user = $groupParts[0];
        $pass = $groupParts[1];
        $version = $groupParts[2];
        if (intval($version, 10) != 1) {
            throw new WebReport_Api_Exception("Invalid version: " . $version, WebReport_Api::CODE_INVALID_PARAMETERS);
        }
        $cameraName = $groupParts[3];
        $serial = $groupParts[4];
        $time = $groupParts[5];

        $jpeg = base64_decode($parts[1]['body']);

        return Core_Model_Cameras::addImage($user, $pass, $cameraName, $serial, $time, $jpeg);
    }

    /*
     * TODO: implement this
     */
    /*
       protected function _addCameraError()
       {
       $encrypted = $this->_readFromInputAndDecrypt();

       $camerasModel = new Core_Model_Cameras();

       return Core_Model_CountData::addDataForSeparatedString($decrypted);
       }
     */

}

