<?php
class Charts_IndexController extends WebReport_Controller_Action {

	protected $_validDataTypes = array("application", "custom");

	public function init()
	{
		parent::init();

		$module = $this->getRequest()->module;
		$controller = $this->getRequest()->controller;
		$action = $this->getRequest()->action;

		$items = array();
		$items[] = array("urlOptions" => array('module' => $module, "controller" => $controller, "action" => "browse"), "text" => 'BROWSE_CHARTS');
		$items[] = array("urlOptions" => array('type' => "custom"), "route" => "charts_add", "text" => 'ADD_CUSTOM_CHART', "activeConditions" => array("type" => "custom"));
		$items[] = array("urlOptions" => array('module' => $module, "controller" => $controller, "action" => "aggtest"), "text" => 'AGGREGATE_TEST');

		$items = WebReport_Module_MenuItems_Abstract::filterNotAllowedItems($items);
		$this->view->menu->submenu = WebReport_Module_MenuItems_Abstract::translate($items);
		
		$this->view->headTitle("CHARTS", Zend_View_Helper_Placeholder_Container_Abstract::PREPEND);

		$this->view->type = $this->_getParam('type');
		$this->view->id = $this->_getParam('id');
	}
        
        public function aggtestAction()
        {
            //SHOULD NOT BE USED IN PRODUCTION
            $identity = Zend_Auth::getInstance()->getIdentity();
            $companies = new Core_Model_Companies();
            $company = $companies->find($identity->company_id)->current();

            $form = new Charts_Form_Aggtest($company);
            
            $this->view->form = $form;

            if(!$this->getRequest()->isPost()) {
                return;
            }
            $this->view = null;
            
            $a = new CM_Interval(new Zend_Date(), '0m');
            
            Zend_Debug::dump(array($a->getStartDate(), $a->getStopDate()));
            
            /*$aggregator = new Charts_Model_DataAggregator_HistSum();

            $cd_sets = new Core_Model_CountData_Sets();

            $cd_set = $cd_sets->find($this->_getParam('count_data_set_id'))->current();
            #$cd = $cd_set->getCountData();

            $aggregator->setData($cd_set);
            

            $aggregator->setHistogramMode((int) $this->_getParam('hist_mode'), (int) $this->_getParam('relative'));
            
            Zend_Debug::dump($aggregator->renderData());
            Zend_Debug::dump($aggregator->getDataLabels());
            Zend_Debug::dump($aggregator->getXLabel());

            //rudimentary sample only ...
            $chart = new CM_Charting();
            $rd = $aggregator->renderData();
            foreach ($aggregator->getDataLabels() as $key => $value) {
                $dpts = array();
                foreach ($rd as $dp) {
                    $dpts[] = $dp->$key;
                }
                $chart->addData(new CM_ChartData("bar", $dpts, $value));
            }

            $xlabels = $aggregator->getXLabel();
            $xlabel = "Time";
            $chart->setXlabel($xlabels, $xlabel);

            Zend_Debug::dump($aggregator->dumpJSON());

            $data_aggregators = new Charts_Model_DataAggregatorList();
            $rows = $data_aggregators->fetchAll();

            $chart->toFile("/tmp/testing.png", 535*2.54, 732*2.54, "Test chart");
            //$chart->stroke(1200,400,"Test Chart");*/

        }


	public function browseAction()
	{

		$customChartsDb = new Charts_Model_CustomCharts();

		$applicationsModel = new Core_Model_Applications();
		$this->view->applicationCharts = $applicationsModel->fetchAllWithCountData();

		$db = Zend_Registry::get('db');

		$identity = Zend_Auth::getInstance()->getIdentity();
		if ($identity->multi_company && Zend_Registry::get('config')->general->multiCompanyUsersCanManageDataForAllRoles) {
			$this->view->customCharts = $customChartsDb->fetchAllCustomCharts();
		} else {
			$companiesDb = new Core_Model_Companies();
			$company = $companiesDb->find($identity->company_id)->current();
			$usersDb = new Core_Model_Users();
			$user = $usersDb->find($identity->user_id)->current();
			$this->view->customCharts = $customChartsDb->fetchAllCustomCharts($company, $user);
		}
		

		if ($this->_flashMessenger->hasMessages())
			$this->view->messages = $this->_flashMessenger->getMessages();
	}


	public function viewAction()
	{
		$validDataTypes = $this->_validDataTypes;
		
		$this->view->dataType = $dataType = (string)$this->_getParam('type');
		$id = (int)$this->_getParam('id');

		if (!$id || !in_array($dataType, $validDataTypes)) {
			throw new WebReport_Exception_ParameterError("CHART_NOT_FOUND.");
		}

		$form = new UniForm_Form(); // force include of uni-form css

		$identity = Zend_Auth::getInstance()->getIdentity();

		if (!$this->getRequest()->isPost()) {
			$timeResolutionSelected = "ts1h"; // hour
		} else {
			$timeResolutionSelected = $_POST['time-resolution'];
		}
		$applicationsModel = new Core_Model_Applications();

		$this->view->timeResolutionSelected = $timeResolutionSelected;
		
		$toMuchData = false;

		if ($dataType == 'application') {
			$this->view->headTitle("APPLICATION_CHART", Zend_View_Helper_Placeholder_Container_Abstract::PREPEND);

			$application = $applicationsModel->findWithId($id);

			if (!$application) {
				throw new WebReport_Exception_ParameterError("APPLICATION_NOT_FOUND");
			}

			$this->view->headTitle($application->getShortName(), Zend_View_Helper_Placeholder_Container_Abstract::PREPEND);
			$this->view->title = $application->getName() . " <span>(" . $this->_translate->_('APPLICATION_CHART') . ")</span>";
			$companiesDb = new Core_Model_Companies();
			$company = $companiesDb->find(Zend_Auth::getInstance()->getStorage()->read()->company_id)->current();
			
			$camerasDb = new Core_Model_Cameras();
			$virtualCamerasDb = new Core_Model_VirtualCameras();
			$cameras = $camerasDb->getCameraNames($application, $company);
			$virtualCameras = $virtualCamerasDb->getCameraNames($application, $company);
			$countTypes = $application->getOutTypes();

			if (!$this->getRequest()->isPost()) {
				$camerasSelected = array_keys(array_slice($cameras, 0, min(count($cameras), 5), true));
				$virtualCamerasSelected = array();
				$countTypesSelected = array_keys($countTypes);
				$chartTypeSelected = 'line';
			} else {
				$camerasSelected = empty($_POST['cameras'])  ? array() : $_POST['cameras'];
				$virtualCamerasSelected = empty($_POST['virtual-cameras']) ? array() : $_POST['virtual-cameras'];
				$countTypesSelected = $_POST['count-types'];
				$chartTypeSelected = $_POST['chart-type'];
			}
			$filterGroupsDb = new Core_Model_CountData_FilterGroups();
			$filterGroup = $filterGroupsDb->createRow();
			$filters = new Core_Model_CountData_Filters();

			$countData = new Core_Model_CountData();

			$allowedCameraIds = array_keys($camerasDb->getCameraNames(null, $company));
			if (count($camerasSelected) > 0) {
				$cameraAllowedIds = array();
				foreach ($camerasSelected as $camId) {
					if (in_array($camId, $allowedCameraIds)) {
						$cameraAllowedIds[] = $camId;
					}
				}
				if (count($cameraAllowedIds) > 0) {
					$camerasRows = $camerasDb->find($cameraAllowedIds);
					$countData->addCameras($camerasRows, $countTypesSelected);
				}
			}

			if (count($virtualCamerasSelected) > 0) {
				$virtualCameraRows = $virtualCamerasDb->find($virtualCamerasSelected);
				foreach ($virtualCameraRows as $virtualCamera) {
					if ($identity->company_id == $virtualCamera->company_id) {
						$countData->addVirtualCamera($virtualCamera, $countTypesSelected);
					}
				}
			}
			$noFieldsToSelect = false;
			try {
				$countData->initDatabaseSelect();
				$firstDate = $countData->getFirstDate();
				$lastDate = $countData->getLastDate();
			} catch (WebReport_Exception_NoFieldsToSelect $e) {
				$lastDate = new Zend_Date();
				$firstDate = new Zend_Date();
				$firstDate->sub(7, Zend_Date::DAY);
				$noFieldsToSelect = true;
			}
		

			if (!$this->getRequest()->isPost()) {
				$sevenDaysBeforeLast = clone $lastDate;
				$sevenDaysBeforeLast->sub(7, Zend_Date::DAY);

				if ($sevenDaysBeforeLast->compare($firstDate) > 0) {
					$firstDateSelected = $sevenDaysBeforeLast;
				} else {
					$firstDateSelected = $firstDate;
				}
				
				$lastDateSelected = $lastDate;
			} else {
				$dataFirstDate = $countData->getFirstDate();
				$firstDateSelected = new Zend_Date(new Zend_Locale('en_IE'));
                                if(empty($_POST['time-interval-start']))
                                {
                                    $firstDateSelected = $dataFirstDate;
                                } else {
                                    $firstDateSelected->setDate($_POST['time-interval-start'], "yyyy-MM-dd");
                                    if ($dataFirstDate->isLater($firstDateSelected)) {
    					$firstDateSelected = $dataFirstDate;
                                    }
                                }

				$lastDateSelected = new Zend_Date(new Zend_Locale('en_IE'));
				$dataLastDate = $countData->getLastDate();
                                if(empty($_POST['time-interval-stop']))
                                {
                                    $lastDateSelected = $dataLastDate;
                                } else {
                                    $lastDateSelected->setDate($_POST['time-interval-stop'], "yyyy-MM-dd");
				
                                    if ($dataLastDate->isEarlier($lastDateSelected)) {
					$lastDateSelected = $dataLastDate;
                                    }
                                }

			}

			$data = array();
			if (!$noFieldsToSelect) {
				if($countData->canGetData($timeResolutionSelected, $firstDateSelected, $lastDateSelected)){
				    $data = $countData->getData($timeResolutionSelected, $firstDateSelected, $lastDateSelected);
				}else{
				    $toMuchData = true;
				}
			} 
			
			if (isset($_POST['format']) && $_POST['format'] != '') {
				$format = $_POST['format'];
				$this->_helper->layout->disableLayout();    //disable layout
				$this->_helper->viewRenderer->setNoRender(); //suppress auto-rendering
				$export = WebReport_Export_Abstract::factory($format);
				$descriptions = $countData->getDescriptionsForLastFetchedData();
				$export->setHeaders($descriptions)->setData($data);
				$export->render();

				return;
			}


			$this->view->cameras = $cameras;
			$this->view->camerasSelected = $camerasSelected;
			$this->view->virtualCameras = $virtualCameras;
			$this->view->virtualCamerasSelected = $virtualCamerasSelected;

			$this->view->countTypes = $countTypes;
			$this->view->countTypesSelected = $countTypesSelected;

			$chart = new Charts_Model_Chart_Application($chartTypeSelected);

			$timeResolutions = $application->getTimeResolutions();
			$this->view->timeResolutions = $timeResolutions;

		} elseif ($dataType == 'custom') {
			$this->view->headTitle("CUSTOM_CHART", Zend_View_Helper_Placeholder_Container_Abstract::PREPEND);

			$chartsDb = new Charts_Model_CustomCharts();
			$select = $chartsDb->getAdapter()->select(); 
			$customChartAclRoleDb = new Charts_Model_CustomChartAclRole();
			// first check against acl
			
			if ($identity->multi_company && Zend_Registry::get('config')->general->multiCompanyUsersCanManageDataForAllRoles) {
				$aclChartRow = true;
			} else {

				$select->from(array("c" => $chartsDb->info(Zend_Db_Table::NAME)), array("custom_chart_id"))
					->join(array("aclr" => $customChartAclRoleDb->info(Zend_Db_Table::NAME)), "aclr.custom_chart_id = c.custom_chart_id", array())
					->where("acl_role_id = ?", $identity->acl_role_id)
					->where("c.custom_chart_id = ?", $id);

				$aclChartRow = $chartsDb->getAdapter()->fetchRow($select);

			}

			$chartRow = $chartsDb->find($id)->current();

			if (!$aclChartRow || !$chartRow) {
				throw new WebReport_Exception("CHART_NOT_FOUND.");
			}

			$countDataSet = $chartRow->findParentRow("Core_Model_CountData_Sets");

			$application = $applicationsModel->findWithId($countDataSet->application_id);

			if (!$application) {
				throw new WebReport_Exception_ParameterError("APPLICATION_NOT_FOUND");
			}

			$this->view->headTitle($chartRow->name, Zend_View_Helper_Placeholder_Container_Abstract::PREPEND);

			$companiesDb = new Core_Model_Companies();
			$company = $companiesDb->find($chartRow->company_id)->current();

			$application = $applicationsModel->findWithId($countDataSet->application_id);
			$company = $companiesDb->find($chartRow->company_id)->current();
			
			$this->view->title = $chartRow->name. " <span>(" . $this->_translate->_("CUSTOM_CHART") . ")</span>";


			$countData = $countDataSet->getCountData();

			$noFieldsToSelect = false;
			try {
				$countData->initDatabaseSelect();
				$firstDate = $countData->getFirstDate();
				$lastDate = $countData->getLastDate();
			} catch (WebReport_Exception_NoFieldsToSelect $e) {
				$lastDate = new Zend_Date();
				$firstDate = new Zend_Date();
				$firstDate->sub(7, Zend_Date::DAY);
				$noFieldsToSelect = true;
			}


			if (!$this->getRequest()->isPost()) {
				$sevenDaysBeforeLast = clone $lastDate;
				$sevenDaysBeforeLast->sub(7, Zend_Date::DAY);

				if ($sevenDaysBeforeLast->compare($firstDate) > 0) {
					$firstDateSelected = $sevenDaysBeforeLast;
				} else {
					$firstDateSelected = $firstDate;
				}

				$lastDateSelected = $lastDate;
				$chartTypeSelected = $chartRow->default_type;
			} else {
				$firstDateSelected = new Zend_Date(new Zend_Locale('en_IE'));
				$firstDateSelected->setDate($_POST['time-interval-start'], "yyyy-MM-dd");
				$lastDateSelected = new Zend_Date(new Zend_Locale('en_IE'));
				$lastDateSelected->setDate($_POST['time-interval-stop'], "yyyy-MM-dd");
				$chartTypeSelected = $_POST['chart-type'];
			}
			
			$data = array();
			if (!$noFieldsToSelect) {
				if($countData->canGetData($timeResolutionSelected, $firstDateSelected, $lastDateSelected)){
				    $data = $countData->getData($timeResolutionSelected, $firstDateSelected, $lastDateSelected);
				}else{
				    $toMuchData = true;
				}
			} 

			if (isset($_POST['format']) && $_POST['format'] != '') {
				$format = $_POST['format'];
				$this->_helper->layout->disableLayout();    //disable layout
				$this->_helper->viewRenderer->setNoRender(); //suppress auto-rendering
				$export = WebReport_Export_Abstract::factory($format);
				$descriptions = $countData->getDescriptionsForLastFetchedData();
				$export->setHeaders($descriptions)->setData($data);
				$export->render();
				return;
			}

			$chart = new Charts_Model_Chart_Custom($chartTypeSelected);


			$timeResolutions = $application->getTimeResolutions();
			$this->view->timeResolutions = $timeResolutions;

		}

		$dataExists = count($data) > 0;
		$this->view->dataExists = $dataExists;
		$formats = array("CSV", "Excel", "HTML");
		$this->view->formats = $formats;
		$this->view->chartTypeSelected = $chartTypeSelected;
		$this->view->firstDate = $firstDate;
		$this->view->lastDate = $lastDate;
		$this->view->firstDateSelected = $firstDateSelected;
		$this->view->lastDateSelected = $lastDateSelected;
		$this->view->toMuchData = $toMuchData;

		$chart->setData($countData->getDescriptionsForLastFetchedData(),$data, $countData->getGraphOptionsForLastFetchedData());

		if ($dataExists) {

			$settings = $chart->getAmChartObject()->getSettings();

			$moduleOptions = $this->getInvokeArg('bootstrap')->getOption('charts');
			if (array_key_exists("defaultColors", $moduleOptions)) {
				$settings->setColors($moduleOptions['defaultColors']);
			}

			$this->view->headScript()->captureStart(); ?>
			
			$(function() {
				// fix height of chart depending on browser size
				var h = $(window).height() - $("#header").height() - $("#submenu").height() - 80;
				var h = Math.min(Math.max(h, 350), 700);
				$("#chart").height(h);
			});
				
			<?php $this->view->headScript()->captureEnd();
			

			$chart->render();
		}


	}


	public function addAction()
	{
		$dataType = $this->_getParam('type');
		$identity = Zend_Auth::getInstance()->getIdentity();
		if ($dataType == "custom") {

			$this->view->title = $this->_translate->_('ADD_CUSTOM_CHART') . ": " . sprintf($this->_translate->_('STEP_%1$s'), 1);
			$form = new Charts_Form_AddCustomChart();
			if ($this->_request->isPost()) {
				$values = $_POST;
				if ($form->isValid($values)) {

					$customChartsDb = new Charts_Model_CustomCharts();
					$customChart = $customChartsDb->createRow();
					$customChart->name = $values['name'];
					$customChart->company_id = $values['company_id'];
					$customChart->description = $values['description'];
					$customChart->default_type = $values['default_type'];
					$customChart->count_data_set_id = $values['count_data_set_id'];

					$customChart->created_by = $identity->user_id;
					$customChart->created_date = new Zend_Db_Expr('NOW()');
					if (!$identity->multi_company) {
						$customChart->company_id = $identity->company_id;
					}
					$customChart->save();

					$userRoleIdIncluded = false;

					$customChartAclRoleDb = new Charts_Model_CustomChartAclRole();
					foreach ($values['acl_role_id'] as $roleId) {
						if ($roleId == $identity->acl_role_id) {
							$userRoleIdIncluded = true;
						}

						$row = $customChartAclRoleDb->createRow(array(
							'acl_role_id' => $roleId,
							'custom_chart_id' => $customChart->custom_chart_id
						));
						$row->save();
					}
					if ($userRoleIdIncluded || ($identity->multi_company && Zend_Registry::get('config')->general->multiCompanyUsersCanManageDataForAllRoles)) {
						$this->_helper->_redirector->gotoRoute(array("id" => $customChart->custom_chart_id, "type" => "custom"), "charts_view");
					} else {
						$this->_flashMessenger->addMessage($this->_translate->_('CUSTOM_CHART_ADDED.'));
						$this->_helper->redirector('browse','index','charts');
					}
				} else {
					$form->populate($values);
				}
			} 
		} else {
			throw new WebReport_Exception("INVALID_DATA_TYPE.");
		}

		$this->view->form = $form;
	}

	public function editAction()
	{
		$dataType = $this->_getParam('type');

		$id = (int)$this->_getParam("id");
		if (!$id) {
			throw new WebReport_Exception_ParameterError("CHART_NOT_FOUND");
		}
		$identity = Zend_Auth::getInstance()->getIdentity();

		if ($dataType == 'custom') {
			$this->view->title = $this->_translate->_("EDIT_CUSTOM_CHART");
			$this->view->headTitle("EDIT_CUSTOM_CHART", Zend_View_Helper_Placeholder_Container_Abstract::PREPEND);
			
			$chartsDb = new Charts_Model_CustomCharts();
			$chartAclRolesDb = new Charts_Model_CustomChartAclRole();
			$chart = $chartsDb->find($id)->current();

			if (!$chart) {
				throw new WebReport_Exception_ParameterError("CHART_NOT_FOUND");
			}

			$applicationsModel = new Core_Model_Applications();
			$countDataSet = $chart->findParentRow("Core_Model_CountData_Sets");
			$application = $applicationsModel->findWithId($countDataSet->application_id);
			$companiesDb = new Core_Model_Companies();
			$company = $companiesDb->find($chart->company_id)->current();
			$form = new Charts_Form_EditCustomChart($application, $company);

			if ($this->getRequest()->isPost()) {

				if ($form->isValid($_POST)) {
					$values = $form->getValues();

					$chart->name = $values['name'];
					$chart->count_data_set_id = $values['count_data_set_id'];
					$chart->default_type = $values['default_type'];
					$chart->description = $values['description'];

					$chart->save();
					$chartId = $chart->custom_chart_id;


					$userRoleIdIncluded = false;

					$chartAclRolesDb->delete($chartAclRolesDb->getAdapter()->quoteInto('custom_chart_id = ?', $id));
					foreach ($values['acl_role_id'] as $aclRoleId) {
						if ($roleId == $identity->acl_role_id) {
							$userRoleIdIncluded = true;
						}

						$aclDataArray = array(
							'acl_role_id' => $aclRoleId,
							'custom_chart_id' => $chartId
						);
						$aclRow = $chartAclRolesDb->createRow($aclDataArray);
						$aclRow->save();
					}

					if ($userRoleIdIncluded || ($identity->multi_company && Zend_Registry::get('config')->general->multiCompanyUsersCanManageDataForAllRoles)) {
						$this->_helper->_redirector->gotoRoute(array("id" => $chartId, "type" => "custom"), "charts_view");
					} else {
						$this->_flashMessenger->addMessage($this->_translate->_('CUSTOM_CHART_UPDATED.'));
						$this->_helper->redirector('browse','index','charts');
					}

					


				} else {
					$form->populate($_POST);
				}
			} else {
				$pop = array();
				$pop += $chart->toArray();

				$aclRoles = $chartAclRolesDb->fetchAll($chartAclRolesDb->select()->where('custom_chart_id = ?', $chart->custom_chart_id));
				foreach ($aclRoles as $role) {
					$pop['acl_role_id'][] = $role->acl_role_id;
				}

				$form->populate($pop);
			}

		} else {
			throw new WebReport_Exception("Invalid data type.");
		}

		$this->view->form = $form;
	}

	public function deleteAction()
	{

		$dataType = $this->_getParam('type');

		$id = (int)$this->_getParam("id");
		if (!$id) {
			throw new WebReport_Exception_ParameterError("CHART_NOT_FOUND");
		}

		$identity = Zend_Auth::getInstance()->getIdentity();

		if ($dataType == 'custom') {
			$chartsDb = new Charts_Model_CustomCharts();
			$chartAclRolesDb = new Charts_Model_CustomChartAclRole();

			$chart = $chartsDb->find($id)->current();

			if (!$chart) {
				throw new WebReport_Exception_ParameterError("CHART_NOT_FOUND");
			}

			if (
				($identity->multi_company && !Zend_Registry::get('config')->general->multiCompanyUsersCanManageDataForAllRoles)
				||
				(!$identity->multi_company && $chart->company_id != $identity->company_id)
			) {
				// make sure the user have a good acl role
				$aclRow = $chartAclRolesDb->fetchRow($chartAclRolesDb->select()->where('custom_chart_id = ?', $id)->where('acl_role_id = ?', $identity->acl_role_id));
				if (!$aclRow) {
					throw new WebReport_Exception_ParameterError("CHART_NOT_FOUND");
				}
			}

			$this->_flashMessenger->addMessage($this->_translate->_('CUSTOM_CHART_DELETED.'));
			$chart->delete();

		} else {
			throw new WebReport_Exception("INVALID_DATA_TYPE.");
		}

		$this->_helper->redirector('browse','index','charts');

	}

public function toImageAction()
        {

                $validDataTypes = $this->_validDataTypes;

                $this->view->dataType = $dataType = (string)$this->_getParam('type');

                if (!in_array($dataType, $validDataTypes)) {
                        throw new WebReport_Exception_ParameterError("INVALID_DATA_TYPE.");
                }

                $this->_helper->layout->disableLayout();    //disable layout
                $this->_helper->viewRenderer->setNoRender(); //suppress auto-rendering

                // amcharts.com export to image utility
                // set image type (gif/png/jpeg)
                $imgtype = 'jpeg';

                // set image quality (from 0 to 100, not applicable to gif)
                $imgquality = 100;
               // get data from $_POST or $_GET ?
                $data = &$_POST;

                // get image dimensions
                $width  = (int) $data['width'];
                $height = (int) $data['height'];

                // create image object
                $img = imagecreatetruecolor($width, $height);

                // populate image with pixels
                for ($y = 0; $y < $height; $y++) {
                        // initialize
                        $x = 0;

                        // get row data
                        $row = explode(',', $data['r'.$y]);
                       // place row pixels
                        $cnt = sizeof($row);
                        for ($r = 0; $r < $cnt; $r++) {
                                // get pixel(s) data
                                $pixel = explode(':', $row[$r]);

                                // get color
                                $pixel[0] = str_pad($pixel[0], 6, '0', STR_PAD_LEFT);
                                $cr = hexdec(substr($pixel[0], 0, 2));
                                $cg = hexdec(substr($pixel[0], 2, 2));
                                $cb = hexdec(substr($pixel[0], 4, 2));
                                // allocate color
                                $color = imagecolorallocate($img, $cr, $cg, $cb);

                                // place repeating pixels
                                $repeat = isset($pixel[1]) ? (int) $pixel[1] : 1;
                                for ($c = 0; $c < $repeat; $c++) {
                                        // place pixel
                                        imagesetpixel($img, $x, $y, $color);
                                       // iterate column
                                        $x++;
                                }
                        }
                }

                // set proper content type
                header('Content-type: image/'.$imgtype);
                header('Content-Disposition: attachment; filename="chart.'.$imgtype.'"');

                // stream image
                $function = 'image'.$imgtype;
                if ($imgtype == 'gif') {
                        $function($img);
                } else {
                        $function($img, null, $imgquality);
                }

                // destroy
                imagedestroy($img);
	}


	private function _stringsToTranslate()
	{
		$this->_translate->_('MOD_CHARTS_NAME');
		$this->_translate->_('BROWSE_CHARTS');
		$this->_translate->_('CHARTS');
		$this->_translate->_('TOO_MANY_DATA_POINTS_CHOSEN._TRY_DECREASING_THE_TIME_RESOLUTION.');
		$this->_translate->_('APPLICATION_CHART');
		$this->_translate->_('DEFAULT_CHART_TYPE');
		$this->_translate->_('CHART_NAME');
		$this->_translate->_('FORMULAS');
		$this->_translate->_('UPDATE');
		$this->_translate->_('COMMON');
		$this->_translate->_('VIEW_CHARTS');
		$this->_translate->_('VIEW_TRUEVIEW_APPLICATIONS');
		$this->_translate->_('EXPORT_TO_IMAGE');
		$this->_translate->_('LINE_CHART');
		$this->_translate->_('LINE_CHARTS');
		$this->_translate->_("PIE_CHART");
		$this->_translate->_("PIE_CHARTS");
		$this->_translate->_("ROLES_ALLOWED_TO_SEE_THE_CHART");
	}

}
