<?php

class Charts_Form_EditCustomChart extends UniForm_Form
{

	protected $_application;
	protected $_company;

	/**
	 * Constructor
	 *
	 * @see Zend_Form
	 * @param string $action Can be new or edit
	 * @param mixed $options
	 * @return void
	 */
	public function __construct($application, Core_Model_Company $company, $options = null)
	{
		$this->_application = $application;
		$this->_company = $company;
		parent::__construct($options);
	}

	public function init()
	{
		parent::init();


		$application = $this->_application;
		$company = $this->_company;

		$name = new UniForm_Form_Element_Text('name');
		$name->setLabel('CHART_NAME')
			->setRequired()
			->addFilter('StringTrim');

		$companiesDb = new Core_Model_Companies();

		$countDataSetsDb = new Core_Model_CountData_Sets();
		$countDataSets = $countDataSetsDb->fetchAll($countDataSetsDb->select()->where('company_id = ?', $company->company_id));

		$count_data_set_id = $countDataSets->getFormElement('count_data_set_id', "COUNT_DATA_SET", true);

		$type = new UniForm_Form_Element_Radio('default_type');
		$type->setLabel('DEFAULT_CHART_TYPE');
		$type->addMultiOption('line','LINE_CHART');
		$type->addMultiOption('column','COLUMN_CHART');
//		$type->addMultiOption('pie','PIE_CHART');
		$type->setRequired();

		$aclRolesDb = new Core_Model_AclRoles();
		$roles = $aclRolesDb->fetchAll($aclRolesDb->select()->where('company_id = ?', $company->company_id)->order('name'));
		$acl_role_id = new UniForm_Form_Element_MultiCheckbox('acl_role_id');
		$acl_role_id->setRequired()
			->setLabel('ROLES_ALLOWED_TO_SEE_THE_CHART');

		foreach ($roles as $role) {
			$acl_role_id->addMultiOption($role->acl_role_id, $role->name);
		}

		$description = new UniForm_Form_Element_Textarea('description');
		$description->setLabel('DESCRIPTION')
			->addFilter('StringTrim');



		$submit = new UniForm_Form_Element_Submit('submit');
		$submit->setLabel('SUBMIT');

		$this->addElements(array($name, $type, $count_data_set_id, $acl_role_id, $description));
		$this->addDisplayGroup(array('name', 'count_data_set_id', 'default_type', 'acl_role_id', 'description'), 'chart-group');


		$this->addElements(array($submit));
	}

}
