<?php

class Charts_Form_ExportChart extends UniForm_Form
{

    protected $_action;

    /**
     * Constructor
     *
     * @see Zend_Form
     * @param string $action Can be new or edit
     * @param mixed $options
     * @return void
     */
    public function __construct($action = null, $options = null)
    {
        $this->_action = $action;
        parent::__construct($options);
    }


    public function init()
    {
        parent::init();
        $format = new UniForm_Form_Element_Select('format');

        $format
            ->setLabel("EXPORT_TYPE");
        foreach(Charts_Model_ChartRenders::getRenders() as $k => $v)
            $format->addMultiOption($k, $v);

        $export_chart = array('format');
        
        if($this->_action == 'view') {
            $permalink = new UniForm_Form_Element_Checkbox('permalink');
            $permalink
		      ->setLabel(_T('GENERATE_PERMALINK'));
            $export_chart[] = 'permalink';
            $this->addElements(array($permalink));
            $embed = new UniForm_Form_Element_Checkbox('embed');
            $embed
		      ->setLabel(_T("EMBED_IN_HTML"));
            $export_chart[] = 'embed';
            $this->addElements(array($embed));
        }


        $export = new UniForm_Form_Element_Submit('export');
        $export->setLabel('EXPORT');
        $this->addElements(array($format));

        $this->addDisplayGroup($export_chart,'export_chart');
        $this->addElements(array($export));
    }
}


