<?php

class Charts_Form_ExportTableForm extends UniForm_Form
{

    protected $_action;

    /**
     * Constructor
     *
     * @see Zend_Form
     * @param string $action Can be new or edit
     * @param mixed $options
     * @return void
     */
    public function __construct($action = "view", $options = null)
    {
        $this->_action = $action;
        parent::__construct($options);
    }


    public function init()
    {
        parent::init();
        $format = new UniForm_Form_Element_Select('format');

        $format
            ->setLabel("EXPORT_TYPE")
            ->addMultiOption("csv", _T("CSV"))
            ->addMultiOption("html", _T("HTML"));
            /*
            ->addMultiOption("json", _T("JSON"))
            ->addMultiOption("excel", _T("EXCEL"))
            ->addMultiOption("", _T("CSV"))
            ->addMultiOption("csv", _T("CSV"));
             */
        $this->setAttrib("target", "_self");
        $export_chart[] = $format;
        if($this->_action == 'view') {
            $permalink = new UniForm_Form_Element_Checkbox('permalink');
            $permalink
		      ->setLabel(_T('GENERATE_PERMALINK'));
            $export_chart[] = 'permalink';
            $this->addElements(array($permalink));
            /*
            $embed = new UniForm_Form_Element_Checkbox('embed');
            $embed
		      ->setLabel(_T("EMBED_IN_HTML"));
            $export_chart[] = 'embed';
            $this->addElements(array($embed));
            */
        }

        $tableId = new UniForm_Form_Element_Hidden("table_id");
        
        $export = new UniForm_Form_Element_Submit('export');
        $export->setLabel('EXPORT');
        $this->addElements(array($format));

        $this->addDisplayGroup($export_chart,'export_chart');
        $this->addElements(array($export));
        $this->addElement($tableId);
    }
}


