<?php
class Charts_Form_GlobalSettings extends UniForm_Form{
    public function init(){
        parent::init();
        // Create elements
        $agg = new Charts_Model_DataAggregatorList();
        $compare_over = $agg->getFormElement('aggregator_id',null,false,"ALL_TIME", array("DAY_OF_MONTH_USAGE"));

        $title = new UniForm_Form_Element_Hidden('title');
        $flags = new UniForm_Form_Element_Hidden('flags');
        $data_resolution = new UniForm_Form_Element_Select('data_resolution');

        $time_filter = new UniForm_Form_Element_Hidden('time_filter_code');

        // Set Label
        $compare_over->setLabel("COMPARE_OVER");
        $data_resolution->setLabel("RESOLUTION");

        //Populate elements
        $data_resolution
 /*           ->addMultiOption('ts1h', 'HOURS')*/
            ->addMultiOption('ts1d', 'DAYS')
            ->addMultiOption('ts1w', 'WEEKS')
            ->addMultiOption('ts1m', 'MONTHS')
            ->addMultiOption('ts1y', 'YEARS');
        $this->addElements(array($compare_over, $title,$flags,$data_resolution,$time_filter));
        $this->addDisplayGroups(array(
            'global-first' => array(
                'elements' => array('aggregator_id','data_resolution')
            )));
        $timefilter_form_id = Charts_Form_DataSource::makeTimeFilterSubForm($this,"global");
        $title->setValue(Zend_Registry::get('Zend_Translate')->translate('MY_NEW_CHART'));
    }

    public function populate($a) {
        $addIfMust = array('DAY_USE', 'DAY_USE(RELATIVE)', 'WEEK_USAGE(RELATIVE)', 'MONTH_USAGE(RELATIVE)', 'HOUR_USAGE(RELATIVE)');
        if(isset($a['aggregator_id']) && $a['aggregator_id']>0){
            $aggDb = new Charts_Model_DataAggregatorList();
            $agg = $aggDb->find($a['aggregator_id'])->current();
                r_log($agg->name);
            if(in_array($agg->name,$addIfMust)){
                if(isset($this->getElement("aggregator_id")->options[$a['aggregator_id']])) r_log("doin nothing"); //do nothing
                else $this->getElement("aggregator_id")->addMultiOption($a['aggregator_id'],$agg->name);
            }
        }
        return parent::populate($a);
    }

    public static function factoryFromArray($array){
        $form = new Charts_Form_GlobalSettings();
        $form->populate($array);
        return $form;
    }

    public function translatableStrings(){
        _("ALL_TIME");
        _("CHOOSE_A_TIME_PERIOD");
        _("CURRENT_YEAR");
        _("CURRENT_MONTH");
        _("CURRENT_WEEK");
        _("CURRENT_DAY");
        _("MANUAL_TIME_INTERVAL");
        _("COUNT_DATA_SET");
        _("CAMERAS");
        _("CHOOSE_A_SOURCE_TYPE");
        _("TIME_FILTER");
        _("NO_TIME_FILTER");
        _("CUSTOM_TIME_FILTER");
        _("LINE_CHART");
        _("COLUMN_CHART");
        _("CHART_TYPE");
        _("COMPARE_OVER");
        _("SOURCE_TYPE");
        _("ALL_TIME");
        _("YEARS");_("MONTHS");_("WEEKS");_("DAYS_OF_THE_WEEK");_("HOURS_OF_THE_DAY");
        _("HOURS");_("DAYS");
    }
}
