<?php
class Charts_Form_TableSectionSettings extends UniForm_Form {
    public function init() {
        parent::init();

        $done = new UniForm_Form_Element_Submit("done");
        $title = new UniForm_Form_Element_Text('title');
        $period = new UniForm_Form_Element_Select('period');
        $period_from = new UniForm_Form_Element_Text('period_from');
        $period_to = new UniForm_Form_Element_Text('period_to');
        $period_manual = new UniForm_Form_Element_Text('period_manual');
        $show_date = new UniForm_Form_Element_Checkbox('show_date');
        $add_entry = new UniForm_Form_Element_Button("add_entry");
        $remove_section = new UniForm_Form_Element_Button("remove_section");

        Charts_Form_DataSource::addAllPeriods($period);

        $title->setLabel(_T("SECTION_TITLE"));
        $period
            ->setLabel(_T("TIME_PERIOD"))
            ->setDescription(_T("SELECT_THE_TIME_PERIOD_FROM_WHICH_DATA_SHOULD_BE_COLLECTED_FOR_THE_CURRENT_SECTION."));
        $period_from->setLabel(_T("Period from"));
        $period_to->setLabel(_T("Period to"));
        $period_manual->setLabel(_T("Manual period code"));
        $done
            ->setLabel(_T("DONE"));
        $show_date
            ->setLabel(_T("APPEND_TIME_PERIOD_TO_SECTION_TITLE"));

        $this->addElements(array($title, $period, $period_from, $period_to, $period_manual, $show_date ));
        $this->addDisplayGroup(array('title', 'period', 'period_from', 'period_to', 'period_manual', 'show_date', 'remove_section'),'table-section-group');
        $this->addElement($done);
    }
}
