<?php

class Charts_Model_Api_Method_Charts_GetChart extends WebReport_Api_Method_Abstract
{

    public function userIsAllowed(Core_Model_User $user)
    {
        return true;
    }

    public function needsAuthentication()
    {
        /*
          if($_SERVER['REMOTE_ADDR'] == "127.0.0.1" ||
          $_SERVER['REMOTE_ADDR'] == "::1" ) {
          return false;
          }
         */
        return false;
    }

    public function call(array $params)
    {
        if(!isset($params["params"]) || !isset($params["params"]["id"])){
            echo "No parameters specified.";
            return;
        }

        $permalink = explode('k', $params['params']['id']);
        $width = isset($params['params']['width']) ? (int)$params['params']['width'] : FALSE;
        $height = isset($params['params']['height']) ? (int)$params['params']['height'] : FALSE;


        if(count($permalink) < 2){
            echo "Wrong format on permalink.";
            return;
        }

        $id = $permalink[0];
        $key = "k" . $permalink[1];
        
        $permalinkDb = new Charts_Model_Permalinks();
        $permalink = $permalinkDb->tryFetchLink($id, $key);
    
        if(!$permalink) {
          echo "Didn't find permalink.";
          return;
        }

        $data = $permalink->getSettings();
        if (array_key_exists("exportFormat", $params['params'])) {
            $data['format'] = $params['params']['exportFormat'];
        }

        // get chartdata and render it.        
        try {
          $chartdata = Charts_Model_ChartData::factoryFromDatabase($data['chart_id']);
          Core_Model_User::SetDefaultDateFormat($chartdata->getCompanyid());
        } catch(WebReport_Exception $e) {
          echo "Could not find chart. It might have been removed.";
          return;
        }

        try {
          $render = Charts_Model_ChartRenders::getRender($data['format']);
          if($width)  $render->setWidth($width);
          if($height) $render->setHeight($height);
        } catch(WebReport_Exception $e) {
          echo "Couldn't find renderer.";
          return;
        }

        // this is outside normal framework.
        $response = Zend_Controller_Front::getInstance()->getResponse();
        
        try {
          $render->renderToOutput($chartdata, $response, true);
        } catch(WebReport_Exception $e) {
          echo "Couldn't render chart.";
          return;
        }
    }
}

