<?php

class Charts_Model_Api_Method_Tables_GetTable extends WebReport_Api_Method_Abstract
{

    public function userIsAllowed(Core_Model_User $user)
    {
        return true;
    }

    public function needsAuthentication()
    {
        /*
          if($_SERVER['REMOTE_ADDR'] == "127.0.0.1" ||
          $_SERVER['REMOTE_ADDR'] == "::1" ) {
          return false;
          }
         */
        return false;
    }

    public function call(array $params)
    {
        if(!isset($params["params"]) || !isset($params["params"]["id"])){
            echo "No parameters specified.";
            return;
        }

        $permalink = explode('k', $params['params']['id']);
        $width = isset($params['params']['width']) ? (int)$params['params']['width'] : FALSE;
        $height = isset($params['params']['height']) ? (int)$params['params']['height'] : FALSE;


        if(count($permalink) < 2){
            echo "Wrong format on permalink.";
            return;
        }

        $id = $permalink[0];
        $key = "k" . $permalink[1];
        
        $permalinkDb = new Charts_Model_Permalinks();
        $permalink = $permalinkDb->tryFetchLink($id, $key);
    
        if(!$permalink) {
          echo "Didn't find permalink.";
          return;
        }

        $data = $permalink->getSettings();
        if (array_key_exists("exportFormat", $params['params'])) {
            $data['format'] = $params['params']['exportFormat'];
        }

        // get chartdata and render it.        
        try {
          $tableDb = Charts_Model_Tables::GetInstance();
          $table = $tableDb->find($data['chart_id'])->current();
        } catch(WebReport_Exception $e) {
          echo "Could not find chart. It might have been removed.";
          return;
        }
        $format = substr($data["format"],6);
        header("Content-Disposition: inline; filename=\"export.$format\"");
        if($format == "csv" ) {
            $renderer = new Charts_Model_TableCsvRenderer();
            $renderer->render($table,true);
            // Force permalinks to open in browser.
            header("Content-Type: text/plain; charset=utf-8");
        } else if($format == "html") {
            header("Content-Type: text/html; charset=utf-8");
            // This is very ugly at the moment, too little time, please refactor.
            // Preferably rendered with a Zend_View or just imported from a phtml file.
            $css1 = "../templates/standard/css/style.css";
            $css2 = "../templates/standard/css/charts.css";
            $renderer = new Charts_Model_TableHtmlRenderer();
            ?>
            <html>
                <head>
                    <meta http-equiv="X-UA-Compatible" content="IE=9" />
                    <title><?= $table->title ?></title>
                    <link rel="stylesheet" type="text/css"  href="<?= $css1?>">
                    <link rel="stylesheet" type="text/css"  href="<?= $css2?>">
                    <style>
                        body { background-image : none }
                    </style>
                </head>
            <body>
                <h1><?= $table->title ?></h1>
                <?= $renderer->render($table) ?>
            </body>
            </html>
            <?
        } else {
          echo "Couldn't find renderer.";
        }
    }
}

