<?

class Charts_Model_Axes implements Countable{
    private $_axes = array();
    public function __construct() {
    }

    public function count() {
        return count($this->_axes);
    }

    public function addAxes($axes){
        if(is_a($axes, "Charts_Model_Axes")) $axes = $axes->getAxes();
        foreach($axes as $axis) $this->_axes[] = $axis;
    }

    public function getAxes() {
        return $this->_axes;
    }

    public function getUnits() {
        $units = array();
        foreach($this->_axes as  $axis) {
            $units[$axis->getTitle()] = $axis->unit();
        }
        return $units;
    }

    public function getIsAverage() {
        if(count($this->_axes) > 1) return null;
        foreach($this->_axes as  $axis) return $axis->isAverage();
    }

    public function getAxesDrawTypes() {
        $prio = array("line" => "10000", "bar" => "10000");
        $choice = array();
        $picked_types = array();
        $picked_axes = array();
        $picked_axes_types = array();
        for($i = 0; $i < 2; $i++) {
            $min = 100000;
            $best_type= NULL;
            $best_axis = NULL;
            foreach($this->_axes as $axis) {
                if(in_array(get_class($axis),$picked_axes)) {
                    continue;
                }
                foreach($axis->getDrawTypePriority() as $prio => $type) {
                    if(in_array($type,$picked_types)) {
                        continue;
                    }
                    if($prio < $min) {
                        
                        $min = $prio;
                        $best_type = $type;
                        $best_axis = $axis;
                    }
                }
            }
            if($min == 100000) break;
            $picked_axes[] = get_class($best_axis);
            $picked_types[] = $best_type;
            $choice[$best_axis->getTitle()] = $best_type;
        }
        return $choice;
    }

    public function merge() {
        $mapping = array();
        $newaxes = array();
        foreach($this->_axes as $i => $a1) {
            $axis = NULL;
            if(method_exists($a1,'merge')) {
                foreach($this->_axes as $j => $a2) {
                    if ($j != $i)
                        $axis = $a1->merge($a2);
                }
            }
            $newaxes[$a1->getTitle()] = $axis ? $axis : $a1;
        }
        $this->_axes = $newaxes;
    }

    public function getAxesInfo() {
        $info = array();
        $types = array();
        foreach($this->_axes as $axes) {
            $types = $axes->getTypes();
            $title = $axes->getTitle();
            if(!isset($info[$title])) $info[$title] = array();
            foreach($types as $type) {
                if(!in_array($type,$info[$title])) $info[$title][] = $type;
            }
        }
        return $info;
    }

    public function getNumberOfAxes() {
        return count($this->_axes);
    }
    public function getDisplayUnits() {
        error_log("TODO: return correct Display Units");
        return array();
    }
}
