<?php

/*
CREATE TABLE IF NOT EXISTS `mod_charts_data_source` (
  `chart_data_source_id` int(11) NOT NULL AUTO_INCREMENT,
  `chart_data_id` int(11) NOT NULL,
  `title` varchar(256) COLLATE utf8_bin NOT NULL,
  `color` varchar(7) COLLATE utf8_bin NOT NULL,
  `time_filter_code` varchar(128) COLLATE utf8_bin DEFAULT NULL,
  `time_period_code` varchar(128) COLLATE utf8_bin DEFAULT NULL,
  `time_period_from` date DEFAULT NULL,
  `time_period_to` date DEFAULT NULL,
  `count_data_set_id` int(11) DEFAULT NULL,
  PRIMARY KEY (`chart_data_source_id`),
  KEY `chart_data_id` (`chart_data_id`),
  KEY `count_data_set_id` (`count_data_set_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin AUTO_INCREMENT=1 ;

ALTER TABLE `mod_charts_data_source`
  ADD CONSTRAINT `mod_charts_data_source_ibfk_1` FOREIGN KEY (`chart_data_id`) REFERENCES `mod_charts_data` (`chart_data_id`) ON DELETE CASCADE,
  ADD CONSTRAINT `mod_charts_data_source_ibfk_2` FOREIGN KEY (`count_data_set_id`) REFERENCES `count_data_set` (`count_data_set_id`) ON DELETE SET NULL;
 */

class Charts_Model_ChartDataSourceList extends Talking_Db_Table
{
    protected $_name = 'mod_charts_data_source';
    protected $_primary = 'chart_data_source_id';

    protected $_dependentTables = array('Charts_Model_ChartDataSourceCameraList');

    protected $_referenceMap = array(
        'ChartData' => array(
            'columns' => array('chart_data_id'),
            'refTableClass' => 'Charts_Model_ChartDataList',
            'refColumns' => array('chart_data_id')
        ),
        'CountData' => array(
            'columns' => array('count_data_set_id'),
            'refTableClass' => 'Core_Model_CountData_Sets',
            'refColumns' => array('count_data_set_id')
        )
    );

}
