<?php

class Charts_Model_ChartListGenerator extends Core_Model_Generic_AbstractListView {
    public function getHeaders(){
        return array(_T("NAME"),_T("DESCRIPTION"));
    }

    protected function _dataRowToTableRow($row){
        $ret = array();
        $ret[] = $row->title;

        $ret['_document_id'] = Core_Model_DocumentFactory::getId($row->chart_data_id, "chart");

        $ret[] = $row->description;
        
        return $ret;
    }

    public function removeText(){
        return _T('DO_YOU_REALLY_WANT_TO_REMOVE_THE_CHART_"%1$s"?');
    }

    protected function _dataRowToRowId($row){
        return $row->chart_data_id;
    }

    public function noDataInformation(){
        return _T("NO_CHARTS.");
    }

    public function getActions($row){
        $folder = $this->_group->group_id;

        $creator = $this->_group->canEdit($this->_user);

        $actions = array();
        $actions[] = parent::CreateAction(_T('VIEW_CHART'),'view', 'view', $folder);

        if($creator) {
            $actions[] = parent::CreateAction(_T('EDIT_CHART'), 'create', 'edit', $folder);
            $actions[] = parent::CreateAction(_T('DELETE_CHART'),'delete', 'delete', $folder);
            $actions[] = parent::CreateAction(_T('COPY_CHART'),'copy', 'copy', $folder);
        }

        return $actions;
    }
}
