<?php
class Charts_Model_ChartRender_Array extends Charts_Model_ChartRender_Abstract {

    protected $_code = "table"; // unique code for this format
    protected $_content_type = "string/php"; //mime content type for this format
    protected $_file_extension = ".php";
    protected $_showTotal = false;

    protected $_sep = ",";

    public function __construct(){
        $this->_addTotalToLegend = true;
    }

    public function render($chartData, $getTotal = null, $getAvg = null, $forceAvg = false){
        parent::_renderCommon($chartData, false, $forceAvg);
        $data = array(
            "isTime" => array(),
            "isAvg"  => array(),
            "data"   => array()
        );
        $axes = $chartData->getAxes()->getAxes();
        //if(count($axes) > 1) throw new Exception ("The chosen datasources can not be combined");

        $currency = $chartData->_chartDataSource[0]->getCurrency();
        if($axes){
            $suffix = $axes[0]->getSuffix();
            $prefix = $axes[0]->getPrefix();
            $skipTot = $axes[0]->isAverage() || $suffix == "%";
        }

        if(mb_strlen($currency,'UTF-8') == 1)
            $prefix = $currency;
        elseif(mb_strlen($currency,'UTF-8') > 1)
            $suffix = " " . $currency;

        $tot = 0;
        for($i=0; $i < $this->_numberOfDataSources; $i++) {
            for($j=0; $j < $this->_dataLength; $j++) {
                $num = $this->_dataSourceData[$i][$j];
                if(is_null($num))
                $data["isAvg"][$i] = $skipTot;
                if(!$j) $data['isTime'][$i] = false;
                if($this->_dataSourceType[$i]=='DURATION'){
                    if(!$j) $data['isTime'][$i] = true;
                    $num = $this->AlmostAmChartDurationFormat($num);
                }
                $tot += $num;
                $data["data"][$i][$j] = $prefix . $num . $suffix;
            }
            if($getTotal) {
                if($skipTot) $data["data"][$i][] = "-";
                else $data["data"][$i][] = $prefix . $tot . $suffix;
            }
            if($getAvg) $data["data"][$i][] = $prefix . round($tot/$this->_dataLength, 1) . $suffix;
        }
        return $data;
    }

    protected function AlmostAmChartDurationFormat($value) {
        //$trans = Zend_Registry::get('Zend_Translate');
        $m = $value % 60;
        $h = ($value-$m) / 60;
        if($h < 1) return $m."m";
        return $h."h ".$m."m";
    }

    function _render(){}


}

