<?php
class Charts_Model_ChartRender_Csv extends Charts_Model_ChartRender_Abstract {

    protected $_code = "csv"; // unique code for this format
    protected $_content_type = "text/plain; charset=utf-8"; //mime content type for this format
    protected $_file_extension = ".csv";

    protected $_sep = ",";
    protected $_replace_sep = " ";

    public function __construct(){
        $this->_addTotalToLegend = false;
    }

    function clean($str) {
        return preg_replace("/$this->_sep/", $this->_replace_sep, $str);
    }

    function _render(){
        $ret = "";

        $row = array();
        $row[] = "Time";
        for($i=0; $i < $this->_numberOfDataSources; $i++) {
            $row[] = $this->clean($this->_dataSourceTitles[$i]);
        }
        $ret .= implode($this->_sep, $row) . "\n";

        for($j=0; $j < $this->_dataLength; $j++) {
            $row = array();
            $row[] = $this->clean($this->_dataLabels[$j]);
            for($i=0; $i < $this->_numberOfDataSources; $i++) {
                $row[] = $this->_dataSourceData[$i][$j];
            }
            $ret .= implode($this->_sep, $row) . "\n";
        }

        return $ret;
    }


}

