<?php

include_once 'IAM_XLS/iam_xls.php';

class Charts_Model_ChartRender_Excel extends Charts_Model_ChartRender_Abstract
{

    protected $_code = "xls"; // unique code for this format
    protected $_content_type = "application/vnd.ms-excel"; //mime content type for this format
    protected $_file_extension = ".xls";
    protected $_add_file_type_to_header = false;

    protected $_extra_headers = array();

    public function __construct(){
        $this->_addTotalToLegend = false;
    }

    function _render() {


        $fn = "WebReport-$this->_title-" . date("Ymd-his");
        $this->_extra_headers['Content-Disposition'] =
                'attachment; filename="' . $fn . $this->_file_extension . '"';


        $xls = new IAM_XLS($fn);
        $xls->WriteValue(0, 0, "TrueView Web Report Export");
        $xls->WriteValue(1, 0, utf8_decode($this->_title));

        $rowCount = 2;

        $xls->WriteValue($rowCount, 0, utf8_decode("Time"));
        for ($i=0; $i < $this->_numberOfDataSources; $i++) {
           $xls->WriteValue($rowCount, $i+1, utf8_decode($this->_dataSourceTitles[$i]));
        }

        for($j=0; $j < $this->_dataLength; $j++) {
            $rowCount++;
            $xls->WriteValue($rowCount, 0, utf8_decode($this->_dataLabels[$j]));
            for($i=0; $i < $this->_numberOfDataSources; $i++) {
                $xls->WriteValue($rowCount, $i+1, $this->_dataSourceData[$i][$j]);
            }
        }

        $xls->_excelEnd();

        return $xls->xls_data;
    }

}
