<?php

include_once("PHP_XLSXWriter/xlsxwriter.class.php");

class Charts_Model_ChartRender_ExcelXlsx extends Charts_Model_ChartRender_Abstract
{

    protected $_code = "xlsx"; // unique code for this format
    protected $_content_type = "application/vnd.openxmlformats-officedocument.spreadsheetml.sheet"; //mime content type for this format
    protected $_file_extension = ".xlsx";
    protected $_add_file_type_to_header = false;

    protected $_extra_headers = array();

    public function __construct(){
        $this->_addTotalToLegend = false;
    }

    function _render() {
        $fn = "WebReport-$this->_title-" . date("Ymd-his");
        $this->_extra_headers['Content-Disposition'] =
            'attachment; filename="' . $fn . $this->_file_extension . '"';

        $writer = new XLSXWriter();

        $data = array(array("TrueView Web Report Export"), array(utf8_decode($this->_title)));

        $firstRow = array("Time");

        for ($i=0; $i < $this->_numberOfDataSources; $i++) {
            $firstRow[] = utf8_decode($this->_dataSourceTitles[$i]);
        }

        $data[] = $firstRow;

        for($j=0; $j < $this->_dataLength; $j++) {
            $row = array(utf8_decode($this->_dataLabels[$j]));

            for($i=0; $i < $this->_numberOfDataSources; $i++) {
                $row[] = $this->_dataSourceData[$i][$j];
            }

            $data[] = $row;
        }

        $writer->writeSheet($data);

        return $writer->writeToString();
    }

}
