<?php

class Charts_Model_ChartRender_Png extends Charts_Model_ChartRender_Abstract {
    protected $_code = "png";
    protected $_content_type = "image/png";
    protected $_file_extension = ".png";

    private $_chartTypeConvert = array(
        "bar" => "column",
        "line" => "line",
        "pie" => "pie"
    );
    
    function __construct(){
        $this->_force_wanted_resolution = true;
    }

    function _render() {
            $tic = time(NULL);
            $translate = Zend_Registry::get('Zend_Translate');

            $image_renderer = null;
            $categories = count($this->_dataLabels);
            $sources = count($this->_dataSourceTitles);
            $points = $categories * $sources;
            
            if($this->_chartType == 'pie')
                $chart = new CM_ChartingPie();
            else
                $chart = new CM_Charting();


            //TODO: change this path to sessio or smthin
            $fn = APPLICATION_PATH . "/../data/session/" . uniqid() . ".png";
            
            //$chart->setYlabel($xlabel, $this->_title);

            $width = $this->getWidth();
            $height = $this->getHeight();
            // Compute some limitations
            $XLabelShowRatio =  $categories / ($width / 70);
            $allowedValues = $width / 25; // Pixels per value label
            $shortenValueLabels = $points > 20;
            // Use them
            $chart->showValues($points < $allowedValues * $width / 1400.0);
            $chart->setXlabel($this->_dataLabels, $translate->_("PERIOD"));

            foreach ($this->_dataSourceTitles as $index => $value) {
			    $chart->addData(new CM_ChartData(
                        $this->_chartTypeConvert[$this->_chartType],
                        $this->_dataSourceData[$index],
                        $value,
                        $this->_rightUnit,
                        $this->_dataSourceColors[$index],
						$this->_dataSourceType[$index],
                        $this->_dataSourceStackId[$index]
                        ));
            }
            
            $chart->setYlabel($this->getLongUnit());
            $chart->toFile($fn, $width, $height, $this->_title);
            if(!file_exists($fn)){
                return file_get_contents(APPLICATION_PATH . "/../public/library/images/errors/data-session-access.png");
            }
            $ret = file_get_contents($fn);
            unlink($fn);
            return $ret;
    }
}

