<?php
class Charts_Model_ChartRender_Table extends Charts_Model_ChartRender_Abstract {

    protected $_code = "table"; // unique code for this format
    protected $_content_type = "string/php"; //mime content type for this format
    protected $_file_extension = ".php";

    protected $_sep = ",";

    public function __construct(){
        $this->_addTotalToLegend = true;
    }

    public function render($chartData){
        parent::_renderCommon($chartData);
        $data = array();
        $data['isTime'] = Array(); 
        for($j=0; $j < $this->_dataLength; $j++) {
            for($i=0; $i < $this->_numberOfDataSources; $i++) {
                $data[$i][$j] = $this->_dataSourceData[$i][$j];
                if(!$j) $data['isTime'][$i] = false;
                if($this->_dataSourceType[$i]=='DURATION'){
                    if(!$j) $data['isTime'][$i] = true;
                    $data[$i][$j] = $this->AlmostAmChartDurationFormat($data[$i][$j]);
                }
            }
        }
        return $data;
    }

    protected function AlmostAmChartDurationFormat($value) {
        //$trans = Zend_Registry::get('Zend_Translate');
        $m = $value % 60;
        $h = ($value-$m) / 60;
        if($h < 1) return $m."m";
        return $h."h ".$m."m";
    }

    function _render(){}


}

