<?php

class Charts_Model_ChartRenders
{
    private static $_codeObject = array(
        "am-chart" => "Charts_Model_ChartRender_AmChart",
        "csv" => "Charts_Model_ChartRender_Csv",
        "excel" => "Charts_Model_ChartRender_Excel",
        "excelx" => "Charts_Model_ChartRender_ExcelXlsx",
        "html" => "Charts_Model_ChartRender_Html",
        "xml" => "Charts_Model_ChartRender_Xml",
        "json" => "Charts_Model_ChartRender_Json",
        "png" => "Charts_Model_ChartRender_Png",
        "png-embed" => "Charts_Model_ChartRender_PngEmbed"
        //      "jpg" => "Charts_Model_ChartRender_Jpg" /* pChart does not support jpg */
    );

    private static $_renders = array(
        "csv" => "CSV",
        "excel" => "EXCEL",
        "excelx" => "EXCEL_(XLSX)",
        "html" => "HTML",
        "json" => "JSON",
        "png" => "PNG",
        //        "jpg" => "JPG", /* pChart does not support jpg */
        "xml" => "XML"
    );

    public static function getRender($code = "csv") {
        if(!array_key_exists($code, self::$_codeObject)) {
            throw new WebReport_Exception_ParameterError("No renderer for $code");
        }
        $ret = new self::$_codeObject[$code]();
        return $ret;
    }

    public static function getRenders() {
        return self::$_renders;
    }
}
