<?php

include_once 'core/models/CountData/Sets.php';

class Charts_Model_CustomCharts extends Talking_Db_Table
{
	protected $_name = 'mod_charts_custom_chart';
	protected $_primary = 'custom_chart_id';

//	protected $_dependentTables = array('FormulaChartFormula');

	protected $_referenceMap    = array(
		'Company' => array(
			'columns'           => array('company_id'),
			'refTableClass'     => 'Core_Model_Companies',
			'refColumns'        => array('company_id')
		),
		'CountDataSet' => array(
			'columns'           => array('count_data_set_id'),
			'refTableClass'     => 'Core_Model_CountData_Sets',
			'refColumns'        => array('count_data_set_id')
		)
	);


	public function fetchAllCustomCharts(Core_Model_Company $company = null, Core_Model_User $user = null) {

		$db = $this->getAdapter();

		$select = $db->select();
		$select->from(array("cc" => $this->info(Zend_Db_Table::NAME)), array("custom_chart_id", "name", "default_type"));
		$companiesDb = new Core_Model_Companies();
		$select = $select->join(array("c" => $companiesDb->info(Zend_Db_Table::NAME)), "c.company_id = cc.company_id", array("company" => "name"));

		$setsDb = new Core_Model_CountData_Sets();
		$select = $select->join(array("s" => $setsDb->info(Zend_Db_Table::NAME)), "s.count_data_set_id = cc.count_data_set_id", array("application_id"));

		if ($company) {
			$select->where('c.company_id = ?', $company->company_id);
		}

		if ($user) {
			$customChartAclRole = new Charts_Model_CustomChartAclRole();
			$select = $select->join(array("ccar" => $customChartAclRole->info(Zend_Db_Table::NAME)), "ccar.custom_chart_id = cc.custom_chart_id", array());
			$select->where('acl_role_id = ?', $user->acl_role_id);
		}

		$select->order('cc.company_id')->order('cc.name');
		
		return $charts = $db->fetchAll($select);
	}




}
