<?php

class Charts_Model_MenuItems extends WebReport_Module_MenuItems_Abstract {

    /**
     * Get charts module menu items.
     *
     * @return array
     */
    public function getAll() {

        $items = array();

        $items['chart-producer'] = array(
            'text' => _T('CHARTS'),
            'class' => 'browse',
            'urlOptions' => array('module' => 'charts', 'controller' => 'chart-producer', 'action' => 'browse'),
            'title' => _T("PRODUCE_OR_VIEW_CHARTS"),
            'activeConditions' => array("module" => "charts", "controller" => "chart-producer", "action" => "browse")
        );

        $items['table-creator'] = array(
            'text' => _T('TABLES'),
            'class' => 'browse-table',
            'urlOptions' => array('module' => 'charts', 'controller' => 'table-creator', 'action' => 'browse'),
            'title' => _T("PRODUCE_OR_VIEW_TABLES"),
            'activeConditions' => array("module" => "charts", "controller" => "table-creator", "action" => "browse")
        );


        $applicationsModel = new Core_Model_Applications();

        $applications = $applicationsModel->fetchAll();

        $items = $this->filterNotAllowedItems($items);

        return $this->translate($items);
    }

    public static function getDescription($item) {
        $t = Zend_Registry::get('Zend_Translate');
        $items = array();
        $items['browse-charts'] = $t->_("BROWSE_CHARTS.");
        $items['table-creator'] = $t->_("BROWSE_TABLES.");
        $items['chart-producer'] = $t->_("PRODUCE_CHARTS.");
        $items['application-1'] = $t->_("VIEW_PEOPLE_COUNTER_CHART.");
        $items['application-2'] = $t->_("VIEW_ZONE_COUNTER_CHART.");
        $items['application-3'] = $t->_("VIEW_PARKING_CHART.");
        $items['application-4'] = $t->_("VIEW_BICYCLE_CHART.");

        return $items[$item];
    }

    private function _translatableStrings() {
        $this->_translate->_('VIEW_AND_MANAGE_ALL_AVAILABLE_CHARTS');
        $this->_translate->_('VIEW_PEOPLE_COUNTER_CHART');
        $this->_translate->_('VIEW_ZONE_COUNTER_CHART');
        $this->_translate->_('VIEW_PARKING_CHART');
        $this->_translate->_('VIEW_BICYCLE_CHART');
        $this->_translate->_('CHART_CREATOR');
        $this->_translate->_('PRODUCE_OR_VIEW_CHARTS');
    }

}
