<?php

class Charts_Model_Permalink extends Zend_Db_Table_Row_Abstract
{
    public function getApi($view = null) {
        $url = Zend_Registry::get('config')->resources->frontController->baseUrl;
        // TODO: Use ACL, api is not registered as a module..
        // $url = $view->aclUrl(array(), "","");
	
		$port = '';
		if($_SERVER['SERVER_PORT'] != '80')
		  $port = ':' . $_SERVER['SERVER_PORT'];
        if ( substr($this->format, 0, 5) == "table" ) {
            $address = $_SERVER["SERVER_NAME"].$port.$url."/api/?method=tables.GetTable&id=";
        } else {
            $address = $_SERVER["SERVER_NAME"].$port.$url."/api/?method=charts.GetChart&id=";
        }
        $permalink = $this->legacy_id.$this->permalink_key;
        return "http://".$address.$permalink;
    }
    
    public function getSettings() {
        $data = array('format'    => $this->format,
                      'chart_id'  => $this->chart_id);

        return $data;
    }
    
    public function touch(){
        $this->last_api_read = new Zend_Db_Expr('NOW()');
        $this->save();
    }

    public function getCompany() {
        if ($this->format == "table-html" || $this->format == "table-csv") {
            $tableDataDb = new Charts_Model_Tables();
            $tableData = $tableDataDb->fetchAll(
                $tableDataDb->select()
                    ->where('table_id = ?', $this->chart_id)
            )->current();
            $documentDb = new Core_Model_Documents();
            $document = $documentDb->fetchAll(
                $documentDb->select()
                    ->where('id = ?', $this->chart_id)
                    ->where('type = ?', "table")
            )->current();
            $company_id = $document->getGroup()->company_id;
        } else {
            $chartDataDb = new Charts_Model_ChartDataList();
            $chartData = $chartDataDb->fetchAll(
                $chartDataDb->select()
                    ->where('chart_data_id = ?', $this->chart_id)
            )->current();
            $company_id = $chartData->company_id;
        }
        $companyDb = new Core_Model_Companies();
        $company = $companyDb->getCompany($company_id);
        return $company;
    }
}
