<?php

class Charts_Model_Permalinks extends Talking_Db_Table
{
    protected $_name = 'mod_charts_permalinks';
	protected $_primary = 'permalink_id';
	protected $_rowClass = 'Charts_Model_Permalink';

//	protected $_dependentTables = array ('Reports_Model_SubscriptionReceivers');

    public function tryFetchLink($id, $key){
        $select = $this->select();
        $select->where('legacy_id = ?', $id);
    	$select->where('permalink_key = ?', $key);

        return $this->fetchAll($select)->current();
    }
    
    public function addPermalink($format, $chart_id, $embed = false)
    {
        $key = substr("k".md5(uniqid(rand(), true)),0,8);
        if ( $embed ) {
            $format .= "-embed";
        }
        $permalinkData = array(
          "chart_id" => $chart_id,
          "format" => $format,
          "permalink_key" => $key,
          "last_api_read" => new Zend_Db_Expr('NOW()')
        );

        $filter = $this->createRow($permalinkData);
        $filter->save();
        return $filter;
    }

    public function addChartPermalink($format, $chart_id, $embed = false)
    {
        return $this->addPermalink($format, $chart_id, $embed);
    }
    public function addTablePermalink($format, $chart_id)
    {
        return $this->addPermalink("table-".$format, $chart_id);
    }
}

