<?php

class SourceTypeSorter {
    private $_this;
    function __construct($instance) {
        $this->_this = $instance;
    }
    function call($a, $b) {
        $ncmp = strcasecmp($a['name'] , $b['name']);
        if ( $ncmp != 0 ) return $ncmp;
        if($this->_this->_sortPriority == NULL) return strcasecmp($a['type']['title'] , $b['type']['title']);
        return array_search($a['type']['id'], $this->_this->_sortPriority) - array_search($b['type']['id'], $this->_this->_sortPriority);
    }
}

abstract class Charts_Model_SourceType_Abstract {
  protected $_pickId = "NOPICKID";
  protected $_types = array("in" => "IN", "out" => "OUT");

  public $_sortPriority = NULL;

  public abstract function getAxes($dataTypeId);
  public abstract function getGroupTitle();
  public abstract function getUniqueIdentifier();
  public abstract function isCountData($type);
  public abstract function addCountData($id, $type, $countData);
  protected abstract function _getAllSources($user);

  public function toSources($id, $name) {
    $all = array();

    foreach($this->_types as $direction => $title) {
        $all[] = array(
            "name" => $name,
            "id" => $id,
            "sourcetype" => $this->getUniqueIdentifier(),
            "type" => array(
                "title" => $title,
                "id" => $direction
            )
        );
    }

    return $all;
  }

  public function getChartDataSourcePickId() {
    if ($this->_pickId == "NOPICKID") throw new Exception("You must overload the variable _pickID.");
    return $this->_pickId;
  }

  public function getAllSources($user, $valPack = null, $idPack = null) {
    $unique = $this->getUniqueIdentifier();
    $list = array();
    $sources = $this->_getAllSources($user);
    $instance = $this;
    usort($sources, array(new SourceTypeSorter($this), "call"));
    foreach($sources as $key => $meta) {
      $v = $valPack ? $valPack($meta) : $meta;
      $k = $idPack  ? $idPack($meta)  : count($list);
      $list[$k] = $v;
    }
    return $list;
  }
}
