<?php

class Charts_Model_SourceType_AveragePurchase extends Charts_Model_SourceType_PosAbstract {
  protected $_types = array('avgpurchase_count' =>'AVERAGE_PURCHASE');

  public function getGroupTitle() {
    return _T("AVERAGE_PURCHASE");
  }
  public function splitSelection($chosen) {
    if($chosen->dataTypeId == 'avgpurchase_count') {
        $trans = (object) array(
          'identifier' => 'AP',
          'id'         => $chosen->id,
          'dataTypeId' => 'sale',
          'group'      => 'pos'
        );
        $sale = (object) array(
          'identifier' => 'TA',
          'id'         => $chosen->id,
          'dataTypeId' => 'transaction',
          'group'      => 'pos'
        );
        $all = array($trans,$sale);
        foreach($this->_getCameraIds($chosen->id) as $id) {
            $cam = clone $chosen;
            $cam->identifier = "PC";
            $cam->dataTypeId = 'in';
            $cam->id = $id;
            $cam->group = "count";
            $all[] = $cam;
        }
        return $all;
    } else {
        return array($chosen);
    }
  }

  public function getUniqueIdentifier() {
    return "AP";
  }

  public function getCountType() {
      return "divbycount:1";
  }

  public function getAxes($dataTypeId) {
    $axes = array();
    $axes[] = new Charts_Model_Axis_AveragePurchase();
    $axes[] = new Charts_Model_Axis_People();
    return $axes;
  }

  public function expandSelections($selections) {
      // Is this function still neded?
      if($selections == 'average_purchase') return array('average_pruchase','in');
      return array($selections);
  }

  public function _getAllSources($user) {
    $all = array();

    $jobs = Pos_Model_ImportJobs::getInstance()->fetchAllVisible($user);
    foreach($jobs as $job) {
      foreach($this->_types as $cnt => $title) {
        $all[] = array(
          'name'       => $job->name, 
          'id'         => $job->pos_data_id,
          'sourcetype' => 'AP',
          'type' => array(
            'title' => $title,
            'id'    => $cnt,
            'cdata' => True
          ),
        );
      }
    }
    return $all;
  }
}
