<?php

class Charts_Model_SourceType_ConversionRate extends Charts_Model_SourceType_PosAbstract {
  protected $_types = array('convrate_count' => 'CONVERSION_RATE');

  public function getGroupTitle() {
    return _T("CONVERSION_RATE");
  }
  public function splitSelection($chosen) {
    if($chosen->dataTypeId == 'convrate_count') {
        $chosen->dataTypeId = 'transaction';
        $chosen->group = "conv";
        $all = array($chosen);
        foreach($this->_getCameraIds($chosen->id) as $id) {
            $cam = clone $chosen;
            $cam->group = "conv";
            $cam->identifier = "PC";
            $cam->dataTypeId = 'in';
            $cam->id = $id;
            $all[] = $cam;
            $cam = clone $cam;
            $cam->group = "count";
            $all[] = $cam;
        }
        return $all;
    } else {
        return array($chosen);
    }
  }

  public function getUniqueIdentifier() {
    return "CR";
  }

  public function getCountType() {
      return "divbycount:100";
  }

  public function getAxes($dataTypeId) {
    $axes = array();
    $axes[] = new Charts_Model_Axis_ConversionRate();
    $axes[] = new Charts_Model_Axis_People();
    return $axes;
  }

  public function expandSelections($selections) {
      if($selections == 'conversionrate') return array('conversionrate','in');
      return array($selections);
  }

  public function _getAllSources($user) {
    $all = array();

    $jobs = Pos_Model_ImportJobs::getInstance()->fetchAllVisible($user);
    foreach($jobs as $job) {
      foreach($this->_types as $cnt => $title) {
        $all[] = array(
          'name'       => $job->name, 
          'id'         => $job->pos_data_id,
          'sourcetype' => 'CR',
          'type' => array(
            'title' => $title,
            'id'    => $cnt,
            'cdata' => True
          ),
        );
      }
    }
    return $all;
  }
}
