<?php

class Charts_Model_SourceType_CountDataSet extends Charts_Model_SourceType_Abstract {
  protected $_pickId = 'count_data_set_id';
  public function getGroupTitle() {
    return _T("COUNT_DATA_SET");
  }

  public function isCountData($type) {
    return True;
  }

  public function getUniqueIdentifier() {
    return 'CDS';
  }

  public function getCountType() {
      return "count";
  }


  public function addCountData($id, $type, $countData) {
    $db = Core_Model_CountData_Sets::getInstance();
    $cds = $db->find($id)->current();
    if ( $cds ) {
        $countData->addCountData($cds->getCountData(), array($type));
    } else {
        error_log("In Charts_Model_SourceType_CountDataSet, tried to find CountDataSat #$id, but it does not exist anymore");
    }
  }

  public function getAxes($dataTypeId) {
    $axes = array();
    $axes[] = new Charts_Model_Axis_People();
    return $axes;
  }

  public function _getAllSources($user) {
    // Only allow applications with in and out, since
    // this is the only thing that can be shown in charts.
    $tvpc = new Core_Model_Application_PeopleCounter();
    $tvp = new Core_Model_Application_Parking();
    $allowed_ids = array($tvpc->getId(), $tvp->getId());
    $all = array();
    foreach(Core_Model_CountData_Sets::getInstance()->fetchAllVisible($user) as $cd) {
        if ( !in_array($cd->application_id, $allowed_ids) ) continue;
        foreach($this->_types as $cnt => $title) {
        $all[] = array(
          'name' => $cd->name, 
          'id'   => $cd->count_data_set_id,
          'sourcetype' => 'CDS',
          'type' => array(
            'title' => $title,
            'id'    => $cnt
          ),
        );
      }
    }
    return $all;
  }
}
