<?php

class Charts_Model_SourceType_Formula extends Charts_Model_SourceType_Abstract {
  protected $_pickId = 'count_data_formula_set_id';
  public function getGroupTitle() {
    return _T("FORMULA");
  }

  public function isCountData($type) {
    return True;
  }

  public function getUniqueIdentifier() {
    return 'F';
  }

  public function getCountType() {
      return "count";
  }

  public function addCountData($id, $type, $countData) {
    $db = Core_Model_CountData_FormulaSets::getInstance();
    $set = $db->find($id)->current();
    $countData->addFormulaSet($set, $type);
  }

  public function getAxes($dataTypeId) {
    $axes = array();
    $axes[] = new Charts_Model_Axis_People();
    return $axes;
  }

  public function toSources($id, $name) {
    $all = array();
    $formulaSetDb = Core_Model_CountData_FormulaSets::getInstance();

    $formulaSet = $formulaSetDb->find($id)->current();
    $formulas = $formulaSet->findDependentRowset("Core_Model_CountData_FormulaSetFormulas");

    foreach($formulas as $formula) {
        $all[] = array(
            "name" => $name,
            "id" => $id,
            "sourcetype" => $this->getUniqueIdentifier(),
            "type" => array(
                "title" => $formula->name,
                "id" => $formula->count_data_formula_set_formula_id   
            )
        );
    } 

    return $all;
  }

  public function _getAllSources($user) {
    $all = array();
    $formulaSetDb = Core_Model_CountData_FormulaSets::getInstance();
    foreach($formulaSetDb->fetchAllVisible($user) as $formulaSet) {
      $formSet = $formulaSetDb->find($formulaSet->count_data_formula_set_id)->current();
      $formulas = $formSet->findDependentRowset('Core_Model_CountData_FormulaSetFormulas');
      foreach($formulas as $formula) {
        $all[] = array(
          'name' => $formulaSet->name, 
          'id'   => $formulaSet->count_data_formula_set_id,
          'sourcetype' => 'F',
          'type' => array(
            'title' => $formula->name,
            'id'    => $formula->count_data_formula_set_formula_id
          ),
        );
      }
    }
    return $all;
  }
}
