<?php

class Charts_Model_SourceType_Gender extends Charts_Model_SourceType_Abstract {
  protected $_types = array("both" => "DISTRIBUTION");
  protected $_pickId = "gender_id";
  public function getGroupTitle() {
    return _T("TRUE_VIEW_GENDER");
  }
  public function isCountData($type) {
    return True;
  }

  public function getCountType() {
      return "ratio";
  }

  public function addCountData($id, $type, $countData) {
    $camDb = Core_Model_Cameras::getInstance();
    $cam = $camDb->find($id)->current();
    $countData->addCamera($cam, array($type));
  }

  public function getAxes($dataTypeId) {
    $axes = array();
    $axes[] = new Charts_Model_Axis_Percentage();
    return $axes;
  }

  public function getUniqueIdentifier() {
    return "G";
  }

  public function expandSelections($selection) {
      if($selection == 'both') return array('female', 'male');
      return array($selection);
  }

  public function _getAllSources($user) {
    $all = array();
    $app = Core_Model_Applications::getWithId(8);
    $cameras = Core_Model_Cameras::getInstance()->fetchAllVisible($user, $app);
    foreach($cameras as $camera) {
      foreach($this->_types as $cnt => $title) {
        $all[] = array(
          'name'       => $camera->name, 
          'id'         => $camera->camera_id,
          'sourcetype' => 'G',
          'type' => array(
            'title' => $title,
            'id'    => $cnt,
            'cdata' => True
          ),
        );
      }
    }
    return $all;
  }
}
