<?php

class Charts_Model_SourceType_Occupancy extends Charts_Model_SourceType_Abstract {
  protected $_types = array('occ' => 'OCCUPANCY', 'avgt' => 'AVERAGE_VISIT_TIME'); 

  protected $_pickId = "occupancy_id";
  public function getGroupTitle() {
    return _T("TRUE_VIEW_OCCUPANCY");
  }
  public function isCountData($type) {
    return True;
  }

  public function getCountType() {
      return "count";
  }

  public function addCountData($id, $type, $countData) {
    $camDb = Core_Model_Cameras::getInstance();
    $cam = $camDb->find($id)->current();
    $countData->addCamera($cam, array($type));
  }

  public function getAxes($dataTypeId) {
      $axes = array();
    if($dataTypeId == "avgt"){
        $axes[] = new Charts_Model_Axis_DurationOcc();
    }else{
        $axes[] = new Charts_Model_Axis_PeopleAverageOcc();
    }
    return $axes;
  }

  public function getUniqueIdentifier() {
    return "OCC";
  }

  public function _getAllSources($user) {
    $all = array();
    $app = Core_Model_Applications::getWithId(11);
    $cameras = Core_Model_Cameras::getInstance()->fetchAllVisible($user, $app);
    foreach($cameras as $camera) {
      foreach($this->_types as $cnt => $title) {
        $all[] = array(
          'name'       => $camera->name, 
          'id'         => $camera->camera_id,
          'sourcetype' => 'OCC',
          'type' => array(
            'title' => $title,
            'id'    => $cnt,
            'cdata' => True
          ),
        );
      }
    }
    return $all;
  }
}
