<?php

class Charts_Model_SourceType_PeopleCounter extends Charts_Model_SourceType_Abstract {

  protected $_pickId = "camera_id";
  public function getGroupTitle() {
    return _T("TRUE_VIEW_PEOPLE_COUNTER");
  }
  public function isCountData($type) {
    return True;
  }

  public function getCountType() {
      return "count";
  }

  public function addCountData($id, $type, $countData) {
    $camDb = Core_Model_Cameras::getInstance();
    $cam = $camDb->find($id)->current();
    $countData->addCamera($cam, array($type));
  }

  public function getUniqueIdentifier() {
    return "PC";
  }

  public function getAxes($dataTypeId) {
    $axes = array();
    $axes[] = new Charts_Model_Axis_People();
    return $axes;
  }

  public function _getAllSources($user) {
    $all = array();

    $app = Core_Model_Applications::getWithId(1);
    $cameras = Core_Model_Cameras::getInstance()->fetchAllVisible($user, $app);
    foreach($cameras as $camera) {
      
      foreach($this->_types as $cnt => $title) {
        $all[] = array(
          'name'       => $camera->name, 
          'id'         => $camera->camera_id,
          'sourcetype' => 'PC',
          'type' => array(
            'title' => $title,
            'id'    => $cnt,
            'cdata' => True
          ),
        );
      }
    }
    return $all;
  }
}
