<?php

abstract class Charts_Model_SourceType_PosAbstract extends Charts_Model_SourceType_Abstract {

  protected $_pickId = "pos_id";

  public function isCountData($type) {
    return True;
  }

  public function isPosData($type) {
    return True;
  }

  public function getCountType() {
    return "count";
  }

  protected function _getCameraIds($id) {
    $jobDb = Pos_Model_ImportJobs::getInstance();
    $job = $jobDb->find($id)->current();
    return $job->getCameras();
  }
  
  public function addCountData($id, $type, $countData) {
    if($type == 'in' || $type == 'out') {
        $jobDb = Pos_Model_ImportJobs::getInstance();
        $job = $jobDb->find($id)->current();
        foreach($job->getCameras() as $camId) {
            Charts_Model_SourceType_PeopleCounter::addCountData($camId, $type, $countData);   
        }
    } else {
        $camDb = Core_Model_Cameras::getInstance();
        $select = $camDb->select()
            ->where('name = ?',"#".$id)
            ->where('camera_group_id is NULL');
        $cam = $camDb->fetchAll($select)->current();
        if(!$cam) {
            error_log("Could not find camera #$id when adding Sales data");
        } else {
            $countData->addCamera($cam, array($type));
        }
    }
  }

  public function getAxes($dataTypeId) {
    $axes = array();
    $axes[] = new Charts_Model_Axis_Sales();
    $axes[] = new Charts_Model_Axis_People();
    return $axes;
  }

  public function expandSelections($selections) {
      if($selections == 'salecount') return array('sale','in');
      return array($selections);
  }

  public function _getAllSources($user) {
    $all = array();

    $jobs = Pos_Model_ImportJobs::getInstance()->fetchAllVisible($user);
    foreach($jobs as $job) {
      foreach(array('salecount' => 'SALES') as $cnt => $title) {
        $all[] = array(
          'name'       => $job->name, 
          'id'         => $job->pos_data_id,
          'sourcetype' => 'SALE',
          'type' => array(
            'title' => $title,
            'id'    => $cnt,
            'cdata' => True
          ),
        );
      }
    }
    return $all;
  }
}
