<?php

class Charts_Model_SourceType_Queue extends Charts_Model_SourceType_Abstract {
  protected $_types = array('high' => 'HIGH', 'mid' => 'MID', 'low' => 'LOW', 'people' => 'PEOPLE_IN_QUEUE');

  protected $_pickId = "queue_id";
  public $_sortPriority = array("people","high","mid", "low");
  public function getGroupTitle() {
    return _T("TRUE_VIEW_QUEUE");
  }
  public function isCountData($type) {
    return True;
  }
  public function getCountType() {
      return 'count';
  }
  public function addCountData($id, $type, $countData) {
    $camDb = Core_Model_Cameras::getInstance();
    $cam = $camDb->find($id)->current();
    $countData->addCamera($cam, array($type));
  }

  public function getUniqueIdentifier() {
    return "Q";
  }

  public function getAxes($dataTypeId) {
    $axes = array();
    if($dataTypeId == 'people'){
        $axes[] = new Charts_Model_Axis_PeopleAverageQueue();
    }else{  
        $axes[] = new Charts_Model_Axis_DurationQueue();
    }
    return $axes;
  }

  public function _getAllSources($user) {
    $all = array();
    $app = Core_Model_Applications::getWithId(7);
    $cameras = Core_Model_Cameras::getInstance()->fetchAllVisible($user, $app);
    foreach($cameras as $camera) {
      foreach($this->_types as $cnt => $title) {
        $all[] = array(
          'name'       => $camera->name, 
          'id'         => $camera->camera_id,
          'sourcetype' => 'Q',
          'type' => array(
            'title' => $title,
            'id'    => $cnt,
            'cdata' => True
          ),
        );
      }
    }
    return $all;
  }
}
