<?php

class Charts_Model_SourceType_Sales extends Charts_Model_SourceType_PosAbstract {
  protected $_types = array('salecount' => 'SALES');

  public function getGroupTitle() {
    return _T("SALES");
  }
  public function splitSelection($chosen) {
    if($chosen->dataTypeId == 'salecount') {
        $chosen->dataTypeId ='sale';
        $chosen->group = "pos";
        $all = array($chosen);
        foreach($this->_getCameraIds($chosen->id) as $id) {
            $cam = clone $chosen;
            $cam->group = "pc";
            $cam->identifier = "PC";
            $cam->dataTypeId = 'in';
            $cam->id = $id;
            $all[] = $cam;
        }
        return $all;
    } else {
        return array($chosen);
    }
  }

  public function getUniqueIdentifier() {
    return "S";
  }

  public function getAxes($dataTypeId) {
    $axes = array();
    $axes[] = new Charts_Model_Axis_Sales();
    $axes[] = new Charts_Model_Axis_People();
    return $axes;
  }

  public function expandSelections($selections) {
      if($selections == 'salecount') return array('sale','in');
      return array($selections);
  }

  public function _getAllSources($user) {
    $all = array();

    $jobs = Pos_Model_ImportJobs::getInstance()->fetchAllVisible($user);
    foreach($jobs as $job) {
      foreach($this->_types as $cnt => $title) {
        $all[] = array(
          'name'       => $job->name, 
          'id'         => $job->pos_data_id,
          'sourcetype' => 'S',
          'type' => array(
            'title' => $title,
            'id'    => $cnt,
            'cdata' => True
          ),
        );
      }
    }
    return $all;
  }
}
