<?php

class Charts_Model_SourceType_VirtualCamera extends Charts_Model_SourceType_Abstract {
  protected $_pickId = 'virtual_camera_id';

  public function getGroupTitle() {
    return _T("VIRTUAL_CAMERA");
  }

  public function isCountData($type) {
    return True;
  }

  public function getUniqueIdentifier() {
    return 'VC';
  }

  public function getCountType() {
      return "count";
  }

  public function addCountData($id, $type, $countData) {
    $db = Core_Model_VirtualCameras::getInstance();
    $vc = $db->find($id)->current();
    $countData->addVirtualCamera($vc, array($type));
  }

  public function getAxes($dataTypeId) {
    $axes = array();
    $axes[] = new Charts_Model_Axis_People();
    return $axes;
  }

  public function _getAllSources($user) {
    $all = array();
    $vcDb = Core_Model_VirtualCameras::getInstance();
    foreach($vcDb->fetchAllVisible($user) as $vc) {
        foreach($this->_types as $direction => $title) {
            $all[] = array(
              'name' => $vc->name, 
              'id'   => $vc->virtual_camera_id,
              'sourcetype' => 'VC',
              'type' => array(
                'title' => $title,
                'id'    => $direction
              ),
            );
        }
    }
    return $all;
  }
}
