<?php

class Charts_Model_TableListGenerator extends Core_Model_Generic_AbstractListView {
    public function getHeaders(){
        return array(_T("NAME"),_T("DESCRIPTION"));
    }

    protected function _dataRowToTableRow($row){
        $ret = array();
        $ret[] = $row->title;

        $ret['_document_id'] = Core_Model_DocumentFactory::getId($row->table_id, "table");

        $ret[] = $row->description;
        
        return $ret;
    }

    public function removeText(){
        return _T('DO_YOU_REALLY_WANT_TO_REMOVE_THE_TABLE_"%1$s"?');
    }

    protected function _dataRowToRowId($row){
        return $row->table_id;
    }

    public function noDataInformation(){
        return _T("THERE_ARE_NO_TABLES_IN_THIS_FOLDER.");
    }

    public function getActions($row){
        $folder = $this->_group->group_id;

        $creator = $this->_group->canEdit($this->_user);

        $actions = array();
        $actions[] = parent::CreateAction(_T('VIEW_TABLE'),'view', 'view', $folder);

        if($creator) {
            $actions[] = parent::CreateAction(_T('EDIT_TABLE'), 'add', 'edit', $folder);
            $actions[] = parent::CreateAction(_T('DELETE_TABLE'),'delete', 'delete', $folder);
            $actions[] = parent::CreateAction(_T('COPY_TABLE'),'copy', 'copy', $folder);
        }

        return $actions;
    }
}
