<?

class Charts_Model_TableSection extends Zend_Db_Table_Row {
    private $_entries = NULL;
    public function __construct($config = array()) {
        parent::__construct($config);
        $this->show_date = (int)($this->show_date);
        $this->_entries = array();
        if($config) {
            $arr = $this->toArray();
            if (array_key_exists("table_section_id", $arr) and $arr["table_section_id"] ) { 
                $tseDb = Charts_Model_TableSectionEntries::getInstance();
                $this->_entries = $tseDb->fetchAll("table_section_id = ".$arr["table_section_id"]);
            }
        } else {
            throw new Exception("Well this is not good");
        }
        if (count($this->_entries)>0 && !$this->_entries[0]) {
            throw new Exception("Well this is not good");
        }
    }

    public static function CreateNew($translate = false) {
        $tsDb = Charts_Model_TableSections::getInstance();
        $section = $tsDb->createRow();
        $section->title = $translate ? $translate->translate(_T("A_NEW_SECTION")) : "";
        $section->period = "0y";
        $section->show_date = 0;
        return $section;
    }

    public function addEntry($entry) {
        $this->_entries[] = $entry;
        return $this;
    }

    public function getEntries() {
        return $this->_entries;
    }

    public function renderArray($table, $translate, $generateDate, $use_cache = False) {
        // use section and table (sections excluded) print_r as key.
        $tmp = $table->_sections;
        $table->_sections = array();
        $cache_key = get_class($this).sha1(print_r($this->toNiceArray(),1)).sha1(print_r($table->toNiceArray(),1));
        // use crc32 to distribute the expiration of sections.
        $time = abs((round(crc32($cache_key)+time())/60/5) % 100000);
        $cache_key .= $time;
        $table->_sections = $tmp;
        $cache = Zend_Registry::get("cache");
        $elist = $use_cache ? $cache->load($cache_key) : false;
        if ( $elist ) {
            return $elist;
        } else {
            $elist = array(
                "title" => $this->title,
                "cleanTitle" => $this->title,
                "entries" => array()
            );
        }

        if($this->show_date){
            if($this->period == "fix"){
                $i = "[" . $this->period_from . " - " . $this->period_to . "]";
            }else if($this->period == "man"){
                $i = new CM_Interval($generateDate, $this->period_manual);
                $i = $i->toReadable();
            }else{
                $i = new CM_Interval($generateDate, $this->period);
                $i = $i->toReadable();
            }
            $elist["title"] = $elist["title"] . " " . $i;
        }
        foreach($this->_entries as $entry) {
            $elist["entries"][] = $entry->renderArray($table, $this, $translate, $generateDate);
        }
        $cache->save($elist, $cache_key);
        return $elist;
    }

    public function storeToDatabase($tableId) {
        $sectionDb = Charts_Model_TableSections::getInstance();
        $section = $sectionDb->createRow();
        $section->setFromArray(array_merge($this->toNiceArray(), array(
            "table_id" => $tableId
        )));
        $sectionId = $section->save();
        foreach($this->_entries as $entry) {
            $entry->storeToDatabase($sectionId);
        }
    }

    public static function fromArray($array) {
        $section = Charts_Model_TableSection::CreateNew();
        $section->title = $array["title"];
        $section->period = $array["period"];
        $section->period_from = $array["period_from"];
        $section->period_to = $array["period_to"];
        $section->period_manual = $array["period_manual"];
        $section->show_date = $array["show_date"];
        if(array_key_exists("entries", $array)) {
            foreach($array["entries"] as $entry) {
                $e = Charts_Model_TableSectionEntry::fromArray($entry);
                $section->addEntry($e);
            }
        }
        return $section;
    }

    public function toNiceArray() {
        $list = array();
        foreach( $this->_entries as $e) {
            $list[] = $e->toNiceArray();
        }
        return array(
            "entries" => $list,
            "period"  => $this->period,
            "period_from"  => $this->period_from,
            "period_to"  => $this->period_to,
            "period_manual"  => $this->period_manual,
            "title"   => $this->title,
            "show_date" => $this->show_date
        );
    }
}
