<?

class Charts_Model_TableSectionEntry extends Zend_Db_Table_Row {
    protected $selections;
    
    public function __construct($config = array()) {
        parent::__construct($config);
        if($config) {
            $arr = $this->toArray();
            if (array_key_exists("table_section_entry_id", $arr) && $arr["table_section_entry_id"] ) {
            }
            if (array_key_exists("selections_json", $arr) && $arr["selections_json"] ) {
                $this->selections = json_decode($arr["selections_json"]);
            }
        }
    }

    public function getCountData() {
        $camDb = Core_Model_Cameras::getInstance();
        $cd = new Core_Model_CountData();
        return $cd;
    }

    public static function CreateNew($translate = false) {
        $tseDb = Charts_Model_TableSectionEntries::getInstance();
        $entry = $tseDb->createRow();
        $entry->title = "";
        $entry->selections = array();
        return $entry;
    }

    public static function fromArray($array) {
        $entry = Charts_Model_TableSectionEntry::CreateNew();
        $entry->title = $array["title"];
        $entry->selections = $array["selections"] ? $array["selections"] : array();
        return $entry;
    }

    public function toNiceArray() {
        return array(
            "title" => $this->title,
            "selections" => $this->selections
        );
    }
/*
    public static function loadFromDatabase($id) {
        $tseDb = Charts_Model_TableSectionEntries::getInstance();
        $tsDb = Charts_Model_TableSections::getInstance();
        $entry = $tseDb->find($id)->current();
        r_log($entry, "loading from database");
        return $entry;
    }*/

    public function storeToDatabase($sectionId) {
        $tseDb = Charts_Model_TableSectionEntries::getInstance();
        $entry = $tseDb->createRow();
        $entry->setFromArray(array(
            "title"             => $this->title,
            "selections_json"   => json_encode($this->selections),
            "table_section_id"  => $sectionId
        ));
        $entry->save();
    }

    public function renderArray($table, $section, $translate, $generateDate) {
        $chart = new Charts_Model_ChartData();
        $chart->setAggregatorId($table->mode);
        $datasource = new Charts_Model_ChartDataSource();
        $datasource
            ->setTitle("TITLE")
            ->setTimeFilterCode($table->getTimeFilterCode());
        if($section->period == "fix"){
            $datasource->setTimePeriodFixed($section->period_from, $section->period_to);
        }else if($section->period == "man"){
            $datasource->setTimePeriodCode($section->period_manual);
        }else{
            $datasource->setTimePeriodCode($section->period);
        }
        $chart->_chartDataSource = array($datasource);
        $datasource->_data = array();
        
        foreach($this->selections as $selection) {
            if($selection[4]=="G") $unitName = "FEMALES";
            $datasource->_data[] = (object) array (
                "dataTypeId" => $selection[2],
                "identifier" => $selection[4],
                "id"         => $selection[1]
            );
        }
        
        $render = new Charts_Model_ChartRender_Array();
        $render->setGenerateDate($generateDate);
        $render->useCache($table->use_cache);
        $info = $render->render($chart,$table->show_tot,$table->show_avg);
        $types = count($info["data"]);
        if ( $types == 0 ) {
            $data = array();
            $labels = NULL;
            $unit = "";
        } else if ( $types == 1) {
            $data = $info["data"][0];
            $labels = $render->_dataLabels;
            $unit = $render->_dataSourceType[0];
        } else if ( $types == 2) {
            error_log("TODO: DO something fancy here");
            $data = $info["data"][0];
            $labels = $render->_dataLabels;
            $unit = $render->_dataSourceType[0];
        }
 
        if(count($data)>0 && $table->comp_tot != "never"){
            $datasource->setTimePeriodCode($table->comp_tot);
            $compTot = $render->render($chart,1);
            array_splice($data, count($data) - $table->show_avg, 0, end($compTot["data"][0]));
        }
        if(count($data)>0 && $table->comp_avg != "never"){
            $isAvg = $info["isAvg"][0];
            $usage = Charts_Model_DataAggregatorList::getUsageById($table->mode);
            if($usage == "HOUR_USAGE" && strpos($section->period,"d")==false && !$isAvg){  
                //if day usage is chosen and comparison is not a day, the numbers will be added. 
                //example 1300 persons came in at 11 during a certain month. Wierd
                $data[] = "-";
            }else if($usage == "WEEK_USAGE" && strpos($section->period, "w")==false && !$isAvg){
                //same thing here. nuber of poeple coming in during any monday is wierd too.
                $data[] = "-";
            }else if($usage == "DAY_OF_MONTH_USAGE" && strpos($section->period, "m")==false && !$isAvg){
                $data[] = "-";
            }else if($usage == "MONTH_USAGE" && strpos($section->period, "y")==false && !$isAvg){
                //using month usage it is wierd to compare other things than months
                $data[] = "-";
            }else if($usage == "MONTH_USAGE" && strpos($table->comp_avg, "y")==false && !$isAvg){
                //using month usage, the only logical averages to compare is month averages for other years. 
                //otherwise -
                $data[] = "-";
            /*    
            }else if($usage == "WEEK_USAGE" && strpos($table->comp_avg, "w")==false && !$isAvg){
                //comparing other averages than weekday average for a certain week is wierd
                $data[] = "-";
            }else if($usage == "DAY_OF_MONTH_USAGE" && strpos($table->comp_avg, "m")==false && !$isAvg){
                $data[] = "-";
             */

            }else{
                $forceAvg = true;
                $datasource->setTimePeriodCode($table->comp_avg);
                $compAvg = $render->render($chart,null,1, $forceAvg);
                $data[] = end($compAvg["data"][0]);
            }
        }

        $title = $this->title;
        $unitName = isset($unitName) ? $unitName : $unit;
        if(!$title)
            $title = $translate->translate($unitName);
//        else if($unitName) $title = $title . " (".$translate->translate($unitName).")";
        $done = array(
            "data" => $data,
            "xlabels" => $labels /*$agg->getXLabel()*/,
            "title" => $title,
            "unit" => $unit,
            "cleanTitle" => $this->title,
            "cleanUnit" => $translate->translate($unit)
        );
        return $done;

    }
}
