<?php
class Charts_Model_TableSectionEntryPdfRenderer {
    public    $_title;
    public    $_data;
    protected $_page;
    protected $_props;

    function __construct($entryData,$index){
        $this->_title       = $entryData['title'];
        $this->_data        = $entryData['data'];
        $this->_entryIndex  = $index;
    }

    public function setFont($font){
        $this->_font = $font;
    }

    public function setPage($page){
        $this->_page = $page;
    }

    public function setProps($props){
        $this->_props = $props;
    }

    public function drawEntry($yPos, $tr){
        $color = $tr->getOddZendColor();
        if($this->_entryIndex%2 == 0)
            $color = $tr->getEvenZendColor();
        
        Reports_Pdf_Drawer::drawRect($this->_page, $color, $tr->getStartX(), $tr->getEndX(), $yPos, $yPos - $tr->getEntryHeight());
        $xPos       = $tr->getStartX() + $tr->getTitlesWidth();
        $ytext      = $yPos - $tr->getVerticalMargin() - $tr->getBaseTextSize();
        $xPos       = $tr->getStartX() + $tr->getHorizontalMargin()*2 + $tr->getBaseTextSize();
        Reports_Pdf_Drawer::write_text_left($this->_page, $this->_title, $tr->getBaseTextSize(), $this->_font, $xPos, $ytext);
        $i = 0;
        foreach($this->_data as $c => $number){
            $x1 = $tr->getStartX() + $tr->getTitlesWidth() + $tr->getEntryCellWidth() *($c);
            $this->_drawNumber($number,$x1,$ytext, $tr->getbaseTextSize(), $tr);
        }
        /*
        $this->_page->setLineColor($this->_color)
            ->drawLine($this->_props['x1'], $yPos, $this->_props['x2'], $yPos)
            ->setLineColor(new Zend_Pdf_Color_Rgb(0,0,0));
        */

        return $yPos - $tr->getEntryHeight();
    }

    protected function _drawNumber($number, $x, $y, $fontsize, $tr){
        $darkGray           = new Zend_Pdf_Color_Rgb(0.35,0.35,0.35);
        $cellw              = $tr->getEntryCellWidth();
        if(strpos($number, "%") !== false){
            $cellw += Reports_Pdf_Drawer::get_text_width("%", $fontsize,$this->_font) * 1.15;
        }
        if(preg_replace("/[^\d]/", "", $number) == 0 ){
            $this->_page
                ->setFillColor($darkGray)
                ->setLineColor($darkGray);
        }else{
            $this->_page
                ->setFillColor(new Zend_Pdf_Color_Rgb(0,0,0))
                ->setLineColor(new Zend_Pdf_Color_Rgb(0,0,0));
        }
        Reports_Pdf_Drawer::write_text_right($this->_page, $number, $fontsize, $this->_font, $x, $y, $cellw - $tr->getHorizontalMargin());
    }

    public function _drawTable(){
        $fontSize           = $this->_numberSize;
        $margin             = ($this->_entryHeight - $fontSize)/2;

    }
}
