<?php
class Charts_Model_TableSectionPdfRenderer {
    protected $_sectionTitle;
    public    $_entries;
    protected $_page;
    protected $_sizes;
    protected $_font;

    function __construct($secData){
        $this->_sectionTitle    = $secData['title'];
        $this->_setEntries($secData['entries']);
    }

    private function _setEntries($entriesData){
        $entries = array();
        foreach($entriesData as $index => $entryData){
            $entry = new Charts_Model_TableSectionEntryPdfRenderer($entryData, $index);
            $entries[] = $entry;      
        }
        $this->_entries = $entries;
    }

    public function setFont($font){
        $this->_font = $font;
        foreach($this->_entries as $entry)
            $entry->setFont($font);
    }

    public function setPage($page){
        $this->_page = $page;
        foreach($this->_entries as $entry)
            $entry->setPage($page);
    }

    public function drawSection($yPos, $tr){
        $yPos = $this->_drawHeader($yPos, $tr);
        foreach($this->_entries as $entry){
            $yPos = $entry->drawEntry($yPos, $tr);
        }
        return $yPos;
    }

    public function getLongestEntryString(){
        $longest = "";
        foreach($this->_entries as $e){
            foreach($e->_data as $d){
                $strW = Reports_Pdf_Drawer::get_text_width($d, 10, $this->_font);
                $longestW = Reports_Pdf_Drawer::get_text_width($longest, 10, $this->_font);
                if($strW > $longestW)
                    $longest = $d;
            }
        }
        return $longest;
    }

    protected function _drawHeader($yPos, $tr){
        $fontsize    = $tr->getSectionTextSize();
        $draw        = new Reports_Pdf_Drawer($this->_page,$this->_font,$fontsize);
        $height      = $tr->getSectionHeight();
        $draw->drawRect($this->_page, $tr->getBlackZendColor(), $tr->getStartX(), $tr->getEndX(), $yPos, $yPos -= $tr->getLineWidth());
        $draw->drawRect($this->_page, $tr->getZendColor(), $tr->getStartX(), $tr->getEndX(), $yPos, $yPos - $height);
        $xPos = $tr->getStartX()+$tr->getHorizontalMargin() + $tr->getBaseTextSize()/2;
        $textPos = $yPos - $fontsize - $tr->getVerticalMargin()*1.25; 
        $draw->text_left($this->_sectionTitle, $xPos, $textPos, $fontsize);
        //$this->_page
        //    ->setFont($this->_font, $fontsize)
        //    ->drawTightText($this->_sectionTitle,$xPos, $textPos);
        return $yPos - $height;
    }
}

