<?php
class Charts_Model_TableSections extends Talking_Db_Table
{
    protected $_name = 'table_section';
    protected $_primary = 'table_section_id';
    protected $_rowClass = 'Charts_Model_TableSection';

    protected $_dependentTables = array('Charts_Model_TableSectionEntries');

    protected $_referenceMap = array(
        'Charts_Model_Table' => array(
            'columns' => array('table_id'),
            'refTableClass' => 'Charts_Model_Tables',
            'refColumns' => array('table_id')
        )
    );

    public function __construct() {
        parent::__construct();
    }

    public static function removeSectionsForTable($tableId) {
        $tsDb = self::getInstance();
        $sections = $tsDb->fetchAll($tsDb->select()->where('table_id = ?', $tableId));
        foreach($sections as $section) {
            $section->delete();
        }
    }
}
