<?php
class Charts_Model_TableTimesPdfRenderer {
    public $_times;

    function __construct($timesData, $timesTitle){
        $this->_times = $timesData;
        $this->_timesTitle = $timesTitle;
    }

    public function setPage($page){
        $this->_page = $page;
    }

    public function setFont($font){
        $this->_font = $font;
    }

    public function getLongestString(){
        //get longest string cut or no cut
        $times = $this->_times;
/*        if(!preg_match('/\d/', $times[1])){
            foreach($this->_times as $i => $time){
                $words = explode(" ", $time);
                if(strlen($words[0]) > 4)
                    $words[0] = substr($words[0],0,3);
                $time = implode(" ", $words);
                $this->_times[$i] = $time;
            }
        }*/
        $longest  = "";
        foreach($times as $time){
            $words = explode(" ", $time);
            $lines = array($time);
            if(count($words)>1 && strlen($words[0]) > 4){
                $lines[0] = implode(" ", array_slice($words, 0, count($words)/2));
                $lines[1] = implode(" ", array_slice($words, count($words)/2));
            }
            foreach($lines as $word){
                $strW = Reports_Pdf_Drawer::get_text_width($word, 10, $this->_font);
                $longestW = Reports_Pdf_Drawer::get_text_width($longest, 10, $this->_font);
                if($strW > $longestW){
                    $longest = $word;
                }
            }
        }
        return $longest;
    }

    public function isTwoRows(){
        foreach($this->_times as $time){
            $words = explode(" ", $time);
            if(count($words)>1 && strlen($words[0]) > 2)
                return true;
        }
        return false;
    }

    public function cutTimesIfNeeded($tr){
        // This feature should not be active, since it is 
        // not confirmed it works in all languages
        if ( true ) return;

        $cut = false;
        foreach($this->_times as $time){
            $strW = Reports_Pdf_Drawer::get_text_width($time, $tr->getBaseTextSize(), $this->_font);
            if($tr->getEntryCellWidth() > $strW + 10) {
                $cut = true;
            }
        }
        if($cut && !preg_match('/\d/', $this->_times[1])){
            foreach($this->_times as $i => $time){
                $words = explode(" ", $time);
                if(mb_strlen($words[0], 'UTF-8') > 2)
                    $words[0] = mb_substr($words[0],0,3,'UTF-8');
                $time = implode(" ", $words);
                $this->_times[$i] = $time;
            }
        }
    }

    public function drawTimes($tr){
        $this->cutTimesIfNeeded($tr);
        $draw       = new Reports_Pdf_Drawer($this->_page, $this->_font, $tr->getBaseTextSize());
        $isTwoRows  = $this->isTwoRows();
        $black      = $tr->getBlackZendColor();
        $gray       = $tr->getLightGrayZendColor();
        $height     = $tr->getEntryHeight();
        if($isTwoRows)
            $height+= $tr->getBaseTextSize() + $tr->getVerticalMargin();
        $y          = $tr->getStartY()-$height;
        $box   = array(
            array($tr->getStartX(),
                  $tr->getStartY()),
            array($tr->getEndX(),
                  $y)
        );
        
        $this->_page->setFillColor($gray)
             ->setLineColor($gray)
             ->drawRectangleFromArray($box)
             ->setFillColor($black)
             ->setLineColor($black);
        $yText = $y + ($height - $tr->getBaseTextSize())/2;
        $yText2= $y + $tr->getVerticalMargin();
        $yText1= $yText2 + $tr->getBaseTextSize() + $tr->getVerticalMargin();
        $x = $tr->getStartX()+$tr->getHorizontalMargin() + $tr->getBaseTextSize()/2;
        $draw->text_left($this->_timesTitle,$x, $yText);
        $x = $tr->getStartX() + $tr->getTitlesWidth();
        $cellWidth = $tr->getEntryCellWidth();
        foreach($this->_times as $k => $label){
            $words = explode(" ", $label);
            if(count($words)>1 && strlen($words[0]) > 2){
                $row1 = implode(" ", array_slice($words, 0, count($words)/2));
                $row2 = implode(" ", array_slice($words, count($words)/2));
                $draw->text_right($row1,$x,$yText1,$cellWidth-$tr->getHorizontalMargin());
                $draw->text_right($row2,$x,$yText2,$cellWidth-$tr->getHorizontalMargin());
            }else{
                $draw->text_right($label,$x,$yText,$cellWidth-$tr->getHorizontalMargin());
            }
            $x += $cellWidth;
        }
        return $y - $tr->getLineWidth();
    }
}
