<?php

class Charts_Model_Tables extends Core_Model_DocumentTableAbstract
{
    protected $_name = 'table';
    protected $_primary = 'table_id';
    protected $_rowClass = "Charts_Model_Table";

    protected $_dependentTables = array('Charts_Model_TableSections', 'Charts_Model_TableSections');

    protected $_referenceMap = array(
    );


    public function __construct() {
        parent::__construct();
    }

    public function userCanSeeTable($tableId,$identity){
        $list = $this->fetchAllVisible($identity);

        foreach($list as $table){
            if($table['table_id'] == $tableDataId){
                return true;
            }
        }
        return false;
    }

    public function fetchAllVisible($user) {
        $groupsDb = new Core_Model_Folders();
        $groups = $groupsDb->getViewableGroups($user);
       
        $tables = array();

        foreach($groups as $group) {
            $documents = $group->findDependentRowset('Core_Model_Documents');
            foreach($documents as $document) {
                $table = $this->find($document->id)->current();
                if($table)
                    $tables[] = $table;
            }
        }

        return $tables;
    }

    public function fetchAllVisibleSorted($user) {
        $groupsDb = Core_Model_Folders::getInstance();
        $groups = $groupsDb->getViewableGroups($user); 

        $ret = array();
        $companiesDb = new Core_Model_Companies();

        foreach($groups as $group) {
            $select = $this->select()->
                setIntegrityCheck(FALSE)->
                from(array('t' => 'table'), array('*'))->
                join(array('d' => 'document'), 't.table_id = d.id', array())->
                where('d.type = ?', 'table')->
                where('d.group_id = ?', $group->group_id)->
                order('t.title');

            $tables = $this->fetchAll($select);
            foreach($tables as $table) {
                if($user->multi_company){
                    $ret[$companiesDb->find($group->company_id)->current()->name . ": " . $group->name][$table->table_id] = $table->title;
                }else 
                    $ret[$group->name][$table->table_id] = $table->title;
            }
        }

        return $ret;

        uksort($tables, "strcasecmp");
        $tablesSorted = array();
        foreach($tables as $k => $companyCharts){
            uasort($companyCharts, "strcasecmp");
            $tablesSorted[$k] = $companyCharts;
        }

        return $tablesSorted;
    }

    public function findNextCopyName($id){
        $title = $this->find($id)->current()->title;
        preg_match('/^.*\\(copy/',$title, $matches);
        if(count($matches) > 0) $title = substr($matches[0],0,-strlen(' (copy')); 

        $dDb = new Core_Model_Documents();
        $select = $dDb->select()->where("type = ?", "table")->where("id = ?", $id);
        $folder_id = $dDb->fetchRow($select)->group_id; 
        
        $db = Zend_Registry::get('db');
        $sql = "select * from `document` join(`table`) on (`table`.table_id = document.id) where type = 'table' AND group_id = " . $db->quote($folder_id) . " AND title like " . $db->quote($title . " (copy%");
        $copys = $db->query($sql)->fetchAll();
        if(count($copys) == 0)
            return $title . " (copy)";

        return $title . " (copy " . count($copys) . ")";
    }

    /*
     * Return a list of Tables that belong to $group.
     */
    public function fetchDocuments($group) {
        // TODO: Write a nice JOIN.
        $documents = $group->getDocuments('table');
        $tablesDb = new Charts_Model_Tables();

        $tables = array();
        foreach($documents as $doc) {
            $table = $tablesDb->find($doc->id)->current();
            if($table) {
                $tables[] = $table;
            }
        }

        return $tables;
    }
}
