<?php

class Core_Model_Api extends WebReport_Model_Api_Abstract {

	public function getUserInfo($params) {
		$necessaryParams = array('e-mail');

		$this->checkValidParams(array_keys($params), $necessaryParams);

		$usersDb = new Core_Model_Users();
		$user = $usersDb->fetchWithEmail($params['e-mail']);
//		Zend_Debug::dump($user);
		if (!$user || !$user->active)
			return false;

		$data = $user->toArray();
		unset($data['password'], $data['password_salt'], $data['role_id'], 
			$data['locale'], $data['created_by'], $data['active'], $data['company_id']);

		$data['company'] = $user->findParentCompaniesByCompany()->name;

		$data = $this->_fixArrayKeys($data, array('user_id' => 'id'));
		$return = array();
		$return['user'] = $data;
		return $return;

	}

	public function getCompanyInfo($params) {
		$necessaryParams = array('name');

		$this->checkValidParams(array_keys($params), $necessaryParams);

		$companiesDb = new Core_Model_Companies();
		$company = $companiesDb->fetchWithName($params['name']);
//		Zend_Debug::dump($user);
		if (!$company || !$company->active)
			return false;

		$data = $company->toArray();
/*		unset($data['password'], $data['password_salt'], $data['role_id'],
			$data['locale'], $data['created_by'], $data['active'], $data['company_id']);*/

/*		$data['company'] = $user->findParentCompaniesByCompany()->name;*/

		$data = $this->_fixArrayKeys($data, array('company_id' => 'id'));
		$return = array();
		$return['company'] = $data;
		return $return;

	}


}

