<?php

class Core_Model_Api_Method_Installation_RunUpdate extends WebReport_Api_Method_Abstract
{
    public function userIsAllowed(Core_Model_User $user)
    {
        if ( $user->multi_company ) {
            return true;
        }
    }

    public function needsAuthentication() {
        return true;
    }

    public function call(array $params)
    {
        header("Content-Type: text");
        $writer = new Zend_Log_Writer_Stream("php://output");
        $logger = new Zend_Log($writer);
        $db = Zend_Registry::get("db");
        $autoloader = Zend_Loader_Autoloader::getInstance();
        $resourceLoader = new Zend_Loader_Autoloader_Resource(array(
            'basePath'  => APPLICATION_PATH . "/modules/installation",
            'namespace' => ucfirst("Installation")
        ));
        $resourceLoader->addResourceType('model', 'models/', 'Model');

        $dbUpdate = new Installation_Model_DatabaseUpdate($db->getConnection(), false, $logger, false);
        if ( isset($params["params"]["class"]) ) {
            $class = "Installation_Model_DatabaseUpdateEntry_" . $params["params"]["class"];
            if(!class_exists($class)) {
                return array("error" =>"Could not find class '$class'.");
            }
            $dbUpdate->clearUpdates();
            $dbUpdate->addUpdate($class);
            $dbUpdate->sync($logger, false, 0);
        } else {
            return array("error" => "No class specified. Example: class=WR320p0_Update0263");
        }
    }
}
