<?php

class Core_Model_Api_Method_OpeningHours_Recalculate extends WebReport_Api_Method_Abstract
{
    public function userIsAllowed(Core_Model_User $user)
    {
        if ($user->multi_company) {
            return true;
        }
    }

    public function needsAuthentication()
    {
        return true;
    }


    public function call(array $params)
    {
        ini_set('max_execution_time', 14400); //Let script run for 4h
        $cameraDb = Core_Model_Cameras::getInstance();
        if (isset($params["params"]["camera_ids"])) {
            $select = $cameraDb->select();
            $cameraIds = $params["params"]["camera_ids"];
            $cameraIds = explode(" ", $cameraIds);
            $select->where('camera_id IN (?)', $cameraIds);
        }
        $cameras = $cameraDb->fetchAll($select);
        foreach ($cameras as $camera) {
            r_log($camera->name, "Starting recalculations for camera: ");
            $countDataHandler = new Core_Model_CountData();
            $countDataHandler->addCamera($camera);
            $success = $countDataHandler->recalculateOpeningHours($camera);
            $result = "Result for \"$camera->name\": ";
            if ($success) {
                $result = $result . "Recalculated opening hours without errors.";
            } else {
                $result = $result . "Something went wrong.";
            }
            echo nl2br($result. "\n");
            ob_flush();
        }
    }
}
