<?php

abstract class Core_Model_Application_Abstract
{

    protected $_applicationId;
    protected $_name;
    protected $_shortName;
    protected $_abbreviatedName;
    protected $_outTypes;
    protected $_inTypes;

    public function __construct()
    {
        $this->init();
    }

    public static function letAppModifyData($data)
    {
        return $data;
    }

    public function hasEventData()
    {
        return ($this instanceof Core_Model_Application_AsEventDataInterface);
    }

    public function addOutType($id, $text, $graphOptions = null)
    {
        $this->_outTypes[$id] = $text;
        $this->_graphOptions[$id] = $graphOptions;
    }

    public function addInType($type)
    {
        $this->_inTypes[$type] = $type;
    }

    public function getInTypes()
    {
        return $this->_inTypes;
    }

    public function getOutTypes()
    {
        return $this->_outTypes;
    }

    public function init()
    {
        
    }

    public function getId()
    {
        return $this->_applicationId;
    }

    public function setId($id)
    {
        $this->_applicationId = $id;
    }

    public function getName()
    {
        return $this->_name;
    }

    public function setName($name)
    {
        $this->_name = $name;
    }

    public function getShortName()
    {
        return $this->_shortName;
    }

    public function setShortName($shortName)
    {
        $this->_shortName = $shortName;
    }

    public function setAbbreviatedName($abb)
    {
        $this->_abbreviatedName = $abb;
    }

    public function getAbbreviatedName()
    {
        return $this->_abbreviatedName;
    }

}

