<?php

class Core_Model_Application_Demographics extends Core_Model_Application_CountDataAbstract implements Core_Model_Application_AsEventDataInterface
{
    //These should be the same as db columns.
    const GENDER = 'gender';
    const AGE = 'age';
    const TRACK_START_TIME = 't_start';
    const TRACK_END_TIME = 't_end';
    const AVERAGE_BOXSIZE = 'avg_boxsize';
    const TRACK_ID = 'event_data_demographics_id';

    const DEMOGRAPHICS_MALE_0_TO_14 = 'male_0_to_14';
    const DEMOGRAPHICS_MALE_15_TO_24 = 'male_15_to_24';
    const DEMOGRAPHICS_MALE_25_TO_34 = 'male_25_to_34';
    const DEMOGRAPHICS_MALE_35_TO_44 = 'male_35_to_44';
    const DEMOGRAPHICS_MALE_45_TO_54 = 'male_45_to_54';
    const DEMOGRAPHICS_MALE_55_TO_64 = 'male_55_to_64';
    const DEMOGRAPHICS_MALE_65_TO_74 = 'male_65_to_74';
    const DEMOGRAPHICS_MALE_75_TO_INF = 'male_75_to_inf';


    const DEMOGRAPHICS_FEMALE_0_TO_14 = 'female_0_to_14';
    const DEMOGRAPHICS_FEMALE_15_TO_24 = 'female_15_to_24';
    const DEMOGRAPHICS_FEMALE_25_TO_34 = 'female_25_to_34';
    const DEMOGRAPHICS_FEMALE_35_TO_44 = 'female_35_to_44';
    const DEMOGRAPHICS_FEMALE_45_TO_54 = 'female_45_to_54';
    const DEMOGRAPHICS_FEMALE_55_TO_64 = 'female_55_to_64';
    const DEMOGRAPHICS_FEMALE_65_TO_74 = 'female_65_to_74';
    const DEMOGRAPHICS_FEMALE_75_TO_INF = 'female_75_to_inf';

    public function asEventDataApplication(){
        $app = new Core_Model_Application_DemographicsEventData();
        return $app;
    }

    public function init()
    {
        parent::init();

        $male_0_to_14 =  _T('male_0_to_14');
        $male_15_to_24 = _T('male_15_to_24');
        $male_25_to_34 = _T('male_25_to_34');
        $male_35_to_44 = _T('male_35_to_44'); 
        $male_45_to_54 = _T('male_45_to_54');
        $male_55_to_64 = _T('male_55_to_64');
        $male_65_to_75 = _T('male_65_to_74');
        $male_75_to_inf =_T('male_75_to_inf');

        $female_0_to_14 =  _T('female_0_to_14');
        $female_15_to_24 = _T('female_15_to_24');
        $female_25_to_34 = _T('female_25_to_34');
        $female_35_to_44 = _T('female_35_to_44'); 
        $female_45_to_54 = _T('female_45_to_54');
        $female_55_to_64 = _T('female_55_to_64');
        $female_65_to_75 = _T('female_65_to_74');
        $female_75_to_inf =_T('female_75_to_inf');

        $gender = _T("GENDER");
        $age = _T("AGE");
        $t_start = _T("TRACK_START_TIMESTAMP");
        $t_end = _T("TRACK_END_TIMESTAMP");
        $avg_boxsize = _T("AVERAGE_BOXSIZE");
        $track_id = _T("UNIQUE_TRACK_ID");
        if (Zend_Registry::isRegistered('Zend_Translate')) {
            $translate = Zend_Registry::get('Zend_Translate');

            $male_0_to_14 = $translate->_($male_0_to_14);
            $male_15_to_24 = $translate->_($male_15_to_24);
            $male_25_to_34 = $translate->_($male_25_to_34);
            $male_35_to_44 = $translate->_($male_35_to_44);
            $male_45_to_54 = $translate->_($male_45_to_54);
            $male_55_to_64 = $translate->_($male_55_to_64);
            $male_65_to_75 = $translate->_($male_65_to_75);
            $male_75_to_inf = $translate->_($male_75_to_inf);

            $female_0_to_14 = $translate->_($female_0_to_14);
            $female_15_to_24 = $translate->_($female_15_to_24);
            $female_25_to_34 = $translate->_($female_25_to_34);
            $female_35_to_44 = $translate->_($female_35_to_44);
            $female_45_to_54 = $translate->_($female_45_to_54);
            $female_55_to_64 = $translate->_($female_55_to_64);
            $female_65_to_75 = $translate->_($female_65_to_75);
            $female_75_to_inf = $translate->_($female_75_to_inf);
        }
        $this->addOutType(self::DEMOGRAPHICS_MALE_0_TO_14, $male_0_to_14);
        $this->addOutType(self::DEMOGRAPHICS_MALE_15_TO_24, $male_15_to_24);
        $this->addOutType(self::DEMOGRAPHICS_MALE_25_TO_34, $male_25_to_34);
        $this->addOutType(self::DEMOGRAPHICS_MALE_35_TO_44, $male_35_to_44);
        $this->addOutType(self::DEMOGRAPHICS_MALE_45_TO_54, $male_45_to_54);
        $this->addOutType(self::DEMOGRAPHICS_MALE_55_TO_64, $male_55_to_64);
        $this->addOutType(self::DEMOGRAPHICS_MALE_65_TO_74, $male_65_to_75);
        $this->addOutType(self::DEMOGRAPHICS_MALE_75_TO_INF, $male_75_to_inf);
        $this->addOutType(self::DEMOGRAPHICS_FEMALE_0_TO_14, $female_0_to_14);
        $this->addOutType(self::DEMOGRAPHICS_FEMALE_15_TO_24, $female_15_to_24);
        $this->addOutType(self::DEMOGRAPHICS_FEMALE_25_TO_34, $female_25_to_34);
        $this->addOutType(self::DEMOGRAPHICS_FEMALE_35_TO_44, $female_35_to_44);
        $this->addOutType(self::DEMOGRAPHICS_FEMALE_45_TO_54, $female_45_to_54);
        $this->addOutType(self::DEMOGRAPHICS_FEMALE_55_TO_64, $female_55_to_64);
        $this->addOutType(self::DEMOGRAPHICS_FEMALE_65_TO_74, $female_65_to_75);
        $this->addOutType(self::DEMOGRAPHICS_FEMALE_75_TO_INF, $female_75_to_inf);

        $this->addInType(Core_Model_CountData::TYPE_DEMOGRAPHICS_MALE_0_TO_14);
        $this->addInType(Core_Model_CountData::TYPE_DEMOGRAPHICS_MALE_15_TO_24);
        $this->addInType(Core_Model_CountData::TYPE_DEMOGRAPHICS_MALE_25_TO_34);
        $this->addInType(Core_Model_CountData::TYPE_DEMOGRAPHICS_MALE_35_TO_44);
        $this->addInType(Core_Model_CountData::TYPE_DEMOGRAPHICS_MALE_45_TO_54);
        $this->addInType(Core_Model_CountData::TYPE_DEMOGRAPHICS_MALE_55_TO_64);
        $this->addInType(Core_Model_CountData::TYPE_DEMOGRAPHICS_MALE_65_TO_74);
        $this->addInType(Core_Model_CountData::TYPE_DEMOGRAPHICS_MALE_75_TO_INF);
        $this->addInType(Core_Model_CountData::TYPE_DEMOGRAPHICS_FEMALE_0_TO_14);
        $this->addInType(Core_Model_CountData::TYPE_DEMOGRAPHICS_FEMALE_15_TO_24);
        $this->addInType(Core_Model_CountData::TYPE_DEMOGRAPHICS_FEMALE_25_TO_34);
        $this->addInType(Core_Model_CountData::TYPE_DEMOGRAPHICS_FEMALE_35_TO_44);
        $this->addInType(Core_Model_CountData::TYPE_DEMOGRAPHICS_FEMALE_45_TO_54);
        $this->addInType(Core_Model_CountData::TYPE_DEMOGRAPHICS_FEMALE_55_TO_64);
        $this->addInType(Core_Model_CountData::TYPE_DEMOGRAPHICS_FEMALE_65_TO_74);
        $this->addInType(Core_Model_CountData::TYPE_DEMOGRAPHICS_FEMALE_75_TO_INF);

        $this->setId(12);
        $this->setName("AXIS Demographic Identifier");
        $this->setShortName("AXIS Demographic Identifier");
        $this->setAbbreviatedName("dg");
    }

    public function getCntMapping(){
            return array(
                self::DEMOGRAPHICS_MALE_0_TO_14 => Core_Model_CountData::TYPE_DEMOGRAPHICS_MALE_0_TO_14,
                self::DEMOGRAPHICS_MALE_15_TO_24 => Core_Model_CountData::TYPE_DEMOGRAPHICS_MALE_15_TO_24,
                self::DEMOGRAPHICS_MALE_25_TO_34 => Core_Model_CountData::TYPE_DEMOGRAPHICS_MALE_25_TO_34,
                self::DEMOGRAPHICS_MALE_35_TO_44 => Core_Model_CountData::TYPE_DEMOGRAPHICS_MALE_35_TO_44,
                self::DEMOGRAPHICS_MALE_45_TO_54 => Core_Model_CountData::TYPE_DEMOGRAPHICS_MALE_45_TO_54,
                self::DEMOGRAPHICS_MALE_55_TO_64 => Core_Model_CountData::TYPE_DEMOGRAPHICS_MALE_55_TO_64,
                self::DEMOGRAPHICS_MALE_65_TO_74 => Core_Model_CountData::TYPE_DEMOGRAPHICS_MALE_65_TO_74,
                self::DEMOGRAPHICS_MALE_75_TO_INF => Core_Model_CountData::TYPE_DEMOGRAPHICS_MALE_75_TO_INF,
                self::DEMOGRAPHICS_FEMALE_0_TO_14 => Core_Model_CountData::TYPE_DEMOGRAPHICS_FEMALE_0_TO_14,
                self::DEMOGRAPHICS_FEMALE_15_TO_24 => Core_Model_CountData::TYPE_DEMOGRAPHICS_FEMALE_15_TO_24,
                self::DEMOGRAPHICS_FEMALE_25_TO_34 => Core_Model_CountData::TYPE_DEMOGRAPHICS_FEMALE_25_TO_34,
                self::DEMOGRAPHICS_FEMALE_35_TO_44 => Core_Model_CountData::TYPE_DEMOGRAPHICS_FEMALE_35_TO_44,
                self::DEMOGRAPHICS_FEMALE_45_TO_54 => Core_Model_CountData::TYPE_DEMOGRAPHICS_FEMALE_45_TO_54,
                self::DEMOGRAPHICS_FEMALE_55_TO_64 => Core_Model_CountData::TYPE_DEMOGRAPHICS_FEMALE_55_TO_64,
                self::DEMOGRAPHICS_FEMALE_65_TO_74 => Core_Model_CountData::TYPE_DEMOGRAPHICS_FEMALE_65_TO_74,
                self::DEMOGRAPHICS_FEMALE_75_TO_INF => Core_Model_CountData::TYPE_DEMOGRAPHICS_FEMALE_75_TO_INF
            );
    }

    public function getTimeResolutions()
    {
        $translate = Zend_Registry::get('Zend_Translate');
        $return = array();
        $return["ts15min"] = $translate->_("COUNT_TIME_RESOLUTION_FIFTEEN_MINUTES");
        $return["ts30min"] = $translate->_("COUNT_TIME_RESOLUTION_HALF_HOUR");
        $return["ts1h"] = $translate->_("COUNT_TIME_RESOLUTION_HOUR");
        $return["ts6h"] = $translate->_("COUNT_TIME_RESOLUTION_QUARTER_DAY");
        $return["ts12h"] = $translate->_("COUNT_TIME_RESOLUTION_HALF_DAY");
        $return["ts1d"] = $translate->_("COUNT_TIME_RESOLUTION_DAY");
        $return["ts1w"] = $translate->_("COUNT_TIME_RESOLUTION_WEEK");
        $return["ts2w"] = $translate->_("COUNT_TIME_RESOLUTION_TWO_WEEKS");
        $return["ts1m"] = $translate->_("COUNT_TIME_RESOLUTION_MONTH");
        $return["ts1q"] = $translate->_("COUNT_TIME_RESOLUTION_QUARTER_OF_YEAR");
        $return["ts1y"] = $translate->_("COUNT_TIME_RESOLUTION_YEAR");

        return $return;
    }

    public function getSqlQueryForCntOutType($outType, $camera, $coalesce = false)
    {
        if ($camera instanceof Core_Model_Camera) {
            $cameraId = $camera->camera_id;
        } else {
            $cameraId = $camera;
        }

        $type = -1;
        $types = $this->getCntMapping();

        if(isset($types[$outType])){
            $type = $types[$outType];
        } else {
            throw new WebReport_Exception("Not valid outtype");
        }

        $ret = "SUM(IFNULL(";
        if ($coalesce) { $ret .= "COALESCE("; }
        $ret .= "c" . $cameraId . "_" . $type;
        if ($coalesce) { $ret .= ",0)"; }
        $ret .= ",0))";

        return $ret;
    }

    public static function aggregateData($data){
        if (count($data['data'])) {
            new DemographicsAggregateData($data);
        }

    }

}

class CountDataEntry {
    public $version;
    public $username;
    public $pass;
    public $serial;
    public $regcode;
    public $cameraName;
    public $fields;
    public $stats;
    public $cnttime;
    public $nbrOfTypes;

    public function __construct($data, $timestamp, $rowdata)
    {
        $this->username = $data['user'];
        $this->pass = $data['pass'];
        $this->regcode = $data['camera_regcode'];
        $this->serial = $data['camera_serial'];
        $this->version = 5;
        $this->fields = 10;
        $this->cameraName = $data['camera_name'];
        $datetime = DateTime::createFromFormat('U.u', $timestamp + $data['utc_offset']);
        if (!$datetime) {
            $datetime = DateTime::createFromFormat('U', $timestamp + $data['utc_offset']);
        }
        $this->cnttime = $datetime->format('YmdHis');
        $this->stats = $rowdata;
        $this->nbrOfTypes = count($rowdata);
    }
}

class DemographicsAggregateData {


    private $_boxes;
    private $_camera;
    private $_data;
    private $_countDataDb;

    const KEY_TIMESTAMP = 1;
    const KEY_GENDER = 2;
    const KEY_AGE = 3;
    const TIMERESOLUTION = 900; // 15*60;

    /* This number is used, since AddDataForSeparatedStrings does not trust the timestamp of the data packages,
     * or that the legacy PeopleCounter packages report their interval end times,
     but should be sorted by start time in db.*/
    const MAGIC_FUCKING_NUMBER = 900;

    public function __construct($data){

        $this->setup($data);
        $this->processOldEntries();
        $this->processNewEntries();
        $this->exportData();
    }

    private function setup($data)
    {
        $camerasDb = Core_Model_Cameras::getInstance();

        $camera = $camerasDb->fetchCamera(array(
            "name"      => $data['camera_name'],
            "username"  => $data['user'],
            "password"  => $data['pass'],
        ));
        $this->_camera = $camera;

        $countDataDb = new Core_Model_CountData();
        $countDataDb->addCamera($camera);
        $countDataDb->initDatabaseSelect();
        $this->_countDataDb = $countDataDb;

        $this->_data = $data;
        $this->_boxes = array();
    }


    private function processOldEntries(){
        $start_time = $this->_data['utc_time_start'] + $this->_camera->utc_offset;
        $end_time = $this->_data['utc_time_end'] + $this->_camera->utc_offset;
        $cntData = $this->_countDataDb->getData("ts15min",
            $this->dateBox($start_time),
            $this->dateBox($end_time),
            null, //timefilter
            null, //row_limit
            true //high_resolution
        );
        if (count($cntData)) {
            $colnames = $this->colnames();
            foreach ($cntData as $row){
                // Translate back the time
                $box = Core_Model_EventData::fromLocalDateTimeToUTCTimestamp($row->cnttime, $this->_camera->utc_offset) + self::MAGIC_FUCKING_NUMBER;
                foreach($colnames as $colname => $fieldtype){
                    $this->add($box, $fieldtype, $row->{$colname});
                }
            }
        }
    }

    private function processNewEntries(){
        foreach ($this->_data['data'] as $row) {
            $this->addRow($row);
        }
    }

    private function exportData(){
        foreach ($this->getBoxes() as $box => $rowdata) {
            $entry = new CountDataEntry($this->_data, $box, $rowdata);
                try{
                    $this->_countDataDb->addDataForSeparatedString($entry);
                }catch(Exception $e){
                    error_log($e->getMessage());
                }

            }
    }

    public function colnames(){
        $app = new Core_Model_Application_Demographics();
        $mapping = $app->getCntMapping();
        $ret = array();
        foreach($mapping as $colname => $fieldtype){
            $ret["c{$this->_camera->camera_id}_$colname"] = $fieldtype;
        }
        return $ret;
    }

    public static function dateBox($timestamp){
        $box = self::timeBox($timestamp);
        $date = new Zend_Date($box, Zend_Date::TIMESTAMP); //"Y-m-d H:i:s");
        $date->setTimeZone('UTC');
        return $date;
    }

    public static function timeBox($timestamp){
        $box = intval($timestamp - $timestamp % self::TIMERESOLUTION);
        return $box;
    }


    private function add($box, $type, $num){
        if (!isset($this->_boxes[$box])){
            $this->_boxes[$box] = $this->emptyBox();
        }

        $this->_boxes[$box][$type] += $num;
    }

    private function addRow($row){
        if (!empty($row)) {
            $box = self::timeBox($row[self::KEY_TIMESTAMP] + self::MAGIC_FUCKING_NUMBER);
            $age = $row[self::KEY_AGE];
            $gender = $row[self::KEY_GENDER];
            $this->add($box, $this->classify($age, $gender), 1);
        }
    }

    public function getBoxes(){
        return $this->_boxes;
    }

    private function classify($age, $gender){
        switch($gender){
        case -1:
            if ($age < 15) {
                return Core_Model_CountData::TYPE_DEMOGRAPHICS_FEMALE_0_TO_14;
            } elseif ($age < 25) {
                return Core_Model_CountData::TYPE_DEMOGRAPHICS_FEMALE_15_TO_24;
            } elseif ($age < 35) {
                return Core_Model_CountData::TYPE_DEMOGRAPHICS_FEMALE_25_TO_34;
            } elseif ($age < 45) {
                return Core_Model_CountData::TYPE_DEMOGRAPHICS_FEMALE_35_TO_44;
            } elseif ($age < 55) {
                return Core_Model_CountData::TYPE_DEMOGRAPHICS_FEMALE_45_TO_54;
            } elseif ($age < 65) {
                return Core_Model_CountData::TYPE_DEMOGRAPHICS_FEMALE_55_TO_64;
            } elseif ($age < 75) {
                return Core_Model_CountData::TYPE_DEMOGRAPHICS_FEMALE_65_TO_74;
            } elseif ($age >= 75) {
                return Core_Model_CountData::TYPE_DEMOGRAPHICS_FEMALE_75_TO_INF;
            } else {
                throw WebReport_Exception_ParameterError("Could not classify age $age");
            }
            break;
        case 1:
            if ($age < 15) {
                return Core_Model_CountData::TYPE_DEMOGRAPHICS_MALE_0_TO_14;
            } elseif ($age < 25) {
                return Core_Model_CountData::TYPE_DEMOGRAPHICS_MALE_15_TO_24;
            } elseif ($age < 35) {
                return Core_Model_CountData::TYPE_DEMOGRAPHICS_MALE_25_TO_34;
            } elseif ($age < 45) {
                return Core_Model_CountData::TYPE_DEMOGRAPHICS_MALE_35_TO_44;
            } elseif ($age < 55) {
                return Core_Model_CountData::TYPE_DEMOGRAPHICS_MALE_45_TO_54;
            } elseif ($age < 65) {
                return Core_Model_CountData::TYPE_DEMOGRAPHICS_MALE_55_TO_64;
            } elseif ($age < 75) {
                return Core_Model_CountData::TYPE_DEMOGRAPHICS_MALE_65_TO_74;
            } elseif ($age >= 75) {
                return Core_Model_CountData::TYPE_DEMOGRAPHICS_MALE_75_TO_INF;
            } else {
                throw WebReport_Exception_ParameterError("Could not classify age $age");
            }
            break;
        default:
            error_log("Age: $age, Gender: $gender");
            throw WebReport_Exception("Could not classify age $age, gender $gender");
        }
    }

    private function emptyBox(){
            return array(
                Core_Model_CountData::TYPE_DEMOGRAPHICS_MALE_0_TO_14     => 0,
                Core_Model_CountData::TYPE_DEMOGRAPHICS_MALE_15_TO_24    => 0,
                Core_Model_CountData::TYPE_DEMOGRAPHICS_MALE_25_TO_34    => 0,
                Core_Model_CountData::TYPE_DEMOGRAPHICS_MALE_35_TO_44    => 0,
                Core_Model_CountData::TYPE_DEMOGRAPHICS_MALE_45_TO_54    => 0,
                Core_Model_CountData::TYPE_DEMOGRAPHICS_MALE_55_TO_64    => 0,
                Core_Model_CountData::TYPE_DEMOGRAPHICS_MALE_65_TO_74    => 0,
                Core_Model_CountData::TYPE_DEMOGRAPHICS_MALE_75_TO_INF   => 0,
                Core_Model_CountData::TYPE_DEMOGRAPHICS_FEMALE_0_TO_14     => 0,
                Core_Model_CountData::TYPE_DEMOGRAPHICS_FEMALE_15_TO_24    => 0,
                Core_Model_CountData::TYPE_DEMOGRAPHICS_FEMALE_25_TO_34    => 0,
                Core_Model_CountData::TYPE_DEMOGRAPHICS_FEMALE_35_TO_44    => 0,
                Core_Model_CountData::TYPE_DEMOGRAPHICS_FEMALE_45_TO_54    => 0,
                Core_Model_CountData::TYPE_DEMOGRAPHICS_FEMALE_55_TO_64    => 0,
                Core_Model_CountData::TYPE_DEMOGRAPHICS_FEMALE_65_TO_74    => 0,
                Core_Model_CountData::TYPE_DEMOGRAPHICS_FEMALE_75_TO_INF    => 0
            );
    }
}



