<?php

class Core_Model_Application_DemographicsEventData extends Core_Model_Application_EventDataAbstract
{
    //These should be the same as db columns.
    const GENDER = 'gender';
    const AGE = 'age';
    const TRACK_START_TIME = 't_start';
    const TRACK_END_TIME = 't_end';
    const AVERAGE_BOXSIZE = 'avg_boxsize';
    const ID = 'event_data_demographics_id';

    public function init()
    {
        parent::init();

        $gender = _T("GENDER");
        $age = _T("AGE");
        $t_start = _T("TRACK_START_TIMESTAMP");
        $t_end = _T("TRACK_END_TIMESTAMP");
        $avg_boxsize = _T("AVERAGE_BOXSIZE");
        $track_id = _T("UNIQUE_TRACK_ID");
        if (Zend_Registry::isRegistered('Zend_Translate')) {
            $translate = Zend_Registry::get('Zend_Translate');
            $gender = $translate->_($gender);
            $age = $translate->_($age);
            $t_start = $translate->_($t_start);
            $t_end = $translate->_($t_end);
            $avg_boxsize = $translate->_($avg_boxsize);
            $track_id = $translate->_($track_id);
        }

        $this->addOutType(self::GENDER, $gender);
        $this->addOutType(self::AGE, $age);
        $this->addOutType(self::TRACK_START_TIME, $t_start);
        $this->addOutType(self::TRACK_END_TIME, $t_end);
        $this->addOutType(self::AVERAGE_BOXSIZE, $avg_boxsize);
        $this->addOutType(self::ID, $track_id);

        $this->addDataColumn(0, self::TRACK_START_TIME);
        $this->addDataColumn(1, self::TRACK_END_TIME);
        $this->addDataColumn(2, self::GENDER);
        $this->addDataColumn(3, self::AGE);
        $this->addDataColumn(4, self::AVERAGE_BOXSIZE);

        $table = Core_Model_EventData_Tables_Demographics::getInstance();
        $this->setEventDataTable($table);
        //$this->setId(120);
        //$this->setName("TrueView Demographics");
        //$this->setShortName("Demographics");
        //$this->setAbbreviatedName("dg");
        $this->setEventEndTimeColumn(self::TRACK_END_TIME);
        $this->setEventStartTimeColumn(self::TRACK_START_TIME);
        $this->setIdColumn(self::ID);
    }

    public static function letAppModifyData($data)
    {
        if ($data['protocol'] == 1) {
            foreach ($data['data'] as &$entry) {
                unset($entry["trackid"]);
            }
            for ($i = 0; $i<sizeof($data['data_struct']); $i++) {
                if ($data['data_struct'][$i] == "trackid") {
                    unset($data['data_struct'][$i]);
                }
            }
            return $data;
        } else {
            throw new WebReport_Exception("Unknown protocol version in DemographicsEventData::getAndPerhapsModifyEntries");
        }
    }
}
