<?php

abstract class Core_Model_Application_EventDataAbstract extends Core_Model_Application_Abstract
{
    protected $_eventDataTable;
    protected $_eventEndTimeColumn;
    protected $_eventStartTimeColumn;
    protected $_dataColumns = array();
    protected $_idColumn;

    public function setIdColumn($column) {
        $this->_idColumn = $column;
    }

    public function getIdColumn()
    {
        return $this->_idColumn;
    }

    public function setEventDataTable($table)
    {
        $this->_eventDataTable = $table;
    }

    public function addDataColumn($index, $column)
    {
        $this->_dataColumns[$index] = $column;
    }

    public function getDataColumns()
    {
        return $this->_dataColumns;
    }

    public function setEventEndTimeColumn($column)
    {
        $this->_eventEndTimeColumn = $column;
    }

    public function getEventEndTimeColumn()
    {
        return $this->_eventEndTimeColumn;
    }

    public function setEventStartTimeColumn($column)
    {
        $this->_eventStartTimeColumn = $column;
    }

    public function getEventStartTimeColumn()
    {
        return $this->_eventStartTimeColumn;
    }

    public function getEventDataTable()
    {
        return $this->_eventDataTable;
    }

    public function modifyNewRowData($row, $protocol_version)
    {
        return $row;
    }

    public function deleteTimespanForCamera($camera, $utc_timestamp_start, $utc_timestamp_end)
    {
        $table = $this->_eventDataTable;
        $select = $table->select();
        $select->where("camera_id = ?", $camera->camera_id)
            ->where("$this->_eventStartTimeColumn >= ?", $utc_timestamp_start)
            ->where("$this->_eventEndTimeColumn <= ?", $utc_timestamp_end);
        $rows = $table->fetchAll($select);
        foreach ($rows as $row) {
            $row->delete();
        }
    }
}
