<?php

class Core_Model_CameraGroup extends Zend_Db_Table_Row_Abstract
{

	public function getCompanyNames()
	{
		$groupId = $this->camera_group_id;

		$companyGroupDb = new Core_Model_CompanyCameraGroup();

		$db = $this->_table->getAdapter();
		$select = $db->select();
		$companiesDb = new Core_Model_Companies();
		$select->from(array("c" => $companiesDb->info('name')), array('name'))
			->join(array("ccg" => $companyGroupDb->info('name')), "c.company_id = ccg.company_id", array())
			->where('camera_group_id = ?', $groupId)->order('name');

		$companyGroups = $db->fetchAll($select);
		$ret = array();
		foreach ($companyGroups as $cg) {
			$ret[] = $cg->name;
		}

		return $ret;
  }

  public function getCameras() {
      return $this->findDependentRowset('Core_Model_Cameras');
  }


    public function getCompanyIds()
    {
        $groupId = $this->camera_group_id;

        $companyGroupDb = new Core_Model_CompanyCameraGroup();

        $db = $this->_table->getAdapter();
        $select = $db->select();
        $companiesDb = new Core_Model_Companies();
        $select->from(array("c" => $companiesDb->info('name')), array('company_id'))
            ->join(array("ccg" => $companyGroupDb->info('name')), "c.company_id = ccg.company_id", array())
            ->where('camera_group_id = ?', $groupId)->order('company_id');

        $companyGroups = $db->fetchAll($select);
        $ret = array();
        foreach ($companyGroups as $cg) {
            $ret[] = $cg->company_id;
        }

        return $ret;

        
    }

    /**
     * Pre-delete logic to be applied to row.
     *
     * @return void
     */
    protected function _delete()
    {
		$camerasDb = new Core_Model_Cameras();
		$camerasToDelete = $camerasDb->fetchAll($camerasDb->select()->where('camera_group_id = ?', $this->camera_group_id));
		foreach ($camerasToDelete as $camera) {
			$camera->delete();
		}
	}

}
