<?php

include_once 'CameraGroup.php';

class Unauthorized_Exception extends WebReport_Exception {}

class Core_Model_CameraGroups extends Talking_Db_Table {

	protected $_name = 'camera_group';
	protected $_primary = 'camera_group_id';
	protected $_rowClass = 'Core_Model_CameraGroup';
    
    protected $_dependentTables = array('Core_Model_Cameras');
    
    /*
     * Return a list of CameraGroup:s that belong to $group.
     */
    public function fetchDocuments($group) {
        /*
         * TODO: Write a nice JOIN.
         */
        $documents = $group->getDocuments('camera_group');
        $cameraGroupsDb = new Core_Model_CameraGroups();

        $cameraGroups = array();
        foreach($documents as $doc) {
            $cg = $cameraGroupsDb->find($doc->id)->current();

            if($cg)
                $cameraGroups[] = $cg;
        }

        return $cameraGroups;
    }

    public function fetchCameraGroup($username, $password){
        $query = $this->select()
                      ->where("username = ?", $username);

        $cameraGroup = $this->fetchRow($query);
        if (!$cameraGroup) {
            throw new Unauthorized_Exception("No camera group with username '$username'. ");
        }

        if (md5(STATIC_SALT . $password . $cameraGroup->password_salt) != $cameraGroup->password) {
            throw new Unauthorized_Exception("Invalid username for camera group {$cameraGroup->name}. (user $username)");
        }
        return $cameraGroup;
    }
        
}

