<?php

class Core_Model_CameraSet_CameraSetType1 extends Zend_Db_Table_Row_Abstract
{
    public function getDayEndHour()
    {
        $offset = $this->day_start_offset;
        $offset_hour = intval(substr($offset, 0, 3));
        if ($offset_hour < 0) {
            $offset_hour = 24 + $offset_hour;
        }
        return $offset_hour;
    }

    /*
     * End hour and start hour is the same,
     * it's just because of the context it made sense to name the functions differently.
     */
    public function getPrettyDayStartHour() {
        $offset = $this->day_start_offset;
        $offset_hour = intval(substr($offset, 0, 3));
        if ($offset_hour < 0) {
            $offset = 24 + $offset_hour . ":00";
        } else {
            $offset = substr($offset,0,5);
        }
        return $offset;
    }

    public function getFetchStatus()
    {
        $sections = $this->getSections();
        $sectionCameraDb = Core_Model_CameraSet_CameraSetType1SectionCameras::getInstance();
        $camerasDb = Core_Model_Cameras::getInstance();
        $status = array("enabled" => array(), "disabled" => array());
        foreach ($sections as $section) {
            $camera_rows = $sectionCameraDb->getCamerasBySectionId($section->camera_set_type1_section_id);
            foreach ($camera_rows as $camera_row) {
                $camera = $camerasDb->find($camera_row->camera_id)->current();
                if ($camera->fetch_me) {
                    $status["enabled"][] = $camera;
                } else {
                    $status["disabled"][] = $camera;
                }
            }
        }
        return $status;
    }

    public function getSections()
    {
        $sectionDb = new Core_Model_CameraSet_CameraSetType1Sections();
        $sections = $sectionDb->getSectionsBySetId($this->camera_set_id);
        return $sections;
    }

    public function getStoreSection()
    {
        $sectionDb = new Core_Model_CameraSet_CameraSetType1Sections();
        $sections = $sectionDb->getSectionsBySetId($this->camera_set_id);
        foreach ($sections as $section) {
            if ($section->is_store==1) {
                $ret = $section;
            }
        }
        return $ret;
    }
}
