<?php

class Core_Model_CameraSet_CameraSetType1SalesRegions extends Talking_Db_Table
{
    protected $_name = 'camera_set_type1_sales_region';
    protected $_primary = 'camera_set_type1_sales_region_id';

    //protected $_rowsetClass = 'Core_Model_CameraSet_CameraSetCamerasRowset';
    protected $_rowClass = 'Core_Model_CameraSet_CameraSetType1SalesRegion';

    public function getNameById($sales_region_id)
    {
        $select = $this->select();
        $select->where('camera_set_type1_sales_region_id= ?', $sales_region_id);
        $sales_region = $this->fetchAll($select)->current();
        return $sales_region->name;
    }

    public static function deleteUnusedSalesRegions()
    {
        $db = Zend_Registry::get("db");
        $select = $db->select()
            ->from(
                array('sales_region' => 'camera_set_type1_sales_region'),
                array('camera_set_type1_sales_region_id')
            )
            ->joinLeft(
                array('store' => 'camera_set_type1'),
                'sales_region.camera_set_type1_sales_region_id = store.sales_region_id'
            )
            ->where('sales_region_id IS NULL');

        $rows_to_delete = $db->fetchAll($select); //This shouldn't be more than one but who knows.
        $salesRegionDb = Core_Model_CameraSet_CameraSetType1SalesRegions::getInstance();
        foreach ($rows_to_delete as $row) {
            $select = $salesRegionDb->select()
                ->where('camera_set_type1_sales_region_id = ?', $row->camera_set_type1_sales_region_id);
            $delete_me = $salesRegionDb->fetchAll($select)->current();
            $delete_me->delete();
        }
    }

    public function getSalesRegionsByCompanyId($company_id) {
        $db = Zend_Registry::get("db");
        $select = $db->select()
            ->from(
                array('sales_region' => 'camera_set_type1_sales_region', array("camera_set_type1_sales_region_id", "name"))
            )
            ->join(
                array(
                    'store' => 'camera_set_type1',
                ),
                'sales_region.camera_set_type1_sales_region_id = store.sales_region_id',
                array('sales_region_id', 'camera_set_id')
            )
            ->join(
                array(
                    'camera_set' => 'camera_set',
                ),
                'store.camera_set_id=camera_set.camera_set_id',
                array('camera_set_id', 'company_id')
            )->where('company_id = ?', $company_id);
        return $db->fetchAll($select);
    }
}
