<?php

class Core_Model_CameraSet_CameraSetType1s extends Talking_Db_Table {

    protected $_name = 'camera_set_type1';
    protected $_primary = 'camera_set_id';
    protected $_rowClass = 'Core_Model_CameraSet_CameraSetType1';

    public function getMetaDataById($camera_set_id)
    {
        $select = $this->select();
        $select->where('camera_set_id = ?', $camera_set_id);
        return $this->fetchAll($select)->current();
    }

    public function getContentById($camera_set_id)
    {
        $select = $this->select();
        $select->where('camera_set_id = ?', $camera_set_id);

        $setSectionsDb = new Core_Model_CameraSet_CameraSetType1Sections();
        $setSections = $setSectionsDb->getSectionsBySetId($camera_set_id);

        $setCamerasDb = new Core_Model_CameraSet_CameraSetType1SectionCameras();

        $camerasDb = new Core_Model_Cameras;

        $setContent = array();
        foreach ($setSections as $setSection) {
            $sectionCameraIdsArray = array();
            $sectionCameraNamesArray = array();
            $setCameras = $setCamerasDb->getCamerasBySectionId($setSection->camera_set_type1_section_id);
            if ($setSection->is_store) {
                $setContent["store_section_id"] = $setSection->camera_set_type1_section_id;
                foreach ($setCameras as $setCamera) {
                    $camera = $camerasDb->getCamera($setCamera->camera_id);
                    $setContent["store_camera_ids"][] = $setCamera->camera_id;
                    $setContent["store_camera_names"][] = $camera->name;
                }
            } else {
                foreach ($setCameras as $setCamera) {
                    $sectionCameraIdsArray[] = $setCamera->camera_id;
                    $camera = $camerasDb->getCamera($setCamera->camera_id);
                    $sectionCameraNamesArray[] = $camera->name;
                }
                $setContent["sections"][] = array(
                    "id" => $setSection->camera_set_type1_section_id,
                    "name" => $setSection->name,
                    "section_camera_ids" => $sectionCameraIdsArray,
                    "section_camera_names" => $sectionCameraNamesArray
                    );
            }
        }

        return $setContent;
    }
}
