<?php

#nclude_once 'CameraGroup.php';

class Core_Model_CameraSets extends Talking_Db_Table {

    protected $_name = 'camera_set';
    protected $_primary = 'camera_set_id';
    protected $_rowClass = 'Core_Model_CameraSet';

    #protected $_dependentTables = array('Core_Model_Cameras','Core_Model_CameraSet');

    /*
     * Return rows with type $type
     */
    public function getSetsByTypeId($typeId)
    {
        $select = $this->select();
        $select->where('camera_set_type_id = ?', $typeId);
        return $this->fetchAll($select);
    }

    public function getSetById($id)
    {
        if (!$id) {
            return null;
        } else {
            $select = $this->select();
            $select->where('camera_set_id = ?', $id);
            return $this->fetchAll($select)->current();
        }

    }

    public function fetchAllWithCompanyId($company_id)
    {
        $select = $this->select();
        $select->where('company_id = ?', $company_id);
        return $this->fetchAll($select);
    }

    public function fetchAllWithType($type_id)
    {
        $select = $this->select();
        $select->where('camera_set_type_id = ?', $type_id);
        return $this->fetchAll($select);
    }

    public function fetchAllWithTypeAndCompanyId($type_id, $company_id)
    {
        $select = $this->select();
        $select->where('company_id = ?', $company_id)->where('camera_set_type_id = ?', $type_id);
        return $this->fetchAll($select);
    }
}
