<?php

class Core_Model_CompaniesRowset extends Zend_Db_Table_Rowset_Abstract
{

	public function fetchAllActiveUsers() {
		return $this->fetchAllUsers(true);

	}

	public function fetchAllInactiveUsers() {
		return $this->fetchAllUsers(false);
	}

	public function fetchAllUsers($active = true) {

		$usersDb = new Core_Model_Users();

		$select = $usersDb->select()->setIntegrityCheck(false)->from($usersDb, '*');
		$select
           ->join(array("c" => $this->getTable()->info('name')), // table
              'user.company_id = c.company_id', // condition
              array("company" => 'name')) // fields
		   ->order(array('surname','forename'));

		if ($active) {
			$select->where('user.active = ?', 1);
		} else {
			$select->where('user.active = ?', 0);
		}
		
		$orWhere = array();
		foreach ($this as $company) {
			$orWhere[] = "user.company_id = " . $company->company_id;
		}

		$select->where(implode(" OR ", $orWhere));
		$users = $usersDb->fetchAll($select);

		return $users;
	}

}


