<?php

class Core_Model_Company extends Zend_Db_Table_Row_Abstract
{

    public function activate()
    {
        $this->active = 1;
        $this->save();
    }

    public function inactivate()
    {
        $this->active = 0;
        $this->save();
    }

    public function toggleActivate()
    {
        $this->active = ($this->active+1)%2;
        $this->save();
    }

    public function getOwner(){
        $owner = $this->findParentRow('Core_Model_Users', 'Owner');
        if ($owner) return $owner->forename . ' ' . $owner->surname;
        return false;
    }

    public function getNumberOfUsers()
    {
        $usersTable = new Core_Model_Users();
        $select = $usersTable->select();
        $select->from($usersTable, array('COUNT(*) as count'))
            ->where("active = 1")
            ->where('company_id = ?', $this->company_id);

        $stmt = $select->query();
        return $stmt->fetch()->count;
    }

    public function getNumberOfCameras()
    {
        $camerasDb = Core_Model_Cameras::getInstance();
        $cameras = $camerasDb->getCameras(null, $this);
        return count($cameras);
    }

    public function getCountDataSets()
    {
        $countDataSetsDb = new Core_Model_CountData_Sets();
        $select = $countDataSetsDb->select()
            ->where('company_id = ?', $this->company_id)
            ->order('application_id')->order('name');
        return $countDataSetsDb->fetchAll($select);
    }



    public function fetchAllUsers($active = true)
    {
        $usersDb = new Core_Model_Users();
        $allUsers = $this->findDependentRowset('Core_Model_Users');
        $users = array();
        foreach( $allUsers as $user){
            if($user->active == 0 ^ $active) $users[] = $user;
        }
        
        return $users;
        $usersDb = new Core_Model_Users();

        $select = $usersDb->select()->setIntegrityCheck(false)->from($usersDb, '*');
        $select
           ->join(array("c" => $this->getTable()->info('name')), // table
              'user.company_id = c.company_id', // condition
              array("company" => 'name')) // fields

           ->order(array('surname','forename'))
            ->where('c.company_id = ?', $this->company_id);

        if ($active) {
            $select->where('user.active = ?', 1);
        } else {
            $select->where('user.active = ?', 0);
        }

        $users = $usersDb->fetchAll($select);

        return $users;
    }

    public function fetchAllActiveUsers() {
        return $this->fetchAllUsers(true);

    }

    public function fetchAllInactiveUsers() {
        return $this->fetchAllUsers(false);
    }


    public function fetchAllInactive($companyId = null) {
        $db = $this->getAdapter();
        $companiesDb = new Core_Model_Companies();
        $select = $db->select()->from(array("u" => $this->info('name')), array("surname", "forename", "email", "user_id", "active"))
            ->join(array("c" => $companiesDb->info('name')), "u.company_id = c.company_id", array("company" => "name"))
            ->where('u.active = ?', 0)
            ->order(array('surname','forename'));

        if (!is_null($companyId)) {
            $select->where('c.company_id = ?', $companyId);
        }
        $users = $db->fetchAll($select);

        return $users;
    }

    public function fetchAllGroups() {
        return $this->findDependentRowset('Core_Model_Folders');
    }
    
}
