<?


class Core_Model_ConfigWriter {
    public $config;
    private $_path;
    public function __construct($fromFile = false, $path = "/config.ini"){
        $this->_path = $fromFile ? $path : "/config.ini";
        if($fromFile){
            $mutex = new Core_Model_Mutex();
            $mutex->init(Core_Model_Mutex::MUTEX_MODIFY_CONFIG);
            if($mutex->acquire() == FALSE) throw new WebReport_Exception("Could not require semaphore");
            try {
            $this->config = new Zend_Config_Ini(APPLICATION_PATH . $this->_path, APPLICATION_ENVIRONMENT, array('allowModifications' => true));
            } catch(Zend_Config_Exception $e) {
                $this->config = new Zend_Config(array(), true);
            }
            if($mutex->release() == FALSE) throw new WebReport_Exception("Could not release semaphore");
        } else {
            $this->config = Zend_Registry::get('config');
        }
    }

    public function save($allow_new = false){
        try {
            $writer = new Zend_Config_Writer_IniNice();
            $writer->allowCreateClean();
            $writer->setConfig($this->config)
                   ->setFilename(APPLICATION_PATH . $this->_path);
            $writer->write();
        } catch(Exception $e) {
            error_log("Could not update config: " . APPLICATION_PATH . $this->_path);
        }
    }
}
