<?php

class Core_Model_CountData_Filter_Part_CameraId extends Core_Model_CountData_Filter_Part_Abstract {

	protected $_id = "filterpartcameraid";

	const CONDITION_IS = "is";
	const CONDITION_IS_NOT = "is not";

	public function __construct()
	{
		$translate = Zend_Registry::get('Zend_Translate');
		$this->setDescription($translate->_("COUNT_DATA_FILTER_PART_DESCRIPTION_CAMERA_ID"));

		$this->_conditions[self::CONDITION_IS] = array("id" => self::CONDITION_IS, "description" => $translate->_("COUNT_DATA_FILTER_PART_CONDITION_IS"));
		$this->_conditions[self::CONDITION_IS_NOT] = array("id" => self::CONDITION_IS_NOT, "description" => $translate->_("COUNT_DATA_FILTER_PART_CONDITION_IS_NOT"));
	}

	public function getConditionElements($conditionId = null, $company = null, $application = null)
	{
		$elements = array();

		$filterGroupNamespace = new Zend_Session_Namespace('WebReport_FilterGroup');
		if ($company == null) {
			$companiesDb = new Core_Model_Companies();
			$company = $companiesDb->find($filterGroupNamespace->company_id)->current();
		}
		if ($application == null) {
			$applicationsModel = new Core_Model_Applications();
			$application = $applicationsModel->findWithId($filterGroupNamespace->application_id);
		}

		$camerasDb = new Core_Model_Cameras();
		$cameraNames = $camerasDb->getCameraNames($application, $company);

		$camArr = array();
		foreach ($cameraNames as $cameraId => $camera) {
			$camArr[] = array("text" => $camera, "value" => $cameraId);
		}

		switch ($conditionId) {
			case self::CONDITION_CONTAINS:
			case self::CONDITION_DOES_NOT_CONTAIN:
				$elements[] = array("type" => "input", "name" => "value");
				break;

			case self::CONDITION_IS:
			case self::CONDITION_IS_NOT:
				$elements[] = array("type" => "select", "data" => $camArr);
				break;
		}

		return $elements;

	}



}