<?php

class Core_Model_CountData_Filter_Part_CountTime extends Core_Model_CountData_Filter_Part_Abstract {
  
	protected $_id = "filtercnttime";

	const CONDITION_IS = "in";
	const CONDITION_IS_NOT = "is not";
  
	public function __construct() {
		$view = $this->getView();
		$this->setDescription($view->translate("COUNT_FILTER_DESCRIPTION_COUNT_TIME"));

		$this->_conditions[self::CONDITION_IS] = array("id" => self::CONDITION_IS, "description" => $view->translate("COUNT_FILTER_CONDITION_IS"));
		$this->_conditions[self::CONDITION_IS_NOT] = array("id" => self::CONDITION_IS_NOT, "description" => $view->translate("COUNT_FILTER_CONDITION_IS_NOT"));
	}

	public function getConditionElements($conditionId = null, $companyId = null, $applicationId = null) {
		$elements = array();
		$filterGroupNamespace = new Zend_Session_Namespace('WebReport_FilterGroup');
		$countData = new Core_Model_CountData($filterGroupNamespace->company_id, $filterGroupNamespace->application_id);

		switch ($conditionId) {
			case self::CONDITION_IS:
			case self::CONDITION_IS_NOT:
		//		$elements[] = array("type" => "select", "data" => $countData->getTypes());
				$elements[] = array("type" => "select", "data" => $countData->getTimeResolutions());
				break;
		}

		return $elements;
  
	}

	public function select($select) {
		parent::select($select);
    
		switch ($this->_currentCondition) {
			case self::CONDITION_IS:
				$select = $select->where('cnttype = ?', $this->_currentConditionData[0]);
				break;
			case self::CONDITION_IS_NOT:
				$select = $select->where('cnttype <> ?', $this->_currentConditionData[0]);
				break;
		}
  
		return $select;
	}


}