<?php

class Core_Model_CountData_Filter_Part_CountType extends Core_Model_CountData_Filter_Part_Abstract
{
  
	protected $_id = "filterpartcounttype";

	const CONDITION_IS = "is";
	const CONDITION_IS_NOT = "is not";

	public function __construct() {
		$translate = Zend_Registry::get('Zend_Translate');
		$this->setDescription($translate->_("COUNT_FILTER_PART_DESCRIPTION_COUNT_TYPE"));

		$this->_conditions[self::CONDITION_IS] = array("id" => self::CONDITION_IS, "description" => $translate->_("COUNT_FILTER_PART_CONDITION_IS"));
		$this->_conditions[self::CONDITION_IS_NOT] = array("id" => self::CONDITION_IS_NOT, "description" => $translate->_("COUNT_FILTER_PART_CONDITION_IS_NOT"));
	}

	public function getConditionElements($conditionId = null, $company = null, $application = null) {
		$elements = array();

		$types = $application->getOutTypes();

		$filterGroupNamespace = new Zend_Session_Namespace('WebReport_FilterGroup');
		if ($company == null) {
		//	$companiesDb = new Core_Model_Companies();
		//	$company = $companiesDb->find($filterGroupNamespace->company_id)->current();
		}
		if ($application == null) {
		//	$applicationsModel = new Core_Model_Applications();
		//	$application = $applicationsModel->findWithId($filterGroupNamespace->application_id);
		}

		$types = $application->getOutTypes();
		$typesRet = array();

		foreach ($types as $key => $type) {
			$typesRet[] = array("value" => $key, "text" => strtolower($type));
		}

		switch ($conditionId) {
			case self::CONDITION_IS:
			case self::CONDITION_IS_NOT:
				$elements[] = array("type" => "select", "data" => $typesRet);
				break;
		}

		return $elements;
	}

	public function select($select) {

		$application = $this->getApplication();
		$inTypes = $application->correspondingInTypes($this->_currentConditionData[0]);

		switch ($this->_currentCondition) {
		case self::CONDITION_IS:
			$whereArr = array();
			foreach ($inTypes as $type) {
				$whereArr[] = sprintf("cnttype = %d", $type);
			}
			$select = $select->where(implode(" OR ", $whereArr));
			break;
		case self::CONDITION_IS_NOT:
			$whereArr = array();
			foreach ($inTypes as $type) {
				$whereArr[] = sprintf("cnttype <> %d", $type);
			}
			$select = $select->where(implode(" OR ", $type));
			break;
		}
  
		return $select;
	}

}