<?php

class Core_Model_CountData_Filter_Parts {
    
	static $_parts;

	public static function factory($part)
	{
		return clone self::$_parts[$part];
	}

	public static function addPart($part) {
		self::$_parts[$part->getId()] = $part;
	}

	public static function getPart($partId) {
		return self::$_parts[$partId];
	}

	/**
	 * Returns filter descriptions for ajax request
	 *
	 * @param bool $includeFirstChain If true the whole first chain for the first filter is included to minimize number of ajax requests
	 * @return array
	 */
	public static function getDescriptions($includeFirstChain = false, $company = null, $application = null) {

		$descriptions = array();

		foreach (self::$_parts as $filter) {
			$descriptions[] = array("id" => $filter->getId(), "description" => $filter->getDescription());
		}

		if ($includeFirstChain) {
			$filter = self::$_parts[$descriptions[0]["id"]];
			$conditions = $filter->getConditions(true, true, $company, $application);
			$descriptions[0]['conditions'] = $conditions;
		}

		return $descriptions;

	}

	public static function getConditions($filterId, $omitKeys = false, $firstElementChain = false, $company = null, $application = null) {
		// TODO: check if $fitlerId is set and exists as key in array
		return self::$_parts[$filterId]->getConditions($omitKeys, $firstElementChain, $company, $application);
	}


}
?>
