<?php

class Core_Model_CountData_FormulaRowset extends Zend_Db_Table_Rowset_Abstract
{
	public function getTimeResolutions()
	{
		
		$resolutions = array();
		$applications = $this->getApplicationsUsed();
		foreach ($applications as $application)
		{
			if (empty($resolutions)) {
				$resolutions = $application->getTimeResolutions();
			} else {
				$resolutions = array_intersect_assoc($resolutions, $application->getTimeResolutions());
			}
		}

		return $resolutions;
	}

	public function getApplicationsUsed()
	{
		$applicationsModel = new Core_Model_Applications();
		$ret = array();
		foreach ($this as $formula)
		{
			$application = $applicationsModel->findWithId($formula->application_id);
			$ret[$application->getId()] = $application;
		}
		return $ret;

	}

	public function getNamesWithApplicationNames()
	{
		$ret = array();
		
		$applicationsModel = new Core_Model_Applications();
		foreach ($this as $formula)
		{
			$application = $applicationsModel->findWithId($formula->application_id);
			$ret[] = $formula->name . " (" . $application->getShortName() . ")";
		}
		return $ret;
	}

}