<?php

include_once 'FormulaSet.php';
//include_once 'FormulaRowset.php';

class Core_Model_CountData_FormulaSets extends Talking_Db_Table
{
	protected $_name = 'count_data_formula_set';
	protected $_primary = 'count_data_formula_set_id';
//	protected $_rowsetClass = 'Core_Model_CountData_FormulaRowset';
	protected $_rowClass = 'Core_Model_CountData_FormulaSet';
	protected $_dependentTables = array('Core_Model_CountData_FormulaSetFormulas');

	protected $_referenceMap    = array(
		'Company' => array(
			'columns'           => array('company_id'),
			'refTableClass'     => 'Core_Model_Companies',
			'refColumns'        => array('company_id')
		)
	);

	public function fetchAllFormulaSets(Core_Model_Company $company = null)
	{
		$db = $this->getAdapter();

		$companiesDb = new Core_Model_Companies();
		$formulasDb = new Core_Model_CountData_FormulaSetFormulas();

		$select = $db->select()
			->from(array("f" => $this->info(Zend_Db_Table::NAME)),
				array("count_data_formula_set_id", "name", "company_id", "application_id", "description"))
			->joinRight(array("fsf" => $formulasDb->info(Zend_Db_Table::NAME)), "f.count_data_formula_set_id = fsf.count_data_formula_set_id", array("count_data_formula_set_formula_id", "formula_count" => new Zend_Db_Expr("COUNT(*)")))
			->join(array("co" => $companiesDb->info(Zend_Db_Table::NAME)),
				"f.company_id = co.company_id",
				array("company" => "name"))
			->group('f.count_data_formula_set_id');

		if ($company) {
			$select->where('co.company_id = ?', $company->company_id);
		}

		$select->order('co.company_id')->order('application_id');

		return $db->fetchAll($select);

	}

    public function fetchDocuments($group) {
        /*
         * TODO: Write a nice JOIN.
         */
        $documents = $group->getDocuments('formula_set');
        $formulaSetsDb = new Core_Model_CountData_FormulaSets();

        $formulaSets = array();
        foreach($documents as $doc) {
           $fs = $formulaSetsDb->find($doc->id)->current();
           if($fs)
               $formulaSets[] = $fs;
        }

        return $formulaSets;
    }

    public function fetchAllVisible($user)
    {
        $groupsDb = new Core_Model_Folders();
        $groups = $groupsDb->getViewableGroups($user);

        $formulaSetsDb = new Core_Model_CountData_FormulaSets();

        $cameras = array();
        foreach($groups as $group) {
            $documents = $group->findDependentRowset('Core_Model_Documents');
            foreach($documents as $document) {
                if($document->type == 'formula_set') {
                    $formulaSet = $formulaSetsDb->find($document->id)->current();
                    if($formulaSet)
                        $cameras[] = $formulaSet;
                }
            }   
        }

        return $cameras;
    }

    public function fetchAllVisibleNames($user, $application = NULL)
    {
        $cameras = $this->fetchAllVisible($user);
        
        $ret = array();
        foreach($cameras as $cam) {
            if(!is_null($application)) {
                if($cam->application_id == $application->getId())
                    $ret[$cam->count_data_formula_set_id] = $cam->name;
            }
            else
                $ret[$cam->count_data_formula_set_id] = $cam->name;
        }
        return $ret;
    }
}
