<?php

include_once "Set.php";
include_once "SetsRowset.php";
include_once "Set/FilterGroups.php";
include_once "Set/Cameras.php";
include_once "Set/VirtualCameras.php";
include_once "Set/FormulaSets.php";

class Core_Model_CountData_Sets extends Talking_Db_Table
{
	protected $_name = 'count_data_set';
	protected $_primary = 'count_data_set_id';
	protected $_rowClass = "Core_Model_CountData_Set";
	protected $_rowsetClass = "Core_Model_CountData_SetsRowset";

	protected $_dependentTables = array('Core_Model_CountData_Set_FilterGroups',
		'Core_Model_CountData_Set_VirtualCameras',
		'Core_Model_CountData_Set_FormulaSets',
		'Core_Model_CountData_Set_Cameras'
	);

	protected $_referenceMap    = array(
		'Company' => array(
			'columns'           => array('company_id'),
			'refTableClass'     => 'Core_Model_Companies',
			'refColumns'        => array('company_id')
		)
	);


	public function fetchAllSets(Core_Model_Company $company = null)
	{
		$db = $this->getAdapter();

		$companiesDb = new Core_Model_Companies();

		$select = $db->select()
			->from(array("cds" => $this->info(Zend_Db_Table::NAME)),
				array("count_data_set_id", "name", "application_id", "created_date", "description"))
			->join(array("co" => $companiesDb->info(Zend_Db_Table::NAME)),
				"cds.company_id = co.company_id",
				array("company" => "name"));
		if ($company) {
			$select->where('cds.company_id = ?', $company->company_id)->order('co.name');
		}
		$select->order('application_id');
		return $db->fetchAll($select);

	}

    public function fetchDocuments($group) {
        /*
         * TODO: Write a nice JOIN.
         */
        $documents = $group->getDocuments('count_data_set');
        $cdsDb = new Core_Model_CountData_Sets();

        $cds = array();
        foreach($documents as $doc) {
            $cd = $cdsDb->find($doc->id)->current();
            if($cd)
                $cds[] = $cd;
        }

        return $cds;
    }

    public function fetchAllVisible($user)
    {
        $groupsDb = new Core_Model_Folders();
        $groups = $groupsDb->getViewableGroups($user);

        $cdsDb = new Core_Model_CountData_Sets();

        $ids = array();
        foreach($groups as $group) {
            $documents = $group->findDependentRowset('Core_Model_Documents');
            foreach($documents as $document) {
                if($document->type == 'count_data_set') {
                    $countDataSet = $cdsDb->find($document->id)->current();
                    if($countDataSet)
                        $ids[] = $countDataSet->count_data_set_id;
                }
            }   
        }

        $cds = $cdsDb->find($ids);
        return $cds;
    }

    public function fetchAllVisibleNames($user, $application = NULL)
    {
        $cameras = $this->fetchAllVisible($user);
        
        $ret = array();
        foreach($cameras as $cam) {
            if(!is_null($application)) {
                if($cam->application_id == $application->getId())
                    $ret[$cam->count_data_set_id] = $cam->name;
            }
            else
                $ret[$cam->count_data_set_id] = $cam->name;
        }
        return $ret;
    }
}
