<?php

class Core_Model_CountData_SetsRowset extends Zend_Db_Table_Rowset_Abstract
{

	public function getFormElement($name, $label = null, $isRequired = false, $nullValueString = null)
	{
		$element = new UniForm_Form_Element_Select($name);
		if ($label) {
			$element->setLabel($label);
		}
		$element->setRequired($isRequired);

		$applicationsModel = new Core_Model_Applications();

		if ($nullValueString) {
			$element->addMultiOption(0, $nullValueString);
		}

		$toAdd = array();
		foreach ($this as $row) {
			$application = $applicationsModel->findWithId($row->application_id);
            $name = $application ? $application->getName() : "UNKNOWN_APPLICATION";
			$toAdd[$name][$row->count_data_set_id] = $row->name;
		}

		foreach ($toAdd as $appName => $values) {
			$element->addMultiOption($appName, $values);
		}

		return $element;

	}


}
