<?php

include_once 'Table.php';

class Core_Model_CountData_Tables extends Talking_Db_Table
{
    protected $_name = 'count_data_table';
    protected $_primary = 'count_data_table_id';

    protected $_rowClass = 'Core_Model_CountData_Table';

    public function getTableForInserting($application)
    {
        $nTypes = count($application->getInTypes());
        $select = $this->select()->where("application_id = ?", $application->getId())->order("table");
        $tables = $this->fetchAll($select);
        $MAX_COLUMNS = 900;
        if ( Zend_Registry::isRegistered("COUNT_DATA_MAX_COLUMNS") ) {
            $MAX_COLUMNS = Zend_Registry::get("COUNT_DATA_MAX_COLUMNS");
        }
        foreach ($tables as $table) {
            // 900 == max number of columns - timestamp-columns
            $count = $this->getColumnCount($table->table);
            if ( $count < $MAX_COLUMNS ) {
                return $table;
            }
        }
        return null;
    }

    public static function getColumnCount($tableName, $skipDateColumns = true) {
        $db = Zend_Registry::get('db');
        $query = $db->query("describe ".$tableName)->fetchAll();
        $count = count($query);
        // There are 19 columns that are date related columns;
        if ( $skipDateColumns ) $count -= 19;
        return $count;
    }
}
