<?php

include_once 'TimeFilter.php';

class Core_Model_CountData_TimeFilters extends Talking_Db_Table {

    protected $_name = 'count_data_time_filter';
    protected $_primary = 'filter_id';
    protected $_rowClass = 'Core_Model_CountData_TimeFilter';
    protected $_dependentTables = array('Core_Model_Companies');
    protected $_referenceMap = array(
        'Company' => array(
            'columns' => array('company_id'),
            'refTableClass' => 'Core_Model_Companies',
            'refColumns' => array('company_id')
        )
    );

    public function fetchById($id) {
        $select = $this->select()->setIntegrityCheck(false)
                ->from(new Core_Model_CountData_TimeFilters, '*');
        $select = $select->where('filter_id = ?', $id);
        return $this->fetchAll($select)->current();
    }

    public function fetchAllForCompany(Core_Model_Company $c = null) {

        $select = $this->select()->setIntegrityCheck(false)
                ->from(new Core_Model_CountData_TimeFilters, '*');

        if (!is_null($c)) {
            $select = $select->where('company_id = ? or factory_default = 1', $c->company_id);
        }

        $filters = $this->fetchAll($select);

        return $filters;
    }
    
    public function getFormElementForCompany($name, $label = null, $is_required = null, $nullValueString = null, $company = null){
        $time_filter_id = new UniForm_Form_Element_Select($name);
	$time_filter_id->setLabel($label)
		->addMultiOption(0, $nullValueString);

	foreach ($this->fetchAllForCompany($company) as $filter) {
	    $time_filter_id->addMultiOption($filter->filter_id, $filter->filter_name);
	}
	return $time_filter_id;
    }

}
