<?php

class Core_Model_DateHelper {
    public static function setHour(Zend_Date $date, $hour){
        $date->setHour($hour);
        if($date->get(Zend_Date::HOUR) != $hour){
            r_log("Compensating for DST-bug in Zend");
            if($date->get(Zend_Date::HOUR) == 23) $date->addHour(1);
            if($date->get(Zend_Date::HOUR) == 01) $date->subHour(1);
            if($date->get(Zend_Date::HOUR) != $hour){
                r_log("Some strange resolution is used? Trying again to compensate for DST-bug");
                if($date->get(Zend_Date::HOUR > $hour)) $date->subHour(1);
                if($date->get(Zend_Date::HOUR < $hour)) $date->addHour(1);
            }
        }
       return $date; 
    }

    public static function addHour(Zend_Date $date, $hours){
        $h1 = $date->get(Zend_Date::HOUR);
        $date->addHour($hours);
        $h2 = $date->get(Zend_Date::HOUR);
        $h2_expected = $h1 + $hours > 23 ? $h1 + $hours - 24 : $h1 + $hours;
        if($h2_expected != $h2){
            r_log("Trying to compensate for DST-bug in Zend (addHour)");
            $date->addHour(1);
            $h2 = $date->get(Zend_Date::HOUR);
            if($h2_expected == $h2){
                r_log("fixed addHour");
                return $date;
            }
            $date->subHour(2);
            $h2 = $date->get(Zend_Date::HOUR);
            if($h2_expected == $h2){
                r_log("fixed addHour");
                return $date;
            }
            $date->addHour(1);
            r_log("Failed to fix addHour");
            return $date;
        }
        return $date;
    }
}
