<?php

class Core_Model_Document extends Zend_Db_Table_Row_Abstract
{
    /*
     * Returns the group that this Document belongs to, NULL if none.
     */
    public function getGroup()
    {
        return $this->findParentRow('Core_Model_Folders');
    }

    /*
     * Move the document to another group.
     */
    public function move($group_id)
    {
        $this->group_id = $group_id;
        $this->save();
    }

    /*
     * Returns TRUE if $user can edit $this.
     */
    public function canEdit($user)
    {
        $group = $this->getGroup();

        return $group->canEdit($user);
    }

    /*
     * Returns TRUE if $user can edit $this.
     */
    public function canView($user)
    {
        $group = $this->getGroup();
        
        return $group->canView($user);
    }

    protected function _insert(){
        //This should be uncommented when I figure out how to run this even during installation (where Zend_Registry::get('loggers') isn't available );
        /*$logger = Zend_Registry::get('loggers')->getLogger('user');
        $user = Zend_Auth::getInstance()->getIdentity();
        if ( $logger ) {
            if ( $user ) {
                $logger->notice($user->forename . " " . $user->surname . ' created a new ' . $this->_data["type"] . " with id " . $this->_data["id"]);
            } else {
                $logger->notice('A script created a new ' . $this->_data["type"] . " with id " . $this->_data["id"]);
            }
        }*/
    }

    protected function _delete(){
        $logger = Zend_Registry::get('loggers')->getLogger('user');
        $user = Zend_Auth::getInstance()->getIdentity();
        if ( $logger ) {
            if ( $user ) {
                $logger->notice($user->forename . " " . $user->surname . ' deleted a ' . $this->_data["type"] . " with id " . $this->_data["id"]);
            } else {
                $logger->notice('A script deleted ' . $this->_data["type"] . " with id " . $this->_data["id"]);
            }
        }
    }

    protected function _update(){
        $logger = Zend_Registry::get('loggers')->getLogger('user');
        $user = Zend_Auth::getInstance()->getIdentity();
        if ( $logger ) {
            if ( $user ) {
                $logger->notice($user->forename . " " . $user->surname . ' modified a ' . $this->_data["type"] . " with id " . $this->_data["id"]);
            } else {
                $logger->notice('A script modified a ' . $this->_data["type"] . " with id " . $this->_data["id"]);
            }
        }
    }
}
