<?php

class Core_Model_DocumentFactory {
    public function add($id, $type, $group = NULL) {
        $document = self::fetch($id, $type);

        if(!$document) {
            $db = new Core_Model_Documents();

            $data = array('id' => $id,
                          'type' => $type);

            if(!is_null($group)){
                if(isset($group->group_id)){
                    $data['group_id'] = $group->group_id;
                } else {
                    //group value has been given as int.
                    $data['group_id'] = $group;
                }
            }


            $document = $db->createRow($data);
        } else {
            $document->id = $id;
            $document->type = $type;

            if(!is_null($group))
                $document->group_id = $group->group_id;
        }

        $document->save();

        return $document;
    }

    public function remove($id, $type) {
        $document = self::fetch($id, $type);

        if($document)
            $document->delete();
    }

    public static function fetch($id, $type) {
        $db = new Core_Model_Documents();

        $select = $db->select()
            ->where('id = ?', $id)
            ->where('type = ?', $type);

        return $db->fetchRow($select);
    }

    public function getId($id, $type) {
        $db = new Core_Model_Documents();

        $select = $db->select()
            ->from('document', 'document.document_id')
            ->where('id = ?', $id)
            ->where('type = ?', $type);

        return $db->fetchRow($select)->document_id;
    }
}
