<?

class Core_Model_EmailNotification {

    protected $_recipients;
    protected $_info;
    protected $_text;
    protected $_title;

    public function __construct(){
        $this->_title = "No Title";
        $this->_info = array();
        $this->_recipients = array();
        $this->_text = "";
    }

    public function addRecipient($mail, $split = false){
        if ( $split ) {
            $mails = explode($split, $mail);
        } else {
            $mails = array($mail);
        }
        foreach($mails as $mail) {
            $this->_recipients[] = trim($mail);
        }
    }

    public function setTitle($title){
        $this->_title = $title;
    }

    public function setInfo($info){
        $this->_info = $info;
    }

    public function setText($text){
        $this->_text = $text;
    }

    public function getText(){
        return $this->_text;
    }

    public function send($identification = false){
	    $config = Zend_Registry::get('config');
        $mailParams = $config->mail->params->toArray();

        if($mailParams['auth'] == 'none')
            $mailParams = array('port' => $mailParams['port']);

	    $transport = new Zend_Mail_Transport_Smtp($config->mail->host, $mailParams);
        $mail = new WebReport_Mail();

        foreach ($this->_recipients as $rec) {
            $add = trim($rec);
            if(filter_var($add, FILTER_VALIDATE_EMAIL))
                $mail->addTo($add);
        }

        $mail->setFrom($config->mail->from->address, $config->mail->from->name);
        $mail->setSubject($this->_title);
        $text = "<html><b>" . htmlspecialchars($this->_text) . "</b><br><br>";
        if(count($this->_info) > 0){
            $text .= "Here is a list of available data associated with the camera:<br>";
            $text .= "<ul>";
            foreach($this->_info as $k => $v){
                $text .= "<li>".htmlspecialchars($k . ": " . $v) . "</li>";
            }
            $text .= "</ul>";
            $text .= "<p><strong>If you recently connected the camera to DataManager, this warning might be incorrect and can be ignored.</strong></p>";
        }
        
        
        $mail->setBodyHtml($text);
        $mail->setCaller(Webreport_Mail::Notification);
        $mail->send($transport, $identification);
    }
}
