<?php

class Core_Model_Log extends Zend_Db_Table_Row_Abstract
{

	public function deleteMessages($companyId = null)
	{
		$messages = new Core_Model_LogMessages();
		$db = $messages->getAdapter();
		$tableName = $messages->getAdapter()->quoteIdentifier($messages->info(Zend_Db_Table::NAME));
		if ($companyId) {
			$sql = "DELETE FROM $tableName WHERE log_id = ? AND company_id = ?";
			$db->query($sql, array($this->log_id, $companyId));
		} else {
			$sql = "DELETE FROM $tableName WHERE log_id = ?";
			$db->query($sql, $this->log_id);
		}


	}

	public function getNumberOfMessages($companyId = null)
	{
		$messagesTable = new Core_Model_LogMessages();
		$select = $messagesTable->select();
		$select = $select->from($messagesTable, array('COUNT(*) as count'))
			->where('log_id = ?', $this->log_id);
		if (!is_null($companyId)) {
			$select = $select->where('company_id = ?', $companyId);
		}

		$stmt = $select->query();
		return $stmt->fetch()->count;
	}

}
