<?php

include_once 'Log.php';

class Core_Model_Logs extends Talking_Db_Table
{
	protected $_name = 'log';
	protected $_primary = 'log_id';
	protected $_rowClass = 'Core_Model_Log';

	protected $_dependentTables = array('LogMessages');

	public function fetchRowWithAlias($alias) {
		$alias = (string)$alias;
		$select = $this->select()->where('alias = ?', $alias);
		return $this->fetchRow($select);
    }

    public function fetchAllVisible(){
        $multiComp = Zend_Auth::getInstance()->getIdentity()->multi_company;
        $select = $this->select();

        if ( !$multiComp ) $select->where("hidden != 1");
		return $this->fetchAll($select);
    }

	public function fetchRowWithName($name) {
		$name = (string)$name;
		$select = $this->select()->where('name = ?', $name);
		return $this->fetchRow($select);
	}



}
