<?php

include_once 'Module.php';
include_once 'ModulesRowset.php';

class Core_Model_Modules extends Talking_Db_Table
{
    protected $_name = 'module';
    protected $_primary = 'module_id';
    protected $_rowClass = 'Core_Model_Module';
    protected $_rowsetClass = 'Core_Model_ModulesRowset';
    
    protected $_dependentTables = array('AclResources');


    public function fetchRowWithAlias($alias)
    {
    	$alias = (string)$alias;
    	$select = $this->select()->where('alias = ?', $alias);
    	return $this->fetchRow($select);
    }
    
    public function fixModuleOrder($logger){
        
    }

    public function getFixes(){
        return array(
            array("text" => "COUNT_DATA_ADMINISTRATION",
                "resources" => array("FILTER_GROUPS","FORMULAS","TIME_FILTERS","COUNT_DATA_SETS")),
            array("text" => "REPORTS",
                "resources" => array("REPORTS", "EXPORT_DATA", "SUBSCRIPTIONS")));
    }
    
    public function fixModuleBelonging($logger){
        $logger->notice("Starting module belonging fix..");
        $s = $this->select();
        $fixes = $this->getFixes();
        foreach($fixes as $fix){
            $s->orWhere("text = '".$fix["text"]."'");
            $id = $this->fetchRow($s)->module_id;
            if($id != null){
                $logger->notice("  ".$fix["text"]." has module_id = ".$id.", lets apply this to the correct modules.");
                $CDA = $fix["resources"];
                $mdb = new Core_Model_AclResources();
            
                foreach($CDA as $item){
                    $mod = $this->fetchRow($mdb->select()->where("text = '".$item."'"));
                    if($mod){
                        $modid = $mod->module_id;
                        if($modid != $id){
                            $logger->notice("    The module_id for ".$item." was ".$modid.", changing to ".$id."...");
                            $mdb->update(array("module_id"=> $id), "acl_resource_id = ".$mod->acl_resource_id);
                        }else{
                            $logger->notice("    The resource ".$item." had the correct module_id.");
                        }
                    }else{
                        $logger->warn("    Could not find resource ".$item." in table acl_resource.");
                    }
                }
            
            }else{
                $logger->emerg("Could not find module ".$fix["text"]."!");
            }
        }
    }
 

}

