<?

class Core_Model_Poller {
    const MINIMUM_WAIT = 900;
    const SLEEP = 10;
    const SLEEP_STEP = 1;
    protected $_base = NULL;
    protected $_unique = NULL;
    protected $_alone = NULL;
    protected $_mainPoller = NULL;
    protected $_mature = NULL;
    protected $_doIteration = NULL;

    public function __construct($unique = false){
        $this->_unique = $unique === false ? md5(microtime())."-".getmypid() : $unique;
        try {
            $writer = new Core_Model_ConfigWriter(true, '/../data/poll.ini');
        } catch(Exception $e) {
            throw $e;
        }
        if(!isset($writer->config->poll)){
            $base_url = Zend_Registry::get('config')->resources->frontController->baseUrl;
            $port = '';
            if ($_SERVER['SERVER_PORT'] != '80') {
                $port = ':' . $_SERVER['SERVER_PORT'];
            }
            $writer->config->poll = array(
                "lastPoll" => 0,
                "consecutive" => 0,
                "base" => $_SERVER["SERVER_NAME"].$port.$base_url,
                "totalPollCount" => 0,
                "lastIteration" => 0,
                "iterationTime" => 600,
                "unique" => $this->_unique
            );
            $writer->save();
        }
        $this->_base = $writer->config->poll->base;
        $diff = time() - $writer->config->poll->lastPoll;
        if($diff < -3600) {
            $diff = 3600;
        }
        $alone = true;
        // if diff is small, soneone else is here
        $alone &= $diff >= self::SLEEP-1;
        // if diff is large we are alone only if unique is the same
        $alone &= $diff >= self::MINIMUM_WAIT || $this->_unique == $writer->config->poll->unique;
        $this->_alone = $alone;
        if($alone){
            $writer->config->poll->lastPoll = $unique === false ? 0 : time();
            if($this->_unique != $writer->config->poll->unique) $writer->config->poll->consecutive = 0;
            $writer->config->poll->unique = $this->_unique;
            $writer->config->poll->consecutive++;
            $writer->save();
        } else {
        }

        $this->_mature = $alone && $writer->config->poll->consecutive > 3;
        $this->_mainPoller = $writer->config->poll->unique;
        $timeSinceLastIteration = time() - $writer->config->poll->lastIteration;
        if($timeSinceLastIteration < 0) {
            $timeSinceLastIteration = 0;
            $writer->config->poll->lastIteration = time();  
            $writer->save();
        }
        $this->_doIteration = $this->_mature && $timeSinceLastIteration > $writer->config->poll->iterationTime;
        if($this->_doIteration){
            $writer->config->poll->lastIteration = time();
            $writer->save();
        }
    }

    public function isMature(){
        return $this->_mature;
    }

    public function getMainID(){
        return $this->_mainPoller;
    }

    public function getID(){
        return $this->_unique;
    }

    public function startIterations(){
    }

    public function doIteration($force = FALSE){
        $has_tentative_file = APPLICATION_PATH . "/../public/tmp/has_tentative_cams";
        if(file_get_contents($has_tentative_file)==null)
            file_put_contents($has_tentative_file, 0);
        $has_tentative  = file_get_contents($has_tentative_file);
        $last_sync_file = APPLICATION_PATH . "/../public/tmp/last_sync";
        if(file_get_contents($last_sync_file)==null)
            file_put_contents($last_sync_file, time());
    
        $content = file_get_contents($last_sync_file);
        if ( !$content ) $content = 0;
        $last_sync      = new Zend_Date($content);
        $now            = new Zend_Date(time());
        $time_to_sync   = ($now->getTimestamp() - $last_sync->getTimestamp()) > 24*60*60;
        $reg = new Core_Model_Registration();

        if(($time_to_sync || $has_tentative) && $reg->isOnline()){
            //error_log("Synchronizing cameras..");
            $camerasDB = new Core_Model_Cameras();
            $camerasDB->synchronizeCameras(); 
            file_put_contents($last_sync_file,time());
            file_put_contents($has_tentative_file,0);
       } 
       if($this->_doIteration || $force){
            //error_log("Doing real iteration. ID:" . $this->getID());
            include(APPLICATION_PATH . "/../maintenance/schedule/run.php");
            //error_log("Running imports..");
            //include(APPLICATION_PATH . '/modules/pos/models/ImportJobs.php');
            Core_Model_AccuracyPoller::MaybeRunAccuracyCalculation();
            Pos_Model_ImportJobs::CheckAllJobs();
            $w = new Admin_Plugin_WarningsLoader();
            $w->checkCameras(true);
            Core_Model_RegistrationPoller::CheckSomeCameras();
        } else {
        }
    }

    public function requestApi(){
        set_time_limit(5);
        $opts = array('http' => 
                    array('metod' => 'GET',
                          'timeout' => 0.5)
                );
        $context = stream_context_create($opts);
        $url = 'http://'.$this->_base.'/api/?method=admin.Poll&internal=true';
        $url .= "&unique=" . $this->_unique;
        try {
            @file_get_contents($url, false, $context,-1,10);
        } catch(Exception $e){
        }
    }

    public function isAlone(){
        return $this->_alone;
    }

    public function sleep(){
        set_time_limit(70);
        $seconds = self::SLEEP;
        while($seconds > 0){
            usleep(self::SLEEP_STEP*1000000 + rand(0,self::SLEEP_STEP*100000));
            $seconds -= self::SLEEP_STEP;
        }
    }
}
