<?php

class Core_Model_Protocols
{
    static $_instance = null;
    protected $_data = array();

    public static function getInstance()
    {
        if (self::$_instance == null) {
            self::$_instance = new Core_Model_Protocols();
        }
        return self::$_instance;
    }

    public static function getWithId($id)
    {
        $protocols = self::getInstance();
        return $protocols->findWithId($id);
    }

    public function __construct()
    {
        $availableProtocols = array(0,1);
        $protocols = array('Legacy', 'JSON');
        foreach ($protocols as $protocolName) {
            $className = "Core_Model_Protocol_" . $protocolName;
            $protocol = new $className();
            if (in_array($protocol->getId(), $availableProtocols)) {
                $this->addProtocol($protocol);
            }
        }
    }

    public function addProtocol(Core_Model_Protocol_Abstract $protocol)
    {
        $this->_data[$protocol->getId()] = $protocol;
    }

    public function fetchAll()
    {
        return $this->_data;
    }

    public function findWithId($id)
    {
        if (isset($this->_data[$id])) {
            return $this->_data[$id];
        } else {
            return null;
        }
    }
}
