<?php

class Core_Model_RegistrationPoller {
    public static function CheckSomeCameras(){
        $camDb = new Core_Model_Cameras();
        $select = $camDb->select();
        $select->where('regcode = "?"')->limit(5);
        foreach($camDb->fetchAll($select) as $camera){
            self::CheckCamera($camera);
        }
    }
    public static function CheckCamera($camera){
        $regcode = self::CheckArgus($camera);
        if(!$regcode) $regcode = self::CheckACAP($camera);
        if($regcode){
            $camera->regcode = $regcode;
        } else {
            $camera->regcode = "??";
        }
        $camera->save();
    }

    public static function CheckACAP($camera){
        $opts = array('http' => 
                    array('metod' => 'GET',
                          'timeout' => 3)
        );
        $context = stream_context_create($opts);
        $url = "http://" . $camera->ip . "/local/people-counter/.api?params.json";
        try {
            $json = @file_get_contents($url, false, $context);
            $data = json_decode($json);
            if($data) return $data->Environment->RegCode;
        } catch(Exception $e){
            return FALSE;
        }
        return FALSE;
    }

    public static function CheckArgus($camera){
        $opts = array('http' => 
                    array('metod' => 'GET',
                          'timeout' => 3)
        );
        $opts['http']['header'] = "Authorization: Basic " . base64_encode("root:pass");
        $context = stream_context_create($opts);
        $url = "http://" . $camera->ip . "/local/people-counter/about.shtml";
        try {
            $page = @file_get_contents($url, false, $context);
            $pos = strpos($page,"regCode");
            if($pos) {
                $pos += strlen("regCode : '");
                $code = substr($page,$pos,14);
                return $code;
            }
        } catch(Exception $e){
            return FALSE;
        }
        return FALSE;
        return FALSE;
    }
}
