<?php

include_once 'User.php';
include_once 'Companies.php';
//include_once 'AclRoles.php';

class Core_Model_Users extends Talking_Db_Table
{
	protected $_name = 'user';
	protected $_primary = 'user_id';
	protected $_rowClass = 'Core_Model_User';

	protected $_dependentTables = array('Core_Model_Companies', 'Core_Model_FoldersUsers');

	protected $_referenceMap    = array(
		'Company' => array(
			'columns'           => array('company_id'),
			'refTableClass'     => 'Core_Model_Companies',
			'refColumns'        => array('company_id')
		),
		'AclRole' => array(
			'columns'           => array('acl_role_id'),
			'refTableClass'     => 'Core_Model_AclRoles',
			'refColumns'        => array('acl_role_id')
	)
    );

	public function fetchWithEmail($email) {
		$email = (string)$email;
		$select = $this->select()->where('email = ?', $email);
		$user = $this->fetchRow($select);
		return $user;
	}

    public static function getCurrentUser(){
        $user = Zend_Auth::getInstance()->getIdentity();
        $userDb = self::getInstance();
        return $userDb->find($user->user_id)->current();
    }

	public function inactivate($userIds) {
		$users = $this->find($userIds);
		if (count($users) == 0)
		return false;

		foreach ($users as $user) {
			if ($user)
			$user->inactivate();
		}
		return true;
	}

    public static function getUser($id){
        $db = new Core_Model_Users();
        $user = $db->find($id);
        return $user->current();
    }


	public function activate($userIds) {
		$users = $this->find($userIds);
		if (count($users) == 0)
		return false;

		foreach ($users as $user) {
			if ($user)
			$user->activate();
		}
		return true;
	}

    public function getFirstSuperUser() {
        $user = $this->find(array('multi_user = ?' => 1))->current();
        return $user;
    }
}
