<?php

//include_once 'CameraGroup.php';

class Core_Model_VirtualCameras extends Talking_Db_Table {

	protected $_name = 'virtual_camera';
	protected $_primary = 'virtual_camera_id';
//	protected $_rowClass = 'Core_Model_CameraGroup';


	public function fetchAllVirtualCameras(Core_Model_Company $company = null)
	{
		$db = $this->getAdapter();

		$companiesDb = new Core_Model_Companies();

		$select = $db->select()
			->from(array("vc" => $this->info(Zend_Db_Table::NAME)),
				array("virtual_camera_id", "name", "vc.company_id", "application_id", "created_date", "description"))
			->join(array("co" => $companiesDb->info(Zend_Db_Table::NAME)),
				"vc.company_id = co.company_id",
				array("company" => "name"));
		if ($company) {
			$select->where('vc.company_id = ?', $company->company_id)->order('co.name');
		}
		$select->order('application_id');
		return $db->fetchAll($select);

	}


	/**
	 * Returns camera names
	 *
	 * @param <type> $application
	 * @param <type> $company
	 * @return array Associative array with camera ids as keys and names as value
	 */
	public function getCameraNames(Core_Model_Application_Abstract $application = null, Core_Model_Company $company = null)
	{
		$db = $this->getAdapter();

		$companiesDb = new Core_Model_Companies();

		$select = $db->select()
			->from(array("vc" => $this->info(Zend_Db_Table::NAME)),
				array("virtual_camera_id", "name", "company_id", "application_id", "created_date", "description"))
			->join(array("co" => $companiesDb->info(Zend_Db_Table::NAME)),
				"vc.company_id = co.company_id",
				array("company" => "name"));
		if ($company) {                
                    $select->where('co.company_id = ?', $company->company_id);
                }
                if ($application) {
                    $select->where('application_id = ?', $application->getId());
                }
		$cameras = $db->fetchAll($select);

		$ret = array();
		$cameras = $db->fetchAll($select);
		foreach ($cameras as $cam) {
			$ret[$cam->virtual_camera_id] = $cam->name;
		}

		return $ret;
	}

    public function fetchDocuments($group) {
        /*
         * TODO: Write a nice JOIN.
         */
        $documents = $group->getDocuments('virtual_camera');
        $virtualCamerasDb = new Core_Model_VirtualCameras();

        $virtualCameras = array();
        foreach($documents as $doc) {
            $vc = $virtualCamerasDb->find($doc->id)->current();

            if($vc)
                 $virtualCameras[] = $vc;                        
        }

        return $virtualCameras;
    }

    public function fetchAllVisible($user)
    {
        $groupsDb = new Core_Model_Folders();
        $groups = $groupsDb->getViewableGroups($user);

        $virtualCamerasDb = new Core_Model_VirtualCameras();

        $cameras = array();
        foreach($groups as $group) {
            $documents = $group->findDependentRowset('Core_Model_Documents');
            foreach($documents as $document) {
                if($document->type == 'virtual_camera') {
                    $virtualCamera = $virtualCamerasDb->find($document->id)->current();
                    if($virtualCamera)
                        $cameras[] = $virtualCamera;
                }
            }   
        }

        return $cameras;
    }

    public function fetchAllVisibleNames($user, $application = NULL)
    {
        $cameras = $this->fetchAllVisible($user);
        
        $ret = array();
        foreach($cameras as $cam) {
            if(!is_null($application)) {
                if($cam->application_id == $application->getId())
                    $ret[$cam->virtual_camera_id] = $cam->name;
            }
            else
                $ret[$cam->virtual_camera_id] = $cam->name;
        }
        return $ret;
    }
}

