<?php

include_once 'Warning.php';
include_once 'Cameras.php';

class Core_Model_Warnings extends Talking_Db_Table
{
	protected $_name = 'warning';
	protected $_primary = 'warning_id';
	protected $_rowClass = 'Core_Model_Warning';

	protected $_referenceMap = array(
		'Camera' => array(
			'columns'           => array('camera_id'),
			'refTableClass'     => 'Core_Model_Cameras',
			'refColumns'        => array('camera_id')
		)
	);

    public function fetchAllForCompany(Core_Model_Company $company)
    {
        // @todo Way to many db-calls for this select
        $camerasDb = new Core_Model_Cameras();
		$cams = $camerasDb->getCameras(null, $company);
        $select = $this->select();
        $cid = array();
		$count = count($cams);
        
		$where = "";
        foreach ($cams as $c) {
            $cid[$c->camera_id] = $c;
            $where .= "camera_id = " . $camerasDb->getAdapter()->quote($c->camera_id);
           	$where .= " OR ";	
        }
        $where .= "camera_id <> NULL";

        $select = $select->where($where)->where('acknowledged = 0')->order("created_date DESC");
        $warnings = $this->fetchAll($select);

        foreach ($warnings as $warning) {
        		// input to setCamera will be a stdClass and not a Core_Model_Camera
        		// it's ugly but what the heck 
				if ((int)$warning->camera_id > 0) {
            	$warning->setCamera($cid[$warning->camera_id]);
            }
        }

        return $warnings;
    }

}
