<?php

class CountData_Forms_Validate_TimeFilter extends Zend_Validate_Abstract {
    const IS_EMPTY = 'isEmpty';
    const INVALID_SYMBOLS = 'invalidSymbols';
    const INVALID_STRUCTURE = 'invalidStructure';

//    protected $_enableElementName = 'time_filter_code';
    protected $_messageTemplates = array(
        self::IS_EMPTY => 'TIME_FILTER_CODE_CANNOT_BE_EMPTY',
        self::INVALID_SYMBOLS => 'TIME_FILTER_CODE_CONTAINS_INCORRECT_SYMBOLS',
        self::INVALID_STRUCTURE => 'TIME_FILTER_CODE_HAS_INVALID_STRUCTURE'
    );

    public function isValid($value, $context = null) {
        $value = (string) $value;
        $this->_setValue($value);

        if (strlen($value) == 0) {
            $this->_error(self::IS_EMPTY);
        } else if (!Core_Model_TimeFilterFactory::isAllowed($value)) {
            $this->_error(self::INVALID_SYMBOLS);
        } else if (!Core_Model_TimeFilterFactory::canConstruct($value)) {
            $this->_error(self::INVALID_STRUCTURE);
        } else {
            return true;
        }
        return false;
    }

    private function _translatableString() {
        $this->_translate->_("TIME_FILTER_CODE_CANNOT_BE_EMPTY");
        $this->_translate->_("TIME_FILTER_CODE_CONTAINS_INCORRECT_SYMBOLS");
        $this->_translate->_("TIME_FILTER_CODE_HAS_INVALID_STRUCTURE");
    }

}
