<?php

class CountData_Model_FormulaSetListGenerator extends Core_Model_Generic_AbstractListView {
    public function getHeaders(){
        return array(_T("NAME"),_T("APPLICATION"),_T("NUMBER_OF_FORMULAS_IN_SET"),_T("DESCRIPTION"));
    }

    protected function _dataRowToTableRow($row){
        $applicationsDb = new Core_Model_Applications();
        $application = $applicationsDb->findWithId($row->application_id);

        $ret = array();
        $ret[] = $row->name;
        $ret[] = $application->getName();
        
        $ret[] = (string)count($row->getFormulas());
        $ret[] = $row->description;

        $ret['_document_id'] = Core_Model_DocumentFactory::getId($row->count_data_formula_set_id, "formula_set");

        return $ret;
    }

    public function removeText(){
        return _T('DO_YOU_REALLY_WANT_TO_REMOVE_THE_FORMULA_SET_"%1$s"?');
    }

    protected function _dataRowToRowId($row){
        return $row->count_data_formula_set_id;
    }

    public function noDataInformation(){
        return _T("NO_FORMULA_SETS.");
    }

    public function getActions($row){
        $folder = $this->_group->group_id;

        $creator = $this->_group->canEdit($this->_user);

        $actions = array();
        $actions[] = parent::CreateAction(_T('VIEW_FORMULA_SET'),'view', 'view', $folder);

        if($creator) {
            $actions[] = parent::CreateAction(_T('EDIT_FORMULA_SET'), 'edit', 'edit', $folder);
            $actions[] = parent::CreateAction(_T('DELETE_FORMULA_SET'),'delete', 'delete', $folder);
        }

        return $actions;
    }
}
