<?php

class CountData_Model_MenuItems extends WebReport_Module_MenuItems_Abstract {

    /**
     * Get count data module menu items.
     *
     * @return array 
     */
    public function getAll() {
        $items = array();

        $items['count-data-sets'] = array(
            'text' => 'MOD_COUNT-DATA_MENU_COUNT_DATA_SETS',
            'class' => 'count-data-sets',
            'urlOptions' => array('module' => 'count-data', 'controller' => 'count-data-sets', 'action' => 'browse'),
            'title' => "MANAGE_COUNT_DATA_SETS"
        );

        $items['virtual-cameras'] = array(
            'text' => 'MOD_COUNT-DATA_MENU_VIRTUAL_CAMERAS',
            'class' => 'virtual-cameras',
            'urlOptions' => array('module' => 'count-data', 'controller' => 'virtual-cameras', 'action' => 'browse'),
            'title' => "MANAGE_VIRTUAL_CAMERAS"
        );

        $items['formulas'] = array(
            'text' => 'MOD_COUNT-DATA_MENU_FORMULAS',
            'class' => 'formula',
            'urlOptions' => array('module' => 'count-data', 'controller' => 'formulas', 'action' => 'browse'),
            'title' => "MANAGE_FORMULAS_FOR_ADVANCED_DATA_MINING"
        );

        $items = $this->filterNotAllowedItems($items);
        return $this->translate($items);
    }

    public static function getDescription($item) {
        $t = Zend_Registry::get("Zend_Translate");
        $items = array();

        $items['time-filter'] = $t->_("MANAGE_TIME_FILTERS_FOR_ADVANCED_FILTERING.");    
        $items['formulas'] = $t->_("MANAGE_FORMULAS_FOR_ADVANCED_DATA_MINING.");
        $items['virtual-cameras'] = $t->_("CREATE_VIRTUAL_CAMERAS_AS_COMBINATIONS_OF_COUNT_DATA_FROM_REAL_CAMERAS.");
        $items['filter-groups'] = $t->_("MANAGE_FILTERS_FOR_GROUPING_DATA_BY_CAMERA,_CAMERA_NAME_AND_COUNT_TYPE.");
        $items['count-data-sets'] = $t->_("CREATE_SETS_OF_CAMERAS_AND_FORMULAS_FOR_FAST_CREATION_OF_CHARTS,_REPORTS_ETC.");
        return $items[$item];
    }

    private function _translatableStrings() {
        $this->_translate->_('MOD_COUNT-DATA_MENU_FILTER_GROUPS');
        $this->_translate->_('MOD_COUNT-DATA_MENU_TIME_FILTERS');
        $this->_translate->_('MOD_COUNT-DATA_MENU_VIRTUAL_CAMERAS');
        $this->_translate->_('MOD_COUNT-DATA_MENU_FORMULAS');
        $this->_translate->_('MOD_COUNT-DATA_MENU_COUNT_DATA_SETS');
        $this->_translate->_('MANAGE_FORMULAS_FOR_ADVANCED_DATA_MINING');
        $this->_translate->_('MANAGE_VIRTUAL_CAMERAS');
        $this->_translate->_('MANAGE_COUNT_DATA_SETS');
        $this->_translate->_('MANAGE_FILTER_GROUPS_FOR_FILTERING_OUT_THE_DATA_YOU_WANT');
        $this->_translate->_('MANAGE_TIME_FILTERS_FOR_ADVANCED_DATA_MINING');
	$this->_translate->_('FIRST_FRIDAY_OF_THE_MONTH');
	$this->_translate->_('FILTER_CODE');
	$this->_translate->_('FILTER_NAME');
    }

}
