<?php

class CountData_Model_VirtualCameraListGenerator extends Core_Model_Generic_AbstractListView {
    public function getHeaders(){
        return array(_T("NAME"),_T("APPLICATION"),_T("DESCRIPTION"));
    }

    protected function _dataRowToTableRow($row){
        $applicationsDb = new Core_Model_Applications();
        $application = $applicationsDb->findWithId($row->application_id);

        $ret = array();
        $ret[] = $row->name;
        $ret[] = $application->getName();
        
        $ret[] = $row->description;

        $ret['_document_id'] = Core_Model_DocumentFactory::getId($row->virtual_camera_id, "virtual_camera");

        return $ret;
    }

    public function removeText(){
        return _T('DO_YOU_REALLY_WANT_TO_REMOVE_THE_VIRTUAL_CAMERA_"%1$s"?');
    }

    protected function _dataRowToRowId($row){
        return $row->virtual_camera_id;
    }

    public function noDataInformation(){
        return _T("NO_VIRTUAL_CAMERAS.");
    }

    public function getActions($row){
        $folder = $this->_group->group_id;

        $creator = $this->_group->canEdit($this->_user);

        $actions = array();
        $actions[] = parent::CreateAction(_T('VIEW_VIRTUAL_CAMERA'),'view', 'view', $folder);

        if($creator) {
            $actions[] = parent::CreateAction(_T('EDIT_VIRTUAL_CAMERA'), 'edit', 'edit', $folder);
            $actions[] = parent::CreateAction(_T('DELETE_VIRTUAL_CAMERA'),'delete', 'delete', $folder);
        }

        return $actions;
    }
}
