<?php

class Demographics_Model_Api_Method_Demographics_AddData extends WebReport_Api_Method_Abstract
{
    public function userIsAllowed(Core_Model_User $user)
    {
        return true;
    }

    public function needsAuthentication()
    {
        return false;
    }

    public function call(array $params)
    {
        $data = $this->decryptAndDecodeJSON();
        //$time = new DateTime();
        $start = microtime(true);
        try {
            $protocol = Core_Model_Protocols::getWithId($data['protocol']);
            $protocol::addData($data);
            $laptime = microtime(true);
            Core_Model_Application_Demographics::aggregateData($data);
        } catch (Exception $e) {
            r_log($e->getMessage());
            throw new WebReport_Exception($e->getMessage());
        }
        $end = microtime(true);
        $execution_time = round($end - $start, 5);
        $event_data_time = round($laptime - $start, 5);
        $count_data_time = round($end - $laptime, 5);
        //r_log("\nAdded demographics data in (seconds): $execution_time \n EventData::addData: $event_data_time \n Demographics::aggregateData: $count_data_time.");
        echo "ok";
        return;
    }
}
