<?php

/*include_once 'core/models/CameraGroups.php';
include_once 'core/models/CompanyCameraGroup.php';
include_once 'core/models/Companies.php';*/

class Export_IndexController extends WebReport_Controller_Action
{
   protected $_user;
   protected $_legacyPermalink;

    public function init()
    {
        parent::init();

        $module = $this->getRequest()->module;
        $controller = $this->getRequest()->controller;
        $action = $this->getRequest()->action;

        $usersDb = Core_Model_Users::getInstance();
        $this->_user = $usersDb->find(Zend_Auth::getInstance()->getIdentity()->user_id)->current();

        $items = array();
        $items[] = array("urlOptions" => array(
            'module' => $module, "controller" => 'index',
            "action" => "index"),
            "text" => _T('LIST_STORED_EXPORTS'),
            'tooltip' => _T('LIST_STORED_EXPORTS_TOOLTIP')
        );
        $items[] = array("urlOptions" => array(
            'module' => $module, "controller" => 'export',
            "action" => "create-export"),
            "text" => _T('CREATE_EXPORT'),
            'tooltip' => _T('CREATE_EXPORT_TOOLTIP')
        );

        $this->view->submenu = WebReport_Module_MenuItems_Abstract::translate($items);
        $this->view->module = $module;
        $this->view->headTitle("EXPORTS", Zend_View_Helper_Placeholder_Container_Abstract::PREPEND);

        $idParam = (int) $this->_request->getParam('id');
        $this->_idParam = $idParam;
    }

    public function indexAction()
    {

        if ($this->_flashMessenger->hasMessages()) {
            $this->view->messages = $this->_flashMessenger->getMessages();
        }

        $this->view->title = $this->_translate->_("EXPORTS");

        $request = $this->_request;
        $user = $this->_user;
        $helper = $this->_helper;

        $legacyPermalinkDb = Reports_Model_Permalinks::getInstance();
        $legacyChartPermalinkDb = Charts_Model_Permalinks::getInstance();
        $exportsDb = Export_Model_Exports::getInstance();
        $allChartPermalinks = $legacyChartPermalinkDb->fetchAll();
        if ($this->_user->multi_company) {
            $storedExports = $exportsDb->fetchAll();
            $permalinks = $legacyPermalinkDb->fetchAll();
            $chartPermalinks = $allChartPermalinks;
        } else {
            $companiesDb = new Core_Model_Companies();
            $company = $companiesDb->find($this->_user->company_id)->current();
            $storedExports = $exportsDb->fetchAllForCompany($company);
            $permalinks = $legacyPermalinkDb->fetchAllForCompany($company);
            foreach ($allChartPermalinks as $chartPermalink) {
                if ($chartPermalink->getCompany()->company_id == $company->company_id) {
                    $chartPermalinks[] = $chartPermalink;
                }
            }
        }
        $this->view->storedExportsList = Export_Model_StoredExportsListGenerator::CreateView($storedExports);
        $this->view->legacyPermalinksList = Export_Model_LegacyPermalinkListGenerator::CreateView($permalinks);
        $this->view->legacyChartPermalinksList = Export_Model_LegacyChartPermalinkListGenerator::CreateView($chartPermalinks);
    }

    public function deleteLegacyPermalinkAction()
    {
        $legacyPermalinksDb = Reports_Model_Permalinks::getInstance();
        $legacyPermalink = $legacyPermalinksDb->find($this->_idParam)->current();
        $legacyPermalink->delete();
        $this->_flashMessenger->addMessage($this->_translate->_('MIGRATED_PERMALINK_DELETED'));
        $this->_helper->redirector('index', 'index');
    }

    public function deleteLegacyChartPermalinkAction()
    {
        $legacyChartPermalinksDb = Charts_Model_Permalinks::getInstance();
        $legacyChartPermalink = $legacyChartPermalinksDb->find($this->_idParam)->current();
        $legacyChartPermalink->delete();
        $this->_flashMessenger->addMessage($this->_translate->_('MIGRATED_PERMALINK_DELETED'));
        $this->_helper->redirector('index', 'index');
    }
}
