<?php

class Export_Model_Api_Method_GetExport extends WebReport_Api_Method_Abstract
{

    public function userIsAllowed(Core_Model_User $user)
    {
        return true;
    }

    public function needsAuthentication()
    {
        return false;
    }

    public function call(array $params)
    {
        if (!isset($params["params"]) || !isset($params["params"]["id"])) {
            echo "No parameters specified.";
            return;
        }

        $permalink = explode("k", $params["params"]["id"]);

        if (count($permalink) < 2) {
            echo "Wrong format on permalink.";
            return;
        }

        $id = $permalink[0];
        $key = "k" . $permalink[1];

        $exportDb = new Export_Model_Exports();
        $export = $exportDb->tryFetchExport($id, $key);

        if (count($export) != 1) {
            // $todo: How to fix translation here?
            echo "Invalid permalink.";
        } else {
            if (isset($params["params"]["INFO"])) {
                $exportArray = $export->toArray();
                foreach ($exportArray as $k => $s) {
                    echo $k . " => " . $s . "<br>";
                }
            } else {
                $export->touch();
                $export->render();
                /*$config = $permalink->getSettings();
                $fine = isset($params["params"]["FINE"]) || isset($params["params"]["fine"]);
                $format = $fine ? "fine" : $config['$outputFormat'];
                // The HahnHausen Fix
                $p = $params['params'];
                $settings = array();
                if(array_key_exists('nameFirst',$p)) $settings['nameFirst'] = true;
                if(array_key_exists('compact',$p)) $settings['compact'] = true;
                if(array_key_exists('header',$p))    $settings['header'] =  $p['header'];
                if(array_key_exists('colon',$p))    $settings['kolon'] =  true;
                if(array_key_exists('dateformat',$p))    $settings['small-endian'] =  $p['dateformat'] == 'L';
                if(array_key_exists('header',$p))    $settings['header'] =  $p['header'];
                if(array_key_exists('inText',$p))    $settings['inText'] =  $p['inText'];
                if(array_key_exists('outText',$p))    $settings['outText'] =  $p['outText'];
                if(count($settings)) $format = 'customcsv';
                // Bootstrap hack
                Core_Model_CountData_Filter_Parts::addPart(new Core_Model_CountData_Filter_Part_CameraName());
                Core_Model_CountData_Filter_Parts::addPart(new Core_Model_CountData_Filter_Part_CountType());
                // End of hack
                Reports_Model_ReportCompiler::renderReport($config['countDataSetId'],
                    $format,
                    $config['aggregatorId'],
                    $config['timeFilterId'],
                    $config['timeResolution'],
                    $config['timeFormat'],
                    $config['firstDateSelected'],
                    $config['lastDateSelected'],
                    $settings);*/
            }
        }
    }
}
