<?php

class Export_Model_LegacyChartPermalinkListGenerator extends Core_Model_Generic_AbstractListView {

    public function __construct()
    {
        parent::__construct();

        $this->_extendedColumns = false;
        $this->_module = Zend_Controller_Front::getInstance()->getRequest()->getModuleName();
        if ($this->_module == "overview") {
            $this->_extendedColumns = true;
        }
    }

    public function getHeaders()
    {
        $headers = array(_T("URL"),_T("FORMAT"),_T("LAST_ACCESSED"));
        if ($this->_isMultiCompany) {
            $headers[] = _T("COMPANY");
        }
        return $headers;
    }

    protected function _dataRowToTableRow($row)
    {
        $this->_url = $row->getApi();
        $ret = array();
        $ret[] = $this->_url;
        $ret[] = $row->format;
        $ret[] = $row->last_api_read;
        if ($this->_isMultiCompany) {
            $ret[] = $row->getCompany()->name;
        }
        return $ret;
    }

    public function removeText(){
        return _T('DO_YOU_REALLY_WANT_TO_REMOVE_THE_MIGRATED_PERMALINK_"%1$s"?');
    }

    protected function _dataRowToRowId($row){
        return $row->permalink_id;
    }

    public function noDataInformation(){
        return "No migrated permalinks, TODO: Hide this table!";
    }

    public function getActions($row){
        $actions = array();
        $actions[] = parent::CreateAction(_T('VIEW_EXPORT'), null, 'view', null, null, null, null, null, $this->_url);
        $actions[] = parent::CreateAction(_T('DELETE_PERMANENT_LINK'), 'delete-legacy-chart-permalink', 'delete', null, null, null, 'export', 'index');
        return $actions;
    }
}
