<?php

class Heatmap_Model_Heatmap extends Zend_Db_Table_Row_Abstract
{

    public function getDataAsMatrix($downscaled = false)
    {
        $d = array();
        $data = "";
        $yl = $this->height;
        $xl = $this->width;

        if ($downscaled) {
            $data = $this->data_ds4;
            $yl = $yl/4;
            $xl = $xl/4;            
        } else {
            $data = $this->data;
        }

        $pos = 0;
        for ($y = 0; $y < $yl; $y++) {
            $arr = array();
            for ($x = 0; $x < $xl; $x++) {
                $arr[$x] = hexdec(substr($data,$pos,2));
                $pos += 2;
            }
            $d[$y] = $arr;
        }
        return $d;
    }

    public function mean($rowset, $onlyLowRes = false)
    {
        $data = array();
        $dataDown = array(); // downscaled data

        // @todo: lame att hårdkoda
        // hela den här funktionen är lite shaky om heatmapparna inte är
        // samma storlek men vi förutsätter väl det I guess
        $this->width = 80;
        $this->height = 60;
        $this->image_width = 640;
        $this->image_height = 480;

        if(!$onlyLowRes){
            for ($i = 0; $i < $this->height*$this->width; $i++) {
                $data[$i] = 0;
            }
        }

        for ($i = 0; $i < $this->height/4*$this->width/4; $i++) {
            $dataDown[$i] = 0;
        }

        foreach ($rowset as $heatmap) {
            if(!$onlyLowRes){
                $d = $heatmap->getDataAsMatrix();
                $c = 0;
                for ($y = 0; $y < $this->height; $y++) {
                    for ($x = 0; $x < $this->width; $x++) {
                        $data[$c] += $d[$y][$x];
                        $c++;
                    }
                }
            }

            $c = 0;
            $d = $heatmap->getDataAsMatrix(true);
            for ($y = 0; $y < $this->height>>2; $y++) {
                for ($x = 0; $x < $this->width>>2; $x++) {
                    $dataDown[$c] += $d[$y][$x];
                    $c++;
                }
            }
        }

        $count = count($rowset);
        if ($count == 0) $count = 1;
        $dst = "";
        $max = 0;
        if(!$onlyLowRes) {
            for ($i = 0; $i < $this->height*$this->width; $i++) {
                $v = round($data[$i]/$count);
                if ($v > $max) $max = $v;
                $dst .= str_pad(dechex($v),2,"0",STR_PAD_LEFT);
            }
        }

        $dsst = "";
        for ($i = 0; $i < ($this->height*$this->width) >> 4; $i++) {
            $v = round($dataDown[$i]/$count);
            $dsst .= str_pad(dechex($v),2,"0",STR_PAD_LEFT);
            if($onlyLowRes && $v > $max) $max = $v;
        }
        $this->data = $dst;
        $this->data_ds4 = $dsst;

        $num_sum = 0;
        foreach ($rowset as $m) { $num_sum += $m->num_sum; }
        $this->num_sum = $num_sum;


        $this->max = $max;
        return $this;
    }

}
