<?php

class Heatmap_Model_Image
{

    protected $_heatmap;
    protected $_colorScheme;
    protected $_format = 'png';
    protected $_image;
    

    public function __construct(Heatmap_Model_Heatmap $heatmap, $colorScheme)
    {
        $this->_heatmap = $heatmap;
        $this->_colorScheme = $colorScheme;
        
        $this->_image = imagecreatetruecolor($heatmap->getWidth(), $heatmap->getHeight());
    }
    
    public function getFormat()
    {
        return $this->_format;
    }

    public function render()
    {
        $hm = $this->_heatmap;
        $img = $this->_image;
        $d = $hm->getData();
        $colors = $this->_colorScheme->getColors();
        $colorCount = count($colors);
        for ($x = 0; $x < $hm->getWidth(); $x++) {
            for ($y = 0; $y < $hm->getHeight(); $y++) {
                $v = $d[$x][$y];
                $bin = floor($v/$colorCount);
                $rgb = $colors[$bin];
                $color = imagecolorallocatealpha($img, $rgb[0], $rgb[1], $rgb[2], 70);
                imagesetpixel($img, $x, $y, $color);
            }
        }
        
        imagepng($img, NULL, 9);   
    }

    public function __destruct() {
        imagedestroy($this->_image);
    }

}