<?php

class Heatmap_Model_Masks extends Talking_Db_Table
{
	protected $_name = 'mod_heatmap_mask';
	protected $_primary = 'heatmap_mask_id';
//	protected $_rowClass = 'Heatmap_Model_Mask';


        public function insertUniqueAutoMask(Core_Model_Camera $camera, array $mask) {
            if(count($mask) != 600) {
                throw new WebReport_Error("Unsupported mask length.");
            }
            $hmpData = "";

            foreach($mask as $value) {
                $value = str_pad(dechex($value), 2, "0", STR_PAD_LEFT);
                $hmpData .= $value;
            }

            $select = $this->select();
            // Windows servers crash if doing long queries, so we must hash the mask
            $select->where("SHA1(mask) LIKE ?", sha1($hmpData));
            $set = $this->fetchAll($select);

            if(count($set)>0) { // any mask will do since these will not be altered
                return $set->current()->heatmap_mask_id;
            }
            $data = array(
                "name" => "auto_generated",
                "auto" => 1,
                "camera_id" => $camera->camera_id,
                "mask" => $hmpData
            );
            $new_id = $this->insert($data);
            return $new_id;
        }
}
