<?php

class Heatmap_Model_MenuItems extends WebReport_Module_MenuItems_Abstract {

    /**
     * Get admin module menu items.
     *
     * @return array 
     */
    public function getAll() {
        $acl = WebReport_Acl::getInstance();
        $items = array();

        $view = Zend_Controller_Action_HelperBroker::getStaticHelper('ViewRenderer')->view;

        $identity = Zend_Auth::getInstance()->getIdentity();
        $companiesDb = Core_Model_Companies::getInstance();
        $camerasDb = Core_Model_Cameras::getInstance();
        $company = $companiesDb->find($identity->company_id)->current();
        $heatmapApp = new Core_Model_Application_Heatmap();
        if($identity->multi_company){
            $hasCameras = $camerasDb->hasCameras($heatmapApp);
        }else{
            $hasCameras = $camerasDb->hasCameras($heatmapApp, $company);
        }
        if($hasCameras) {
            $items['heatmaps'] = array(
                'text' => 'MOD_HEATMAP_MENU_BROWSE_HEATMAPS',
                'class' => 'browse',
                'urlOptions' => array('module' => 'heatmap', 'controller' => 'index', 'action' => 'index'),
                'title' => "BROWSE_HEATMAPS_HISTORY"
            );
        }
/*
        $items['settings'] = array(
            'text' => 'MOD_HEATMAP_MENU_SETTINGS',
            'class' => 'settings',
            'urlOptions' => array('module' => 'heatmap', 'controller' => 'settings', 'action' => 'index'),
            'title' => "C"
        );
*/

        $items = $this->filterNotAllowedItems($items);

        return $this->translate($items);
    }

    public static function getDescription($item) {
        $t = Zend_Registry::get("Zend_Translate");
        $items = array();
        $items['heatmaps'] = $t->_("BROWSE_HEATMAPS_FOR_MULTIPLE_CAMERAS_AND_DIFFERENT_TIME_RESOLUTIONS.");
//        $items['settings'] = "TODO";
        return $items[$item];
    }

    private function _translatableStrings() {
        $this->_translate->_('BROWSE_HEATMAPS_HISTORY');
    }


}
