<?php

class Installation_Form_CompanyAndUser extends UniForm_Form
{

	public function init()
	{
		parent::init();

		$this->addElementPrefixPath('CM_Validate_User', 'CM/Validate/User/', 'validate');
		$this->addElementPrefixPath('WebReport_Validate_User', 'WebReport/Validate/User/', 'validate');

		$name = new UniForm_Form_Element_Text('name');
		$name->setLabel('COMPANY_NAME')
			->setAttrib('maxlength', '255')
			->addFilter('StringTrim')
			->setRequired();


		$this->addElements(array($name));
		$this->addDisplayGroup(array('name'), 'company-group', array('legend' => 'YOUR_COMPANY'));

		$forename = new UniForm_Form_Element_Text('forename');
		$forename->setLabel('FORENAME')
			->setRequired()
			->addFilter('StringTrim');

		$surname = new UniForm_Form_Element_Text('surname');
		$surname->setLabel('SURNAME')
			->setRequired()
			->addFilter('StringTrim');

		$email = new UniForm_Form_Element_Text('email');
		$email->setLabel('E-MAIL')
			->setRequired()
			->addValidator('EmailAddress');

		$password = new UniForm_Form_Element_Password('password');
		$password->setLabel('PASSWORD')
			->addValidator('PasswordStrength',true)
			->addValidator('PasswordConfirmation')
			->setRequired();

		$password_confirm = new UniForm_Form_Element_Password('password_confirm');
		$password_confirm->setLabel('CONFIRM_PASSWORD')
			->setRequired();

		$submit = new UniForm_Form_Element_Submit('submit');
		$submit->setLabel('SUBMIT');

		$this->addElements(array($forename, $surname, $email, $password, $password_confirm));

		$this->addDisplayGroup(array('forename','surname','company_id', 'email', 'password', 'password_confirm'), 'user-group', array('legend' => 'ADMINISTRATIVE_USER'));


		$submit = new UniForm_Form_Element_Submit('submit');
		$submit->setLabel('NEXT_STEP');

		$this->addElements(array($submit));



		return $this;

	}

}
