<?php

class Installation_Form_Database extends UniForm_Form
{

    public function init()
    {
        parent::init();

        $t = Zend_Registry::get('Zend_Translate');

        $database_params_host = new UniForm_Form_Element_Text('database_params_host');
        $database_params_host->setLabel('HOST_NAME')
            ->setDescription($t->_("ENTER_THE_HOST_NAME_FOR_YOUR_DATABASE._THIS_IS_USUALLY_'localhost'."))
            ->setValue("localhost")	
            ->setRequired();

        $database_params_username = new UniForm_Form_Element_Text('database_params_username');
        $database_params_username->setLabel('USER_NAME')
            ->setDescription($t->_("ENTER_THE_USER_NAME_FOR_THE_DATABASE_USER._IT_MUST_HAVE_ALL_PERMISSIONS_WITHIN_THE_DATABASE_YOU_WANT_TO_USE."))
            ->setValue("root")
            ->setRequired();

        $database_params_password = new UniForm_Form_Element_Password('database_params_password');
        $database_params_password->setLabel('PASSWORD')
            ->setDescription($t->_("FOR_SITE_SECURITY_USING_A_PASSWORD_FOR_THE_DATABASE_ACCOUNT_IS_MANDATORY."))
            ->setRequired();

        $db_name = "datamanager_" . str_replace('-','_', str_replace('.','_',WebReport_Version::VERSION));
        $database_params_dbname = new UniForm_Form_Element_Text('database_params_dbname');
        $database_params_dbname->setLabel('DATABASE_NAME')
            ->setDescription($t->_("ENTER_THE_DATABASE_NAME_YOU_WANT_TrueView_DataManager_TO_USE."))
            ->setValue($t->_($db_name))
            ->setRequired();

        if(@mysql_connect("localhost", "root", "")) {
            $database_params_password_c = new UniForm_Form_Element_Password('database_params_password_c');
            $database_params_password_c->setLabel('CONFIRM_PASSWORD')
                ->setDescription($t->_("WE_HAVE_DETECTED_THAT_THE_ROOT_PASSWORD_OF_YOUR_DATABASE_IS_BLANK._YOUR_DATABASE_PASSWORD_WILL_CHANGED_AUTOMATICALLY_IF_YOU_SET_IT_HERE."))
                ->setRequired()
                ->addValidator('Identical', false, array('token' => 'database_params_password'));
        } else
            $database_params_password_c = NULL;

        $database_newdb = new UniForm_Form_Element_Checkbox('database_newdb');
        $database_newdb->setLabel($t->_('CREATE_NEW_DATABASE'))
            ->setDescription($t->_("CREATE_A_NEW_DATABASE."));

        $database_import = new UniForm_Form_Element_Select('database_import');
        $database_import
            ->setLabel($t->_("IMPORT_FROM_AN_EXISTING_TrueView_DataManager<sup>&reg;</sup>_DATABASE"))
            ->setDescription($t->_("IMPORT_FROM_AN_EXISTING_TrueView_DataManager_DATABASE._USED_TO_UPGRADE_FROM_OLD_WINDOWS_SYSTEMS"))
            ->addMultiOption(0,$t->_("NO"))
            ->addMultiOption(1,$t->_("YES"))
            ->setRequired();

        $database_import_params_host = new UniForm_Form_Element_Text('database_import_params_host');
        $database_import_params_host
            ->setLabel($t->_("IMPORT_DATABASE_HOST"))
            ->setDescription($t->_("ENTER_MYSQL_HOST_TO_IMPORT_FROM_AN_OLD_TrueView_DataManager_DATABASE"));

        $database_import_params_port = new UniForm_Form_Element_Text('database_import_params_port');
        $database_import_params_port
            ->setLabel($t->_("IMPORT_DATABASE_PORT"))
            ->setValue("3306")
            ->setDescription($t->_("ENTER_MYSQL_PORT_TO_IMPORT_FROM_AN_OLD_TrueView_DataManager_DATABASE"));

        $database_import_params_username = new UniForm_Form_Element_Text('database_import_params_username');
        $database_import_params_username
            ->setLabel('IMPORT_USER_NAME')
            ->setDescription($t->_("ENTER_THE_USER_NAME_FOR_THE_DATABASE_USER._IT_MUST_HAVE_ALL_PERMISSIONS_WITHIN_THE_DATABASE_YOU_WANT_TO_USE."));

        $database_import_params_password = new UniForm_Form_Element_Password('database_import_params_password');
        $database_import_params_password->setLabel('IMPORT_PASSWORD')
            ->setDescription($t->_("FOR_SITE_SECURITY_USING_A_PASSWORD_FOR_THE_DATABASE_ACCOUNT_IS_MANDATORY."));

        $database_import_params_dbname = new UniForm_Form_Element_Text('database_import_params_dbname');
        $database_import_params_dbname->setLabel('IMPORT_DATABASE_NAME')
            ->setDescription($t->_("ENTER_THE_DATABASE_NAME_YOU_WANT_TrueView_DataManager_TO_USE."));

        $database_import_test = new UniForm_Form_Element_Button('database_import_connection_test');
        $database_import_test
            ->setLabel($t->_("TEST_IMPORT_CONNECTION"))
            ->setDescription($t->_("VERIFY_THAT_THE_DATABASE_CONNECTION_IS_VALID"));

        $this->addElements(array($database_params_host, $database_params_username, $database_params_password, $database_params_password_c, $database_params_dbname, $database_newdb, $database_import,
            $database_import_test, $database_import_params_host, $database_import_params_port, $database_import_params_username,
            $database_import_params_password, $database_import_params_dbname));

        $this->addDisplayGroup(array('database_params_host', 'database_params_username', 'database_params_password', 'database_params_password_c', 'database_params_dbname', 'database_newdb'),
            'web-report-database-group'
        );
        $this->addDisplayGroup(array('database_import'),
            'do-database-import'
        );
        $this->addDisplayGroup(array('database_import_params_host','database_import_params_port','database_import_params_username','database_import_params_password','database_import_params_dbname','database_import_connection_test'),
            'database-import-group');


        $submit = new UniForm_Form_Element_Submit('submit');
        $submit->setLabel('NEXT_STEP');

        $this->addElements(array($submit));


        return $this;

    }

}
