<?php

class Installation_Form_Registration extends UniForm_Form
{

	public function init()
	{
		parent::init();

		$t = Zend_Registry::get('Zend_Translate');

		$this->setDescription("&nbsp;");

		$registration_code = new UniForm_Form_Element_Text('registration_code');
		$registration_code->setLabel('REGISTRATION_CODE')
			->setDescription($t->_("ENTER_THE_REGISTRATION_CODE_YOU_RECEIVED_FROM_COGNIMATICS."))
			->setRequired();


		$installation_id = new UniForm_Form_Element_Text('installation_id');
		$installation_id->setLabel('INSTALLATION_ID')
			->setDescription($t->_("THE_INSTALLATION_ID_IS_UNIQUE_FOR_THIS_REGISTRATION_CODE_AND_YOUR_COMPUTER."))
			->setAttrib("disabled", true)
			->setRequired();

		$activation_code = new UniForm_Form_Element_Text('activation_code');
		$activation_code->setLabel('ACTIVATION_CODE')
			->setDescription($t->_("ENTER_THE_ACTIVATION_CODE_YOU_WILL_GET_BY_CLICKING_ON_THE_LINK_ABOVE_THIS_FORM."))
			->setRequired();


		$this->addElements(array($registration_code, $installation_id, $activation_code));

		$this->addDisplayGroup(array('registration_code', 'installation_id', 'activation_code'),
							'web-report-registration-group'
						);


		$submit = new UniForm_Form_Element_Submit('submit');
		$submit->setLabel('REGISTER');

		$this->addElements(array($submit));


		return $this;

	}

}
