<?php
class Installation_Model_AclDbSyncFunctions{
    public function _setResourceModule($resourcekey, $resource){
        $mod = $resource['module'];

        $resDb = new Core_Model_AclResources();
        $modDb = new Core_Model_Modules();
        $k = $resDb->fetchRow(array('text = ?' => $resourcekey));
        if($k == null){
            return false;
        }
        $modid = $k->module_id;
        $curmodrow = $modDb->find($modid)->current();
        $modname = $curmodrow['alias'];

        if ($modname != $mod){
            $correctRow = $modDb->fetchRow(array('alias = ?' => $mod));
            $k->module_id = $correctRow->module_id;
            $k->save();
        }
    }
    
    

    public function _addResource($data) {
        $data = (object) $data;

        $moduleDb = new Core_Model_Modules();
        $module = $moduleDb->fetchAll(array('alias = ?' => $data->module))->current();

        if(is_null($module)) {
            throw new WebReport_Exception('MODULE_DOES_NOT_EXIST._' . $data->module);
        }
        
        $resourceDb = new Core_Model_AclResources();
        $resource  = $resourceDb->createRow(array(
            'text' => $data->text,
            'controller' => $data->controller,
            'module_id' => $module->module_id
            ));
        $arr = array(
            'text' => $data->text,
            'controller' => $data->controller,
            'module_id' => $module->module_id
            );
        $resource->save();

    }

    public function _addGroup($data) {
        $data = (object) $data;

        $resourceDb = new Core_Model_AclResources();
        $resource = $resourceDb->fetchAll(array('text = ?' => $data->resource))->current();

        if(is_null($resource)) {
            throw new WebReport_Exception('NOT_A_VALID_RESOURCE._' . $data->resource);
        }

        $groupDb = new Core_Model_AclPrivilegeGroups();
        $group = $groupDb->createRow(array(
            'text' => $data->group,
            'acl_resource_id' => $resource->acl_resource_id
            ));
        $group->save();
    }

    public function _addAssembly($data) {
        $data = (object) $data;

        $resourceDb = new Core_Model_AclResources();
        $resource = $resourceDb->fetchAll(array('text = ?' => $data->resource))->current();

        if(is_null($resource)) {
            throw new WebReport_Exception('NOT_A_VALID_RESOURCE._' . $data->resource);
        }
        $groupDb = new Core_Model_AclPrivilegeGroups();
        $group = $groupDb->fetchAll(array('text = ?' => $data->group, 'acl_resource_id = ?' => $resource->acl_resource_id))->current();

        if(is_null($group)) {
            throw new WebReport_Exception("NO_SUCH_GROUP_".$data->group);
        }

        $assemblyDb = new Core_Model_AclPrivilegeGroupAssemblies();

        $assembly = $assemblyDb->createRow(array(
            'text' => $data->assembly,
            'optional' => $data->optional,
            'value' => $data->value,
            'acl_privilege_group_id' => $group->acl_privilege_group_id
        ));

        $assembly->save();
    }

    public function _addAction($data, $_action_extra){
        $data = (object) $data;

        $resourceDb = new Core_Model_AclResources();
        $resource = $resourceDb->fetchAll(array('text = ?' => $data->resource))->current();

        if(is_null($resource)) {
            throw new WebReport_Exception('NOT_A_VALID_RESOURCE._' . $data->resource);
        }
        $groupDb = new Core_Model_AclPrivilegeGroups();
        $group = $groupDb->fetchAll(array('text = ?' => $data->group, 'acl_resource_id = ?' => $resource->acl_resource_id))->current();

        if(is_null($group)) {
            throw new WebReport_Exception("NO_SUCH_GROUP_".$data->group);
        }

        $assemblyDb = new Core_Model_AclPrivilegeGroupAssemblies();
        $assembly = $assemblyDb->fetchAll(array('acl_privilege_group_id = ?' => $group->acl_privilege_group_id, 'text = ?' => $data->assembly))->current();

        if(is_null($assembly)) {
            throw new WebReport_Exception("NO_SUCH_ASSEMBLY_".$data->assembly);
        }
        $action_privDb = new Core_Model_AclPrivilegeGroupAssemblyPrivilege();
        $actionDb = new Core_Model_AclPrivileges();

        $action = null;

        /*
        $new_action = $action_privDb->fetchAll($action_privDb->select(array('acl_privilege_id'))->setIntegrityCheck(false)
                ->join('acl_privilege',
                        'acl_privilege_group_assembly_privilege.acl_privilege_id = acl_privilege.acl_privilege_id')
                ->where('acl_privilege_group_assembly_id = ?', $assembly->acl_privilege_group_assembly_id))->current();

        if(is_null($new_action))
            $action=$actionDb->fetchAll(array('acl_resource_id = ?' => $resource->acl_resource_id, 'action = ?' => $data->action))->current();
        else
            $action=$actionDb->fetchAll($new_action->acl_privilege_id)->current();*/
        $action = null;

        if(is_null($action)) {
            $action = $actionDb->createRow(array(
                'acl_resource_id' => $resource->acl_resource_id,
                'action' => $data->action
            ));
            $action->save();
        }

        if(!is_null($data->additional_keys)) {
            foreach($_action_extra as $extra) {
                if(isset($data->additional_keys[$extra])) {
                    $action->$extra = $data->additional_keys[$extra];
                } else {
                    $action->$extra = null;
                }
            }
            $action->save();
        }

        $action_priv = $action_privDb->fetchAll(array(
                 'acl_privilege_group_assembly_id = ?' => $assembly->acl_privilege_group_assembly_id,
                 'acl_privilege_id = ?' => $action->acl_privilege_id))->current();

        if(is_null($action_priv))
            $action_priv = $action_privDb->createRow(array(
                    'acl_privilege_group_assembly_id' => $assembly->acl_privilege_group_assembly_id,
                    'acl_privilege_id' => $action->acl_privilege_id
                ));
        $action_priv->save();
    }

    public function _addRole($data,$company_id) {
        $data = (object) $data;

        $resourceDb = new Core_Model_AclResources();
        $resource = $resourceDb->fetchAll(array('text = ?' => $data->resource))->current();

        if(is_null($resource)) {
            throw new WebReport_Exception('NOT_A_VALID_RESOURCE._' . $data->resource);
        }
        $groupDb = new Core_Model_AclPrivilegeGroups();
        $group = $groupDb->fetchAll(array('text = ?' => $data->group, 'acl_resource_id = ?' => $resource->acl_resource_id))->current();

        if(is_null($group)) {
            throw new WebReport_Exception("NO_SUCH_GROUP_".$data->group);
        }

        $assemblyDb = new Core_Model_AclPrivilegeGroupAssemblies();
        $assembly = $assemblyDb->fetchAll(array('acl_privilege_group_id = ?' => $group->acl_privilege_group_id, 'text = ?' => $data->assembly))->current();

        if(is_null($assembly)) {
            throw new WebReport_Exception("NO_SUCH_ASSEMBLY_".$data->assembly);
        }

        $acl_roleDb = new Core_Model_AclRoles();
        $acl_role = $acl_roleDb->fetchAll(array('name = ?' => $data->acl_role, 'company_id = ?' => $company_id))->current();

        if(is_null($acl_role)) {
            $acl_role = $acl_roleDb->createRow(array(
                'company_id' => $company_id,
                'name' => $data->acl_role
            ));
            $acl_role->save();
        }

        $acl_priv_rolesDb = new Core_Model_AclRolePrivilegeGroupAssembly();
        $n = $acl_priv_rolesDb->fetchAll(
                array(
              'acl_role_id = ?' => $acl_role->acl_role_id,
              'acl_privilege_group_assembly_id = ?' => $assembly->acl_privilege_group_assembly_id
                ));
        if(count($n)==0) {
            $acl_priv_role = $acl_priv_rolesDb->createRow(array(
                  'acl_role_id' => $acl_role->acl_role_id,
                'acl_privilege_group_assembly_id' => $assembly->acl_privilege_group_assembly_id
            ));
            $acl_priv_role->save();
        }

    }
}


