<?php

abstract class Installation_Model_DatabaseUpdateEntryAbstractAddColumn extends Installation_Model_DatabaseUpdateEntryAbstract
{
    protected $_table = null;
    protected $_column = null;
    protected $_settings = null;
    protected $_after = null;
    protected $_index = false;
    protected $_tables = null;

    protected function _preAssert() {
        foreach($this->_getTables() as $table){
            $q = $this->_conn->query("DESCRIBE `".$table."` `".$this->_column."`")->fetchAll();
            if(count($q) != 0) {
                return false;
            }
        }
        return true;
    }

    protected function _postAssert() {
        foreach($this->_getTables() as $table){
            $q = $this->_conn->query("DESCRIBE `".$table."` `".$this->_column."`")->fetchAll();
            if(count($q) != 1) {
                return false;
            }
        }
        return true;
    }

    protected function _update() {
        foreach($this->_getTables() as $table){
            $this->_conn->exec("ALTER TABLE `" . $table . "` ADD `" . $this->_column . "` " . $this->_settings . " AFTER `".$this->_after."`");
            if($this->_index) $this->_conn->exec("ALTER TABLE `" .  $table . "` ADD INDEX ( `" . $this->_column . "` )");
        }
        return true;
    }

    protected function _getTables(){
        return $this->getTables($this->_table, $this->_tables);
    }

    protected function _description() {
        return "Add column " . $this->_table .".".$this->_column;
    }
}
