<?php

abstract class Installation_Model_DatabaseUpdateEntryAbstractAddModule extends Installation_Model_DatabaseUpdateEntryAbstract
{
    protected $_module = 'null';
    protected $_text = 'null';
    protected $_uninstallable = 1;
    protected $_order = 20;
    protected $_populateToCompanies = true;

    protected function _preAssert() {
        $q = $this->_conn->query("SHOW TABLES LIKE 'module'")->fetchAll();
        if(count($q) == 0) {
            return false;
        }
        return true;
    }

    protected function _postAssert() {
        $q = $this->_conn->query("SELECT * FROM module WHERE alias LIKE '".$this->_module."'")->fetchAll();
        if(count($q) != 1) {
            return false;
        }
        return true;
    }

    protected function _update() {
        if($this->_postAssert()) return true;
        $this->_conn->exec("INSERT INTO module(`text`, `alias`, `order`, `installed`, `uninstallable`) VALUES(
            '".$this->_text."','".$this->_module."',".$this->_order.", NOW() ," . $this->_uninstallable . ")");

        $moduleid = $this->_conn->lastInsertId();

        if($this->_populateToCompanies) {
            $companyDb = new Core_Model_Companies();
            $companies = $companyDb->fetchAll();
            $moduleCompany = new Core_Model_ModuleCompany();

            foreach ($companies as $company) {
                $mc = $moduleCompany->fetchRow($moduleCompany->select()->where('company_id = ?', $company->company_id)
                    ->where('module_id = ?', $moduleid));
                if (!$mc) {
                    $mc = $moduleCompany->createRow();
                    $mc->company_id = $company->company_id;
                    $mc->module_id = $moduleid;
                    $mc->save();
                }
            }
        }
        return true;
    }

    protected function _description() {
        return "Add module " . $this->_module;
    }
}
