<?php

class Installation_Model_DatabaseUpdateEntryAbstractModifyTableColumns extends Installation_Model_DatabaseUpdateEntryAbstract
{
    protected $_tableName = "";
    protected $_newValues = NULL;
    protected $_where = NULL;
    protected $_alwaysRun = true;
    protected $_tableNames = null;

    protected function _preAssert() {
        foreach($this->_getTables() as $table){
            $q = $this->_conn->query("SHOW TABLES LIKE '".$table."'")->fetchAll();

            if(count($q) != 1) {
                return false;
            }
        }

        return true;
    }

    protected function _postAssert() {
        foreach($this->_getTables() as $table){
            $q = $this->_conn->query("SHOW TABLES LIKE '".$table."'")->fetchAll();

            if(count($q) != 1) {
                return false;
            }
        }
        // You could actually formulate a better assert here using the entry parameters.

        return true;
    }

    protected function _update() {
        foreach($this->_getTables() as $table){
            $update_list = "";
            foreach($this->_newValues as $columnName => $newValue)
                $update_list .= $columnName . " = " . $newValue . ",";
            $sql_cmd = "UPDATE " . $table . " SET " . rtrim($update_list, ","); 
            if(!is_null($this->_where)) $sql_cmd .= " WHERE " . $this->_where;
            $this->_conn->exec($sql_cmd);
        }
        return true;
    }

    protected function _getTables(){
        return $this->getTables($this->_tableName,$this->_tableNames);
    }

    protected function _description() {
        if(count($this->_getTables()) > 1) return $this->_t->_("POPLULATE_TABLE_FROM_SELECT");
        return "Populate table " . $this->_tableName;
    }
}
