<?php

class Installation_Model_DatabaseUpdateEntryAbstractPopulateTable extends Installation_Model_DatabaseUpdateEntryAbstract
{
    protected $_tableName = "";
    protected $_data = false;
    protected $_checkInsert = true;
    protected $_checkEmpty = false;
    protected $_allowPDOException = false;
    protected $_ignoreAssertOnKeys = array();

    protected function _createSelect($keys, $values){
        $s = "SELECT * FROM `" . $this->_tableName . "` WHERE ";
        $whereCount = 0;
        for($i = 0; $i < count($keys); $i++){
            if($values[$i] == null || in_array($keys[$i],$this->_ignoreAssertOnKeys)) continue;
            if($whereCount > 0) $s .= " AND ";
            $s .= "`".$keys[$i]."`". " = '" . $values[$i] . "' ";
            $whereCount++;
        }
        return $s;
    }


    protected function _preAssert() {
        $q = $this->_conn->query("SHOW TABLES LIKE '".$this->_tableName."'")->fetchAll();
        if(count($q) != 1) {
            return false;
        }

        if($this->_checkInsert) {
            foreach($this->_data as $data)
            {
                $keys = array_keys($data);
                $values = array_values($data);
                $q = $this->_conn->query($this->_createSelect($keys,$values))->fetchAll();
                if(count($q) != 0) {
                    return false;
                }
            }
        }
        if($this->_checkEmpty) {
            $q = $this->_conn->query("SELECT COUNT(*) FROM `" . $this->_tableName . "`")->fetchAll();
            if($q[0])
               throw new WebReport_Exception("TABLE_NOT_EMPTY");
        }

        return true;
    }

    protected function _postAssert() {
        $q = $this->_conn->query("SHOW TABLES LIKE '".$this->_tableName."'")->fetchAll();

        if(count($q) != 1) {
            return false;
        }

        if($this->_checkInsert) {
             foreach($this->_data as $data) {
                $keys = array_keys($data);
                $values = array_values($data);
                $where = "";

                $q = $this->_conn->query($this->_createSelect($keys,$values))->fetchAll();
                if(count($q) != 1) {
                    return false;
                }
            }
        }

        return true;
    }

    protected function _update() {
        foreach($this->_data as $data)
        {
            $keys = array_keys($data);
            $values = array_values($data);

            $new_values = array();
            foreach($values as $value) {
                if(is_null($value))
                    $new_values[] = "NULL";
                else
                    $new_values[] = "'" . $value . "'";
            }
    
            $sql_cmd = "INSERT INTO `" . $this->_tableName . "` (`" . implode("`,`", $keys) . "`)" . " VALUES(" . implode(",",$new_values). ")";
            try {
                $this->_conn->exec($sql_cmd);
            } catch (PDOException $e){
                if(!$this->_allowPDOException) {
                    return false;
                }
            }
        }

        return true;
    }

    protected function _description() {
        return "Populate table " . $this->_tableName;
    }
}
