-- MySQL dump 10.13  Distrib 5.5.50, for debian-linux-gnu (x86_64)
--
-- Host: localhost    Database: datamanager_1_4_0
-- ------------------------------------------------------
-- Server version	5.5.50-0+deb8u1-log

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;
/*!40103 SET @OLD_TIME_ZONE=@@TIME_ZONE */;
/*!40103 SET TIME_ZONE='+00:00' */;
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;

--
-- Table structure for table `acl_privilege`
--

DROP TABLE IF EXISTS `acl_privilege`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `acl_privilege` (
  `acl_privilege_id` int(11) NOT NULL AUTO_INCREMENT,
  `acl_resource_id` int(11) NOT NULL,
  `action` varchar(64) COLLATE utf8_bin NOT NULL COMMENT 'same as controller action name',
  `param1_key` varchar(64) COLLATE utf8_bin NOT NULL,
  `param1_value` varchar(128) COLLATE utf8_bin NOT NULL,
  `param2_key` varchar(64) COLLATE utf8_bin NOT NULL,
  `param2_value` varchar(128) COLLATE utf8_bin NOT NULL,
  `param3_key` varchar(64) COLLATE utf8_bin NOT NULL,
  `param3_value` varchar(128) COLLATE utf8_bin NOT NULL,
  PRIMARY KEY (`acl_privilege_id`),
  KEY `acl_resource_id` (`acl_resource_id`),
  CONSTRAINT `acl_privilege_ibfk_1` FOREIGN KEY (`acl_resource_id`) REFERENCES `acl_resource` (`acl_resource_id`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `acl_privilege_group`
--

DROP TABLE IF EXISTS `acl_privilege_group`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `acl_privilege_group` (
  `acl_privilege_group_id` int(11) NOT NULL AUTO_INCREMENT,
  `acl_resource_id` int(11) NOT NULL,
  `text` varchar(64) COLLATE utf8_bin NOT NULL,
  PRIMARY KEY (`acl_privilege_group_id`),
  KEY `acl_resource_id` (`acl_resource_id`),
  CONSTRAINT `acl_privilege_group_ibfk_1` FOREIGN KEY (`acl_resource_id`) REFERENCES `acl_resource` (`acl_resource_id`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `acl_privilege_group_assembly`
--

DROP TABLE IF EXISTS `acl_privilege_group_assembly`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `acl_privilege_group_assembly` (
  `acl_privilege_group_assembly_id` int(11) NOT NULL AUTO_INCREMENT,
  `acl_privilege_group_id` int(11) NOT NULL,
  `text` varchar(64) COLLATE utf8_bin NOT NULL,
  `optional` tinyint(1) NOT NULL DEFAULT '1',
  `value` tinyint(1) NOT NULL DEFAULT '1',
  PRIMARY KEY (`acl_privilege_group_assembly_id`),
  KEY `acl_privilege_group_id` (`acl_privilege_group_id`),
  CONSTRAINT `acl_privilege_group_assembly_ibfk_1` FOREIGN KEY (`acl_privilege_group_id`) REFERENCES `acl_privilege_group` (`acl_privilege_group_id`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `acl_privilege_group_assembly_privilege`
--

DROP TABLE IF EXISTS `acl_privilege_group_assembly_privilege`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `acl_privilege_group_assembly_privilege` (
  `acl_privilege_group_assembly_privilege_id` int(11) NOT NULL AUTO_INCREMENT,
  `acl_privilege_group_assembly_id` int(11) NOT NULL,
  `acl_privilege_id` int(11) NOT NULL,
  PRIMARY KEY (`acl_privilege_group_assembly_privilege_id`),
  KEY `acl_privilege_group_assembly_id` (`acl_privilege_group_assembly_id`),
  KEY `acl_privilege_id` (`acl_privilege_id`),
  CONSTRAINT `acl_privilege_group_assembly_privilege_ibfk_1` FOREIGN KEY (`acl_privilege_group_assembly_id`) REFERENCES `acl_privilege_group_assembly` (`acl_privilege_group_assembly_id`) ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT `acl_privilege_group_assembly_privilege_ibfk_2` FOREIGN KEY (`acl_privilege_id`) REFERENCES `acl_privilege` (`acl_privilege_id`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `acl_resource`
--

DROP TABLE IF EXISTS `acl_resource`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `acl_resource` (
  `acl_resource_id` int(11) NOT NULL AUTO_INCREMENT,
  `module_id` int(11) NOT NULL,
  `text` varchar(64) COLLATE utf8_bin NOT NULL,
  `controller` varchar(64) COLLATE utf8_bin NOT NULL COMMENT 'same as controller name',
  PRIMARY KEY (`acl_resource_id`),
  KEY `module_id` (`module_id`),
  CONSTRAINT `acl_resource_ibfk_1` FOREIGN KEY (`module_id`) REFERENCES `module` (`module_id`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `acl_role`
--

DROP TABLE IF EXISTS `acl_role`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `acl_role` (
  `acl_role_id` int(11) NOT NULL AUTO_INCREMENT,
  `company_id` int(11) NOT NULL,
  `name` varchar(255) COLLATE utf8_bin NOT NULL,
  `description` text COLLATE utf8_bin NOT NULL,
  PRIMARY KEY (`acl_role_id`),
  KEY `company_id` (`company_id`),
  CONSTRAINT `acl_role_ibfk_1` FOREIGN KEY (`company_id`) REFERENCES `company` (`company_id`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `acl_role_privilege_group_assembly`
--

DROP TABLE IF EXISTS `acl_role_privilege_group_assembly`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `acl_role_privilege_group_assembly` (
  `acl_role_privilege_group_assembly_id` int(11) NOT NULL AUTO_INCREMENT,
  `acl_role_id` int(11) NOT NULL,
  `acl_privilege_group_assembly_id` int(11) NOT NULL,
  PRIMARY KEY (`acl_role_privilege_group_assembly_id`),
  KEY `acl_role_id` (`acl_role_id`),
  KEY `acl_privilege_group_assembly_id` (`acl_privilege_group_assembly_id`),
  CONSTRAINT `acl_role_privilege_group_assembly_ibfk_1` FOREIGN KEY (`acl_privilege_group_assembly_id`) REFERENCES `acl_privilege_group_assembly` (`acl_privilege_group_assembly_id`) ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT `acl_role_privilege_group_assembly_ibfk_2` FOREIGN KEY (`acl_role_id`) REFERENCES `acl_role` (`acl_role_id`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `camera`
--

DROP TABLE IF EXISTS `camera`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `camera` (
  `camera_id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(100) COLLATE utf8_bin NOT NULL,
  `serial` varchar(24) COLLATE utf8_bin NOT NULL,
  `regcode` varchar(15) COLLATE utf8_bin DEFAULT NULL,
  `ip` varchar(32) COLLATE utf8_bin NOT NULL DEFAULT '',
  `application_id` int(11) NOT NULL,
  `camera_group_id` int(11) DEFAULT NULL,
  `count_data_table_id` int(11) DEFAULT NULL,
  `report_warnings` tinyint(1) NOT NULL DEFAULT '1',
  `first_date` datetime DEFAULT NULL,
  `last_date` datetime DEFAULT NULL,
  `last_contact` datetime DEFAULT NULL,
  `first_contact` datetime DEFAULT NULL,
  `data_last_utc_timestamp` double DEFAULT NULL,
  `utc_offset` int(11) DEFAULT NULL,
  `first_contact_hash` text COLLATE utf8_bin,
  `signature` text COLLATE utf8_bin,
  `sync_me` tinyint(1) DEFAULT '0',
  `fetch_me` tinyint(1) DEFAULT '0',
  `meta_data` varchar(10000) COLLATE utf8_bin DEFAULT '{}',
  PRIMARY KEY (`camera_id`),
  KEY `camera_group_id` (`camera_group_id`),
  KEY `count_data_table_id` (`count_data_table_id`),
  CONSTRAINT `camera_ibfk_1` FOREIGN KEY (`camera_group_id`) REFERENCES `camera_group` (`camera_group_id`) ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT `camera_ibfk_2` FOREIGN KEY (`count_data_table_id`) REFERENCES `count_data_table` (`count_data_table_id`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `camera_group`
--

DROP TABLE IF EXISTS `camera_group`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `camera_group` (
  `camera_group_id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) COLLATE utf8_bin NOT NULL,
  `username` varchar(255) COLLATE utf8_bin NOT NULL,
  `password` varchar(255) COLLATE utf8_bin NOT NULL,
  `password_salt` varchar(50) COLLATE utf8_bin NOT NULL,
  `description` text COLLATE utf8_bin NOT NULL,
  `email` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `no_data_timeout` int(11) DEFAULT '48',
  `no_connection_timeout` int(11) DEFAULT '8',
  PRIMARY KEY (`camera_group_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `camera_image`
--

DROP TABLE IF EXISTS `camera_image`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `camera_image` (
  `camera_image_id` int(11) NOT NULL AUTO_INCREMENT,
  `camera_id` int(11) NOT NULL,
  `time` datetime NOT NULL,
  `filename` varchar(255) COLLATE utf8_bin NOT NULL,
  PRIMARY KEY (`camera_image_id`),
  KEY `camera_id` (`camera_id`),
  CONSTRAINT `camera_image_ibfk_1` FOREIGN KEY (`camera_id`) REFERENCES `camera` (`camera_id`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `camera_opening_hours`
--

DROP TABLE IF EXISTS `camera_opening_hours`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `camera_opening_hours` (
  `opening_hour_id` int(11) NOT NULL AUTO_INCREMENT,
  `camera_id` int(11) NOT NULL,
  `date` date NOT NULL,
  `opens` time DEFAULT NULL,
  `closes` time DEFAULT NULL,
  `conn_protocol` varchar(64) COLLATE utf8_bin NOT NULL,
  `last_update` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  PRIMARY KEY (`opening_hour_id`),
  KEY `camera_and_date` (`camera_id`,`date`),
  CONSTRAINT `opening_hour_ibfk_1` FOREIGN KEY (`camera_id`) REFERENCES `camera` (`camera_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `camera_set`
--

DROP TABLE IF EXISTS `camera_set`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `camera_set` (
  `camera_set_id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `camera_set_type_id` int(11) NOT NULL,
  `company_id` int(11) DEFAULT NULL,
  PRIMARY KEY (`camera_set_id`),
  KEY `camera_set_ibfk_1` (`company_id`),
  CONSTRAINT `camera_set_ibfk_1` FOREIGN KEY (`company_id`) REFERENCES `company` (`company_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `camera_set_type`
--

DROP TABLE IF EXISTS `camera_set_type`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `camera_set_type` (
  `camera_set_type_id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) COLLATE utf8_bin NOT NULL,
  PRIMARY KEY (`camera_set_type_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `camera_set_type1`
--

DROP TABLE IF EXISTS `camera_set_type1`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `camera_set_type1` (
  `camera_set_id` int(11) NOT NULL,
  `day_start_offset` time NOT NULL DEFAULT '00:00:00',
  `location_coordinates` varchar(128) COLLATE utf8_bin DEFAULT NULL,
  `location_region` varchar(128) COLLATE utf8_bin DEFAULT NULL,
  `location_city` varchar(128) COLLATE utf8_bin DEFAULT NULL,
  `location_country` varchar(128) COLLATE utf8_bin DEFAULT NULL,
  `sales_region_id` int(11) DEFAULT NULL,
  PRIMARY KEY (`camera_set_id`),
  CONSTRAINT `camera_set_type1_ibfk_1` FOREIGN KEY (`camera_set_id`) REFERENCES `camera_set` (`camera_set_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `camera_set_type1_sales_region`
--

DROP TABLE IF EXISTS `camera_set_type1_sales_region`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `camera_set_type1_sales_region` (
  `camera_set_type1_sales_region_id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) COLLATE utf8_bin NOT NULL,
  PRIMARY KEY (`camera_set_type1_sales_region_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `camera_set_type1_section`
--

DROP TABLE IF EXISTS `camera_set_type1_section`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `camera_set_type1_section` (
  `camera_set_type1_section_id` int(11) NOT NULL AUTO_INCREMENT,
  `camera_set_id` int(11) NOT NULL,
  `name` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `is_store` tinyint(1) DEFAULT '1',
  PRIMARY KEY (`camera_set_type1_section_id`),
  KEY `camera_set_id_key` (`camera_set_id`),
  CONSTRAINT `camera_set_type1_section_ibfk_1` FOREIGN KEY (`camera_set_id`) REFERENCES `camera_set` (`camera_set_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `camera_set_type1_section_accuracy`
--

DROP TABLE IF EXISTS `camera_set_type1_section_accuracy`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `camera_set_type1_section_accuracy` (
  `camera_set_type1_section_accuracy_id` int(11) NOT NULL AUTO_INCREMENT,
  `camera_set_type1_section_id` int(11) NOT NULL,
  `date` date NOT NULL,
  `count_error` float(5,2) DEFAULT NULL,
  PRIMARY KEY (`camera_set_type1_section_accuracy_id`),
  KEY `camera_set_type1_section_id_key` (`camera_set_type1_section_id`),
  CONSTRAINT `camera_set_type_1_section_accuracy_ibfk_1` FOREIGN KEY (`camera_set_type1_section_id`) REFERENCES `camera_set_type1_section` (`camera_set_type1_section_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `camera_set_type1_section_camera`
--

DROP TABLE IF EXISTS `camera_set_type1_section_camera`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `camera_set_type1_section_camera` (
  `camera_set_type1_section_camera_id` int(11) NOT NULL AUTO_INCREMENT,
  `camera_set_type1_section_id` int(11) NOT NULL,
  `camera_id` int(11) DEFAULT NULL,
  `reverse_count` tinyint(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`camera_set_type1_section_camera_id`),
  KEY `camera_id_key` (`camera_id`),
  KEY `camera_set_id_key` (`camera_set_type1_section_id`),
  CONSTRAINT `camera_set_type_1_section_camera_ibfk_1` FOREIGN KEY (`camera_id`) REFERENCES `camera` (`camera_id`) ON DELETE CASCADE,
  CONSTRAINT `camera_set_type_1_section_camera_ibfk_2` FOREIGN KEY (`camera_set_type1_section_id`) REFERENCES `camera_set_type1_section` (`camera_set_type1_section_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `company`
--

DROP TABLE IF EXISTS `company`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `company` (
  `company_id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) COLLATE utf8_bin NOT NULL,
  `owner` int(11) NOT NULL,
  `url` varchar(255) COLLATE utf8_bin NOT NULL,
  `email` varchar(255) COLLATE utf8_bin NOT NULL,
  `phone1` varchar(255) COLLATE utf8_bin NOT NULL,
  `phone2` varchar(255) COLLATE utf8_bin NOT NULL,
  `fax` varchar(255) COLLATE utf8_bin NOT NULL,
  `address` mediumtext COLLATE utf8_bin NOT NULL,
  `city` varchar(255) COLLATE utf8_bin NOT NULL,
  `state` varchar(255) COLLATE utf8_bin NOT NULL,
  `zip` varchar(10) COLLATE utf8_bin NOT NULL,
  `country` varchar(10) COLLATE utf8_bin NOT NULL,
  `week_start` int(1) DEFAULT '0',
  `date_format` varchar(16) COLLATE utf8_bin DEFAULT 'auto',
  `weather_enable` tinyint(1) NOT NULL DEFAULT '0',
  `logo_enable` tinyint(1) NOT NULL DEFAULT '0',
  `logo_filename` varchar(255) COLLATE utf8_bin NOT NULL,
  `active` tinyint(1) NOT NULL DEFAULT '1',
  `created_by` int(11) NOT NULL,
  `created_date` datetime NOT NULL,
  `cameras_allowed` int(11) DEFAULT NULL,
  `comment` varchar(1000) COLLATE utf8_bin DEFAULT '',
  `next_invoice` varchar(250) COLLATE utf8_bin DEFAULT '',
  `end_customer_contact` varchar(250) COLLATE utf8_bin DEFAULT '',
  `end_customer_name` varchar(250) COLLATE utf8_bin DEFAULT '',
  `integrator_contact` varchar(250) COLLATE utf8_bin DEFAULT '',
  `integrator_name` varchar(250) COLLATE utf8_bin DEFAULT '',
  `distributor_contact` varchar(250) COLLATE utf8_bin DEFAULT '',
  `distributor_name` varchar(250) COLLATE utf8_bin DEFAULT '',
  PRIMARY KEY (`company_id`),
  KEY `created_by` (`created_by`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `company_camera_group`
--

DROP TABLE IF EXISTS `company_camera_group`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `company_camera_group` (
  `company_camera_group_id` int(11) NOT NULL AUTO_INCREMENT,
  `company_id` int(11) NOT NULL,
  `camera_group_id` int(11) NOT NULL,
  PRIMARY KEY (`company_camera_group_id`),
  KEY `company_id` (`company_id`),
  KEY `camera_group_id` (`camera_group_id`),
  CONSTRAINT `company_camera_group_ibfk_1` FOREIGN KEY (`company_id`) REFERENCES `company` (`company_id`) ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT `company_camera_group_ibfk_2` FOREIGN KEY (`camera_group_id`) REFERENCES `camera_group` (`camera_group_id`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `company_channel_log`
--

DROP TABLE IF EXISTS `company_channel_log`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `company_channel_log` (
  `company_channel_log_id` int(11) NOT NULL AUTO_INCREMENT,
  `company_id` int(11) NOT NULL,
  `user_id` int(11) NOT NULL,
  `channels` int(11) DEFAULT NULL,
  `time` datetime NOT NULL,
  PRIMARY KEY (`company_channel_log_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `configurations`
--

DROP TABLE IF EXISTS `configurations`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `configurations` (
  `property` varchar(255) NOT NULL DEFAULT '',
  `value` varchar(255) NOT NULL,
  PRIMARY KEY (`property`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `count_data`
--

DROP TABLE IF EXISTS `count_data`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `count_data` (
  `count_data_id` int(11) NOT NULL AUTO_INCREMENT,
  `camera_id` int(11) NOT NULL,
  `cnttime` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  `cnttype` int(11) NOT NULL,
  `count` int(11) NOT NULL,
  PRIMARY KEY (`count_data_id`),
  KEY `camera_id` (`camera_id`),
  KEY `time` (`cnttime`),
  KEY `type` (`cnttype`),
  CONSTRAINT `count_data_ibfk_1` FOREIGN KEY (`camera_id`) REFERENCES `camera` (`camera_id`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `count_data_filter_group`
--

DROP TABLE IF EXISTS `count_data_filter_group`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `count_data_filter_group` (
  `count_data_filter_group_id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) COLLATE utf8_bin NOT NULL,
  `company_id` int(11) NOT NULL,
  `application_id` int(11) NOT NULL,
  `description` mediumtext COLLATE utf8_bin NOT NULL,
  `filters` longtext COLLATE utf8_bin NOT NULL,
  `created_by` int(11) NOT NULL,
  `created_date` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (`count_data_filter_group_id`),
  KEY `company_id` (`company_id`),
  KEY `created_by` (`created_by`),
  CONSTRAINT `count_data_filter_group_ibfk_1` FOREIGN KEY (`company_id`) REFERENCES `company` (`company_id`) ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT `count_data_filter_group_ibfk_2` FOREIGN KEY (`created_by`) REFERENCES `user` (`user_id`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `count_data_formula_set`
--

DROP TABLE IF EXISTS `count_data_formula_set`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `count_data_formula_set` (
  `count_data_formula_set_id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) COLLATE utf8_bin NOT NULL,
  `company_id` int(11) NOT NULL,
  `application_id` int(11) NOT NULL,
  `description` mediumtext COLLATE utf8_bin NOT NULL,
  `created_by` int(11) NOT NULL,
  `created_date` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (`count_data_formula_set_id`),
  KEY `company_id` (`company_id`),
  KEY `created_by` (`created_by`),
  CONSTRAINT `count_data_formula_set_ibfk_1` FOREIGN KEY (`company_id`) REFERENCES `company` (`company_id`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `count_data_formula_set_formula`
--

DROP TABLE IF EXISTS `count_data_formula_set_formula`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `count_data_formula_set_formula` (
  `count_data_formula_set_formula_id` int(11) NOT NULL AUTO_INCREMENT,
  `count_data_formula_set_id` int(11) NOT NULL,
  `name` varchar(255) COLLATE utf8_bin NOT NULL,
  `formula` text COLLATE utf8_bin NOT NULL,
  PRIMARY KEY (`count_data_formula_set_formula_id`),
  KEY `count_data_formula_set_id` (`count_data_formula_set_id`),
  CONSTRAINT `count_data_formula_set_formula_ibfk_1` FOREIGN KEY (`count_data_formula_set_id`) REFERENCES `count_data_formula_set` (`count_data_formula_set_id`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `count_data_set`
--

DROP TABLE IF EXISTS `count_data_set`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `count_data_set` (
  `count_data_set_id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) COLLATE utf8_bin NOT NULL,
  `company_id` int(11) NOT NULL,
  `application_id` int(11) NOT NULL,
  `description` mediumtext COLLATE utf8_bin NOT NULL,
  `created_by` int(11) DEFAULT NULL,
  `created_date` datetime NOT NULL,
  PRIMARY KEY (`count_data_set_id`),
  KEY `count_data_filter_group_id` (`company_id`),
  KEY `creator` (`created_by`),
  CONSTRAINT `count_data_set_ibfk_1` FOREIGN KEY (`company_id`) REFERENCES `company` (`company_id`) ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT `count_data_set_ibfk_2` FOREIGN KEY (`created_by`) REFERENCES `user` (`user_id`) ON DELETE CASCADE ON UPDATE SET NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `count_data_set_acl_role`
--

DROP TABLE IF EXISTS `count_data_set_acl_role`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `count_data_set_acl_role` (
  `count_data_set_acl_role_id` int(11) NOT NULL AUTO_INCREMENT,
  `count_data_set_id` int(11) NOT NULL,
  `acl_role_id` int(11) NOT NULL,
  PRIMARY KEY (`count_data_set_acl_role_id`),
  KEY `acl_role_id` (`acl_role_id`),
  KEY `custom_chart_id` (`count_data_set_id`),
  CONSTRAINT `count_data_set_acl_role_ibfk_2` FOREIGN KEY (`acl_role_id`) REFERENCES `acl_role` (`acl_role_id`) ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT `count_data_set_acl_role_ibfk_3` FOREIGN KEY (`count_data_set_id`) REFERENCES `count_data_set` (`count_data_set_id`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `count_data_set_camera`
--

DROP TABLE IF EXISTS `count_data_set_camera`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `count_data_set_camera` (
  `count_data_set_camera_id` int(11) NOT NULL AUTO_INCREMENT,
  `count_data_set_id` int(11) NOT NULL,
  `camera_id` int(11) NOT NULL,
  PRIMARY KEY (`count_data_set_camera_id`),
  KEY `count_data_filter_group_id` (`count_data_set_id`),
  KEY `creator` (`camera_id`),
  CONSTRAINT `count_data_set_camera_ibfk_1` FOREIGN KEY (`camera_id`) REFERENCES `camera` (`camera_id`) ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT `count_data_set_camera_ibfk_2` FOREIGN KEY (`count_data_set_id`) REFERENCES `count_data_set` (`count_data_set_id`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `count_data_set_filter_group`
--

DROP TABLE IF EXISTS `count_data_set_filter_group`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `count_data_set_filter_group` (
  `count_data_set_filter_group_id` int(11) NOT NULL AUTO_INCREMENT,
  `count_data_set_id` int(11) NOT NULL,
  `count_data_filter_group_id` int(11) NOT NULL,
  PRIMARY KEY (`count_data_set_filter_group_id`),
  KEY `count_data_filter_group_id` (`count_data_set_id`),
  KEY `creator` (`count_data_filter_group_id`),
  CONSTRAINT `count_data_set_filter_group_ibfk_2` FOREIGN KEY (`count_data_filter_group_id`) REFERENCES `count_data_filter_group` (`count_data_filter_group_id`) ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT `count_data_set_filter_group_ibfk_3` FOREIGN KEY (`count_data_set_id`) REFERENCES `count_data_set` (`count_data_set_id`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `count_data_set_formula_set`
--

DROP TABLE IF EXISTS `count_data_set_formula_set`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `count_data_set_formula_set` (
  `count_data_set_formula_set_id` int(11) NOT NULL AUTO_INCREMENT,
  `count_data_set_id` int(11) NOT NULL,
  `count_data_formula_set_id` int(11) NOT NULL,
  PRIMARY KEY (`count_data_set_formula_set_id`),
  KEY `count_data_filter_group_id` (`count_data_set_id`),
  KEY `creator` (`count_data_formula_set_id`),
  CONSTRAINT `count_data_set_formula_set_ibfk_2` FOREIGN KEY (`count_data_formula_set_id`) REFERENCES `count_data_formula_set` (`count_data_formula_set_id`) ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT `count_data_set_formula_set_ibfk_3` FOREIGN KEY (`count_data_set_id`) REFERENCES `count_data_set` (`count_data_set_id`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `count_data_set_virtual_camera`
--

DROP TABLE IF EXISTS `count_data_set_virtual_camera`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `count_data_set_virtual_camera` (
  `count_data_set_virtual_camera_id` int(11) NOT NULL AUTO_INCREMENT,
  `count_data_set_id` int(11) NOT NULL,
  `virtual_camera_id` int(11) NOT NULL,
  PRIMARY KEY (`count_data_set_virtual_camera_id`),
  KEY `count_data_filter_group_id` (`count_data_set_id`),
  KEY `creator` (`virtual_camera_id`),
  CONSTRAINT `count_data_set_virtual_camera_ibfk_2` FOREIGN KEY (`virtual_camera_id`) REFERENCES `virtual_camera` (`virtual_camera_id`) ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT `count_data_set_virtual_camera_ibfk_3` FOREIGN KEY (`count_data_set_id`) REFERENCES `count_data_set` (`count_data_set_id`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `count_data_table`
--

DROP TABLE IF EXISTS `count_data_table`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `count_data_table` (
  `count_data_table_id` int(11) NOT NULL AUTO_INCREMENT,
  `table` varchar(24) COLLATE utf8_bin NOT NULL,
  `camera_count` smallint(6) NOT NULL,
  `application_id` int(11) NOT NULL,
  KEY `count_data_table_id` (`count_data_table_id`),
  KEY `table` (`table`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `count_data_time_filter`
--

DROP TABLE IF EXISTS `count_data_time_filter`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `count_data_time_filter` (
  `filter_id` int(11) NOT NULL AUTO_INCREMENT,
  `filter_name` varchar(128) NOT NULL,
  `company_id` int(11) NOT NULL,
  `filter_code` varchar(1024) NOT NULL,
  `date_last_modified` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `created_by` int(11) NOT NULL,
  `factory_default` int(4) NOT NULL,
  PRIMARY KEY (`filter_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `database_version`
--

DROP TABLE IF EXISTS `database_version`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `database_version` (
  `database_version_id` int(11) NOT NULL AUTO_INCREMENT,
  `version` varchar(256) COLLATE utf8_bin NOT NULL,
  `applied_patch_number` int(11) NOT NULL,
  `datestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (`database_version_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `document`
--

DROP TABLE IF EXISTS `document`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `document` (
  `document_id` int(11) NOT NULL AUTO_INCREMENT,
  `group_id` int(11) DEFAULT NULL,
  `type` varchar(64) COLLATE utf8_bin NOT NULL,
  `id` int(11) NOT NULL,
  PRIMARY KEY (`document_id`),
  KEY `group_id` (`group_id`),
  CONSTRAINT `document_ibfk_1` FOREIGN KEY (`group_id`) REFERENCES `group` (`group_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `event_data_demographics`
--

DROP TABLE IF EXISTS `event_data_demographics`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `event_data_demographics` (
  `event_data_demographics_id` int(11) NOT NULL AUTO_INCREMENT,
  `camera_id` int(11) NOT NULL,
  `t_start` double NOT NULL,
  `t_end` double NOT NULL,
  `gender` tinyint(1) NOT NULL,
  `age` tinyint(3) NOT NULL,
  `avg_boxsize` smallint(4) NOT NULL,
  PRIMARY KEY (`event_data_demographics_id`),
  KEY `camera_id_key` (`camera_id`),
  KEY `t_end_key` (`t_end`),
  CONSTRAINT `event_data_demographics_ibfk_1` FOREIGN KEY (`camera_id`) REFERENCES `camera` (`camera_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `export`
--

DROP TABLE IF EXISTS `export`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `export` (
  `export_id` bigint(20) NOT NULL AUTO_INCREMENT,
  `company_id` int(11) NOT NULL,
  `name` varchar(128) COLLATE utf8_bin NOT NULL,
  `export_type` tinyint(3) NOT NULL,
  `application_id` int(11) DEFAULT NULL,
  `output_format` varchar(16) COLLATE utf8_bin NOT NULL,
  `time_interval_type` varchar(16) COLLATE utf8_bin NOT NULL,
  `fix_interval_start` date DEFAULT NULL,
  `fix_interval_end` date DEFAULT NULL,
  `time_resolution` varchar(16) COLLATE utf8_bin DEFAULT NULL,
  `last_accessed` date DEFAULT NULL,
  `times_accessed` int(8) DEFAULT '0',
  `aggregator_id` tinyint(3) DEFAULT '0',
  `access_key` varchar(16) COLLATE utf8_bin NOT NULL,
  PRIMARY KEY (`export_id`),
  KEY `company_id_key` (`company_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `export_camera`
--

DROP TABLE IF EXISTS `export_camera`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `export_camera` (
  `export_camera_id` int(11) NOT NULL AUTO_INCREMENT,
  `export_id` bigint(11) NOT NULL,
  `camera_id` int(11) NOT NULL,
  PRIMARY KEY (`export_camera_id`),
  KEY `export_id_key` (`export_id`),
  KEY `export_camera_ibfk_2` (`camera_id`),
  CONSTRAINT `export_camera_ibfk_1` FOREIGN KEY (`export_id`) REFERENCES `export` (`export_id`) ON DELETE CASCADE,
  CONSTRAINT `export_camera_ibfk_2` FOREIGN KEY (`camera_id`) REFERENCES `camera` (`camera_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `group`
--

DROP TABLE IF EXISTS `group`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `group` (
  `group_id` int(11) NOT NULL AUTO_INCREMENT,
  `company_id` int(11) NOT NULL,
  `name` varchar(255) COLLATE utf8_bin NOT NULL,
  `description` varchar(1024) COLLATE utf8_bin NOT NULL,
  `parent_id` int(11) DEFAULT NULL,
  `in_sync` tinyint(1) NOT NULL DEFAULT '0',
  `camera_group_id` int(11) NOT NULL,
  `camera_conn_enabled` tinyint(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`group_id`),
  KEY `company_id` (`company_id`),
  KEY `parent_id` (`parent_id`),
  CONSTRAINT `group_ibfk_1` FOREIGN KEY (`company_id`) REFERENCES `company` (`company_id`) ON DELETE CASCADE,
  CONSTRAINT `group_ibfk_2` FOREIGN KEY (`parent_id`) REFERENCES `group` (`group_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `group_user`
--

DROP TABLE IF EXISTS `group_user`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `group_user` (
  `group_id` int(11) NOT NULL,
  `user_id` int(11) NOT NULL,
  `permission` varchar(16) COLLATE utf8_bin NOT NULL,
  PRIMARY KEY (`group_id`,`user_id`),
  KEY `group_user_ibfk_2` (`user_id`),
  CONSTRAINT `group_user_ibfk_1` FOREIGN KEY (`group_id`) REFERENCES `group` (`group_id`) ON DELETE CASCADE,
  CONSTRAINT `group_user_ibfk_2` FOREIGN KEY (`user_id`) REFERENCES `user` (`user_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `group_user_sync`
--

DROP TABLE IF EXISTS `group_user_sync`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `group_user_sync` (
  `group_id` int(11) NOT NULL,
  `user_id` int(11) NOT NULL,
  `permission` varchar(16) COLLATE utf8_bin NOT NULL,
  PRIMARY KEY (`group_id`,`user_id`),
  KEY `group_user_sync_ibfk_2` (`user_id`),
  CONSTRAINT `group_user_sync_ibfk_1` FOREIGN KEY (`group_id`) REFERENCES `group` (`group_id`) ON DELETE CASCADE,
  CONSTRAINT `group_user_sync_ibfk_2` FOREIGN KEY (`user_id`) REFERENCES `user` (`user_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `log`
--

DROP TABLE IF EXISTS `log`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log` (
  `log_id` int(11) NOT NULL AUTO_INCREMENT,
  `text` varchar(128) COLLATE utf8_bin NOT NULL,
  `alias` varchar(64) COLLATE utf8_bin NOT NULL,
  `hidden` int(11) DEFAULT '0',
  PRIMARY KEY (`log_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `log_message`
--

DROP TABLE IF EXISTS `log_message`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_message` (
  `log_message_id` int(11) NOT NULL AUTO_INCREMENT,
  `log_id` int(11) NOT NULL,
  `date` datetime NOT NULL,
  `company_id` int(11) DEFAULT NULL,
  `priority_id` int(11) NOT NULL,
  `message` mediumtext COLLATE utf8_bin NOT NULL,
  PRIMARY KEY (`log_message_id`),
  KEY `priority_id` (`priority_id`),
  KEY `log_id` (`log_id`),
  KEY `company_id` (`company_id`),
  CONSTRAINT `log_message_ibfk_1` FOREIGN KEY (`log_id`) REFERENCES `log` (`log_id`) ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT `log_message_ibfk_2` FOREIGN KEY (`company_id`) REFERENCES `company` (`company_id`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `mod_charts_custom_chart`
--

DROP TABLE IF EXISTS `mod_charts_custom_chart`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `mod_charts_custom_chart` (
  `custom_chart_id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) COLLATE utf8_bin NOT NULL,
  `company_id` int(11) NOT NULL,
  `count_data_set_id` int(11) NOT NULL,
  `default_type` varchar(60) COLLATE utf8_bin NOT NULL DEFAULT 'line',
  `description` mediumtext COLLATE utf8_bin NOT NULL,
  `created_by` int(11) DEFAULT NULL,
  `created_date` datetime NOT NULL,
  PRIMARY KEY (`custom_chart_id`),
  KEY `count_data_filter_group_id` (`company_id`),
  KEY `creator` (`created_by`),
  KEY `count_data_set_id` (`count_data_set_id`),
  CONSTRAINT `mod_charts_custom_chart_ibfk_1` FOREIGN KEY (`company_id`) REFERENCES `company` (`company_id`) ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT `mod_charts_custom_chart_ibfk_2` FOREIGN KEY (`count_data_set_id`) REFERENCES `count_data_set` (`count_data_set_id`) ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT `mod_charts_custom_chart_ibfk_3` FOREIGN KEY (`created_by`) REFERENCES `user` (`user_id`) ON DELETE SET NULL ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `mod_charts_custom_chart_acl_role`
--

DROP TABLE IF EXISTS `mod_charts_custom_chart_acl_role`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `mod_charts_custom_chart_acl_role` (
  `custom_chart_acl_role_id` int(11) NOT NULL AUTO_INCREMENT,
  `custom_chart_id` int(11) NOT NULL,
  `acl_role_id` int(11) NOT NULL,
  PRIMARY KEY (`custom_chart_acl_role_id`),
  KEY `acl_role_id` (`acl_role_id`),
  KEY `custom_chart_id` (`custom_chart_id`),
  CONSTRAINT `mod_charts_custom_chart_acl_role_ibfk_2` FOREIGN KEY (`acl_role_id`) REFERENCES `acl_role` (`acl_role_id`) ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT `mod_charts_custom_chart_acl_role_ibfk_3` FOREIGN KEY (`custom_chart_id`) REFERENCES `mod_charts_custom_chart` (`custom_chart_id`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `mod_charts_custom_chart_set_acl_role`
--

DROP TABLE IF EXISTS `mod_charts_custom_chart_set_acl_role`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `mod_charts_custom_chart_set_acl_role` (
  `custom_chart_acl_role_id` int(11) NOT NULL AUTO_INCREMENT,
  `count_data_set_id` int(11) NOT NULL,
  `acl_role_id` int(11) NOT NULL,
  PRIMARY KEY (`custom_chart_acl_role_id`),
  KEY `acl_role_id` (`acl_role_id`),
  KEY `custom_chart_id` (`count_data_set_id`),
  CONSTRAINT `mod_charts_custom_chart_set_acl_role_ibfk_2` FOREIGN KEY (`acl_role_id`) REFERENCES `acl_role` (`acl_role_id`) ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT `mod_charts_custom_chart_set_acl_role_ibfk_3` FOREIGN KEY (`count_data_set_id`) REFERENCES `count_data_set` (`count_data_set_id`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `mod_charts_data`
--

DROP TABLE IF EXISTS `mod_charts_data`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `mod_charts_data` (
  `chart_data_id` int(11) NOT NULL AUTO_INCREMENT,
  `user_id` int(11) NOT NULL,
  `company_id` int(11) DEFAULT NULL,
  `created` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `title` varchar(256) COLLATE utf8_bin NOT NULL,
  `description` varchar(1024) COLLATE utf8_bin NOT NULL,
  `flags` char(100) COLLATE utf8_bin DEFAULT NULL,
  `time_filter_code` varchar(128) COLLATE utf8_bin NOT NULL,
  `chart_type` varchar(16) COLLATE utf8_bin NOT NULL,
  `data_resolution` varchar(16) COLLATE utf8_bin NOT NULL,
  `aggregator_object` varchar(64) COLLATE utf8_bin NOT NULL,
  `aggregator_init` varchar(512) COLLATE utf8_bin NOT NULL,
  `aggregator_id` int(11) DEFAULT NULL,
  PRIMARY KEY (`chart_data_id`),
  KEY `user_id` (`user_id`),
  KEY `company_id` (`company_id`),
  CONSTRAINT `mod_charts_data_ibfk_2` FOREIGN KEY (`company_id`) REFERENCES `company` (`company_id`) ON DELETE SET NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `mod_charts_data_source`
--

DROP TABLE IF EXISTS `mod_charts_data_source`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `mod_charts_data_source` (
  `chart_data_source_id` int(11) NOT NULL AUTO_INCREMENT,
  `chart_data_id` int(11) NOT NULL,
  `title` varchar(256) COLLATE utf8_bin NOT NULL,
  `appearance` varchar(16) COLLATE utf8_bin NOT NULL DEFAULT 'default',
  `color` varchar(7) COLLATE utf8_bin NOT NULL,
  `time_filter_code` varchar(128) COLLATE utf8_bin DEFAULT NULL,
  `time_period_code` varchar(128) COLLATE utf8_bin DEFAULT NULL,
  `time_period_from` date DEFAULT NULL,
  `time_period_to` date DEFAULT NULL,
  `time_period_to_title` tinyint(1) DEFAULT '0',
  PRIMARY KEY (`chart_data_source_id`),
  KEY `chart_data_id` (`chart_data_id`),
  CONSTRAINT `mod_charts_data_source_ibfk_1` FOREIGN KEY (`chart_data_id`) REFERENCES `mod_charts_data` (`chart_data_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `mod_charts_data_source_camera`
--

DROP TABLE IF EXISTS `mod_charts_data_source_camera`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `mod_charts_data_source_camera` (
  `chart_data_source_camera_id` int(11) NOT NULL AUTO_INCREMENT,
  `chart_data_source_id` int(11) NOT NULL,
  `camera_id` int(11) DEFAULT NULL,
  `virtual_camera_id` int(11) DEFAULT NULL,
  `count_data_set_id` int(11) DEFAULT NULL,
  `count_data_formula_set_id` int(11) DEFAULT NULL,
  `queue_id` int(11) DEFAULT NULL,
  `parking_id` int(11) DEFAULT NULL,
  `gender_id` int(11) DEFAULT NULL,
  `pos_id` int(11) DEFAULT NULL,
  `pos_data_id` int(11) DEFAULT NULL,
  `type` varchar(64) COLLATE utf8_bin NOT NULL,
  `sourcetype` varchar(64) COLLATE utf8_bin DEFAULT NULL,
  `occupancy_id` int(11) DEFAULT NULL,
  PRIMARY KEY (`chart_data_source_camera_id`),
  KEY `chart_data_source_id` (`chart_data_source_id`),
  KEY `camera_id` (`camera_id`),
  KEY `virtual_camera_id` (`virtual_camera_id`),
  CONSTRAINT `mod_charts_data_source_camera_ibfk_1` FOREIGN KEY (`chart_data_source_id`) REFERENCES `mod_charts_data_source` (`chart_data_source_id`) ON DELETE CASCADE,
  CONSTRAINT `mod_charts_data_source_camera_ibfk_2` FOREIGN KEY (`camera_id`) REFERENCES `camera` (`camera_id`) ON DELETE CASCADE,
  CONSTRAINT `mod_charts_data_source_camera_ibfk_3` FOREIGN KEY (`virtual_camera_id`) REFERENCES `virtual_camera` (`virtual_camera_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `mod_charts_dataaggregator`
--

DROP TABLE IF EXISTS `mod_charts_dataaggregator`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `mod_charts_dataaggregator` (
  `dataaggregator_id` int(11) NOT NULL AUTO_INCREMENT,
  `name` text COLLATE utf8_bin NOT NULL,
  `description` text COLLATE utf8_bin NOT NULL,
  `obj` text COLLATE utf8_bin NOT NULL,
  `initobject` text COLLATE utf8_bin NOT NULL,
  PRIMARY KEY (`dataaggregator_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `mod_charts_permalinks`
--

DROP TABLE IF EXISTS `mod_charts_permalinks`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `mod_charts_permalinks` (
  `permalink_id` int(11) NOT NULL AUTO_INCREMENT,
  `chart_id` int(11) NOT NULL,
  `format` varchar(64) COLLATE utf8_bin NOT NULL,
  `permalink_key` varchar(10) COLLATE utf8_bin NOT NULL,
  `last_api_read` date NOT NULL,
  `legacy_id` int(11) DEFAULT NULL,
  PRIMARY KEY (`permalink_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `mod_heatmap_heatmap`
--

DROP TABLE IF EXISTS `mod_heatmap_heatmap`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `mod_heatmap_heatmap` (
  `heatmap_id` int(11) NOT NULL AUTO_INCREMENT,
  `camera_id` int(11) NOT NULL,
  `heatmap_mask_id` int(11) DEFAULT NULL,
  `time` datetime NOT NULL,
  `delta` int(11) NOT NULL,
  `width` int(11) NOT NULL,
  `height` int(11) NOT NULL,
  `image_width` int(11) NOT NULL,
  `image_height` int(11) NOT NULL,
  `max` int(11) NOT NULL,
  `num_sum` int(11) NOT NULL,
  `data` text COLLATE utf8_bin NOT NULL,
  `data_ds4` varchar(600) COLLATE utf8_bin NOT NULL,
  PRIMARY KEY (`heatmap_id`),
  KEY `camera_id` (`camera_id`),
  KEY `ix_camera_id_delta_time` (`camera_id`,`delta`,`time`),
  CONSTRAINT `mod_heatmap_heatmap_ibfk_1` FOREIGN KEY (`camera_id`) REFERENCES `camera` (`camera_id`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `mod_heatmap_mask`
--

DROP TABLE IF EXISTS `mod_heatmap_mask`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `mod_heatmap_mask` (
  `heatmap_mask_id` int(11) NOT NULL AUTO_INCREMENT,
  `camera_id` int(11) NOT NULL,
  `name` varchar(25) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL,
  `created` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `auto` int(11) NOT NULL,
  `mask` varchar(4200) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL,
  PRIMARY KEY (`heatmap_mask_id`),
  KEY `mask` (`mask`(255))
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `mod_reports_permalinks`
--

DROP TABLE IF EXISTS `mod_reports_permalinks`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `mod_reports_permalinks` (
  `permalink_id` int(11) NOT NULL AUTO_INCREMENT,
  `company_id` int(11) NOT NULL,
  `permalink_data` varchar(2048) COLLATE utf8_bin NOT NULL,
  `permalink_key` varchar(10) COLLATE utf8_bin NOT NULL,
  `last_api_read` date NOT NULL,
  PRIMARY KEY (`permalink_id`),
  KEY `company_id` (`company_id`),
  CONSTRAINT `mod_reports_permalinks_ibfk_1` FOREIGN KEY (`company_id`) REFERENCES `company` (`company_id`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `mod_reports_report`
--

DROP TABLE IF EXISTS `mod_reports_report`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `mod_reports_report` (
  `report_id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) COLLATE utf8_bin NOT NULL,
  `description` text COLLATE utf8_bin NOT NULL,
  `company_id` int(11) NOT NULL,
  `size` text COLLATE utf8_bin NOT NULL,
  `footer_enabled` tinyint(1) NOT NULL,
  `footer_text` varchar(255) COLLATE utf8_bin NOT NULL,
  `footer_align` varchar(18) COLLATE utf8_bin NOT NULL,
  `header_enabled` tinyint(1) NOT NULL,
  `header_text` varchar(255) COLLATE utf8_bin NOT NULL,
  `header_align` varchar(18) COLLATE utf8_bin NOT NULL,
  `show_logo` tinyint(1) DEFAULT '0',
  `coglogo_enabled` tinyint(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`report_id`),
  KEY `company_id` (`company_id`),
  CONSTRAINT `mod_reports_report_ibfk_1` FOREIGN KEY (`company_id`) REFERENCES `company` (`company_id`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `mod_reports_report_page`
--

DROP TABLE IF EXISTS `mod_reports_report_page`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `mod_reports_report_page` (
  `report_page_id` int(11) NOT NULL AUTO_INCREMENT,
  `template_id` int(11) NOT NULL,
  `report_id` int(11) NOT NULL,
  `landscape` tinyint(1) NOT NULL,
  `title_enabled` tinyint(1) NOT NULL,
  `title` varchar(255) COLLATE utf8_bin NOT NULL,
  `title_align` varchar(24) COLLATE utf8_bin NOT NULL,
  `title_size` int(11) NOT NULL,
  `order` int(11) NOT NULL,
  PRIMARY KEY (`report_page_id`),
  KEY `template_id` (`template_id`,`report_id`),
  KEY `report_id` (`report_id`),
  CONSTRAINT `mod_reports_report_page_ibfk_1` FOREIGN KEY (`template_id`) REFERENCES `mod_reports_template` (`template_id`) ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT `mod_reports_report_page_ibfk_2` FOREIGN KEY (`report_id`) REFERENCES `mod_reports_report` (`report_id`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `mod_reports_report_page_cell`
--

DROP TABLE IF EXISTS `mod_reports_report_page_cell`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `mod_reports_report_page_cell` (
  `report_page_cell_id` int(11) NOT NULL AUTO_INCREMENT,
  `report_page_id` int(11) NOT NULL,
  `template_row_cell_id` int(11) NOT NULL,
  `type` varchar(24) COLLATE utf8_bin NOT NULL,
  `title` varchar(255) COLLATE utf8_bin NOT NULL,
  `text` text COLLATE utf8_bin NOT NULL,
  `count_data_set_id` int(11) DEFAULT NULL,
  `chart_type` varchar(18) COLLATE utf8_bin NOT NULL,
  `title_enabled` int(11) NOT NULL,
  `time_interval` char(10) COLLATE utf8_bin NOT NULL,
  `time_interval_manual` char(10) COLLATE utf8_bin DEFAULT NULL,
  `time_interval_fixed_from` date DEFAULT NULL,
  `time_interval_fixed_to` date DEFAULT NULL,
  `dataaggregator_id` int(11) DEFAULT NULL,
  `time_filter_id` int(11) DEFAULT NULL,
  `data_source_id` int(11) DEFAULT NULL,
  `table_id` int(11) DEFAULT NULL,
  `include_table` tinyint(1) NOT NULL,
  `has_weather` tinyint(1) NOT NULL,
  `weather_location` varchar(128) COLLATE utf8_bin DEFAULT NULL,
  `weather_time_period` varchar(20) COLLATE utf8_bin DEFAULT NULL,
  PRIMARY KEY (`report_page_cell_id`),
  KEY `report_page_id` (`report_page_id`,`template_row_cell_id`),
  KEY `template_row_cell_id` (`template_row_cell_id`),
  KEY `count_data_set_id` (`count_data_set_id`),
  KEY `time_filter_id` (`time_filter_id`),
  KEY `data_source_id` (`data_source_id`),
  CONSTRAINT `mod_reports_report_page_cell_ibfk_1` FOREIGN KEY (`report_page_id`) REFERENCES `mod_reports_report_page` (`report_page_id`) ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT `mod_reports_report_page_cell_ibfk_2` FOREIGN KEY (`template_row_cell_id`) REFERENCES `mod_reports_template_row_cell` (`template_row_cell_id`) ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT `mod_reports_report_page_cell_ibfk_3` FOREIGN KEY (`count_data_set_id`) REFERENCES `count_data_set` (`count_data_set_id`) ON DELETE SET NULL ON UPDATE CASCADE,
  CONSTRAINT `mod_reports_report_page_cell_ibfk_4` FOREIGN KEY (`time_filter_id`) REFERENCES `count_data_time_filter` (`filter_id`) ON DELETE CASCADE,
  CONSTRAINT `mod_reports_report_page_cell_ibfk_5` FOREIGN KEY (`data_source_id`) REFERENCES `mod_charts_data` (`chart_data_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `mod_reports_subscription`
--

DROP TABLE IF EXISTS `mod_reports_subscription`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `mod_reports_subscription` (
  `subscription_id` int(11) NOT NULL AUTO_INCREMENT,
  `company_id` int(11) NOT NULL,
  `report_id` int(11) NOT NULL,
  `name` varchar(128) COLLATE utf8_bin NOT NULL,
  `send_frequency` varchar(128) COLLATE utf8_bin NOT NULL,
  `message_body` varchar(2048) COLLATE utf8_bin DEFAULT NULL,
  `last_send` date DEFAULT NULL,
  `send_hour` int(11) DEFAULT NULL,
  `send_day` int(11) DEFAULT NULL,
  `send_weekday` varchar(128) COLLATE utf8_bin DEFAULT NULL,
  `send_days` set('mon','tue','wed','thu','fri','sat','sun') COLLATE utf8_bin DEFAULT NULL,
  `timezone` varchar(128) COLLATE utf8_bin DEFAULT 'Europe/London',
  PRIMARY KEY (`subscription_id`),
  KEY `company_id` (`company_id`),
  KEY `report_id` (`report_id`),
  CONSTRAINT `mod_reports_subscription_ibfk_1` FOREIGN KEY (`company_id`) REFERENCES `company` (`company_id`) ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT `mod_reports_subscription_ibfk_2` FOREIGN KEY (`report_id`) REFERENCES `mod_reports_report` (`report_id`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `mod_reports_subscription_receiver`
--

DROP TABLE IF EXISTS `mod_reports_subscription_receiver`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `mod_reports_subscription_receiver` (
  `subscription_receiver_id` int(11) NOT NULL AUTO_INCREMENT,
  `subscription_id` int(11) NOT NULL,
  `acl_role_id` int(11) DEFAULT NULL,
  `user_id` int(11) DEFAULT NULL,
  `mail` varchar(2048) COLLATE utf8_bin DEFAULT NULL,
  PRIMARY KEY (`subscription_receiver_id`),
  KEY `subscription_id` (`subscription_id`),
  KEY `acl_role_id` (`acl_role_id`),
  KEY `user_id` (`user_id`),
  CONSTRAINT `mod_reports_subscription_receiver_ibfk_1` FOREIGN KEY (`subscription_id`) REFERENCES `mod_reports_subscription` (`subscription_id`) ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT `mod_reports_subscription_receiver_ibfk_2` FOREIGN KEY (`acl_role_id`) REFERENCES `acl_role` (`acl_role_id`) ON DELETE SET NULL,
  CONSTRAINT `mod_reports_subscription_receiver_ibfk_3` FOREIGN KEY (`user_id`) REFERENCES `user` (`user_id`) ON DELETE SET NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `mod_reports_template`
--

DROP TABLE IF EXISTS `mod_reports_template`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `mod_reports_template` (
  `template_id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) COLLATE utf8_bin NOT NULL,
  `order` int(11) NOT NULL DEFAULT '1',
  `active` tinyint(1) NOT NULL DEFAULT '1',
  PRIMARY KEY (`template_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `mod_reports_template_row`
--

DROP TABLE IF EXISTS `mod_reports_template_row`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `mod_reports_template_row` (
  `template_row_id` int(11) NOT NULL AUTO_INCREMENT,
  `template_id` int(11) NOT NULL,
  `height` float NOT NULL COMMENT 'percent',
  `order` int(11) NOT NULL,
  PRIMARY KEY (`template_row_id`),
  KEY `template_id` (`template_id`),
  CONSTRAINT `mod_reports_template_row_ibfk_1` FOREIGN KEY (`template_id`) REFERENCES `mod_reports_template` (`template_id`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `mod_reports_template_row_cell`
--

DROP TABLE IF EXISTS `mod_reports_template_row_cell`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `mod_reports_template_row_cell` (
  `template_row_cell_id` int(11) NOT NULL AUTO_INCREMENT,
  `template_row_id` int(11) NOT NULL,
  `width` float NOT NULL,
  `colspan` int(11) NOT NULL,
  `rowspan` int(11) NOT NULL,
  `order` int(11) NOT NULL,
  PRIMARY KEY (`template_row_cell_id`),
  KEY `template_row_id` (`template_row_id`),
  CONSTRAINT `mod_reports_template_row_cell_ibfk_1` FOREIGN KEY (`template_row_id`) REFERENCES `mod_reports_template_row` (`template_row_id`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `module`
--

DROP TABLE IF EXISTS `module`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `module` (
  `module_id` int(11) NOT NULL AUTO_INCREMENT,
  `text` varchar(64) COLLATE utf8_bin NOT NULL,
  `alias` varchar(64) COLLATE utf8_bin NOT NULL,
  `order` int(11) NOT NULL,
  `installed` datetime NOT NULL,
  `uninstallable` tinyint(1) NOT NULL DEFAULT '1',
  PRIMARY KEY (`module_id`),
  UNIQUE KEY `alias` (`alias`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `module_company`
--

DROP TABLE IF EXISTS `module_company`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `module_company` (
  `module_company_id` int(11) NOT NULL AUTO_INCREMENT,
  `module_id` int(11) NOT NULL,
  `company_id` int(11) NOT NULL,
  `config` text COLLATE utf8_bin NOT NULL,
  PRIMARY KEY (`module_company_id`),
  KEY `company_id` (`company_id`),
  KEY `module_id` (`module_id`),
  CONSTRAINT `module_company_ibfk_1` FOREIGN KEY (`company_id`) REFERENCES `company` (`company_id`) ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT `module_company_ibfk_2` FOREIGN KEY (`module_id`) REFERENCES `module` (`module_id`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `pos_camera_set`
--

DROP TABLE IF EXISTS `pos_camera_set`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `pos_camera_set` (
  `pos_camera_set_id` int(6) NOT NULL AUTO_INCREMENT,
  `pos_data_id` int(6) NOT NULL,
  `camera_id` int(6) NOT NULL,
  `filter_group_id` int(6) NOT NULL,
  `formula_set_id` int(6) NOT NULL,
  `virtual_camera_id` int(6) NOT NULL,
  PRIMARY KEY (`pos_camera_set_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `pos_data`
--

DROP TABLE IF EXISTS `pos_data`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `pos_data` (
  `pos_data_id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) COLLATE utf8_bin NOT NULL,
  `description` varchar(255) COLLATE utf8_bin NOT NULL,
  `file_url` varchar(512) COLLATE utf8_bin NOT NULL,
  `sync_info` text COLLATE utf8_bin,
  `encoding` varchar(64) COLLATE utf8_bin NOT NULL,
  `separator` varchar(5) COLLATE utf8_bin NOT NULL,
  `schedule` varchar(16) COLLATE utf8_bin NOT NULL,
  `currency` varchar(16) COLLATE utf8_bin NOT NULL,
  `last_sent` int(11) NOT NULL,
  `use_header` tinyint(1) NOT NULL,
  `mapping` varchar(1024) COLLATE utf8_bin NOT NULL,
  `date_format` int(11) NOT NULL,
  `store_filter` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `time_format` int(11) NOT NULL,
  `country` varchar(255) COLLATE utf8_bin NOT NULL,
  `company_id` int(11) NOT NULL,
  `created_by` int(11) NOT NULL,
  `created_date` datetime NOT NULL,
  PRIMARY KEY (`pos_data_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `pos_data_pos1`
--

DROP TABLE IF EXISTS `pos_data_pos1`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `pos_data_pos1` (
  `pos_data_pos1_id` int(11) NOT NULL AUTO_INCREMENT,
  `cnttime` datetime NOT NULL,
  `ts1min` int(11) NOT NULL,
  `ts5min` int(11) NOT NULL,
  `ts10min` int(11) NOT NULL,
  `ts15min` int(11) NOT NULL,
  `ts30min` int(11) NOT NULL,
  `ts1h` int(11) NOT NULL,
  `ts6h` int(11) NOT NULL,
  `ts12h` int(11) NOT NULL,
  `ts1d` int(11) NOT NULL,
  `ts1w` int(11) NOT NULL,
  `ts1w_m` int(11) NOT NULL,
  `ts2w` int(11) NOT NULL,
  `ts2w_m` int(11) NOT NULL,
  `ts1m` int(11) NOT NULL,
  `ts1q` int(11) NOT NULL,
  `ts1y` int(11) NOT NULL,
  PRIMARY KEY (`pos_data_pos1_id`),
  KEY `time` (`cnttime`),
  KEY `ts5min` (`ts5min`),
  KEY `ts10min` (`ts10min`),
  KEY `ts15min` (`ts15min`),
  KEY `ts1h` (`ts1h`),
  KEY `ts6h` (`ts6h`),
  KEY `ts1d` (`ts1d`),
  KEY `ts1w` (`ts1w`),
  KEY `ts1w_m` (`ts1w_m`),
  KEY `ts30min` (`ts30min`),
  KEY `ts2w` (`ts2w`),
  KEY `ts2w_m` (`ts2w_m`),
  KEY `ts1m` (`ts1m`),
  KEY `ts1q` (`ts1q`),
  KEY `ts1y` (`ts1y`),
  KEY `ts1min` (`ts1min`),
  KEY `ts12h` (`ts12h`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `pos_tag`
--

DROP TABLE IF EXISTS `pos_tag`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `pos_tag` (
  `pos_tag_id` int(11) NOT NULL AUTO_INCREMENT,
  `company_id` int(11) NOT NULL,
  `name` varchar(255) COLLATE utf8_bin NOT NULL,
  `is_datetime` tinyint(1) NOT NULL,
  `is_date` tinyint(1) NOT NULL,
  `is_time` tinyint(1) NOT NULL,
  `is_timefrom` tinyint(1) NOT NULL,
  `is_timeto` tinyint(1) NOT NULL,
  `is_sales` tinyint(1) NOT NULL,
  `is_currency` tinyint(1) NOT NULL,
  PRIMARY KEY (`pos_tag_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `table`
--

DROP TABLE IF EXISTS `table`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `table` (
  `table_id` int(11) NOT NULL AUTO_INCREMENT,
  `created` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `title` varchar(256) COLLATE utf8_bin NOT NULL,
  `description` varchar(1024) COLLATE utf8_bin NOT NULL,
  `mode` varchar(8) COLLATE utf8_bin NOT NULL,
  `color_hex` varchar(256) COLLATE utf8_bin NOT NULL,
  `hour_from` int(11) NOT NULL,
  `hour_to` int(11) NOT NULL,
  `show_tot` int(11) NOT NULL,
  `show_avg` int(11) NOT NULL,
  `comp_tot` varchar(64) COLLATE utf8_bin NOT NULL,
  `comp_avg` varchar(64) COLLATE utf8_bin NOT NULL,
  `meta_data` varchar(500) COLLATE utf8_bin DEFAULT '{"simple_mode":false}',
  PRIMARY KEY (`table_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `table_section`
--

DROP TABLE IF EXISTS `table_section`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `table_section` (
  `table_section_id` int(11) NOT NULL AUTO_INCREMENT,
  `table_id` int(11) NOT NULL,
  `show_date` int(11) NOT NULL DEFAULT '0',
  `title` varchar(256) COLLATE utf8_bin NOT NULL,
  `period` varchar(64) COLLATE utf8_bin NOT NULL,
  `period_manual` varchar(64) COLLATE utf8_bin DEFAULT NULL,
  `period_from` varchar(64) COLLATE utf8_bin DEFAULT NULL,
  `period_to` varchar(64) COLLATE utf8_bin DEFAULT NULL,
  PRIMARY KEY (`table_section_id`),
  KEY `chart_data_id` (`table_id`),
  CONSTRAINT `table_section_ibfk_1` FOREIGN KEY (`table_id`) REFERENCES `table` (`table_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `table_section_entry`
--

DROP TABLE IF EXISTS `table_section_entry`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `table_section_entry` (
  `table_section_entry_id` int(11) NOT NULL AUTO_INCREMENT,
  `table_section_id` int(11) NOT NULL,
  `title` varchar(256) COLLATE utf8_bin DEFAULT NULL,
  `selections_json` text COLLATE utf8_bin,
  PRIMARY KEY (`table_section_entry_id`),
  KEY `table_section_id` (`table_section_id`),
  CONSTRAINT `table_section_entry_ibfk1` FOREIGN KEY (`table_section_id`) REFERENCES `table_section` (`table_section_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `user`
--

DROP TABLE IF EXISTS `user`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `user` (
  `user_id` int(11) NOT NULL AUTO_INCREMENT,
  `forename` varchar(128) COLLATE utf8_bin NOT NULL,
  `surname` varchar(128) COLLATE utf8_bin NOT NULL,
  `company_id` int(11) NOT NULL,
  `acl_role_id` int(11) NOT NULL,
  `password` varchar(64) COLLATE utf8_bin NOT NULL,
  `password_salt` varchar(50) COLLATE utf8_bin NOT NULL,
  `digest_helper_password` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'To use when Digest HTTP Authentication is used, see http://nz2.php.net/features.http-auth',
  `email` varchar(255) COLLATE utf8_bin NOT NULL,
  `language` varchar(10) COLLATE utf8_bin NOT NULL DEFAULT 'en',
  `country` varchar(10) COLLATE utf8_bin NOT NULL,
  `logincount` int(10) NOT NULL,
  `created_by` int(11) DEFAULT NULL,
  `created_date` datetime DEFAULT NULL,
  `last_login` datetime NOT NULL,
  `multi_company` tinyint(1) NOT NULL DEFAULT '0',
  `active` tinyint(1) NOT NULL DEFAULT '1',
  `template` varchar(32) COLLATE utf8_bin NOT NULL DEFAULT 'standard',
  `legacy` int(11) NOT NULL DEFAULT '0',
  `administrator` tinyint(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`user_id`),
  KEY `company_id` (`company_id`),
  KEY `role_id` (`acl_role_id`),
  KEY `created_by` (`created_by`),
  CONSTRAINT `user_ibfk_1` FOREIGN KEY (`company_id`) REFERENCES `company` (`company_id`) ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT `user_ibfk_4` FOREIGN KEY (`created_by`) REFERENCES `user` (`user_id`) ON DELETE SET NULL ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `virtual_camera`
--

DROP TABLE IF EXISTS `virtual_camera`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `virtual_camera` (
  `virtual_camera_id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(100) COLLATE utf8_bin NOT NULL,
  `company_id` int(11) NOT NULL,
  `application_id` int(11) NOT NULL,
  `description` text COLLATE utf8_bin NOT NULL,
  `created_by` int(11) NOT NULL,
  `created_date` datetime NOT NULL,
  PRIMARY KEY (`virtual_camera_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `virtual_camera_formula`
--

DROP TABLE IF EXISTS `virtual_camera_formula`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `virtual_camera_formula` (
  `virtual_camera_formula_id` int(11) NOT NULL AUTO_INCREMENT,
  `virtual_camera_id` int(11) NOT NULL,
  `count_out_type` varchar(255) COLLATE utf8_bin NOT NULL,
  `formula` text COLLATE utf8_bin NOT NULL,
  PRIMARY KEY (`virtual_camera_formula_id`),
  KEY `virtual_camera_id` (`virtual_camera_id`),
  CONSTRAINT `virtual_camera_formula_ibfk_1` FOREIGN KEY (`virtual_camera_id`) REFERENCES `virtual_camera` (`virtual_camera_id`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `warning`
--

DROP TABLE IF EXISTS `warning`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `warning` (
  `warning_id` int(11) NOT NULL AUTO_INCREMENT,
  `camera_id` int(11) DEFAULT NULL,
  `warning` varchar(255) COLLATE utf8_bin NOT NULL,
  `created_date` int(11) NOT NULL,
  `acknowledged` tinyint(1) NOT NULL DEFAULT '0',
  `notification_sent` int(11) DEFAULT NULL,
  PRIMARY KEY (`warning_id`),
  KEY `camera_id` (`camera_id`),
  KEY `notification_sent` (`notification_sent`),
  CONSTRAINT `warning_ibfk_1` FOREIGN KEY (`camera_id`) REFERENCES `camera` (`camera_id`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;
/*!40103 SET TIME_ZONE=@OLD_TIME_ZONE */;

/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;

-- Dump completed on 2016-09-16 10:03:12
-- MySQL dump 10.13  Distrib 5.5.50, for debian-linux-gnu (x86_64)
--
-- Host: localhost    Database: datamanager_1_4_0
-- ------------------------------------------------------
-- Server version	5.5.50-0+deb8u1-log

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;
/*!40103 SET @OLD_TIME_ZONE=@@TIME_ZONE */;
/*!40103 SET TIME_ZONE='+00:00' */;
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;

--
-- Dumping data for table `module`
--

/*!40000 ALTER TABLE `module` DISABLE KEYS */;
INSERT INTO `module` VALUES (1,'CORE','mod_core',1,'2009-02-16 10:37:35',0),(2,'ADMINISTRATION','mod_admin',2,'2009-02-16 10:38:36',0),(3,'CHARTS','mod_charts',4,'2009-03-03 09:27:32',1),(5,'REPORTS','mod_reports',5,'2009-06-12 11:21:54',1),(6,'HEATMAP','mod_heatmap',6,'2011-10-07 08:48:21',0),(7,'COUNT_DATA_ADMINISTRATION','mod_count-data',3,'2011-10-07 08:48:21',1),(8,'POINT_OF_SALES','mod_pos',20,'2013-06-07 14:29:54',1),(9,'GENDER','mod_gender',20,'2014-01-08 11:10:31',1),(10,'OCCUPANCY','mod_occupancy',21,'2014-05-15 00:00:00',1);
/*!40000 ALTER TABLE `module` ENABLE KEYS */;

--
-- Dumping data for table `log`
--

/*!40000 ALTER TABLE `log` DISABLE KEYS */;
INSERT INTO `log` VALUES (3,'USER_LOG','user',0),(4,'COUNT_DATA_UPLOAD_LOG','count_data_upload',0),(6,'TRANSLATION_LOG','translation',0),(7,'MAIL_LOG','mail',0),(11,'MAINTENANCE_LOG','maintenance',1),(12,'SYNCHRONIZATION_LOG','synchronization',0);
/*!40000 ALTER TABLE `log` ENABLE KEYS */;

--
-- Dumping data for table `mod_reports_template`
--

/*!40000 ALTER TABLE `mod_reports_template` DISABLE KEYS */;
INSERT INTO `mod_reports_template` VALUES (1,'2x2',1,1),(2,'2x1',2,1),(3,'hej',3,1),(4,'1x1',4,1),(5,'blank',5,1),(6,'3x4',1,1),(7,'2x3',6,1),(8,'1x2',7,1);
/*!40000 ALTER TABLE `mod_reports_template` ENABLE KEYS */;

--
-- Dumping data for table `mod_reports_template_row`
--

/*!40000 ALTER TABLE `mod_reports_template_row` DISABLE KEYS */;
INSERT INTO `mod_reports_template_row` VALUES (1,1,50,1),(2,1,50,2),(3,2,50,1),(4,2,50,1),(5,3,66,1),(6,3,33,2),(7,4,100,1),(8,6,25,1),(9,6,25,2),(10,6,25,3),(11,6,25,4),(12,7,33,1),(13,7,33,2),(14,7,33,3),(15,8,100,1);
/*!40000 ALTER TABLE `mod_reports_template_row` ENABLE KEYS */;

--
-- Dumping data for table `mod_reports_template_row_cell`
--

/*!40000 ALTER TABLE `mod_reports_template_row_cell` DISABLE KEYS */;
INSERT INTO `mod_reports_template_row_cell` VALUES (1,1,50,0,0,1),(2,1,50,0,0,2),(3,2,50,0,0,1),(4,2,50,0,0,2),(5,3,100,0,0,1),(6,4,100,0,0,1),(7,5,100,2,0,1),(8,6,50,0,0,1),(9,6,50,0,0,2),(10,7,100,0,0,1),(11,8,33,0,0,1),(12,8,33,0,0,2),(13,8,33,0,0,3),(14,9,33,0,0,1),(15,9,33,0,0,2),(16,9,33,0,0,3),(17,10,33,0,0,1),(18,10,33,0,0,2),(19,10,33,0,0,3),(20,11,33,0,0,1),(21,11,33,0,0,2),(22,11,33,0,0,3),(24,12,100,0,0,1),(25,13,100,0,0,1),(26,14,100,0,0,1),(27,15,50,0,0,1),(28,15,50,0,0,2);
/*!40000 ALTER TABLE `mod_reports_template_row_cell` ENABLE KEYS */;

--
-- Dumping data for table `mod_charts_dataaggregator`
--

/*!40000 ALTER TABLE `mod_charts_dataaggregator` DISABLE KEYS */;
INSERT INTO `mod_charts_dataaggregator` VALUES (1,'DAY_USE','USE_OVER_DAY','Charts_Model_DataAggregator_HistSum','{\"_mode\": 4,\"_relative\": 1}'),(2,'WEEK_USAGE','SHOW_DISTRIBUTED_OVER_WEEK_DAYS','Charts_Model_DataAggregator_HistSum','{\"_mode\": 2,\"_relative\": 0}'),(3,'MONTH_USAGE','SHOW_USAGE_DISTRIBUTED_OVER_MONTH','Charts_Model_DataAggregator_HistSum','{\"_mode\": 3,\"_relative\": 0}'),(4,'HOUR_USAGE','SHOW_USAGE_DISTRIBUTED_OVER_HOURS','Charts_Model_DataAggregator_HistSum','{\"_mode\": 1,\"_relative\": 0}'),(5,'TOTAL_SUM_OF_DATA_SOURCES','SHOW_THE_TOTAL_SUM_OF_ALL_CURRENT_DATA_SOURCES','Charts_Model_DataAggregator_TotalSum','{\"_mode\": 0,\"_relative\": 0}'),(6,'WEEK_USAGE(RELATIVE)','RELATIVE_WEEK_USAGE','Charts_Model_DataAggregator_HistSum','{\"_mode\": 2,\"_relative\": 1}'),(7,'MONTH_USAGE(RELATIVE)','RELATIVE_USE_OVER_MONTHS','Charts_Model_DataAggregator_HistSum','{\"_mode\": 3,\"_relative\": 1}'),(8,'HOUR_USAGE(RELATIVE)','RELATIVE_HOUR_USAGE','Charts_Model_DataAggregator_HistSum','{\"_mode\": 1,\"_relative\": 1}'),(9,'15_MINUTE_USAGE','USAGE_EVERY_15MIN','Charts_Model_DataAggregator_HistSum','{\"_mode\": 6,\"_relative\": 0}'),(10,'DAY_OF_MONTH_USAGE','USAGE_FOR_DAYS_IN_MONTH','Charts_Model_DataAggregator_HistSum','{\"_mode\": 5,\"_relative\": 0}');
/*!40000 ALTER TABLE `mod_charts_dataaggregator` ENABLE KEYS */;

--
-- Dumping data for table `database_version`
--

/*!40000 ALTER TABLE `database_version` DISABLE KEYS */;
INSERT INTO `database_version` VALUES (1,'1.0.0-rc3',-1,'2015-12-17 13:14:42'),(2,'1.2.0-rc1',9,'2016-02-29 11:16:18'),(3,'1.2.0',11,'2016-03-15 11:35:00'),(4,'1.4.0',13,'2016-09-16 08:02:01');
/*!40000 ALTER TABLE `database_version` ENABLE KEYS */;

--
-- Dumping data for table `count_data_time_filter`
--

/*!40000 ALTER TABLE `count_data_time_filter` DISABLE KEYS */;
INSERT INTO `count_data_time_filter` VALUES (1,'WEEKENDS',1,'weekend','2010-12-31 23:00:00',1,1),(2,'WEEKEND_AFTER_PAYDAY_(25TH)',1,'weekfrom[25] & weekend','2010-12-31 23:00:00',1,1),(3,'FIRST_WEEKEND_IN_MONTH',1,'day < 8 & weekend','2010-12-31 23:00:00',1,1),(4,'NINE_TO_FIVE',1,'hour >= 9 & hour <  17','2010-12-31 23:00:00',1,1),(5,'FIRST_FRIDAY_OF_THE_MONTH',1,'friday & day < 8','2010-12-31 23:00:00',1,1),(6,'WORKING_DAYS',1,'workday','2010-12-31 23:00:00',1,1),(7,'test',60,'hour > 13','2011-12-28 14:49:39',250,0);
/*!40000 ALTER TABLE `count_data_time_filter` ENABLE KEYS */;

--
-- Dumping data for table `configurations`
--

/*!40000 ALTER TABLE `configurations` DISABLE KEYS */;
INSERT INTO `configurations` VALUES ('backup_reminder','{\"show\":false}'),('custom_companies_info','{\"show\":false}'),('show_relative','{\"show\":false}');
/*!40000 ALTER TABLE `configurations` ENABLE KEYS */;
/*!40103 SET TIME_ZONE=@OLD_TIME_ZONE */;

/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;

-- Dump completed on 2016-09-16 10:03:12
