<?php
class Overview_IndexController extends WebReport_Controller_Action
{
    protected $_user, $_group;

    public function init()
    {
        parent::init();

        $module = $this->getRequest()->module;
        $controller = $this->getRequest()->controller;
        $action = $this->getRequest()->action;

        $usersDb = Core_Model_Users::getInstance();
        $this->_user = $usersDb->find(Zend_Auth::getInstance()->getIdentity()->user_id)->current();
        $this->view->user = $this->_user;

        //TODO: Submenu is now in layout per module, not controller, so should be defined in module, not here.
        /*$items = array();
        $items[] = array("urlOptions" => array(
            'module' => $module, "controller" => $controller,
            "action" => "index"),
            "text" => 'FULL_OVERVIEW');

        $this->view->submenu = WebReport_Module_MenuItems_Abstract::translate($items);*/
        $this->view->module = $module;
        $this->view->headTitle("OVERVIEW", Zend_View_Helper_Placeholder_Container_Abstract::PREPEND);
    }

    public function indexAction()
    {

        if ($this->_flashMessenger->hasMessages()) {
            $this->view->messages = $this->_flashMessenger->getMessages();
        }

        $this->view->title = $this->_translate->_("OVERVIEW");

        $request = $this->_request;
        $user = $this->_user;
        $helper = $this->_helper;

        $camerasDb = Core_Model_Cameras::getInstance();
        $cameraSetsDb = Core_Model_CameraSets::getInstance();
        $companiesDb = Core_Model_Companies::getInstance();
        $exportsDb = Export_Model_Exports::getInstance();
        $is_multicomp = $this->_user->multi_company;

        if ($is_multicomp) {
            $companies = $companiesDb->fetchAllActive();
            $sets = $cameraSetsDb->fetchAll();
            $cameras = $camerasDb->fetchAll();
            $users = $companies->fetchAllActiveUsers();
            $exports = $exportsDb->fetchAll();
        } else {
            $company = $companiesDb->find($this->_user->company_id)->current();
            $cameras_array = $camerasDb->getCameras(null, $company);
            foreach($cameras_array as $camera) {
                $select = $camerasDb->select();
                $camera_row = $camerasDb->fetchAll($select->where("camera_id = ?", $camera->camera_id))->current();
                $cameras[] = $camera_row;
            }
            $sets = $cameraSetsDb->fetchAllWithCompanyId($user->company_id);
            $users = $company->fetchAllActiveUsers();
            $exports = $exportsDb->fetchAllForCompany($company);
        }
        $this->view->userList = Admin_Model_UserListGenerator::CreateView($users);
        if ($is_multicomp) {
            $this->view->companyList = Admin_Model_CompanyListGenerator::CreateView($companiesDb->fetchAllActive());
        }
        $this->view->cameraList = Sources_Model_CameraListGenerator::CreateView($cameras);
        $this->view->setList = Sets_Model_SetListGenerator::CreateView($sets);
        $this->view->exportList = Export_Model_StoredExportsListGenerator::CreateView($exports);

    }
}
