<?php

class Pos_Form_AddPosDataStep2 extends UniForm_Form
{

	protected $_action;
	protected $_data;
	protected $_safeHeaders;

	/**
	 * Constructor
	 *
	 * @see Zend_Form
	 * @param string $action Can be new or edit
	 * @param mixed $options
	 * @return void
	 */
	public function __construct($action = "add", array $data=array(), $safeHeaders=null, $options = null)
	{
		$this->_action = $action;
        $this->_data = $data;
        $this->_safeHeaders = $safeHeaders;
		parent::__construct($options);
	}

	public function init()
	{
		parent::init();
        $dateFormat = new UniForm_Form_Element_Select('date_format');
        $timeFormat = new UniForm_Form_Element_Select('time_format');

        $dateFormat->setLabel(_T('DATE_FORMAT'))->setAttrib('escape',false);
        $jobs = new Pos_Model_ImportJobs();

        foreach ($jobs->getDateFormats() as $k => $d)
            $dateFormat->addMultiOption($k, $d["title"])->setAttrib('escape',false);

        $timeFormat->setLabel(_T('TIME_FORMAT'))->setAttrib('escape',false);
        foreach ($jobs->getTimeFormats() as $k => $t)
            $timeFormat->addMultiOption($k, $t["title"]);

        $this->addElements(array($dateFormat, $timeFormat));
        $this->addDisplayGroup(array('date_format', 'time_format'), 'format-group');

        $storeId = array();
        $i = 0;
        foreach($this->_data as $key=>$value) {
            foreach($value as $k=>$v) {
                if(! isset($storeId[$k])) { 
                    $storeId[$k] = new UniForm_Form_Element_Select('store_id' . $i);
                    $safe = array_search($k, $this->_safeHeaders);
                    $storeId[$k]->setLabel(_T('FILTER_STORE'))->setAttrib('name', 'store_id[' . $safe . ']');
                    $storeId[$k]->addMultiOption(Null, "No filter");
                    $this->addElements(array($storeId[$k]));
                    $this->addDisplayGroup(array('store_id' . $i), 'store-group' . $i);
                    $i++;
                }
                if($v)
                    $storeId[$k]->addMultiOption($v, $v);
            }
        }

        
	}

}
