<?php

class Pos_Form_AddPosDataStep3 extends UniForm_Form
{

	protected $_action, $_upload;

	/**
	 * Constructor
	 *
	 * @see Zend_Form
	 * @param string $action Can be new or edit
	 * @param mixed $options
	 * @return void
	 */
	public function __construct($action = "add", $options = null, $uploaded=FALSE)
	{
        $this->_upload = $uploaded;

		$this->_action = $action;
		parent::__construct($options);
	}

	public function init()
	{
		parent::init();
        $user = Core_Model_Users::getCurrentUser();
	$tvpc = new Core_Model_Application_PeopleCounter();
        $action = $this->_action;  
		$camerasDb = new Core_Model_Cameras();
		$virtualCamerasDb = new Core_Model_VirtualCameras();
        $formulaDb = new Core_Model_CountData_FormulaSetFormulas();

		$camera_id = new UniForm_Form_Element_MultiCheckbox('camera_id');
		$camera_id->setLabel(_T('CAMERAS'));
        $cameraElements = array();

		$cameras = $camerasDb->fetchAllVisible($user, $tvpc);
        if($cameras) {
    		foreach ($cameras as $camera) {
			$group = $camera->getCameraGroup();
	    		$camera_id->addMultiOption($camera->camera_id, $camera->name . " (" . $group->name . ")");
		    }
		    $this->addElements(array($camera_id));
            $cameraElements[] = 'camera_id';
        }
/*
		$virtualCameras = $virtualCamerasDb->fetchAllVisible($user, $tvpc);
        if($virtualCameras) {
		    $virtual_camera_id = new UniForm_Form_Element_MultiCheckbox('virtual_camera_id');
	    	$virtual_camera_id->setLabel('VIRTUAL_CAMERAS');
    		foreach ($virtualCameras as $camera) {
	    		$virtual_camera_id->addMultiOption($camera->virtual_camera_id, $camera->name);
    		}
			$this->addElements(array($virtual_camera_id));
            $cameraElements[] = 'virtual_camera_id';
        }
*/
        if(count($cameraElements) > 0)
            $this->addDisplayGroup($cameraElements, 'camera-group',array("legend" => "CAMERAS"));

		$step = new UniForm_Form_Element_Hidden('step');
		$step->setRequired()
			->setValue(3);
		$step2 = new UniForm_Form_Element_Hidden('step2');
		$step2->setRequired()
			->setValue(3);

		$submit = new UniForm_Form_Element_Submit('submit');
		$submit->setLabel(_T('FINISH')); 

        if($this->_upload)
            $submit->setAttrib('id', 'upload');
                
		$this->addElements(array($step, $step2));

		$this->addDisplayGroup(array('step','step2'), 'map-group');

		$this->addElements(array($submit));
	}

}
