<?php

class Pos_Model_ImportJobs extends Talking_Db_Table
{
	protected $_name = 'pos_data';
	protected $_primary = 'pos_data_id';

	protected $_rowClass = "Pos_Model_ImportJob";
	protected $_referenceMap    = array(
		'Company' => array(
			'columns'           => array('company_id'),
			'refTableClass'     => 'Core_Model_Companies',
			'refColumns'        => array('company_id')
		)
    );

    protected $_dependentTables = array('Pos_Model_SetCamera');

	public function fetchAllJobs($company = null)
    {
        #if(!is_null($company)) throw new Exception("Only multi company mode support, fix it!");
		$db = $this->getAdapter();
		$companiesDb = new Core_Model_Companies();
		$select = $db->select()
			->from($this->info(Zend_Db_Table::NAME),
				array("pos_data_id", "name", "description", "company_id", "file_url"));
        if($company){
            if(is_int($company))
                $company_id = $company;
            else
                $company_id = $company->company_id;

            $select->where("company_id = ?", $company->company_id);
        }

		return $db->fetchAll($select);
    }

    public static function CheckAllJobs(){
        $db = new Pos_Model_ImportJobs();
        $jobs = $db->fetchAll();
        foreach($jobs as $job){
            $job->runIfTime();
        }
    }

    public function fetchOne($pos_data_id, Core_Model_Company $company = null)
    {
        if(!is_null($company)) throw new Exception("Only multi company mode support, fix it!");
        $row = $this->find($pos_data_id);

        return $row->current();
    }
        public function importPos($set) {
            throw new Exception("Not Implemented");
            $path = Pos_Model_PosPath($set->file_url);

            if($path->tryUpdateSyncFile()) {
                foreach($path->getFilesToUpdate() as $k => $v){
                    $import = new Pos_Model_CSVImport();
                }
            } else {
            }
            $fQuickCSV = new Pos_Model_CSVImport();
            $CSV = new Pos_Model_CSV();

            $lineSeparator = $CSV->detect_line_ending( $set->file_url );
            if( '\n' != $lineSeparator ) {
                $fQuickCSV->line_separate_char = $lineSeparator;
            }

            $fQuickCSV->pos_id = $set->pos_data_id;            
            $fQuickCSV->file_name = $set->file_url;            
            $fQuickCSV->use_csv_header = $set->use_header;
            $fQuickCSV->is_full_import = true;
            $fQuickCSV->make_temporary = true;
            $fQuickCSV->table_exists = false;
            $fQuickCSV->field_separate_char = $set->separator;
            $fQuickCSV->encoding = $set->encoding;
            //$fQuickCSV->field_enclose_char = $options['field_enclose_char'];
            //$fQuickCSV->field_escape_char = $options['field_escape_char'];
            //$fQuickCSV->arr_csv_columns = $values['mapping'];
            $fQuickCSV->arr_csv_columns2 = explode(",", $set->mapping);

            $fQuickCSV->import();

            if( !empty($fQuickCSV->error) )
            {
                $error = $fQuickCSV->error;
                throw new WebReport_Exception($error);
            }
            elseif( 0 == $fQuickCSV->rows_count )
            {
                $error = 'Imported rows count is 0.';
                throw new WebReport_Exception($error);                
            }
            return $fQuickCSV->rows_count;
        }


        public function createRowFromNamespace($namespace){
            $identity = Zend_Auth::getInstance()->getIdentity();
            $set = $this->createRow(array(
                'name' => $namespace->name,
                'descripton' => "",
                'file_url' => $namespace->file,
                'encoding' => $namespace->enc,
                'schedule' => $namespace->schedule,
                "last_run" => 0,
                'separator' => $namespace->separator,
                'use_header' => $namespace->header_enabled,
                'mapping' => json_encode(array_flip($namespace->mapping)),
                'store_filter' => $namespace->store_filter,
                'date_format' => $namespace->date_format,
                'time_format' => $namespace->time_format,
                'country' => $namespace->country,
                'currency' => $namespace->currency,
                'company_id' => $namespace->company_id,
                'created_by' => $identity->user_id,
                'created_date' => new Zend_Db_Expr('NOW()')
            ));
            $set->save();
            return $set;          
        }
        
        public function insertPos() {
            $posDataSession = new Zend_Session_Namespace('WebReport_PosData_Set');                               
            $identity = Zend_Auth::getInstance()->getIdentity();            
            $set = $this->createRow(
					array(
						                        'name' => $posDataSession->name,
                                                'file_url' => $posDataSession->file,
                                                'encoding' => $posDataSession->encoding,
                                                'separator' => $posDataSession->separator,
                                                'use_header' => $posDataSession->use_csv_header,
                                                'mapping' => $posDataSession->mapping,
                                                'country' => $posDataSession->country,
                                                'company_id' => $posDataSession->company_id,
                                                'created_by' => $identity->user_id,
                                                'created_date' => new Zend_Db_Expr('NOW()')                                        
					)
				);         
            
            $set->save();            
            $lastid = $this->getAdapter()->lastInsertId(); 
            return $lastid;
            //$this->_flashMessenger->addMessage($this->_translate->_('POS_DATA_ADDED.'));
        }

        
        public function getNextPosId() {
           //get next pos id
            $db = $this->getAdapter();
            $select = "SELECT MAX(pos_data_id) from pos_data";     
            $result = $db->fetchOne($select);
            return $result + 1;
        }

        public function getDateFormats() {
            $config = new Zend_Config_Ini(MODULES_PATH . '/pos/config/config.ini', APPLICATION_ENVIRONMENT);
            return $config->DateFormats->toArray();
        }

        public function getDateFormat($index) {
            $formats = $this->getDateFormats();
            return $formats[$index];
        }

        public function getTimeFormats() {
            $config = new Zend_Config_Ini(MODULES_PATH . '/pos/config/config.ini', APPLICATION_ENVIRONMENT);
            return $config->TimeFormats->toArray();
        }

        public function getTimeFormat($index) {
            $formats = $this->getTimeFormats();
            return $formats[$index];
        }

        public function testDateTimeFormat($map, $date_format, $time_format, $headers, $examples) {
            $key_time = array_search('time', $map);
            $key_date = array_search('date', $map);
            $key_datetime = array_search('datetime', $map);
            $fmtDate = $this->getDateFormat($date_format);
            $fmtTime = $this->getTimeFormat($time_format);
            $bad = array();

            if($key_date) {
                $key = array_search($key_date, $headers);
                $date = $examples[$key];
                if(!DateTime::CreateFromFormat($fmtDate["value"], substr($date, 0, strlen($fmtDate["title"]))))
                    $bad['date_format'] = 1;
            } else if ($key_datetime) {
                $key = array_search($key_datetime, $headers);
                $date_time = $examples[$key];
                if(!DateTime::CreateFromFormat($fmtDate["value"] . "*" . $fmtTime["value"], $date_time)) {
                    $bad['date_format'] = 1;
                    $bad['time_format'] = 1;
                }
            } else {
                return false;
            }
            return $bad;
        }

        public function getEncodings() {
            return array("utf8" => "UTF-8 Unicode",
                "utf16" => "UTF-16 Unicode",
                "utf32" => "UTF-32 Unicode",
                "ascii" => "US ASCII");
        }

    /*
     * Return a list of ImportJobs that belong to $group.
     */
    public function fetchDocuments($group) {
        // TODO: Write a nice JOIN.
        $documents = $group->getDocuments('importjob');
        $jobsDb = new Pos_Model_ImportJobs();

        $jobs = array();
        foreach($documents as $doc) {
            $job = $jobsDb->find($doc->id)->current();
            if($job)
                $jobs[] = $job;
        }

        return $jobs;
    }

    public function fetchAllVisible($user)
    {
        $groupsDb = new Core_Model_Folders();
        $groups = $groupsDb->getViewableGroups($user);

        $jobsDb = new Pos_Model_ImportJobs();

        $ids = array();
        foreach($groups as $group) {
            $documents = $group->findDependentRowset('Core_Model_Documents');
            foreach($documents as $document) {
                if($document->type == 'importjob') {
                    $importJob = $jobsDb->find($document->id)->current();
                    if($importJob)
                        $ids[] = $importJob->pos_data_id;
                }
            }   
        }

        $jobs = $jobsDb->find($ids);
        return $jobs;
    }
}
