<?php

class Pos_Model_PosListGenerator extends Core_Model_Generic_AbstractListView {
    public function getHeaders(){
        if($this->_isMultiCompany) return array(_T("NAME"),_T("DIRECTORY"),_T("COMPANY"));
        else return array(_T("NAME"),_T("DIRECTORY"));
    }

    protected function _dataRowToTableRow($row){
        $ret = array();
        $ret[] = $row->name;
        $ret[] = $row->file_url;
        
        if($this->_isMultiCompany)
            $ret[] = Core_Model_Companies::getCompany($row->company_id)->name;

        $ret['_document_id'] = Core_Model_DocumentFactory::getId($row->pos_data_id, 'importjob');

        return $ret;
    }

    public function removeText(){
        return _T('DO_YOU_REALLY_WANT_TO_REMOVE_"%1$s"?');
    }

    protected function _dataRowToRowId($row){
        return $row->pos_data_id;
    }

    public function noDataInformation(){
        return _T("NO_IMPORTS_ADDED.");
    }


    public function getActions($row){
        $folder = $this->_group->group_id;

        $creator = $this->_group->canEdit($this->_user);
        $actions = array();
        if($creator)
            $actions[] = parent::CreateAction(_T('RUN_IMPORT'),'import', 'run', $folder, FALSE, TRUE);
        $actions[] = parent::CreateAction(_T('VIEW_IMPORT_SETTINGS'),'view', 'view', $folder);
        if($creator) {
            $actions[] = parent::CreateAction(_T('EDIT_IMPORT_SETTINGS'),'edit','edit',  $folder);
            $actions[] = parent::CreateAction(_T('DELETE_IMPORT_SETTINGS'),'delete', 'delete', $folder);
        }

        return $actions;
    }
}
