<?php

class Queue_Model_Api_Method_Queue_AddData extends WebReport_Api_Method_Abstract
{
    public function userIsAllowed(Core_Model_User $user)
    {
        return true;
    }

    public function needsAuthentication()
    {
        return false;
    }

    public function call(array $params)
    {
        $data = $this->decryptAndDecodeJSON();

        $rois_data = self::createDataForEachRoi($data);
        $time = new DateTime();
        $start = microtime(true);
        try {
            $protocol = Core_Model_Protocols::getWithId($data['protocol']);
            foreach ($rois_data as $roi_data) {
                //Core_Model_CountData::addDataForDecodedJSON($roi_data);
                $protocol::addData($roi_data);
            }
        } catch (Exception $e) {
            r_log($e->getMessage());
            throw new WebReport_Exception($e->getMessage());
        }
        $end = microtime(true);
        $execution_time = round($end - $start, 5);
        # r_log("Added new Queue 2 data in $execution_time seconds");
        echo "ok";
        return;
    }

    private static function createDataForEachRoi($data)
    {
        $ret = array();
        for ($i=0; $i<sizeof($data['queue_areas']); $i++) {
            $roi = $data;
            $roi['reporter_name'] = Core_Model_Application_Queue2::areaName($roi['reporter_name'], $roi['queue_areas'][$i]);
            $roi['data'] = $roi['data'][$i];
            $roi['queue_upper_limit'] = $roi['queue_upper_limit'][$i];
            $roi['queue_lower_limit'] = $roi['queue_lower_limit'][$i];
            unset($roi['queue_areas']);
            $ret[] = $roi;
        }
        return $ret;
    }
}
