<?php

class Queue_Model_Api_Method_Queue_GetLastDate extends WebReport_Api_Method_Abstract
{

    public function userIsAllowed(Core_Model_User $user)
    {
        return true;
    }

    public function needsAuthentication()
    {
        return false;
    }

    public function call(array $params)
    {
        $data = $this->decryptAndDecodeJSON();

        $row = $data;
        unset($row['queue_areas']);

        try {
            $protocol = Core_Model_Protocols::getWithId($data['protocol']);
            foreach ($data['queue_areas'] as $roi) {
                $row['reporter_name'] = Core_Model_Application_Queue2::areaName($data['reporter_name'], $roi);
                $date = $protocol::getLastDataDate($row);
                if (!isset($date)) {
                    $date = 0;
                }

                if (isset($min_date)) {
                    $min_date = min($min_date, $date);
                } else {
                    $min_date = $date;
                }
            }


            echo $min_date;
        } catch (Exception $e) {
            r_log($e->getMessage());
            throw new WebReport_Exception($e->getMessage());
        }
    }
}
