<?php

abstract class Reports_Pdf_Page_Cell_Abstract
{

    protected $_page;
    protected $_cell;
    protected $_frame;
    protected $_drawingFrame;

    public function __construct(Reports_Pdf_Page $page, $cell, Reports_Pdf_Frame $frame, $render = true)
    {
        if (!($cell instanceof Reports_Model_Report_Page_Cell_Abstract)) {
            throw new WebReport_Exception("Invalid input, cell must be instanceof class Reports_Model_Report_Page_Cell_Abstract");
                }

        $this->_page = $page;
        $this->_cell = $cell;
        $this->_frame = $frame;
        $this->_drawingFrame = $frame;
        
        if ($render) {
            $date = $page->getGenerateDate();
            $this->render($date);
        }
    }

    public function render()
    {
        $f = $this->_frame;
        $page = $this->_page;
        //$c = $page->getLineColor();
        $page->setLineColor(new Zend_Pdf_Color_GrayScale(0.0));
        //$page->drawRectangle($f->getX1(), $f->getY1(), $f->getX2(), $f->getY2(), Zend_Pdf_Page::SHAPE_DRAW_STROKE);
        //$page->setLineColor($c);
        $cell = $this->_cell;
        if ($cell->isTitleEnabled()) {
            $this->drawTitle();
        }
    }

    public function drawTitle()
    {
        $f = $this->_frame;
        $c = $this->_cell;
        $p = $this->_page;
        $font = $this->_page->getFont();
        $size = $p->getFontSize() ;
        $titleSize = Reports_Pdf_Page::CELL_TITLE_FONT_SIZE;
        $p->setFont($font, $titleSize);        
        //$p->drawRoundedRectangle($f->getX1(), $f->getY2()-$titleSize*1.3, $f->getX2(), $f->getY2(), 10);
        //$p->setLineColor(new Zend_Pdf_Color_Grayscale(0.7));
        $p->setFillColor(new Zend_Pdf_Color_Grayscale(0.0));        

        $this->_page->drawAlignedText($c->getTitle()->getText(), $f->getX1(), $f->getY2()-$titleSize, $f->getX2(), Talking_Pdf_Page::TEXT_ALIGN_LEFT, $font, $size);

        $df = $this->_drawingFrame;
        $df->decreaseHeight($titleSize*1.9);

        $p->setFont($font, $size);
    }
}
