<?php

class Reports_Pdf_Page_Cell_Table extends Reports_Pdf_Page_Cell_Abstract
{

    const WANTED_FONTSIZE = 9;
    const SMALLEST_FONTSIZE = 6;
    const WANTED_NUMBERSIZE = 7;
    const SMALLEST_NUMBERSIZE = 3;

    const MARGIN = 1.5;

    protected $_maxLabels = 6;
    protected $_inch = 2.54;

    protected $_drawWeather;
    protected $_table = NULL;

    protected $_textSize;
    protected $_numberSize;
    protected $_weatherIconSize = 25;
    protected $_renderer = NULL;

    public function render()
    {
        parent::render();
        set_time_limit(60);
        $tic = time(NULL);
        $this->_font = $this->_page->getFont();
        if ($this->_font == NULL) throw new WebReport_Exception("No font assigned before rendering");

        if( is_null($this->_renderer) )
            $this->_setupRenderer();

        $this->_renderer->render();
    
    }

    private function _setupRenderer(){
        $this->_page->setFont($this->_page->font, Reports_Pdf_Page::CELL_TEXT_SIZE);
        $date = $this->_page->getGenerateDate();
        $tableRenderer   = $this->_cell->getRenderInstance();
        $tableRenderer   ->setGenerateDate($date);

        $tableRenderer   ->setWeather(Reports_Model_WeatherServiceAbstract::WeatherIsEnabled() && $this->_cell->getHasWeather());
        $tableRenderer   ->prepareRender()
                         ->setPage($this->_page)
                         ->setFrame($this->_drawingFrame)
                         ->setFont($this->_page->font);
        $this->_renderer = $tableRenderer;
    }

    public function getTextSize(){
        if( is_null($this->_renderer) )
            $this->_setupRenderer();
        $this->_renderer -> calculateProps();
        return $this->_renderer -> getBaseTextSize();
    }

    public function limitTextSize($size){
        if( is_null($this->_renderer) )
            $this->_setupRenderer();
        $this->_renderer->limitTextSize($size);
    }
}
