<?php

class Reports_Pdf_Page_Cell_Warnings extends Reports_Pdf_Page_Cell_Abstract
{
        const _row_spacing =2;
        const _left_margin =20;
        const _right_margin =20;

	public function render()
	{
		parent::render();

		$page = $this->_page;
		$cell = $this->_cell;
                $translate = Zend_Registry::get('Zend_Translate');

		$f = $this->_drawingFrame;

                $warnings = $cell->render();

                $allfit = true;
                $nrows = count($warnings);
                $size = $page->getFontSize()+self::_row_spacing;

		$current_y = $f->getY2()-$size-self::_row_spacing;
		$max_diff_y = 0;
		for($i=0;$i<$nrows;$i++) {
		  $ts = new Zend_Date($warnings[$i][2], Zend_Date::TIMESTAMP);
		  $tmp_y = $current_y;
		  $current_y = $page->drawTextBox( $ts->toString('yyyy-mm-dd') . ' - ' . $warnings[$i][1] . ' ' . $warnings[$i][0], $f->getX1()+self::_left_margin, $current_y, $f->getX2()-self::_right_margin) - self::_row_spacing;
		  $max_diff_y = max($tmp_y - $current_y, $max_diff_y);
		  
		  if($current_y - ($max_diff_y + $size) < $f->getY1()) {
		    $allfit = false;
		    break;
		  }		  
		}

                if(!$allfit) 
		  $page->drawTextBox( $translate->_('NO_MORE_WARNINGS_FIT'), $f->getX1()+self::_left_margin, $current_y, $f->getX2()-self::_right_margin) - self::_row_spacing;

                if($nrows==0)
		  $page->drawTextBox( $translate->_('NO_WARNINGS'), $f->getX1()+self::_left_margin, $current_y, $f->getX2()-self::_right_margin) - self::_row_spacing;

		
	}

}
