<?php

class Reports_Pdf_Pdf extends Zend_Pdf
{
	protected $_report;

    const TOP = 0;
    const RIGHT = 1;
    const BOTTOM = 2;
    const LEFT = 3;

    /**
     * The default encoding
     * 
     * @var string
     */

    public static $encoding = 'UTF-8';



	public function __construct(Reports_Model_Report $report, $generate_date = null)
	{
		parent::__construct();
		$this->_report = $report;

        $gray  = new Zend_Pdf_Color_Rgb(0.6, 0.6, 0.6);
        $black = new Zend_Pdf_Color_Rgb(0, 0, 0);
		$ps    = $report->getPages();
        $fontpath = APPLICATION_PATH . "/../public/library/fonts/FreeSans.ttf";
		$font = Zend_Pdf_Font::fontWithPath($fontpath);

        foreach ($ps as $p) {
            $page = new Reports_Pdf_Page($p, $report->getSize(), $report->showLogo(), $generate_date, $font);
			$this->pages[] = $page;

                        
			if ($report->isPageHeaderEnabled()) {
				$page->drawHeader($report->getCompany());
            }

			if ($report->isPageFooterEnabled()) {
				$page->drawFooter();
            }
            
            $page   ->drawLogo($report->getCompany());
            $page   ->setFillColor($gray)
                    ->setLineColor($gray)
                    ->drawCognimaticsFooter($report->isCogLogoEnabled());
            $page   ->setFillColor($black)
                    ->setLineColor($black);     
        }
	}
}
