<?php

class Reports_Form_ExportData extends UniForm_Form
{
    protected $_user;
	
	private $countDataSetCount;

	/**
	 * Constructor
	 *
	 * @see Zend_Form
	 * @param string $action Can be new or edit
	 * @param mixed $options
	 * @return void
	 */
	public function __construct($user, $options = null)
	{
	    $this->_user = $user;
    	parent::__construct($options);
	}

	public function init()
	{
		parent::init();

		$this->addElementPrefixPath('WebReport_Validate_DataExport', 'WebReport/Validate/DataExport', 'validate');

		$applicationsModel = new Core_Model_Applications();
		$camerasDb = new Core_Model_Cameras();

		$applications = $applicationsModel->fetchAllWithCountData();
		$countDataSetsDb = new Core_Model_CountData_Sets();
		
        $countDataSets = $countDataSetsDb->fetchAllVisible($this->_user);
 
        $this->countDataSetCount = count($countDataSets) > 0;
		if(!$this->countDataSetCount){
			return;
		}
		$count_data_set_id = $countDataSets->getFormElement('count_data_set_id', "COUNT_DATA_SET", false, "SELECT_A_COUNT_DATA_SET.");
		$count_data_set_id->setLabel('COUNT_DATA_SETS')
			->setRequired("true");

		$this->addElements(array($count_data_set_id));
		$this->addDisplayGroup(array('count_data_set_id'), 'count-data-sets', array("legend" => "COUNT_DATA_SETS"));
		
		/*$timeFilterDb = new Core_Model_CountData_TimeFilters();
		$time_filter_id = $timeFilterDb->getFormElementForCompany('time_filter_id','TIME_FILTER',false,"NONE",$company);

		$this->addElements(array($time_filter_id));
		$this->addDisplayGroup(array('time_filter_id'), 'filtergroup-group', array("legend" => "FILTER_GROUPS"));*/
		
		$format = new UniForm_Form_Element_Radio('format');
		$format->setLabel('FORMAT')
			->addMultiOption('csv','CSV')
//			->addMultiOption('xml','XML')
                        ->addMultiOption('excel','EXCEL')
			->addMultiOption('html','HTML')
			->setRequired();

		$step = new UniForm_Form_Element_Hidden('step');
		$step->setValue(1);

		$submit = new UniForm_Form_Element_Submit('submit');
		$submit->setLabel('SUBMIT');
		$this->addElements(array($format, $step));
	
		$this->addDisplayGroup(array('format', 'step'), 'format-group', array("legend" => "FORMAT"));

		$this->addElements(array($submit));
	}
	

	public function hasCountDataSets(){
		return $this->countDataSetCount > 0;
	}

	/**
	 * Function to catch translatable strings in Poedit.
	 *
	 * @return void
	 */
	private function _translatableStrings() {
		$this->_translate->_('DATA_AGGREGATORS');
		$this->_translate->_('NO_DATA_AGGREGATOR');
		$this->_translate->_('DATA_AGGREGATOR');
		$this->_translate->_('SELECT_A_COUNT_DATA_SET');
		$this->_translate->_('COUNT_DATA_SETS');
		$this->_translate->_('APPLICATION');
		$this->_translate->_('NO_TIME_FILTER');
		$this->_translate->_('APPLICATION');
		$this->_translate->_('FILTER_GROUP');
		$this->_translate->_('FILTER_GROUP');
		$this->_translate->_('FORMAT');
		$this->_translate->_('FORMAT');
		$this->_translate->_('NO_COMPANY');
		$this->_translate->_('NO_FILTER_GROUP');
		$this->_translate->_('NO_APPLICATION');
		$this->_translate->_('CSV');
                $this->_translate->_('EXCEL');
                $this->_translate_>_('EXCEL_(XLSX)');
		$this->_translate->_('HTML');
		$this->_translate->_('XML');
	}

}
