<?php

class Reports_Form_ReportAdd_Page extends UniForm_Form
{
	
	public function init()
	{
		parent::init();

		$this->addElementPrefixPath('Reports_Form_ReportAdd_Page_Validate', 'reports/forms/ReportAdd/Page/Validate', 'validate');
		
		$title_enabled = new UniForm_Form_Element_Checkbox('page_title_enabled');
		$title_enabled->setLabel("ENABLE_PAGE_TITLE")
			->setRequired();

		$title = new UniForm_Form_Element_Text('page_title');
		$title->setLabel("PAGE_TITLE")
			->setAllowEmpty(false)
			->addValidator('TitleEnabled');


		$font_size = new UniForm_Form_Element_Radio('page_title_font_size');
		$font_size->setLabel('SIZE');


		$font_size->addMultiOption("small", "SMALL")
			->addMultiOption("medium", "MEDIUM")
			->addMultiOption("large", "LARGE")
			->addMultiOption("largest", "LARGEST")
			->setValue("medium");

		$title_align = new UniForm_Form_Element_Radio('page_title_align');
		$title_align->setLabel("ALIGN");
		$title_align->addMultiOption(Talking_Pdf_Page::TEXT_ALIGN_LEFT, "LEFT")
			->addMultiOption(Talking_Pdf_Page::TEXT_ALIGN_CENTER, "CENTER")
			->addMultiOption(Talking_Pdf_page::TEXT_ALIGN_RIGHT, "RIGHT")
			->setValue(Talking_Pdf_Page::TEXT_ALIGN_CENTER);

		$this->addElements(array($title_enabled, $title, $font_size, $title_align));
		$this->addDisplayGroup(array('page_title_enabled', 'page_title', 'page_title_font_size', 'page_title_align'), 'edit-page-group');

		$submit = new UniForm_Form_Element_Submit('submit');
		$submit->setLabel("OK")
		 ->setAttrib("id", "page-submit");
		 
		$this->addElement($submit);


	}



}