<?php

class Reports_Form_ReportAdd_TemplateCell_Validate_CountDataSetRequired extends Zend_Validate_Abstract
{
	
    const COUNT_DATA_SET_MUST_BE_CHOSEN = 'countDataSetMustBeChosen';

    protected $_messageTemplates;

    function __construct(){
        $translate = Zend_Registry::get('Zend_Translate');
        $this->_messageTemplates = array(
            self::COUNT_DATA_SET_MUST_BE_CHOSEN =>  $translate->_('COUNT_DATA_SET_MUST_BE_CHOSEN')
        );
    }

    public function isValid($value, $context = null)
    {

        $value = (string) $value;
        $this->_setValue($value);

        if (is_array($context)) {
            if (isset($context["cell_type"]) && 
           		(
                	$context["cell_type"] != Reports_Model_Report_Page_Cell::TYPE_CHART &&
                	$context["cell_type"] != Reports_Model_Report_Page_Cell::TYPE_TABLE
               ))
            {
                return true;
            }
        }
        
			$validator = new Zend_Validate_NotEmpty(
    			Zend_Validate_NotEmpty::INTEGER + Zend_Validate_NotEmpty::ZERO
			);
			$valid = $validator->isValid($value);

        if ($valid) {
        	return true;
        }

        $this->_error(_(self::COUNT_DATA_SET_MUST_BE_CHOSEN));

        return false;
    }
}
