<?php

class Reports_Form_ReportAdd_TemplateCell_Validate_DateInterval extends Zend_Validate_Abstract
{
	
    const INVALID_DATE_INTERVAL = 'invalidDateInterval';

    protected $_messageTemplates = array(
        self::INVALID_DATE_INTERVAL => 'Invalid date interval'
    );

    public function isValid($value, $context = null, $allow_empt = false , $additional_codes = null)
    {
        $value = (string) $value;
        $this->_setValue($value);

        if (is_array($context)) {
            if (isset($context["cell_type"]) && 
           		(
                	$context["cell_type"] != Reports_Model_Report_Page_Cell::TYPE_CHART &&
                	$context["cell_type"] != Reports_Model_Report_Page_Cell::TYPE_TABLE
               )
            ) {
                return true;
            }
            
            if (isset($context["cell_time_interval"]) && $context["cell_time_interval"] != "fix") {
            	return true;	
            }
        }


	$validator = new Zend_Validate_NotEmpty(
            Zend_Validate_NotEmpty::INTEGER + Zend_Validate_NotEmpty::ZERO
	);
	$valid = $validator->isValid($value);

        if ($valid) {
        	return true;
        }

        $this->_error(self::INVALID_DATE_INTERVAL);

        return false;
    }
}
