<?php

class Reports_Form_ReportAdd_TemplateCell_Validate_TextNotEmpty extends Zend_Validate_Abstract
{
	
    const IS_EMPTY = 'isEmpty';

    protected $_messageTemplates = array(
        self::IS_EMPTY => 'Value cannot be empty'
    );

    public function isValid($value, $context = null)
    {

        $value = (string) $value;
        $this->_setValue($value);

        if (is_array($context)) {
            if (isset($context["cell_type"])
                && ($context["cell_type"] != Reports_Model_Report_Page_Cell::TYPE_TEXT))
            {
                return true;
            }
        }

			$validator = new Zend_Validate_NotEmpty();
			$valid = $validator->isValid($value);

        if ($valid) {
        	return true;
        }

        $this->_error(self::IS_EMPTY);

        return false;
    }
}
