<?php

class Reports_Form_ReportAdd_TemplateCell_Validate_TimeInterval extends Zend_Validate_Abstract
{

    const TIME_INTERVAL_MUST_BE_CHOSEN = 'timeIntervalMustBeChosen';
    const TIME_INTERVAL_CODE_NOT_VALID = 'timeIntervalIntervalCodeNotValid';

    protected $_messageTemplates = array(
        self::TIME_INTERVAL_MUST_BE_CHOSEN => 'A_TIME_INTERVAL_MUST_BE_CHOSEN',
        self::TIME_INTERVAL_CODE_NOT_VALID => 'TIME_INTERVAL_CODE_IS_NOT_VALID'
    );

    public function isValid($value, $context = null)
    {

        $value = (string) $value;
        $this->_setValue($value);

        if (is_array($context)) {
            if (isset($context["cell_type"]) &&
           		(
                	$context["cell_type"] != Reports_Model_Report_Page_Cell::TYPE_CHART &&
                	$context["cell_type"] != Reports_Model_Report_Page_Cell::TYPE_TABLE
               ))
            {
                return true;
            }
        }
        $valid = true;

        if($context['cell_time_interval'] != 'man')
            return true;

        if($context['cell_time_interval'] == 'man') {
            $validator = new Zend_Validate_NotEmpty(
                Zend_Validate_NotEmpty::INTEGER + Zend_Validate_NotEmpty::ZERO
            );
            $valid = $validator->isValid($value);

            if (!$valid) {
               $this->_error($this->translate->_(self::TIME_INTERVAL_MUST_BE_CHOSEN));
            }
        }

        if($valid) {
            $valid = CM_Interval::isValidCode($value);
            if(!$valid) {
                $this->_error(_(self::TIME_INTERVAL_CODE_NOT_VALID));
            }
        }

        return $valid;
    }
}
