<?php

abstract class Reports_Form_ReportAdd_Validate_EnabledAbstract extends Zend_Validate_Abstract
{
	
    const IS_EMPTY = 'isEmpty';

	protected $_enableElementName;

    protected $_messageTemplates = array(
        self::IS_EMPTY => 'Value cannot be empty'
    );

    public function isValid($value, $context = null)
    {

			if (!$this->_enableElementName) {
				throw new WebReport_Exception('Variable $_enableElementName is not set');
			}

        $value = (string) $value;
        $this->_setValue($value);

        if (is_array($context)) {
            if (isset($context[$this->_enableElementName])
                && ($context[$this->_enableElementName] == "0"))
            {
                return true;
            }
        }

			$validator = new Zend_Validate_NotEmpty();
			$valid = $validator->isValid($value);

        if ($valid) {
        	return true;
        }

        $this->_error(self::IS_EMPTY);

        return false;
    }
}
