<?php

class Reports_Model_Api_Method_Reports_GetGameReport extends WebReport_Api_Method_Abstract
{
    public function userIsAllowed(Core_Model_User $user)
    {
        return false;
    }

    public function needsAuthentication() {
        if($_SERVER['REMOTE_ADDR'] == "127.0.0.1" ||
           $_SERVER['REMOTE_ADDR'] == "::1" ) {
            return false;
        }
        return true;
    }
    
    public function call(array $params)
    {
        $exportparams = $params['params'];
        $date_export = $exportparams['date'];
        //ALL cameras
        $camerasDb = new Core_Model_Cameras();
        $companiesDb = new Core_Model_Companies();
        
        //game company id == 1
        //$company = $companiesDb->find(1)->current();
        $company = $companiesDb->fetchWithName("Cognimatics");
        
        //only interested in People Counter
        $app = new Core_Model_Application_PeopleCounter();
        $cameras = $camerasDb->getCameraNames($app, $company);

        //check for cameras that follow the naming standard
        foreach ($cameras as $id => $cntname) {
            $parts = explode('_', $cntname);
            //require strict format CONTRYCODE STORENAME STORENUMBER
            if(count($parts) != 3)
            {
                unset ($cameras[$id]);
                continue;
            }
            
            if( (strtolower($parts[0]) != 'se' ) &&
                (strtolower($parts[0]) != 'swe') &&
                (strtolower($parts[0]) != 'cog') )
            {
                unset ($cameras[$id]);
                continue;
            }
        }
        
        $cameraIds = array_keys($cameras);
        $cameras = $camerasDb->find($cameraIds);
        
        $response = Zend_Controller_Front::getInstance()->getResponse();
        $response->setHeader("Content-Type", "text/plain");
        $filename = "VISITOR_INFORMATION_SE_" . $date_export;
        //$response->setHeader("Content-Disposition", 'attachment;filename="' . $filename . '.csv"');
        $response->setHeader("Content-Disposition", 'filename="' . $filename . '.csv"');

        $firstDateSelected = new Zend_Date();
        $firstDateSelected->setDate($date_export, "yyyyMMdd");
        $firstDateSelected->setHour(0)->setMinute(0)->setSecond(0);
        
        $lastDateSelected = new Zend_Date();
        $lastDateSelected->setDate($date_export, "yyyyMMdd");
        $lastDateSelected->setHour(0)->setMinute(0)->setSecond(0);
        
        ob_start();
        echo "DATE,HOUR,STORE_CODE,STORE_NAME,NO_OF_VISITORS\n";
        $lcount = 2; //header and footer
        
        foreach ($cameras as $camera) {
            
            $countDataDb = new Core_Model_CountData();
            $countDataDb->addCamera($camera);
            $countDataDb->initDatabaseSelect();


            $headers = $countDataDb->getDescriptionsForLastFetchedData();
            $ck = array_keys($headers);

            $cntname = $headers[$ck[1]];
            $cntname = substr($cntname, 0, -5);
            $parts = explode('_', $cntname);
            
            $timeResolution = "ts1h"; //$_POST['time-resolution'];
            $data = $countDataDb->getData($timeResolution,
                                          $firstDateSelected,
                                          $lastDateSelected);
            foreach ($data as $row) {
                $toEcho = array();
                $row = (array)$row;
            
                
                if(is_null($row[$ck[0]]))
                    continue;
                $row_date = new Zend_Date($row[$ck[0]], Zend_Date::ISO_8601);
                //var_dump($row_date->toString("HH"));
                //die();
                $toEcho[] = $row_date->toString("dd/MM/yyyy");
                $toEcho[] = $row_date->toString("H");
                
                $p1 = (!is_null($row[$ck[1]])) ? $row[$ck[1]] : 0;
                $p2 = (!is_null($row[$ck[2]])) ? $row[$ck[2]] : 0;
                $sum = floor( ( (int)$p1 + (int)$p2 )/2);
                $toEcho[] = $parts[2];
                $toEcho[] = $parts[1];
                $toEcho[] = $sum;
            
                echo implode(",", $toEcho) . "\n";
            }
            $lcount += count($data);
        }
        echo "TR,".$firstDateSelected->toString("dd/MM/yyyy").",".$lcount;
        ob_end_flush();
		
	}


}