<?php

class Reports_Model_MenuItems extends WebReport_Module_MenuItems_Abstract
{
	/**
	 * Get admin module menu items.
	 *
	 * @return array
	 */
	public function getAll()
	{
		$acl = WebReport_Acl::getInstance();
		$items = array();

		// @todo Check with ACL
		$identity = Zend_Auth::getInstance()->getIdentity();

		$items['reports'] = array(
			'text' => 'MOD_REPORTS_MENU_REPORTS',
			'class' => 'reports',
			'urlOptions' => array('module' => 'reports', 'controller' => 'index', 'action' => 'browse'),
			'title' => "CREATE_TAILOR_MADE_REPORTS_FOR_YOUR_NEEDS"
		);

		$items['export-data'] = array(
			'text' => 'MOD_REPORTS_MENU_EXPORT_DATA',
			'class' => 'export-data',
			'urlOptions' => array('module' => 'reports', 'controller' => 'export', 'action' => 'index'),
			'title' => "EXPORT_COUNT_DATA_IN_DIFFERENT_FORMATS"
		);
                
                $items['subscribe'] = array(
			'text' => 'MOD_REPORTS_MENU_SUBSCRIPTIONS',
			'class' => 'subscribe',
			'urlOptions' => array('module' => 'reports', 'controller' => 'subscribe', 'action' => 'browse'),
			'title' => "REPORT_SUBSCRIPTIONS"
		);

		$items = $this->filterNotAllowedItems($items);

		return $this->translate($items);

	}

	public static function getDescription($item)
	{
		$t = Zend_Registry::get('Zend_Translate');
		$items = array();
		$items['export-data'] = $t->_("EXPORT_COUNT_DATA_AS_CSV,_EXCEL_OR_HTML.");
		$items['reports'] = $t->_("CREATE,_VIEW_AND_SEND_REPORTS_OF_YOUR_COUNT_DATA.");
                $items['subscribe'] = $t->_("CREATE_SUBSCRIPTIONS_FOR_REPORTS");
                
		return $items[$item];
	}

	private function _translatableStrings()
	{
		$this->_translate->_('EXPORT_COUNT_DATA_IN_DIFFERENT_FORMATS');
                $this->_translate->_('MOD_REPORTS_MENU_SUBSCRIPTIONS');
                $this->_translate->_('REPORT_SUBSCRIPTIONS');
                $this->_translate->_('CREATE_TAILOR_MADE_REPORTS_FOR_YOUR_NEEDS');
	}

}
