<?php

class Reports_Model_Permalink extends Zend_Db_Table_Row_Abstract
{
    public function getApi($view = null){
        $url = Zend_Registry::get('config')->resources->frontController->baseUrl;
        // TODO: Use ACL, api is not registered as a module..
        // $url = $view->aclUrl(array(), "","");
	
		$port = '';
		if($_SERVER['SERVER_PORT'] != '80')
		  $port = ':' . $_SERVER['SERVER_PORT'];

        $address = $_SERVER["SERVER_NAME"].$port.$url."/api/?method=reports.GetReport&id=";
        $data_decoded = json_decode($this->permalink_data);
        $permalink = $data_decoded->legacyId.$this->permalink_key;
        return "http://".$address.$permalink;
    }
    
    public function getSettings($convertTime = true){
        $data = Zend_Json::decode($this->permalink_data);
	
        if($convertTime){
	    if($data["timeFormat"] == "fix"){
	        $firstDateSelected = new Zend_Date();
	        $firstDateSelected->setDate($data['firstDateSelected'], "yyyy-MM-dd");
	        $lastDateSelected = new Zend_Date();
	        $lastDateSelected->setDate($data['lastDateSelected'], "yyyy-MM-dd");
	        $data['firstDateSelected'] = $firstDateSelected;
	        $data['lastDateSelected'] = $lastDateSelected;
	    }
	}

        return $data;
    }
    
    public function touch(){
        $this->last_api_read = new Zend_Db_Expr('NOW()');
	    $this->save();
    }
}
