<?php

class Reports_Model_Permalinks extends Talking_Db_Table
{
        protected $_name = 'mod_reports_permalinks';
	protected $_primary = 'permalink_id';
	protected $_rowClass = 'Reports_Model_Permalink';

//	protected $_dependentTables = array ('Reports_Model_SubscriptionReceivers');

	protected $_referenceMap    = array(
		'Company' => array(
			'columns'           => 'company_id',
			'refTableClass'     => 'Core_Model_Companies',
			'refColumns'        => 'company_id'
		)
	);

    public function fetchAllForCompany(Core_Model_Company $c) {
        $select = $this->select();
        $select->where('company_id = ?', $c->company_id);

        return $this->fetchAll($select);
    }
    
    public function tryFetchLegacyLink($id, $key)
    {
        $select = $this->select();

        $select->where('permalink_key = ?', $key);
        $row = $this->fetchAll($select)->current();
        $data_decoded = json_decode($row->permalink_data);
        if ($data_decoded->legacyId != $id) {
            return null;
        }
        return $row;
    }
    
    public function addPermalink($outputFormat, $companyId,$countDataSetId,$aggregatorId, $timeFilterId,$timeResolution, $timeFormat,$firstDateSelected,$lastDateSelected)
    {
	$config = array();
	$config['countDataSetId'] = $countDataSetId;
	$config['aggregatorId'] = $aggregatorId;
	$config['timeFilterId'] = $timeFilterId;
	$config['timeFormat'] = $timeFormat;
	$config['timeResolution'] = $timeResolution;
	$config['firstDateSelected'] = $firstDateSelected;
	$config['lastDateSelected'] = $lastDateSelected;
	$config['$outputFormat'] = $outputFormat;
	
	if($timeFormat != "fix"){
	    $config['firstDateSelected'] = null;
	    $config['lastDateSelected'] = null;
	}
	
	$configJson = Zend_Json::encode($config);
	$key = substr("k".md5(uniqid(rand(), true)),0,8);

	$permalinkData = array(
	    "permalink_data" => $configJson,
	    "company_id" => $companyId,
	    "permalink_key" => $key,
	    "last_api_read" => new Zend_Db_Expr('NOW()'),
	);
        $filter = $this->createRow($permalinkData);
        $filter->save();
	return $filter;
    }
}

