<?php

class Reports_Model_Report_Page_Cell_Datasource extends Reports_Model_Report_Page_Cell

{

	// column or line
    protected $_weatherEnabled;
    protected $_hasWeather;
    protected $_weatherLocation;
    protected $_weatherTimePeriod;
    protected $_dataSourceId;
    protected $_renderName = 'Charts_Model_ChartRender_Png';
    protected $_includeTable;
    // made for the future, when using native pdf charting and generate tables in report
    // maybe a renderer is not always sufficent.

	public function setDataSourceId($id)
	{
		$this->_dataSourceId = $id;
		return $this;
	}

	public function getDataSourceId()
	{
		return $this->_dataSourceId;
    }

    public function getDataSource() {
        return Charts_Model_ChartData::factoryFromDatabase($this->getDataSourceId());
    }

    public function setRenderName($renderer) {
        $this->_renderName = $renderer;
        return $this;
    }

    public function getRenderName() {
        return $this->_renderName;
    }

    public function getRenderInstance() {
        return new $this->_renderName();
    }

    public function setIncludeTable($include_table = true){
        $this->_includeTable = $include_table;
        return $this; 
    }

    public function getIncludeTable(){
        return $this->_includeTable;
    }

    public function setHasWeather($has_weather = true)
    {
        $this->_hasWeather = $has_weather;
        return $this;
    }

    public function getHasWeather()
    {
        return $this->_hasWeather;
    }

    public function setWeatherLocation($weather_location)
    {
        $this->_weatherLocation = $weather_location;
        return $this;
    }

    public function getWeatherLocation()
    {
        return $this->_weatherLocation;
    }

    public function getWeatherCoord()
    {
        return current(explode(' ', $this->_weatherLocation));
    }

    public function setWeatherTimePeriod($weather_time_period)
    {
        $this->_weatherTimePeriod = $weather_time_period;
        return $this;
    }

    public function getWeatherTimePeriod()
    {
        return $this->_weatherTimePeriod;
    }

    public function getWeatherEnabled()
    {
        return $this->_weatherEnabled;
    }

    public function setWeatherEnabled($weather_enabled)
    {
        $this->_weatherEnabled = $weather_enabled;
        return $this;
    }
}
