<?php

class Reports_Model_Report_Page_Cell_Table extends Reports_Model_Report_Page_Cell

{
    protected $_renderName = 'Charts_Model_TablePdfRenderer';
    protected $_tableId;
    protected $_hasWeather = false;
    protected $_weatherLocation;
    protected $_weatherTimePeriod;
    protected $_weatherEnabled;

    public function setTableId($id)
    {
        $this->_tableId = $id;
        return $this;
    }
 
    public function getTableId()
    {
        return $this->_tableId;
    }

    public function getTable() {
        $tDb = Charts_Model_Tables::getInstance();
        $table = $tDb->find($this->_tableId)->current();

        return $table;
    }
 
    public function getRenderInstance() {
        return new $this->_renderName($this->getTable());
    }
    
    public function setHasWeather($has_weather = true)
    {
        $this->_hasWeather = $has_weather;
        return $this;
    }

    public function getHasWeather()
    {
        return $this->_hasWeather;
    }

    public function setWeatherLocation($weather_location)
    {
        $this->_weatherLocation = $weather_location;
        return $this;
    }

    public function getWeatherLocation()
    {
        return $this->_weatherLocation;
    }

    public function getWeatherCoord()
    {
        return current(explode(' ', $this->_weatherLocation));
    }

    public function setWeatherTimePeriod($weather_time_period)
    {
        $this->_weatherTimePeriod = $weather_time_period;
        return $this;
    }

    public function getWeatherTimePeriod()
    {
        return $this->_weatherTimePeriod;
    }

    public function getWeatherEnabled()
    {
        return $this->_weatherEnabled;
    }

    public function setWeatherEnabled($weather_enabled)
    {
        $this->_weatherEnabled = $weather_enabled;
        return $this;
    }

}
