<?php

class Reports_Model_Report_Page_Label_PageNumber extends Reports_Model_Report_Page_Label
{

	/**
	 * Page number
	 *
	 * @var int
	 */
	protected $_pageNumber;

	/**
	 * Total page count
	 *
	 * @var int
	 */
	protected $_pageCount;

        protected $_report = null;


	public function setPageNumber($number)
	{
		$this->_pageNumber = $number;
		return $this;
	}

	public function getPageNumber()
	{
		return $this->_pageNumber;
	}

	/*public function setPageCount($count)
	{
		$this->_pageCount = $count;
		return $this;
	}*/

        public function setReport($report) {
            $this->_report = $report;
            return $this;
        }

	public function getPageCount()
	{
            if(is_null($this->_report))
		return 0;//count($this->_report->_pages);
            return $this->_report->getPageCount();
	}

	protected function _transform()
	{

		$fText = parent::_transform();

		$fText = str_replace("%pn", $this->getPageNumber(), $fText);
		$fText = str_replace("%pc", $this->getPageCount(), $fText);
        $fText = str_replace("%d", date("Y-m-d"), $fText);
        $fText = str_replace("%t", date("H:i:s"), $fText);
        

		return $fText;
	}

}
