<?php

class Reports_Model_Report_PageMapper extends WebReport_Model_Mapper_Abstract
{
	
	protected $_dbTableClass = "Reports_Model_DbTable_Report_Page";

   public function save(Reports_Model_Report_Page $page, $recursive = true)
   {
   	$title = $page->getTitle();
      $data = array(
            'template_id'	=> $page->getTemplate()->getId(),
            'report_id'	=> $page->getReport()->getId(),
            'landscape' => $page->getLandscape(), 
     		'title_enabled'	=> (int)$page->isTitleEnabled(),
      		'title_align' => $title->getAlign(),
      		'title_size' => $title->getFontSize(),
      		'order' => $page->getOrder()
      );
		if (null === ($id = $page->getId())) {
 			$id = $this->getDbTable()->insert($data);
 			$page->setId($id);
		} else {
         $this->getDbTable()->update($data, array('report_page_id = ?' => $id));
		}
        
      if ($recursive) {
      	$cells = $page->getCells();
      	$cellMapper = new Reports_Model_Report_Page_CellMapper();
      	foreach ($cells as $cell) {
      		$cellMapper->save($cell);
      	}
       }
    }
    
    public function fetchAllForReport(Reports_Model_Report $report)
    {
    	$pages = $this->fetchAll(array("where" => "report_id = " . (int)$report->getId(), "order" => "order"));
    	
    	foreach ($pages as $page) {
    		$page->setReport($report);
    	}
    	return $pages;
    }

	protected function _populateFromRow($row, $populateDeep = true, $params = array()) {
      $entry = new Reports_Model_Report_Page();
      $entry->setId($row->report_page_id)
      	    ->enableTitle((bool)$row->title_enabled)
            ->setLandscape($row->landscape);

      $title = new Reports_Model_Report_Page_Title($row->title, $row->title_align, $row->title_size);
      $entry->setTitle($title);

    	$templatesMapper = new Reports_Model_TemplateMapper();
    	$template = $templatesMapper->find($row->template_id);
    	$entry->setTemplate($template);
		if ($populateDeep) {

			$cellMapper = new Reports_Model_Report_Page_CellMapper();
			$cells = $cellMapper->fetchAllForPage($entry);
			$entry->setCells($cells);
		}
 
      return $entry;
	}

}

