<?php

class Reports_Model_ReportCompiler
{
	public static function renderReport($countDataSetId, $outputFormat, $aggregatorId, $timeFilterId, $timeResolution,$timeFormat, $firstDateSelected, $lastDateSelected, $settings = array())
	{
		$class = "WebReport_Export_" . ucfirst($outputFormat);
		$export = new $class();
        $export->setSettings($settings);

		$timeFilterDb = new Core_Model_CountData_TimeFilters();
		$timeFilter = $timeFilterDb->fetchById((int) $timeFilterId);
		$countDataSets = new Core_Model_CountData_Sets();
		$countDataSet = $countDataSets->find($countDataSetId)->current();

		if($timeFormat != "fix"){
			$inter = new CM_Interval(Zend_Date::now(),$timeFormat);
			if(!is_null($inter)){
				$firstDateSelected = $inter->getStartDate();
				$lastDateSelected = $inter->getStopDate();			
			}else{
				// $todo: do something proper here
				$firstDateSelected = new Zend_Date();
				$lastDateSelected = new Zend_Date();
			}
		}
		if ($aggregatorId > 0) {
			$dataAggregatorDb = new Charts_Model_DataAggregatorList();
			$aggregator = $dataAggregatorDb->getAggregator($aggregatorId);

			$aggregator->setData($countDataSet);
			$aggregator->setPeriod($firstDateSelected, $lastDateSelected);
                        
            if($timeFilter != null){
                $aggregator->setTimeFilter($timeFilter);
            }

			$data_tmp = $aggregator->renderData();

			$labels = $aggregator->getXLabel();

			$descriptions = array("bin" => "Time Segment") + $aggregator->getDataLabels(false);

			$unit = $aggregator->getDisplayUnit();
			if ($unit != "") {
				foreach ($data_tmp as $data) {
					foreach (array_keys($descriptions) as $label) {
						$data->$label .= $unit;
					}
				}
			}

			$ind = 0;
			foreach ($labels as $label)
				$data_tmp[$ind++]->bin = $label;

            $export->setHeaders($descriptions)->setData($data_tmp);
		} else {
			$countDataDb = $countDataSet->getCountData();
			$countDataDb->initDatabaseSelect();
			$data = $countDataDb->getData($timeResolution, $firstDateSelected, $lastDateSelected, $timeFilter);
			$descriptions = $countDataDb->getDescriptionsForLastFetchedData();
			$export->setHeaders($descriptions)->setData($data);
		}

		$export->render();
	}
}

