<?php

class Reports_Model_ReportListGenerator extends Core_Model_Generic_AbstractListView {
    public function getHeaders(){
        if($this->_isMultiCompany){
            return array(_T("NAME"),_T("DESCRIPTION"),_T("COMPANY"));
        } else {
            return array(_T("NAME"),_T("DESCRIPTION"));
        }
    }

    protected function _dataRowToTableRow($row){
        $ret = array();
        $ret[] = $row->name;
        $ret[] = $row->description;
        
        if($this->_isMultiCompany)
            $ret[] = Core_Model_Companies::getCompany($row->company_id)->name;

        $ret['_document_id'] = Core_Model_DocumentFactory::getId($row->report_id, "report");

        return $ret;
    }

    public function removeText(){
        return _T('DO_YOU_REALLY_WANT_TO_REMOVE_THE_REPORT_"%1$s"?');
    }

    protected function _dataRowToRowId($row){
        return $row->report_id;
    }

    public function noDataInformation(){
        return _T("NO_REPORTS.");
    }

    public function getActions($row){
        $folder = $this->_group->group_id;

        $creator = $this->_group->canEdit($this->_user);

        $actions = array();

        //Note that for the loader parameter (true/false) below to work it must also be one of the selected classes in
        //GenericListViewGenerator on line 83. This is due to a workaround to get wanted dialog behaviour in addition to overlays.
        //Both delete and preview-report creates their overlays from their respective dialogs instead.
        $actions[] = parent::CreateAction(_T('DOWNLOAD_REPORT'),'preview-report', 'download', $folder, false, true);

        if($creator) {
            $actions[] = parent::CreateAction(_T('EDIT_REPORT'), 'edit', 'edit', $folder);
            $actions[] = parent::CreateAction(_T('DELETE_REPORT'),'delete', 'delete', $folder, false, false);
            $actions[] = parent::CreateAction(_T('COPY_REPORT'), 'copy', 'copy', $folder);
            $actions[] = parent::CreateAction(_T('DOWNLOAD_REPORT_FOR_A_SPECIFIC_DATE'), 'preview-report', 'previous', $folder, false, true);
        }

        return $actions;
    }
}
