<?php

class Reports_Model_SubscriptionListGenerator extends Core_Model_Generic_AbstractListView {
    public function getHeaders(){
        if($this->_isMultiCompany){
            return array(_T("NAME"),_T("REPORT"),_T("SEND_HOW_OFTEN"),_T("LAST_SENT"),_("COMPANY"));
        } else {
            return array(_T("NAME"),_T("REPORT"),_T("SEND_HOW_OFTEN"),_T("LAST_SENT"));
        }
    }

    protected function _dataRowToTableRow($row){
        $ret = array();
        $ret[] = $row->name;
        $ret[] = $row->reportName();
        $ret[] = $this->translate($row->readableDuration());
        $ret[] = $this->translate(!is_null($row->last_send) ? $row->last_send : _T("NEVER"));

        if($this->_isMultiCompany)
            $ret[] = $row->companyName();

        $ret['_document_id'] = Core_Model_DocumentFactory::getId($row->subscription_id, "subscription");

        return $ret;
    }

    public function removeText(){
        return _T('DO_YOU_REALLY_WANT_TO_REMOVE_THE_SUBSCRIPTION_"%1$s"?');
    }

    protected function _dataRowToRowId($row){
        return $row->subscription_id;
    }

    public function noDataInformation(){
        return _T("NO_SUBSCRIPTIONS.");
    }

    public function getActions($row){
        $folder = $this->_group->group_id;

        $creator = $this->_group->canEdit($this->_user);

        $actions = array();
        $actions[] = parent::CreateAction(_T('VIEW_SUBSCRIPTION'),'view', 'view', $folder);

        if($creator) {
            $actions[] = parent::CreateAction(_T('EDIT_SUBSCRIPTION'), 'edit', 'edit', $folder);
            $actions[] = parent::CreateAction(_T('DELETE_REPORT'),'remove', 'delete', $folder);
            $actions[] = parent::CreateAction(_T('SEND_REPORT'),'send', 'send-report', $folder, false, true);
        }

        return $actions;
    }
}
