<?php

class Reports_Model_SubscriptionScheduler
{

  public function run($logger = null) {
    $mutex = new Core_Model_Mutex();
    $mutex->init(Core_Model_Mutex::MUTEX_SUBSCRIPTION_SCHEDULER);
    $mutex->acquire();
	if(!$logger) {
	  $logger = new Zend_log();
	  $logger->addWriter(new Zend_Log_Writer_Null());
	}

	$now = new Zend_Date();
	$subscriptionDb = new Reports_Model_Subscriptions();
	$subscriptions = $subscriptionDb->fetchAll();

	foreach($subscriptions as $subscription) {
      $lastSent = $subscription->getLastSent();
      $currentTime = $subscription->getCurrentTime();
	  $logger->notice("Handling " . $subscription->name . ". Last sent at $lastSent, current time is $currentTime");
      
	  if($subscription->timeToSend()) {
		try {
		  $subscription->updateSend();
		  $subscription->save();
		  $subscription->send();
		  $logger->notice("Sending report!");
		} catch (WebReport_Exception $e){
		  $logger->warn("The subscription " . $subscription->name . " will not be sent. Information: " . $e->getMessage() );
		}
	  }	    
	  else { 
		$logger->notice("Not time to send.");
	  }
	}
    $mutex->release();
	return true;
  }
}
