<?php

class Reports_Model_Subscriptions extends Talking_Db_Table
{
        protected $_name = 'mod_reports_subscription';
	protected $_primary = 'subscription_id';
	protected $_rowClass = 'Reports_Model_Subscription';

	protected $_dependentTables = array ('Reports_Model_SubscriptionReceivers');

	protected $_referenceMap    = array(
		'Company' => array(
			'columns'           => 'company_id',
			'refTableClass'     => 'Core_Model_Companies',
			'refColumns'        => 'company_id'
		),
                'Reciever' => array(
                    	'columns'           => 'subscription_id',
			'refTableClass'     => 'Reports_Model_SubscriptionRecievers',
			'refColumns'        => 'subscription_id'
                 ),
                 /*'Report' => array(
                    	'columns'           => 'report_id',
			'refTableClass'     => 'Reports_Model_DbTable_Report',
			'refColumns'        => 'report_id'
                 ),*/
            
	);

    public function fetchAllForCompany(Core_Model_Company $c) {
        $select = $this->select();
        $select->where('company_id = ?', $c->company_id);
        return $this->fetchAll($select);
    }
    
    public function fetchAllForCompanyId($company_id) {
        $select = $this->select();
        $select->where('company_id = ?', $company_id);
        return $this->fetchAll($select);
    }

    public function fetchDocuments($group) {
        $documents = $group->getDocuments('subscription');
        $subDb = new Reports_Model_Subscriptions();

        $subscriptions = array();
        foreach($documents as $doc) {

            $subscription = $subDb->find($doc->id)->current();

            if($subscription)
                $subscriptions[] = $subscription;
        }    

        return $subscriptions;
    }
     
}
