<?php

class Reports_Model_Template extends WebReport_Model_Abstract
{

	protected $_mapperClass = "Reports_Model_TemplateMapper";
	
    protected $_id = null;
    protected $_name;
    protected $_order;
    protected $_active;
    
    protected $_rows = array(); // template rows 
    

    public function setId($id)
    {
        $this->_id = (int) $id;
        return $this;
    }

    public function getId()
    {
        return $this->_id;
    }

    public function setName($name)
    {
        $this->_name = (string) $name;
        return $this;
    }
    
    public function getName()
    {
    	return $this->_name;	
    }
    
    public function activate()
    {
    	$this->_active = true;
    	return $this;
    }
    
    public function isActive()
    {
    	return $this->_active;
    }
    
	public function setRows($rows)
	{
		$this->_rows = $rows;	
	}    
    
    public function addRow(Reports_Model_Template_Row $row)
    {
    	$this->_rows[] = $rows;	
    }
    
    public function getRows()
    {
    	usort($this->_rows, array("Reports_Model_Template_Row", "compare"));
    	return $this->_rows;
    }
    
    public function getRowCellWithId($id) {
    	foreach ($this->getRows() as $r) {
    		foreach ($r->getCells() as $c) {
    			if ($c->getId() == $id) {
    				return $c;
    			}
    		}	
    	}
    	return null;
    }
    
    public function toHtml()
    {
    	$rows = $this->getRows();
    	$s = '<table cellpadding="0" cellspacing="0" id="template-' . $this->getId() . '">';
    	foreach ($rows as $row) {
    		$cells = $row->getCells();
    		$s .= '<tr id="template-row-' . $row->getId() . '"  style="height:' . $row->height . '%">';
    		foreach ($cells as $cell) {
				$colspan = ($cell->getColspan() ? ' colspan="' . $cell->getColspan() . '"' : "");
				$rowspan = ($cell->getRowspan() ? ' rowspan="' . $cell->getRowspan() . '"' : "");    			
				$s .= '<td id="template-row-cell-' . $cell->getId() . '"' . $colspan . $rowspan . ' style="width: ' . $cell->getWidth() . '%"></td>';
    		}
    		$s .= "</tr>";
    	}
    	$s .= "</table>";
    	return $s;
    }
    
    
    public function __toString()
    {
    	return "[" . get_class($this) . " (" . $this->getId() . ")] Name: " . $this->getName(); 	
    }


}

