<?php

class Reports_Model_Template_Row_CellMapper extends WebReport_Model_Mapper_Abstract
{
	
	protected $_dbTableClass = "Reports_Model_DbTable_Template_Row_Cell";


    public function save(Reports_Model_Template_Row_Cell $cell)
    {
        $data = array(
            'width' 				=> $template->getWidth(),
            'colspan'			=> $template->getColspan(),
            'rowspan'			=> $template->getRowspan(),
				'order'				=> $template->getOrder(),
        );

			$row = $cell->getRow();
			if (!$row) {
				throw new WebReport_Model_Mapper_Exception("Cell must have a template row");
			}
			$data['template_row_id'] = $row->getId();	
			

        if (null === ($id = $template->getId())) {
            unset($data['id']);
            $this->getDbTable()->insert($data);
        } else {
            $this->getDbTable()->update($data, array('template_row_id = ?' => $id));
        }
    }


	protected function _populateFromRow($row, $populateDeep = true, $params = array()) 
	{
		$entry = new Reports_Model_Template_Row_Cell();
      $entry->setId($row->template_row_cell_id)
      	->setWidth($row->width)
			->setColspan($row->colspan)
			->setRowspan($row->rowspan)
      	->setOrder($row->order);
      return $entry;
	}

	public function fetchAllForRow(Reports_Model_Template_Row $row) 
	{
		$id = $row->getId();
		
		if (null === $id) {
			throw new WebReport_Exception("Id must be set for template");	
		}
		
		return $this->fetchAll(array("where" => "template_row_id = " . $id, "order" => "order"));

	}

}

