<?php

class Reports_Model_TemplateMapper extends WebReport_Model_Mapper_Abstract
{
	
	protected $_dbTableClass = "Reports_Model_DbTable_Template";

   public function save(Application_Model_Template $template, $recursive = true)
   {
        $data = array(
            'name'	=> $template->getName(),
            'order'	=> $template->getOrder(),
            'active' => (int)$template->isActive(),
        );

        if (null === ($id = $template->getId())) {
            unset($data['id']);
            $this->getDbTable()->insert($data);
        } else {
            $this->getDbTable()->update($data, array('template_id = ?' => $id));
        }
        
        if ($recursive) {
        		$rows = $template->getRows();
        		$rowMapper = new Reports_Model_Template_RowMapper();
        		
        		foreach ($rows as $row) {
        				$rowMapper->save($row, true);
        		}
        	
        }
    }

	

	protected function _populateFromRow($row, $deepPopulate = true, $params = array()) {
		$entry = new Reports_Model_Template();
      $entry->setId($row->template_id)
      	->setName($row->name);
      	
      if ($deepPopulate) {
			$rowMapper = new Reports_Model_Template_RowMapper();
			$rows = $rowMapper->fetchAllForTemplate($entry);
			foreach ($rows as $row) {
				$row->setTemplate($entry);	
			}
    		$entry->setRows($rows);
      }
      return $entry;
	}


}

