<?php
class Sets_IndexController extends WebReport_Controller_Action
{
    protected $_user;

    public function init()
    {
        parent::init();

        $module = $this->getRequest()->module;
        $controller = $this->getRequest()->controller;
        $action = $this->getRequest()->action;

        $usersDb = Core_Model_Users::getInstance();
        $this->_user = $usersDb->find(Zend_Auth::getInstance()->getIdentity()->user_id)->current();

        //TODO: Submenu is now in layout per module, not controller, so should be defined in module, not here.
        $items = array();
        $items[] = array("urlOptions" => array(
            'module' => $module,
            "controller" => "index",
            "action" => "index"),
            "text" => _T('LIST_SETS'),
            "tooltip" => _T('LIST_SETS_TOOLTIP'));
        /*$items[] = array("urlOptions" => array(
            'module' => $module,
            "controller" => 'sets',
            "action" => "add-export-set"),
            "text" => _T('ADD_SOURCE_SET'),
            "tooltip" => _T('ADD_SOURCE_SET_TOOLTIP'));*/
        $items[] = array("urlOptions" => array(
            'module' => $module,
            "controller" => 'sets',
            "action" => "add-store"),
            "text" => _T('ADD_STORE'),
            "tooltip" => _T('ADD_STORE_TOOLTIP'));


        $this->view->submenu = WebReport_Module_MenuItems_Abstract::translate($items);
        $this->view->module = $module;
    }

    public function indexAction()
    {


        $this->view->headTitle("SETS", Zend_View_Helper_Placeholder_Container_Abstract::PREPEND);

        $this->view->title = $this->_translate->_("SETS");
        $request = $this->_request;
        $user = $this->_user;
        $helper = $this->_helper;

        if ($this->_flashMessenger->hasMessages()) {
            $this->view->messages = $this->_flashMessenger->getMessages();
        }
        $cameraSetsDb = new Core_Model_CameraSets();
        if ($user->multi_company) {
            $sets = $cameraSetsDb->fetchAllWithType(Core_Model_CameraSet_CameraSetTypes::STORE);
            $sourceSets = $cameraSetsDb->fetchAllWithType(Core_Model_CameraSet_CameraSetTypes::SOURCE_SET);
        } else {
            $sets = $cameraSetsDb->fetchAllWithTypeAndCompanyId(Core_Model_CameraSet_CameraSetTypes::STORE, $user->company_id);
            $sourceSets = $cameraSetsDb->fetchAllWithTypeAndCompanyId(Core_Model_CameraSet_CameraSetTypes::SOURCE_SET, $user->company_id);
        }
        $this->view->setList = Sets_Model_SetListGenerator::CreateView($sets);
        $this->view->sourceSetList = Sets_Model_SourceSetListGenerator::CreateView($sourceSets);
    }
}
