<?php

class Sets_Model_Api_Method_Sets_GetLocations extends WebReport_Api_Method_Abstract
{
    public function userIsAllowed(Core_Model_User $user)
    {
        return true;
    }

    public function needsAuthentication()
    {
        /*
		  if($_SERVER['REMOTE_ADDR'] == "127.0.0.1" ||
		  $_SERVER['REMOTE_ADDR'] == "::1" ) {
		  return false;
		  }
        */
        return false;
    }

    protected function _get_request_url($p) {
        //$base_url = 'http://www.worldweatheronline.com/feed/search.ashx?';
        $base_url = 'https://api.worldweatheronline.com/free/v1/search.ashx?';
        $params = '';
        $first = true;
        foreach ($p as $key => $value) {
            $params .= ($first ? '' : '&') . $key . '=' . urlencode($value);
            $first = false;
        }
        return $base_url . $params;
    }

    public function call(array $params)
    {
        $request_url = $this->_get_request_url($params['params']);
        $ch = curl_init($request_url);

        $options = array(
                         CURLOPT_RETURNTRANSFER => true,
                         CURLOPT_HTTPHEADER => array('Content-type: application/json'),
                         CURLOPT_SSL_VERIFYPEER => false,
                         CURLOPT_SSL_VERIFYHOST => false
                       );

        $config = Zend_Registry::get('config');

        if (!empty($config->general->httpProxy))
          $options[CURLOPT_PROXY] = $config->general->httpProxy;
        if (!empty($config->general->httpProxyPort))
          $options[CURLOPT_PROXYPORT] = $config->general->httpProxyPort;
        if (!empty($config->general->httpProxyUser) && !empty($config->general->httpProxyPass))
          $options[CURLOPT_PROXYUSERPWD] = $config->general->httpProxyUser . ":" . $config->general->httpProxyPass;

        curl_setopt_array($ch, $options);
        $result = curl_exec($ch);
        if ($result === false) {
          echo json_encode(array("status" => "failed", "msg" => "query_failed"));
        } else { 
          $result_encoding_fix = preg_replace_callback('/\\\\u([0-9a-fA-F]{4})/', function ($match) {
              return mb_convert_encoding(pack('H*', $match[1]), 'UTF-8', 'UCS-2BE');
          }, $result);
          if ($result_encoding_fix) {
              echo utf8_decode($result_encoding_fix);
          } else {
              r_log("Something went wrong with encoding fix, might display broken characters!");
              echo utf8_decode($result);
          }
        }
    }
}
