<?php

class Sets_Model_SourceSetListGenerator extends Core_Model_Generic_AbstractListView
{
    public function getHeaders()
    {
        //TODO shorter version.
        if($this->_user->multi_company) {
            return array(_T("NAME"),_T("COMPANY"),_T("CITY"),_T("REGION"),_T("COUNTRY"),_T("SALES_AREA"),_T("LATEST_COUNT_ERROR"),_T("DAY_START_HOUR"),_T("CONTENT"));
        } else {
            return array(_T("NAME"),_T("CITY"),_T("REGION"),_T("COUNTRY"),_T("SALES_AREA"),_T("LATEST_COUNT_ERROR"),_T("DAY_START_HOUR"),_T("CONTENT"));
        }

    }

    protected function _dataRowToTableRow($row)
    {
        $storeMetaData = $row->getSetMetadataRow();
        $sections = $storeMetaData->getSections();

        $set_contents = $row->getSetContent();
        $accuracyDb = new Core_Model_CameraSet_CameraSetType1SectionAccuracies();

        $count_error_str = "";
        foreach ($sections as $section) {
            $accuracyDb = new Core_Model_CameraSet_CameraSetType1SectionAccuracies();
            $accuracyRow = $accuracyDb->getLatestCountErrorBySection($section->camera_set_type1_section_id);
            if(isset($accuracyRow)){
                if ($section->is_store) {
                    $count_error_str = $count_error_str . $accuracyRow->count_error . "% ";
                } else {
                    $count_error_str = $count_error_str . " [&nbsp;" . $section->name . ":&nbsp;" . $accuracyRow->count_error . "%&nbsp;]";
                }
            } else {
                $count_error_str = "";
            }
        }
        $count_error_str = html_entity_decode($count_error_str);

        if (isset($set_contents["store_camera_names"])) {
            $store_camera_names = $set_contents["store_camera_names"];
        }
        if (isset($set_contents["sections"])) {
            $store_sections = $set_contents["sections"];
        }

        if (!isset($store_sections) && isset($store_camera_names)) {
            $contentStr = implode(", ", $store_camera_names);
        } elseif (!isset($store_sections) && !isset($store_camera_names)) {
            $contentStr = "";
        } else {
            $sections_str = "";
            foreach ($store_sections as $store_section) {
                $section_cameras_str = "";
                if(!empty($store_section["section_camera_names"])){
                    $section_cameras_str = implode(", ", $store_section["section_camera_names"]);
                } else {
                    $section_cameras_str = "";
                }
                $sections_str = $sections_str . " [&nbsp;" . $store_section["name"] . ": " . $section_cameras_str . "&nbsp;] ";
            }
            if (isset($store_camera_names)) {
                $store_cameras_str = implode(", ", $store_camera_names);
            } else {
                $store_cameras_str = "";
            }
            $contentStr = $store_cameras_str
                . " " . $sections_str;
            $contentStr = html_entity_decode($contentStr);
        }

        $salesRegionDb = new Core_Model_CameraSet_CameraSetType1SalesRegions();
        $salesRegion = $salesRegionDb->getNameById($storeMetaData->sales_region_id);

        $companyDB = new Core_Model_Companies();
        $company = $companyDB->getCompany($row->company_id);
        $ret = array(
            $row->name,
            $company->name,
            $storeMetaData->location_city,
            $storeMetaData->location_region,
            $storeMetaData->location_country,
            $salesRegion,
            $count_error_str,
            $storeMetaData->getPrettyDayStartHour(),
            $contentStr,
            );
        if(!$this->_user->multi_company) {
            unset($ret[1]); //Remove company.
        }
        return $ret;
    }

    public function removeText()
    {
        return _T('DO_YOU_REALLY_WANT_TO_REMOVE_THE_STORE_"%1$s"?');
    }

    protected function _dataRowToRowId($row)
    {
        return $row->camera_set_id;
    }

    public function noDataInformation()
    {
        return _T("NO_SOURCE_SETS_CREATED_YET.");
    }

    public function getActions($row)
    {
        $actions = array();
        $actions[] = parent::CreateAction(_T('EDIT_STORE'), 'edit', 'edit', null, null, null, 'sets', 'sets');
        $actions[] = parent::CreateAction(_T('DELETE_STORE'), 'delete', 'delete', null, null, null, 'sets', 'sets');
        return $actions;
    }
}
