<?php

class Sources_Form_AddEditCamera extends UniForm_Form
{

	protected $_action;

	/**
	 * Constructor
	 *
	 * @see Zend_Form
	 * @param mixed $options
	 * @return void
	 */
	public function __construct($action = "add", $options = null)
	{
		$this->_action = $action;
		parent::__construct($options);
	}

	public function init()
	{
		parent::init();

		$name = new UniForm_Form_Element_Text('name');
		$name->setLabel('NAME')
			->setRequired()
			->addFilter('StringTrim')
			->setDescription("EDIT_CAMERA_NAME_DESC");

		$report_warnings = new UniForm_Form_Element_Checkbox('report_warnings');
		$report_warnings->setLabel("REPORT_WARNINGS")
			->setRequired()
			->setDescription("UNCHECK_TO_DISABLE_REPORTING_OF_WARNINGS.");

		$submit = new UniForm_Form_Element_Submit('submit');
		$submit->setLabel('UPDATE');

		$this->addElements(array($name, $serial, $report_warnings));
		$this->addDisplayGroup(array('name','serial','report_warnings'),'camera-info');

		$this->addElements(array($submit));

	}

}
