<?php

class Sources_Form_AddGroupStep2 extends UniForm_Form
{
    protected $_values;
    protected $_users;
    protected $_groups;

    public function __construct($values, $users, $groups, $options = null)
    {
        $this->_values = $values;
        $this->_users = $users;
        $this->_groups = $groups;

        parent::__construct($options);
    }

    public function init()
    {
        parent::init();

        $values = new UniForm_Form_Element_Hidden('values');
        $values->setValue(json_encode($this->_values));

        $users = new UniForm_Form_Element_MultiSelect('users');

        $folder_members = new UniForm_Form_Element_MultiSelect('folder_members');
        $folder_members->setLabel("FOLDER_MEMBERS");

        $creators = new UniForm_Form_Element_MultiCheckbox('creators');
        foreach($this->_users as $user) {
            $folder_members->addMultiOption($user->user_id, $user->getFullName(). ' <span class = email>(' . $user .')</span>');

//            $folder_members->addMultiOption($user->user_id, $user->getFullName());
            $creators->addMultiOption($user->user_id, $user->getFullName());
        }

        $this->addElements(array($values, $folder_members, $creators));
        $this->addDisplayGroup(array('values', 'folder_members', 'creators'), 'group-group');
   
        $submit = new UniForm_Form_Element_Submit('submit');
        $submit->setLabel('SUBMIT');
        
        $this->addElements(array($submit));
    }
}
