<?php

class Sources_Form_EditGroup extends UniForm_Form
{
    protected $_users;
    protected $_group;

    public function __construct($group = null, $options = null)
    {
        $this->_group = $group;

        parent::__construct($options);
    }

    public function init()
    {
        parent::init();

        $name = new UniForm_Form_Element_Text('name');
        $name->setLabel('NAME')
            ->setRequired()
            ->addFilter('StringTrim');

        $description = new UniForm_Form_Element_Textarea('description');
        $description->setLabel('DESCRIPTION')
            ->addFilter('StringTrim');

        if (!$this->_group) {
            throw new WebReport_Exception("Camera group (folder) must be set.");
        }
       
        $this->addElements(array($name, $description));
        $this->addDisplayGroup(array('name','description',), 'group-group');

        $submit = new UniForm_Form_Element_Submit('submit');
        $submit->setLabel('SUBMIT');
        
        $this->addElements(array($submit));
    }
}
