<?php

class Sources_Form_EditGroupUserPermissions extends UniForm_Form
{
    protected $_users;
    protected $_group;

    public function __construct($users, $group = null, $options = null)
    {
        $this->_users = $users;
        $this->_group = $group;

        parent::__construct($options);
    }

    public function init()
    {
        parent::init();

        if (!$this->_group) {
            throw new WebReport_Exception("Camera group (folder) must be set.");
        }

        $folder_members = new UniForm_Form_Element_MultiSelect('folder_members');
        $folder_members->setLabel("FOLDER_MEMBERS");

        $creators = new UniForm_Form_Element_MultiCheckbox('creators');

        foreach($this->_users as $user) {
            $folder_members->addMultiOption($user->user_id, $user->getFullName(). ' <span class = email>(' . $user .')</span>');
            $creators->addMultiOption($user->user_id, $user->getFullName());
        }

        $this->addElements(array($folder_members, $creators));
        $this->addDisplayGroup(array('folder_members', 'creators',), 'group-group');

        $submit = new UniForm_Form_Element_Submit('submit');
        $submit->setLabel('SUBMIT');

        $this->addElements(array($submit));
    }
}
