<?php

class Stereo_Model_Api_Method_Stereo_AddData extends WebReport_Api_Method_Abstract
{
    public function userIsAllowed(Core_Model_User $user)
    {
        return true;
    }

    public function needsAuthentication()
    {
        return false;
    }

    public function call(array $params)
    {
        $data = $this->decryptAndDecodeJSON();
        $time = new DateTime();
        $start = microtime(true);
        try {
            $protocol = Core_Model_Protocols::getWithId($data['protocol']);
            $protocol::addData($data);
        } catch (Exception $e) {
            r_log($e->getMessage());
            throw new WebReport_Exception($e->getMessage());
        }
        $end = microtime(true);
        $execution_time = round($end - $start, 5);
        r_log("Added new Stereo data in $execution_time seconds");
        echo "ok";
        return;
    }
}
