<?php

class Stereo_Model_Api_Method_Stereo_GetLastDate extends WebReport_Api_Method_Abstract
{

    public function userIsAllowed(Core_Model_User $user)
    {
        return true;
    }

    public function needsAuthentication()
    {
        return false;
    }

    public function call(array $params)
    {
        r_log("stereo.GetLastSavedDataTime called");
        $data = $this->decryptAndDecodeJSON();
        try {
            $protocol = Core_Model_Protocols::getWithId($data['protocol']);
            $last_date = $protocol::getLastDataDate($data);
            r_log($last_date);
            if (isset($last_date)) {
                echo '{"status":"CM_OK", "date": "'.$last_date.'"}';
            } else {
                http_response_code(204);
                echo '{"status":"CM_NOT_PRESENT"}';
            }
        } catch (Exception $e) {
            r_log($e->getMessage());
            if (is_a($e, "Unauthorized_Exception")) {
                http_response_code(401);
                echo $e->getMessage();
            } else {
                throw new WebReport_Exception($e->getMessage());
            }
        }
    }
}
