<?php

class AmCharts_Data_Serie
{

	const APPEND = 'append';
	const PREPEND = 'prepend';

	protected $_description;
	protected $_values;
	protected $_options;

	public function __construct($description = "serie", $values = array()) {
		$this->setDescription($description);
		$this->setValues($values);
	}

	public function setDescription($description)
	{
		$this->_description = $description;
	}

	public function getDescription()
	{
		return $this->_description;
	}

	public function setValues($values)
	{
		$values = $this->_convertInputToArray($values);
		$this->_values = $values;
	}

	public function getValues()
	{
		return $this->_values;
	}

	public function addValue($x, $value) {
		if (is_null($x))
			$this->_values[] = $value;
		else
			$this->_values[$x] = $value;
	}

	public function addValues(array $values, $where = self::APPEND)
	{
		$values = $this->_convertInputToArray($values);
		switch ($where) {
			case self::APPEND:
				$this->_data = $this->_data + $values;
				break;
			case self::PREPEND:
				$this->_data = $values + $this->_data;
				break;
			default:
				throw new AmCharts_Exception("Not valid place to put data");
		}
	}

	public function appendValues(array $values)
	{
		$this->addValues($values, self::APPEND);
	}

	public function prependValues(array $values)
	{
		$this->addValues($values, self::PREPEND);
	}

	protected function _convertInputToArray($values)
	{
		if (is_numeric($values)) {
			$values = array($values);
		} else if (is_array($values)) {
		} else {
			throw new AmCharts_Exception("Not valid in data");
		}
		return $values;
	}

	/** 
	 * set amcharts graph options
	 */
	public function setOptions(array $options)
	{
		$this->_options = $options;
	}

	public function getOptions()
	{
		return $this->_options;
	}

}