<?php
class CM_ChartData {

    protected $_legend; //label of serie
    protected $_type; //line, bar, pie...
    protected $_datay; //data points
    protected $_datax;
    protected $_unit;
    protected $_color = NULL;
	protected $_data_type; // counting, pos;
    protected $_graph_type;

    function __construct($type, $datay, $legend, $unit = null, $color = null, $data_type = null, $stackId, $graphtype) {
        $this->_datay = $datay;
        $this->_type = $type;
        $this->_legend = $legend;
        $this->_unit = $unit;
        $this->_color = $color;
		$this->_data_type = $data_type;
        $this->_stackId = $stackId;
        $this->_graph_type = $graphtype;
	}

    function getType() {
        return $this->_type;
    }

    function getY() {
        if(is_null($this->_datay) || count($this->_datay) == 0)
            return array(0);
        return $this->_datay;
    }

    function getLegend() {
        return $this->_legend;
    }

    function getGraphType() {
        return $this->_graph_type;
    }
    
    function hasUnit() {
        return $this->_unit != null && count($this->_unit) > 0;
    }
    
    function getUnit() {
        return $this->_unit;
    }

    function getStackId() {
        return $this->_stackId;
    }
    
    function hasColor() {
        return !is_null($this->_color);
    }

    function getColor() {
        return $this->_color;
    }

    function getColorArray() {
        if(!$this->hasColor())
            return NULL;
        // #ff0000 -> array("r"=>255,"g"=>0, "b"=>0, "alpha" => 1);
        if(strlen($this->_color) == 7) {
            $color = substr($this->_color,1);
        } else {
            $color = $this->_color;
        }

        if(!is_string($color) || strlen($color) != 6 ) {
            throw new WebReport_Exception("invalid format for color");
        }
        
        $c = str_split($color,2);
        return array(
            "R" => hexdec($c[0]),
            "G" => hexdec($c[1]),
            "B" => hexdec($c[2]),
            "Alpha" => 100);
    }

	function getDataType() {
	  return $this->_data_type;
	}

	function hasDataType() {
	  return !is_null($this->_data_type);
	}
}
