<?php

include_once("pChart/class/pData.class.php");
include_once("pChart/class/pDraw.class.php");
include_once("pChart/class/pImage.class.php");


class CM_Charting {

    protected $_width;
    protected $_height;
    protected $_format;
    protected $_title;
    protected $_data; // array of CM_ChartData
    protected $_showValues;
    protected $_translate;

    protected $_yaxis_name;
    const _font = "/fonts/verdana.ttf";//"/fonts/Lucida_Grande_Bold.ttf";

    protected $_basedir;

    public $includeTable;
    
    public function __construct() {
    $this->_translate = Zend_Registry::get('Zend_Translate');
    $this->_format = "png";
    $this->_basedir = dirname(__FILE__);
    $this->_basedir .= "/../pChart";
    $this->_yaxis_name = "Persons";
    $this->_data = array();


    }

    public function setYlabel($label) 
    {
        $this->_yaxis_name = $label;
        return $this;
    }

    public function showValues($showThem){
        $this->_showValues = $showThem;
    }

    public function getYlabel($label)
    {
        return $this->_yaxis_name;
    }

    public function setData($data) {
        $this->_data = $data;
    }

    public function addData($data) {
        $this->_data[] = $data;
    }

    public function setXlabel($labels, $name) {
        $this->_xlabels = $labels;
        $this->_xlabel = $name;
    }

    private function _renderTheme_test()
    {

    }

    private function _simul_alpha($color, $alpha)
    {
        $alpha /= 100.0;

        $ret_color = array();
        $ret_color['R'] = (int) ($alpha*$color['R'] + (1.0-$alpha)*255.0);
        $ret_color['G'] = (int) ($alpha*$color['G'] + (1.0-$alpha)*255.0);
        $ret_color['B'] = (int) ($alpha*$color['B'] + (1.0-$alpha)*255.0);

        return $ret_color;
    }

    public function prep($width, $height, $title=null)
    {
        //TODO remove log
        //$logger= new Zend_Log();
        //$logger->addWriter(new Zend_Log_Writer_Stream('/tmp/charting_log'));
                    

        $graph_data = new pData();
        $colors = array();
        $categories = 0;
        $alpha = 40;

        $chartingData = new pData();
        $chartingData->loadPalette($this->_basedir."/palettes/light.color", TRUE);

        $unit = null;
        $max_yvalue = 0; $max_yvalue_pos = 0;
        $bar_names = array();
        $pos_names = array();
        $cnt_names = array();
        $rightAxisLabel = "UNKNOWN_UNIT";
        $id_to_name = array();

        $is_bar_chart = false;
        foreach ($this->_data as $key => $cdata) {
            error_log("New Data Source: $key ------------------");
            $data_type = $cdata->getDataType();
            $graph_type = $cdata->getGraphType();
            r_log($graph_type, "Graph type..");
            $is_bar_chart = $graph_type == 'bar';
            $is_pos = false;
            $stack_id = $cdata->getStackId();
            r_log($stack_id, "Stack ID is");

            error_log("Data type is $data_type");
            $currency = $cdata->getUnit();
            if($currency) $currency = "($currency)";
            else $currency ="";
            
            $legend = uniqid();
            $id_to_name[$legend] = $cdata->getLegend();
                
            if($data_type == Core_Model_PosData::TYPE_SALES ||
                     $data_type == Core_Model_PosData::TYPE_CONVERSION_RATE ||
                     $data_type == Core_Model_PosData::TYPE_AVERAGE_BASKET_VALUE ||
                     $data_type == Core_Model_PosData::TYPE_TRANSACTIONS) {
                $rightAxisLabel =  $this->_translate->_(Core_Model_PosData::GetTypeDescription($data_type)) . " $currency";
                
                $is_pos = true;
                $pos_names[] = $legend;
            }
            else {
                $cnt_names[] = $legend;
            }

            $chartingData->addPoints($cdata->getY(), $legend);
        
            if(!$is_pos)
                $max_yvalue = max(max($cdata->getY()), $max_yvalue);
            else
                $max_yvalue_pos = max(max($cdata->getY()), $max_yvalue_pos);
        
            // set line width
            $chartingData->setSerieWeight($legend, 1);

            if($cdata->hasColor()) {
                $color = $cdata->getColorArray();
                $color['Alpha'] = 100;
                $chartingData->setPalette($legend, $color);
                $colors[$legend] = $color;
            }
            
            if($cdata->hasUnit())
                $unit = $cdata->getUnit();
                            
            //file_put_contents('/tmp/miniprof',print_r(array("type" => $cdata->getType(),'data' =>$cdata->getY(), "legend" => $legend),true),FILE_APPEND);
            /*switch ($cdata->GetType()) {
            case "line":
            if(!$is_pos)
                $line_names[] = $legend;
            else
                $bar_names[] = $legend;
            $categories++;
            break;
            case "column":
            if(!$is_pos)
                $bar_names[] =    $legend;
            else
                $line_names[] = $legend;
            $categories++;
            break;
            case "pie":
            //$plot = new PieGraph($cdata->getY());
            break;
            default:
            break;*/

            $categories++;

            if($cdata->getType() == 'column' && !$is_pos) {
                $is_bar_chart = true;
            }
        }

        // set cnt data on left axis
        foreach($cnt_names as $cnt_name)
            $chartingData->setSerieOnAxis($cnt_name, 0);

        //Set the left axis name (and units)
        $chartingData->setAxisPosition(0,AXIS_POSITION_LEFT);
        $chartingData->setAxisName(0,$this->_yaxis_name);
        if(count($this->_xlabels) * $categories > 17.0*$width/1400.0 ){
           $chartingData->setAxisDisplay(0,AXIS_FORMAT_METRIC);
        }
           $chartingData->setAxisDisplay(0,AXIS_FORMAT_METRIC);

        // if pos data enable right axis
        if(count($pos_names)) {
            foreach($pos_names as $pos_name) {
                $chartingData->setSerieOnAxis($pos_name, 1);
            }        

            $chartingData->setAxisPosition(1, AXIS_POSITION_RIGHT);
            $chartingData->setAxisName(1,$rightAxisLabel);
            $chartingData->setAxisDisplay(1,AXIS_FORMAT_METRIC);

            // also add alpha to barchart
            foreach(($is_bar_chart ? $cnt_names : $pos_names) as $pos_name)
                $colors[$pos_name]['Alpha'] = 40;
            
        } else {
        }

        // set colors
        foreach($colors as $legend => $color)
            $chartingData->setPalette($legend, $color);

        //$chartingData->setAxisUnit(0,"");
        $labelRotation = 0;
        $legendExtraOffset = 50;
        $legendSize = 100;
        $lineNameFontSize = 14;

        if(count($this->_xlabels) > 14){
            $labelRotation = 90;
            $legendExtraOffset = 120;
        } else if(count($this->_xlabels) > 7){
            $labelRotation = 30;
            $legendExtraOffset = 80;
        }

        $lineNameFontSize = max(11 - count($cnt_names) / 2,7);
                    
        if($categories > 3){
            $legendSize += ($categories - 3) * ($lineNameFontSize);
        }
                    

        //The labels on the x-axis
        //$logger->notice(print_r(array($this->_yaxis_name,$this->_xlabels, $this->_xlabel), true));
        if($this->includeTable)
            foreach(array_keys($this->_xlabels) as $key) $this->_xlabels[$key]="";
        
        $chartingData->addPoints($this->_xlabels, $this->_xlabel);
        
        $chartingData->setAbscissa($this->_xlabel);

        //set up drawing surface
        $chartingSurface = new pImage($width, $height, $chartingData);

        $chartingSurface->setFontProperties(array("FontName"=>$this->_basedir.self::_font,"FontSize"=>20));
        $TextSettings = array("Align"=>TEXT_ALIGN_MIDDLEMIDDLE , "R"=>0, "G"=>0, "B"=>0);
        if(!is_null($title)){
            $chartingSurface->drawText($width/2, 18, $title, $TextSettings);
        }

        //$chartingSurface->setShadow(FALSE);
        
        if($this->includeTable){
            $legendExtraOffset=80;
            $legendSize=100;
        }

        $chartingSurface->setGraphArea(80,50,$width-80,$height-$legendExtraOffset-$legendSize);
        $chartingSurface->setFontProperties(array("R"=>0,"G"=>0,"B"=>0,"FontName"=>$this->_basedir.self::_font,"FontSize"=>9));

        $axisBoundaries = array(0=>array("Min"=>0, "Max"=>ceil($max_yvalue)),
                                1=>array("Min"=>0, "Max"=>ceil($max_yvalue_pos)));
        $Settings = array("Pos"=>SCALE_POS_LEFTRIGHT
                            , "Mode"=>SCALE_MODE_MANUAL
                            , "LabelingMethod"=>LABELING_ALL
                            , "GridR"=>0, "GridG"=>0, "GridB"=>0, "GridAlpha"=>10, "TickR"=>0, "TickG"=>0, "TickB"=>0, "TickAlpha"=>50, "CycleBackground"=>0, "DrawXLines"=>ALL, "DrawSubTicks"=>1, "SubTickR"=>255, "SubTickG"=>0, "SubTickB"=>0, "SubTickAlpha"=>50, "DrawYLines"=>ALL, "ManualScale" => $axisBoundaries, "MinDivHeight"=>round($height/10));
        $labelSkip = floor(count($this->_xlabels) / (40 * $width/1400.0));
        if($labelSkip > 0) $Settings['LabelSkip'] = $labelSkip;

        $Settings['LabelRotation'] = $labelRotation;
        $k = $chartingSurface->drawScale($Settings);

        // draw counting data
        foreach ($pos_names as $pos_name) {
            $chartingData->setSerieDrawable($pos_name, false);
        }
         
        foreach($cnt_names as $cnt_name) {
            $chartingData->setSerieDrawable($cnt_name, true,1);
        }
                    
        error_log("Time to decide! stackid= $stack_id");
        if($is_bar_chart) {
            error_log("Is bar chart, stack id is $stack_id");
            $Config = array("DisplayPos" => LABEL_POS_TOP,"DisplayValues"=>(int)$this->_showValues, "Gradient"=>0, "AroundZero"=>0,    "Surrounding"=>30);
            if($stack_id != 0) {
                error_log("Stacked!");
                $chartingSurface->drawStackedBarChart($Config);
            } else {
                $chartingSurface->drawBarChart($Config);
            }
            $bar_names = $cnt_names;
        }
        else {
            //draw all lines
            $Config = "";
            $chartingSurface->drawLineChart($Config);
        }

        if(count($pos_names)) {
            // disable cnt data and enable pos data
            foreach ($cnt_names as $cnt_name) {
                $chartingData->setSerieDrawable($cnt_name, false);
            }

            foreach ($pos_names as $pos_name) {
                $chartingData->setSerieDrawable($pos_name, true);
            }

            if($is_bar_chart)
                $chartingSurface->drawLineChart("");

            else {
                $Config = array("DisplayPos" => LABEL_POS_TOP,"DisplayValues"=>(int)$this->_showValues, "Gradient"=>0, "AroundZero"=>0,    "Surrounding"=>30);
                $chartingSurface->drawBarChart($Config);
                $bar_names = $pos_names;
            }
        }
                    
        //file_put_contents('/tmp/miniprof',print_r(array('line',count($line_names),count($this->_data)),true),FILE_APPEND);
            
        //enable all for legend
        foreach ($pos_names as $pos_name) {
            $chartingData->setSerieDrawable($pos_name, true);
            $chartingData->setSerieDescription($pos_name, $id_to_name[$pos_name]);
        }

        foreach ($cnt_names as $cnt_name) {
            $chartingData->setSerieDrawable($cnt_name, true);
            $chartingData->setSerieDescription($cnt_name, $id_to_name[$cnt_name]);
        }

        foreach($bar_names as $bar_name) {
            $chartingData->setPalette($bar_name, $this->_simul_alpha($colors[$bar_name], $alpha));
        }
        //legend is left
        $Config = array("Margin"=>5, "Alpha"=>230, "BoxSize"=>5,"R" => 255,"G" => 255, "B" => 255, /*"BorderR" => 50,"BorderG" => 50,"BorderB" => 50,*/
                        "Style"=>LEGEND_ROUND, "Mode"=>LEGEND_VERTICAL, "Family" => LEGEND_FAMILY_CIRCLE,"Style" => LEGEND_ROUND,
                        );
                    
        //TODO warn when box grows to large.
        $chartingSurface->setFontProperties(array("FontName"=>$this->_basedir.self::_font, "FontSize"=>$lineNameFontSize ));
        //$logger->notice(print_r($chartingSurface->DataSet->getData(),true));
        
        if(! $this->includeTable)
            $chartingSurface->drawLegend(80, $height-$legendSize, $Config);
        //$logger->notice(print_r($r,true));
                    
        $this->_chartingSurface = $chartingSurface;
    }

    public function toFile($filename, $width, $height, $title="Chart") {
        $this->prep($width,$height, $title);
        error_log("$width $height $title");
        $this->_chartingSurface->render($filename);
    }

    public function stroke($width, $height, $title="Chart") {
        $this->prep($width,$height, $title);
        $this->_chartingSurface->stroke();
    }
}

