<?php

abstract class CM_Crypt {
	protected $string;

	public function __construct($key, $string = null) {
		$this->setKey($key);

		if ($string != null) {
			$this->setString($string);
		}
	}

	protected function setString($string) {
		if (is_string($string)) {
			$this->string = $string;
		} else {
			throw new Exception('Not valid data input');
		}
	}

	protected function setKey($key) {
		if (is_array($key) && count($key) > 0) {
			$this->key = $key;
		} else {
			throw new Exception('Not valid key');
		}
	}


	// abstract 'save()' method
	abstract protected function encrypt();
	abstract protected function decrypt();

	protected function _swap(&$a, &$b) {
		list($a, $b) = array($b, $a);
	}
}