<?php

require_once 'CM/Crypt.php';


class CM_Crypt_RC4 extends CM_Crypt
{

	protected $state;
	protected $key;

	function encrypt() {}

	function decrypt() {
		$this->state = $this->_keyInit($this->key);
		$out = $this->_xcrypt($this->string);
		return $out;
	}


  /**  Initialize key state using variable length base key  **/
	private function _keyInit($key) {
		$keylen = count($key);

		$state = array();
		$state['eight_byte_key'] = array();

		for ( $i = 255; $i >= 0; $i-- ) {
			$state['eight_byte_key'][$i] = $i;
		}

		$state['a'] = 0;
		$state['b'] = 0;

		for ( $j = $i = 255; $i >= 0; $i-- ) {
			$j += $state['eight_byte_key'][$i] + $key[$i % $keylen];
			$j %= 256;
			$this->_swap( $state['eight_byte_key'][$i], $state['eight_byte_key'][$j] );
		}

		return $state;
	}

  /**  En/decrypt buffer using current key state  **/
	function _xcrypt($inbuf) {
		$outbuf = array();
		$buflen = strlen($inbuf);

		for ( $i = 0; $i < $buflen; $i++ ) {
			$this->state['b'] += $this->state['eight_byte_key'][++$this->state['a']];
			$this->state['b'] %= 256;
			$this->_swap( $this->state['eight_byte_key'][$this->state['a']], $this->state['eight_byte_key'][$this->state['b']] );
			$j = $this->state['eight_byte_key'][$this->state['a']] + $this->state['eight_byte_key'][$this->state['b']];
			$j %= 256;
			$outbuf[$i] = ord( $inbuf[$i] ) ^ $this->state['eight_byte_key'][$j];
			$outbuf[$i] = chr($outbuf[$i]);
		}
		return implode($outbuf);
	}



}
