<?php

require_once 'Thumbnail-v2/thumbnail.inc.php';

class CM_Image {

  protected $_sourcePath;
  protected $_width;
  protected $_height;

  public function __construct($sourcePath) 
  {
    $this->_sourcePath = $sourcePath;

    if (!CM_Filesystem_File::exists($sourcePath)) 
    {
      // @todo throw exception
      exit;
    }
        
    list($this->_width, $this->_height, $type, $attr) = getimagesize($this->_sourcePath);
  
  }

  public function createThumbnail($w = null, $h = null, $destPath = null, $q = 85) 
  {
  
    $thumb = new Thumbnail($this->_sourcePath);

    // if $h is null, calc height from width
    if (is_null($h) && !is_null($w)) 
      $h = $w/$this->_width*$this->_height;    
    
    elseif (!is_null($h) && is_null($w)) 
      $w = $h/$this->_height*$this->_width;    
        
    if (is_null($h) && is_null($w))
      $thumb->resizePercent(50);
    
    
    if (is_null($destPath)) 
      $destPath = $this->_createThumbnailPath();

    $thumb->resize($w, $h);
    $thumb->save($destPath, $q);
    return $destPath;
  }
 
  public function _createThumbnailPath($sourcePath = null) 
  {
    if (is_null($sourcePath)) $sourcePath = $this->_sourcePath;
    $lastSlashPos = strrpos($sourcePath, '/');
    $thumbPath = substr($sourcePath, 0, $lastSlashPos) . '/' . $this->createThumbnailFilename(substr($sourcePath, $lastSlashPos+1));
    return $thumbPath; 
  
  }
  
  public static function createThumbnailFilename($filename)
  {
    $dotPos = strrpos($filename, '.');
    return substr($filename, 0, $dotPos) . '.thumb' . substr($filename, $dotPos);
  }

}