<?php

class CM_Validate_ValueNotEqual extends Zend_Validate_Abstract
{
    const MATCH = 'Match';
    const MISSING = 'Missing';

    protected $_messageTemplates = array(
        self::MATCH => 'Values cannot be equal',
        self::MISSING => 'Dependacy is missing'
    );

    public $depend = '';
    /*protected $_messageVariables = array (
        'dep' => 'depend'
    );*/

    public function isValid($value, $context = null)
    {
        $value = (string) $value;
        $this->_setValue($value);

        if (is_array($context)) {
            if (isset($context[$this->depend])
                && ($value != $context[$this->depend]))
            {
                return true;
            }
        } elseif (is_string($context) && ($value != $context)) {
            return true;
        }

        if ( is_array($context) && !isset($context[$this->depend])) {
            $this->_error(self::MISSING);
        } else {
            $this->_error(self::MATCH);
        }
        return false;
    }
}
