<?php

abstract class Talking_Pdf_Chart_Abstract
{
	
	protected $_frame;

	protected $_settings;
	protected $_data;

	protected $_chartType;

	public function __construct(Talking_Pdf_Frame $frame = null)
	{
		$this->_frame = $frame;

		$className = get_class($this);
		$classNameArr = explode("_", $className);
		$chartType = strtolower($classNameArr[3]);

		$this->_chartType = $chartType;

		$settingsClassName = "Talking_Pdf_Chart_Settings_" . ucfirst($chartType);

		$this->setSettings(new $settingsClassName());

		$dataClassName = "Talking_Pdf_Chart_Data_" . ucfirst($chartType);

		$this->setData(new $dataClassName());

	}

	public function setFrame(Talking_Pdf_Frame $frame)
	{
		$this->_frame = $frame;
	}

	public function getFrame()
	{
		return $this->_frame;
	}

	public function setSettings($settings)
	{
		$this->_settings = $settings;
	}

	public function getSettings()
	{
		if (!$this->_settings) {
			$settingsClass = "Talking_Pdf_Chart_Settings_" . ucfirst($this->_chartType);
			$this->_settings = new $settingsClass();
		}
		return $this->_settings;
	}


	public function setData($data)
	{
		$this->_data = $data;
	}

	public function getData()
	{
		if (!$this->_data) {
			$dataClass = "Talking_Pdf_Chart_Settings_" . ucfirst($this->_chartType);
			$this->_data = new $dataClass();
		}
		return $this->_data;
	}

	abstract function render(Talking_Pdf_Page $page, Talking_Pdf_Frame $frame = null);

}