<?php

class Talking_Rect
{
	protected $_x;
	protected $_y;
	protected $_width;
	protected $_height;

	public function __construct($x, $y, $width, $height)
	{
		$this->_x = $x;
		$this->_y = $y;
		$this->_width = $width;
		$this->_height = $height;
	}

	public function getWidth()
	{
		return $this->_width;
	}

	public function getHeight()
	{
		return $this->_height;
	}

	public function getX()
	{
		return $this->_x;
	}
	
	public function getX1()
	{
		return $this->getX();	
	}
	
	public function getX2()
	{
		return $this->getX()+$this->getWidth();	
	}

	public function getY()
	{
		return $this->_y;
	}

	public function getY1()
	{
		return $this->getY();
	}
	
	public function getY2()
	{
		return $this->getY()+$this->getHeight();	
	}

	public function setWidth($width)
	{
		$this->_width = $width;
		return $this;
	}
	
	public function increaseWidth($val) 
	{
		$this->_width += $val;
		return $this;
	}

	public function decreaseWidth($val) 
	{
		$this->_width -= $val;
		return $this;		
	}

	public function setHeight($height)
	{
		$this->_height = $height;
		return $this;
	}

	public function increaseHeight($val) 
	{
		$this->_height += $val;
		return $this;
	}

	public function decreaseHeight($val) 
	{
		$this->_height -= $val;
		return $this;
	}

    // decrease height in the reverse direction.
    public function decreaseHeight2($val)
    {
        $this->_height -= $val;
        $this->_y += $val;

        return $this;
    }

	public function setX($x)
	{
		$this->_x = $x;
		return $this;
	}

	public function setY($y)
	{
		$this->_y = $y;
		return $this;
	}

	public function translate($x, $y) 
	{
		$this->increaseHeight($x)
			->increaseWidth($y);	
		return $this;
	}

	public function __toString()
	{
		return "width: " . $this->_width . ", height: " . $this->_height . ", x: " . $this->_x . ", y: " . $this->_y . "\n";
	}



}