<?php

/**
 * @see Zend_Controller_Front
 */
require_once 'Zend/Controller/Front.php';

class Talking_View_Helper_BaseUrl
{
    /**
     * Returns site's base url
     *
     * $file is appended to the base url for simplicity
     *
     * @param string $file
     * @return string
     */
    public function baseUrl($file = null)
    {
        // Get baseUrl
        $baseUrl = Zend_Controller_Front::getInstance()->getBaseUrl();

        // Remove trailing slashes
        $file = ($file !== null) ? ltrim($file, '/\\') : null;

        // Build return
        $return = rtrim($baseUrl, '/\\') . (($file !== null) ? ('/' . $file) : '');
        return $return;
    }
}
