<?php

class UniForm_Form_Decorator_UniFormDateInterval extends Zend_Form_Decorator_Abstract
{

    public function render($content)
    {
        $element = $this->getElement();
        if (!$element instanceof UniForm_Form_Element_DateInterval) {
            // only want to render DateInterval elements
            return $content;
        }

        $view = $element->getView();
        if (!$view instanceof Zend_View_Interface) {
            // using view helpers, so do nothing if no view present
            return $content;
        }

			$fromDate = $element->getFromDate();
			$toDate = $element->getToDate();
			
        $name  = $element->getFullyQualifiedName();

        $params = array(
            'size'      => 10,
            'maxlength' => 10,
            'class'		=> 'textInput'
        );

			$from = "";
			$to = "";
			
        $markup = $view->formText($name . '[from]', $from, $params)
                . ' &ndash; ' . $view->formText($name . '[to]', $to, $params);

        switch ($this->getPlacement()) {
            case self::PREPEND:
                return $markup . $this->getSeparator() . $content;
            case self::APPEND:
            default:
                return $content . $this->getSeparator() . $markup;
        }
    }
}
 