<?php
/**
 * Uni-form extension to Zend Framework
 *
 * LICENSE
 *
 * Due to the license of Uni-form these classes are release under a Creative
 * Commons License.
 * 
 * @category   UniForm
 * @package    UniForm_Form
 * @subpackage Decorator
 * @copyright  Copyright (c) 2008 Gustaf Lindqvist (http://www.lookwhostalkingnow.com)
 * @license    http://creativecommons.org/licenses/by-sa/2.5/ Creative Commons License.
 * @version	   0.5
 */

/** Zend_Form_Decorator_Abstract */
require_once 'Zend/Form/Decorator/Abstract.php';

/**
 * UniForm_Form_Decorator_UniFormErrors
 *
 * Any options passed will be used as HTML attributes of the p tag for the errors.
 * 
 */
class UniForm_Form_Decorator_UniFormErrors extends Zend_Form_Decorator_Abstract
{
    /**
     * Render errors.
     * 
     * @param  string $content 
     * @return string
     */
    public function render($content)
    {
        $element = $this->getElement();
        $view    = $element->getView();
        if (null === $view) {
            return $content;
        }

        $errors = $element->getMessages();
        if (empty($errors)) {
            return $content;
        }

        $separator = $this->getSeparator();
        $placement = $this->getPlacement();
        //$errors    = $view->formErrors($errors, $this->getOptions()); 
        $s = '';
        foreach ($errors as $fn => $error) {
          $s .= '<p class="errorField"><strong>' . $error . '</strong></p>';  
        }
        $errors = $s;

        // @todo fix placement

        /*switch ($placement) {
            case self::APPEND:
                return $content . $separator . $errors;
            case self::PREPEND:
          */      return $errors . $separator . $content;
        //}
    }
}
