<?php
ini_set('precision',16); //This is needed to handle the high precisions timestamps for eventdata.

abstract class WebReport_Api_Method_Abstract
{
    public function call(array $params)
    {
        throw new WebReport_Api_Exception("call function must be implemented", WebReport_Api::CODE_INVALID_METHOD);
    }

    public function needsAuthentication()
    {
        return true;
    }

    public function userIsAllowed(Core_Model_User $user)
    {
        return false;
    }

    public function decryptAndDecodeJSON()
    {
        $json_data = $this->decryptStream();
        $f = fopen("/tmp/decrypted_json", "w");
        fputs($f, print_r($json_data, true)); // write the data in the opened file
        fclose($f); // close the file*/
        $data = json_decode($json_data, true);
        if (isset($data)) {
            return $data;
        } else {
            r_log("Something went wrong with JSON decode.");
            throw new WebReport_Api_Exception("Something is wrong with data from application. JSON decode failed");
        }
    }

    public function decodeVersion4($delta = '00:15:00') {
        $stream = $this->decryptStream();
        $data = explode('##', $stream);
        if (count($data) <= 4) {
            return false;
        }
        
        $username = $data[0];
        $pass = $data[1];
        $version = $data[2];
        $cameraName = $data[3];
        $serial = $data[4];
        $cnttime = isset($data[5]) ? $data[5] : null;
        $nbrOfTypes = isset($data[6]) ? $data[6] : 0;

        $cntmp = (new Zend_Date($cnttime, "yyyyMMddHHmmss"));
        $cnttime = $cntmp
            ->sub($delta,Zend_Date::TIMES)
            ->toString('yyyyMMddHHmmss');
        $parsed_serial = substr($serial,0,12);
        $keys = explode("::",$serial);
        if(count($keys) > 1){
            $regcode = $keys[1];
        } else {
            $regcode = "?";
        }
        $d = new stdClass;
        $d->username   = $username;
        $d->pass       = $pass;
        $d->version    = $version;
        $d->cameraName = $cameraName;
        $d->serial     = Core_Model_Cameras::getSerialFromData($data);
        $d->regcode    = Core_Model_Cameras::getRegCodeFromData($data);
        $d->stats      = Core_Model_Cameras::getStatsFromData($data);
        $d->cnttime    = $cnttime;
        $d->nbrOfTypes = $nbrOfTypes;
        $d->fields     = count($data);
        
        $names = explode('::',$d->cameraName);
        if(count($names) > 1){
            $d->cameraName = $names[0];
            for($i = 1; $i < count($names); $i++){
                if(strpos($names[$i],'Empty Region') === false){
                    $d->subnames[] = $names[$i];
                }
            }
        }
        if ($version == '3') {
            return $d;
        }
        if((int)$version > 4) throw new WebReport_Api_Exception("Highest protocol version is 4, you sent $version");
        $d->version = $version;
        $afterData = 6+$d->nbrOfTypes*2;
        return $d;
    }

    public function decryptStream() {
        $inputStream = fopen('php://input','r');
        $encrypted = '';
        while(!feof($inputStream)) {
            $encrypted .= fgets($inputStream);
        }
        fclose($inputStream);
        $encrypted = base64_decode(str_replace(" ","+", $encrypted));
        $license = Zend_Registry::get('config-license');
        $decrypted = cm_decrypt2(
            $license->registrationCode, $license->activationCode, $encrypted
        );
        return $decrypted;
    }
    
}
