<?php

class WebReport_Controller_Helper_Browse {
    const COOKIE_NAME = 'current_folder';
    const DURATION = 3600;

    public function getController($user, $group, $helper, $request, $class, $listGenerator)
    {
        $folder = $request->getParam('folder');
        if(!isset($folder) && isset($_COOKIE[self::COOKIE_NAME])) {
            $helper->redirector($request->getActionName(),
                                $request->getControllerName(),
                                $request->getModuleName(),
                                array('folder' => $_COOKIE[self::COOKIE_NAME]));
        }

        if($group && $group->canView($user)) {
            /*
             * Create list and get objects in Group.
             */
            $objects = $class::fetchDocuments($group);
            $list = $listGenerator::CreateView($objects, $group);
            
            setcookie(self::COOKIE_NAME, $group->group_id, time()+self::DURATION, '/');
        }
        else {
            /*
             * Generate root view.
             */
            $list = $listGenerator::CreateView(NULL, WebReport_View_Helper_GenericListView::ROOT_FOLDER);
            setcookie(self::COOKIE_NAME, 0, time()+self::DURATION, '/');
        }   
        
        return $list;
    }
}
