<?php

abstract class WebReport_Export_Abstract {

	protected $_data;
	protected $_headers;
    protected $_settings;

	public static function factory($format) {
		$class = "WebReport_Export_" . ucfirst(strtolower($format));
		return new $class();
	}

    public function setSettings($settings){
        $this->_settings = array_merge($this->_settings,$settings);
    }

	public function __construct($headers = null, $data = null) {
        $this->_settings = array(
            "nameFirst"    => false,
            "header"       => false,
            "inText"       => false,
            "outText"      => false,
            "kolon"        => false,
            "small-endian" => false,
            "aggregate"    => false,
            "type"         => Export_Model_Exports::COUNT_DATA_EXPORT
        );
		if ($headers) {
			$this->setHeaders($headers);
		}

		if ($data) {
			$this->setData($data);
		}
	}

	public function setData($data)
	{
		$this->_data = $data;
		return $this;
	}

	public function setHeaders($headers)
	{
		$this->_headers = $headers;
		return $this;
	}

	public function getHeaders()
	{
		return $this->_headers;
	}

	public function getData()
	{
		return $this->_data;
	}

	abstract public function render($filename = null);

}

