<?php

class WebReport_Export_Customcsv extends WebReport_Export_Abstract
{

    public function render($filename = null)
    {
        if (!$filename)
            $filename = "WebReport-Csv-" . date("Ymdhis");

        $headers = $this->getHeaders();
        $data = $this->getData();
        ob_start();
        $response = Zend_Controller_Front::getInstance()->getResponse();
        $response->setHeader("Content-Type", "text/plain");
        $response->setHeader("Content-Disposition", 'filename="' . $filename . '.txt"');
        $sources = array_slice($headers, 1);
        $settings = $this->_settings;
        $compact = isset($settings['compact']) && $settings['compact'];;

        if($settings['nameFirst']) $headers  = array("Source", $headers['cnttime'],  "Type", "Count");
        else $headers = array($headers['cnttime'], "Source", "Type", "Count");
        if($compact) {
            $headers[2] = "In";
            $headers[3] = "Out";
        }
        $translate = Zend_Registry::get("Zend_Translate");
        $tIn = $translate->translate("COUNT_TYPE_OUT_IN");
        $tOut = $translate->translate("COUNT_TYPE_OUT_OUT");

        if($settings['header']) echo $settings['header']."\n";
        else echo implode(", ", $headers) . "\n";
        $ck = array_keys($sources);
        foreach ($data as $row) {
            set_time_limit(90);
            $toEcho = array();
            $row = (array)$row;

            if($settings['small-endian']) {
                $str = $row['cnttime'];
                $str[16] = "-";
                $str[13] = "-";
                $str[10] = "-";
                $dates = explode("-", $str);
                 
                //$date2 = (new Zend_Date($row['cnttime'], 'yyyy-MM-dd HH:mm'));
                //$date2 = $date2->toString('dd.MM.yyyy HH:mm');
                $date = $dates[2].".".$dates[1].".".$dates[0]." ".$dates[3].":".$dates[4];
                //if ( $date != $date2 ) throw new Exception("Wrong dates! $date $date2");
            }

            foreach ($ck as $k) {
                $source = $sources[$k];
                $type = "?";
                $sep = ", ";
                $pos = strrpos($source,"(");
                if($pos !== false){
                    $type = substr($source,$pos+1,strlen($source)-$pos-2);
                    $source = substr($source,0,$pos);
                }
                if($compact && $type == 'In') {
                    error_log("Skipping..");
                    continue;
                }
                if($settings['inText'] && $type ==$tIn) $type = $settings['inText'];
                if($settings['outText'] && $type ==$tOut) $type = $settings['outText'];
                $data = array($row['cnttime'], trim($source), $type, $row[$k]);
                if($compact) {
                    $data[2] = $row[str_replace("_out","_in", $k)];
                }
                if($settings['small-endian']){
                    // This is extremly slow, but not used as standard.
                    $data[0] = $date;
                }
                
                if($settings['nameFirst']) {
                    $data = array($data[1],$data[0], $data[2], $data[3]);
                }
                if($settings['kolon']) $sep =";";
                echo  $data[0]  .$sep .
                      $data[1]  .$sep .
                      $data[2]  .$sep .
                      $data[3]  ."\n";
                //$toEcho[] = (array_key_exists($k,$row) &&!is_null($row[$k])) ? $row[$k] : '';
            }
        }
        ob_end_flush();
    }

}
