<?php

class WebReport_Mail extends Zend_Mail
{
    const Subscription = 0;
    const Config = 1;
    const Notification = 2;
    protected $_caller = -1;

    public function setCaller($caller) {
        $this->_caller = $caller;
    }

    public function __construct() {
        parent::__construct("UTF-8");
    }

    public function send($transport = null, $identification = null)
    {
        try {
            parent::send($transport);
        } catch(Zend_Mail_Protocol_Exception $e){
            $logger = Zend_Registry::get('loggers')->getLogger('mail');
            $msg = $e->getMessage();
            $caller = $this->_caller;
            $errorMsg = "";
            $identificationStr = "";
            if ($caller == $this::Subscription) {
                if ($identification) $identificationStr = ' for subscription "' . $identification . '"'; 
                $errorMsg = "Failed sending subscription email" . $identificationStr . ": ";
            } else if ($caller == $this::Config) {
                $errorMsg = "Failed sending email from configuration: ";
            } else if ($caller == $this::Notification) {
                $errorMsg = "Failed sending notification email: ";
                if ( $identification ) {
                    $errorMsg = "Failed sending notification email triggered by $identification: ";
                }
            }

            if(strstr($msg, 'UGFzc3dvcmQ6') !== FALSE) {
                $exc = "Incorrect SMTP settings. Your username/password is probably missing.";
            } else if (strstr($msg, '5.5.2') !== FALSE) {
                $exc = "Could not send, there seems to be an incorrect e-mail address in the list.";
            } else if (strstr($msg, '5.1.2') !== FALSE){
                $exc = "Could not send, there seems to be an incorrect domain in an e-mail address.";
            } else if (strstr($msg, '5.7.1') !== FALSE){
                $exc = "Username and Password not accepted.";
            } else if (strstr($msg, 'No recipient forward path has been supplied') !== FALSE) {
                $exc = "Could not send, the recipient list might be empty or malformed for this e-mail.";
            } else {
                $exc = $msg;
            }
            $logger->notice($errorMsg . $exc);
            throw new WebReport_Exception($errorMsg . $exc);
            throw $e;
        }
    }

}
