<?php

abstract class WebReport_Model_Api_Abstract {

	protected function checkValidParams($params, $necessaryParams) {
		foreach ($necessaryParams as $p) {
			if (!in_array($p, $params)) {
				throw new WebReport_Api_Exception("Invalid parameters - Your request is missing a required parameter.", 6);
			}
		}
	}

    public function __call($name, $arguments) {
		throw new WebReport_Api_Exception("No method with that name in this package.", 3);
    }

	/**
	 * Replaces keys and change them to camelCase
	 * 
	 * @param array $array Original array
	 * @param array $reps Associative with old keys as keys and new keys as values
	 * @return array Array with replaced keys and camelCase
	 */
	protected function _fixArrayKeys($array, $reps) {
		$array = Talking_Toolbox_Array::replaceKeys($array, $reps);
		$return = array();
		foreach($array as $key => $value) {
			$return[Talking_Toolbox_String::toCamel($key)] = $value;
		}
		return $return;

	}

}