<?php

abstract class WebReport_Module_MenuItems_Abstract extends Talking_Db_Table
{
    abstract function getAll();

    public static function filterNotAllowedItems($items)
    {
        $acl = WebReport_Acl::getInstance();
        $allowedItems = array();

        foreach ($items as $key => $item) {
            $route = isset($item['route']) ? $item['route'] : null;
            if(isset($item['deprecated'])){
                $auth = Zend_Auth::getInstance();
                $user = $auth->getIdentity();
                if(isset($user->legacy) && !$user->legacy) continue;
            }
            if ($acl->isUrlOptionsAllowed($item['urlOptions'], $route)) {
                $allowedItems[$key] = $item;
            }
        }
        return $allowedItems;
    }

    public static function translate($items)
    {
        $t = Zend_Registry::get('Zend_Translate');


        if(is_array($items))
            foreach ($items as &$item) {
                $item['text'] = $t->_($item['text']);
                if (isset($item['title']) && $item['title'] !== '') {
                    $item['title'] = $t->_($item['title']);
                }
                if (isset($item['tooltip']) && $item['tooltip'] !== '') {
                    $item['tooltip'] = $t->_($item['tooltip']);
                }
            }
        else
            return $t->_($items);

        return $items;

    }

}
