<?php

class WebReport_TestCase extends Zend_Test_PHPUnit_ControllerTestCase {
    protected $_application;

    public function setUp()
    {
        $this->bootstrap = array($this, 'appBootstrap');
        parent::setUp();
    }

    public function appBootstrap()
    {
        $this->_application = new Zend_Application(APPLICATION_ENVIRONMENT,
            APPLICATION_PATH . '/config.test.ini');

        $this->_application->bootstrap();

        $front = Zend_Controller_Front::getInstance();
        if($front->getParam('bootstrap') === null) {
            $front->setParam('bootstrap', $this->_application->getBootstrap());
        }

        $config = Zend_Registry::get('config');
        $config->database->params->dbname = 'webreport_unit_test';

        Zend_Registry::set('config', $config);
    }

    public function tearDown()
    {
        $this->resetRequest();
        $this->resetResponse();
        parent::tearDown();
    }

    public function loginUser($email, $password)
    {
        $db = Zend_Registry::get('db');
        $authAdapter = new Zend_Auth_Adapter_DbTable($db);
        $authAdapter
            ->setTableName('user')
            ->setIdentityColumn(new Zend_Db_Expr('LOWER(user.email)'))
            ->setCredentialColumn('password')
            ->setCredentialTreatment("MD5(CONCAT('" . STATIC_SALT . "', ?, password_salt)) AND active = '1'");

        $authAdapter
            ->setIdentity($email)
            ->setCredential($password);

        $auth = Zend_Auth::getInstance();

        $result = $auth->authenticate($authAdapter);
            
        if($result->isValid()) {
            $data = $authAdapter->getResultRowObject(null, 'password');

            $auth->getStorage()->write($data); 
        
            return TRUE;
        } else {
            return FALSE;
        }   
    }

    public function logoutUser()
    {   
        Zend_Auth::getInstance()->clearIdentity();
    }
}
