<?php

class WebReport_Time {

    public static function readableTimeAgo($datefrom,$dateto=-1,$skip_seconds=false) {
    		$t = Zend_Registry::get('Zend_Translate');
// Defaults and assume if 0 is passed in that
// its an error rather than the epoch

        if($datefrom<=0) {
            return "A long time ago";
        }
        if($dateto==-1) {
            $dateto = time();
        }

// Calculate the difference in seconds betweeen
// the two timestamps

        $difference = $dateto - $datefrom;

// If difference is less than 60 seconds,
// seconds is a good interval of choice

        if($difference < 60) {
            $interval = "s";
        }

// If difference is between 60 seconds and
// 60 minutes, minutes is a good interval
        elseif($difference >= 60 && $difference<60*60) {
            $interval = "n";
        }

// If difference is between 1 hour and 24 hours
// hours is a good interval
        elseif($difference >= 60*60 && $difference<60*60*24) {
            $interval = "h";
        }

// If difference is between 1 day and 7 days
// days is a good interval
        elseif($difference >= 60*60*24 && $difference<60*60*24*7) {
            $interval = "d";
        }

// If difference is between 1 week and 30 days
// weeks is a good interval
        elseif($difference >= 60*60*24*7 && $difference <
                60*60*24*30) {
            $interval = "ww";
        }

// If difference is between 30 days and 365 days
// months is a good interval, again, the same thing
// applies, if the 29th February happens to exist
// between your 2 dates, the function will return
// the 'incorrect' value for a day
        elseif($difference >= 60*60*24*30 && $difference <
                60*60*24*365) {
            $interval = "m";
        }

// If difference is greater than or equal to 365
// days, return year. This will be incorrect if
// for example, you call the function on the 28th April
// 2008 passing in 29th April 2007. It will return
// 1 year ago when in actual fact (yawn!) not quite
// a year has gone by
        elseif($difference >= 60*60*24*365) {
            $interval = "y";
        }

// Based on the interval, determine the
// number of units between the two dates
// From this point on, you would be hard
// pushed telling the difference between
// this function and DateDiff. If the $datediff
// returned is 1, be sure to return the singular
// of the unit, e.g. 'day' rather 'days'

        switch($interval) {
            case "m":
                $months_difference = floor($difference / 60 / 60 / 24 /
                        29);
                while (mktime(date("H", $datefrom), date("i", $datefrom),
                        date("s", $datefrom), date("n", $datefrom)+($months_difference),
                        date("j", $dateto), date("Y", $datefrom)) < $dateto) {
                    $months_difference++;
                }
                $datediff = $months_difference;

// We need this in here because it is possible
// to have an 'm' interval and a months
// difference of 12 because we are using 29 days
// in a month

                if($datediff==12) {
                    $datediff--;
                }

                $res = ($datediff==1) ? sprintf($t->_("%s month ago"), $datediff) : sprintf($t->_("%s months ago"), $datediff);
                break;

            case "y":
                $datediff = floor($difference / 60 / 60 / 24 / 365);
                $res = ($datediff==1) ? sprintf($t->_("%s year ago"), $datediff) : sprintf($t->_("%s years ago"), $datediff);
                break;

            case "d":
                $datediff = floor($difference / 60 / 60 / 24);
                $res = ($datediff==1) ? sprintf($t->_("%s day ago"), $datediff) : sprintf($t->_("%s days ago"), $datediff);
                break;

            case "ww":
                $datediff = floor($difference / 60 / 60 / 24 / 7);
                $res = ($datediff==1) ?  sprintf($t->_("%s week ago"), $datediff) : sprintf($t->_("%s weeks ago"), $datediff);
                break;

            case "h":
                $datediff = floor($difference / 60 / 60);
                $res = ($datediff==1) ?  sprintf($t->_("%s hour ago"), $datediff) : sprintf($t->_("%s hours ago"), $datediff);
                break;

            case "n":
                $datediff = floor($difference / 60);
                $res = ($datediff==1) ? sprintf($t->_("%s minute ago"), $datediff) : sprintf($t->_("%s minutes ago"), $datediff);
                break;

            case "s":
                $datediff = $difference;
                $res = ($datediff==1) ? sprintf($t->_("%s second ago"), $datediff) : sprintf($t->_("%s seconds ago"), $datediff);
                break;
        }
        if ($interval == "s" && $skip_seconds) {
            $res = $t->_("LESS_THAN_A_MINUTE_AGO");
        }
        return $res;
    }
}