<?php

class WebReport_Validate_Company_UniqueName extends Zend_Validate_Abstract
{
	const NOT_UNIQUE_COMPANY_NAME = 'notUniqueCompanyName';

	protected $_messageTemplates = array(
		self::NOT_UNIQUE_COMPANY_NAME => 'A company with that name already exists'
	);

	public function isValid($value, $context = null)
	{
		$value = (string) $value;
		$this->_setValue($value);



		if (is_array($context)) {
			if (isset($context['current_name'])
				&& (strtolower($value) == strtolower($context['current_name'])))
			{
				return true;
			}
		} elseif (is_string($context) && (strtolower($value) == strtolower($context))) {
			return true;
		}

		$companiesDb = new Core_Model_Companies();
		$company = $companiesDb->fetchRow($companiesDb->select()->where('LCASE(name) = ?', strtolower($value)));

		if (is_null($company)) {
			return true;
		}

		$this->_error(self::NOT_UNIQUE_COMPANY_NAME);
		return false;
	}
}