<?php

class WebReport_Validate_DataExport_SelectFilterGroupOrCompany extends Zend_Validate_Abstract
{
	const NOT_SELECTED = 'notSelected';

	protected $_messageTemplates = array(
		self::NOT_SELECTED => 'One filter group OR application must be selected'
	);

	public function isValid($value, $context = null)
	{
		$applicationId = (int) $value;
		$companyId = (int) $context['company_id'];
		$filterGroupId = (int) $context['count_data_filter_group_id'];

		if ($applicationId == 0 && $filterGroupId > 0) {
			return true;
		} elseif ($applicationId > 0 && $companyId > 0 && $filterGroupId == 0) {
			return true;
		}

		$this->_error(self::NOT_SELECTED);
		return false;
	}
}