<?php

class WebReport_Validate_Database_CountDataTableExists extends Zend_Validate_Abstract
{
	const TABLE_EXISTS = 'tableExists';

	protected $_messageTemplates = array(
		self::TABLE_EXISTS => 'Count data table already exists.'
	);

	public function isValid($value, $context = null)
	{
		$value = (string) $value;
		$this->_setValue($value);

		$database = $context['database'];
		$table = $context['table'];

		if ($context['database'] == '') {
			return true;
		}

		$db = Zend_Registry::get('db');

		$databaseQuoted = $db->quoteIdentifier($database);
		$tableQuoted = $db->quoteIdentifier($table);

		$result = $db->fetchRow("SHOW DATABASES LIKE ?", $database);
		// if database $database doesn't exists $result equals false
		if ($result === false) {
			return true;
		}

		$db->query("USE $databaseQuoted");
		$result = $db->fetchRow("SHOW TABLES LIKE ?", $table);

		$config = Zend_Registry::get('config');

		$webreportDatabase = $config->database->params->dbname;

		$webreportDatabaseQuoted = $db->quoteIdentifier($webreportDatabase);
		$sql = "USE $webreportDatabaseQuoted";

		$db->query($sql);


		/* if $result equals false table doesn't exists */
		if ($result === false) {
			return true;
		}

		$this->_error(self::TABLE_EXISTS);
		return false;
	}
}