<?php

class WebReport_Validate_Database_UserExists extends Zend_Validate_Abstract
{
	const USER_EXISTS = 'userExists';

	protected $_messageTemplates = array(
		self::USER_EXISTS => 'MySQL user already exists.'
	);

	public function isValid($value, $context = null)
	{
		$value = (string) $value;
		$this->_setValue($value);

		$db = Zend_Registry::get('db');

		$select = $db->select()
			->from('user', '*', 'mysql')
			->where("User = ?", $value);

		$user = $db->fetchRow($select);

		if (!$user)
			return true;

		$this->_error(self::USER_EXISTS);
		return false;
	}
}