<?php

class WebReport_Validate_User_UniqueEmailAddress extends Zend_Validate_Abstract
{
	const NOT_UNIQUE = 'notUnique';

	protected $_messageTemplates = array(
		self::NOT_UNIQUE => 'A user with that e-mail already exists'
	);

	public function isValid($value, $context = null)
	{
		$value = (string) $value;
		$this->_setValue($value);

		$users = new Core_Model_Users();

		if (is_array($context)) {
			if (isset($context['current_email'])
				&& (strtolower($value) == strtolower($context['current_email'])))
			{
				return true;
			}
		} elseif (is_string($context) && (strtolower($value) == strtolower($context))) {
			return true;
		}

		$user = $users->fetchRow($users->select()->where('LCASE(email) = ?', strtolower($value)));

		if (is_null($user)) {
			return true;
		}

		$this->_error(self::NOT_UNIQUE);
		return false;
	}
}