<?php

final class WebReport_Version
{
	/**
	 * Cognimatics Web Report version identification - see compareVersion()
	 */
	const VERSION = '1.6.0';

	/*
	 * This is for legacy camera reporting support, camera uses Version.get api too see if it the
	 * instance it reports to has a high enough version number.
	 * For DataManager the CAMERA_API_VERSION in the Version.get api
	 * is used instead of VERSION to get around this.
	 */
	const CAMERA_API_VERSION = '3.4.0';

	/**
	 * Compare the specified Web Report version string $version
	 * with the current WebReport_Version::VERSION of Web Report.
	 *
	 * @param  string  $version  A version string (e.g. "0.7.1").
	 * @return int               -1 if the $version is older,
	 *                           0 if they are the same,
	 *                            and +1 if $version is newer.
	 *
 	 */
	public static function compareVersion($version)
	{
		return version_compare($version, self::VERSION);
	}
}
