<?php

class WebReport_View_Helper_DatepickerBindToSelects
{
  public $view;

  public function datepickerBindToSelects(array $options)
  {
    /* connects datepicker text input with selects */

    $this->view->headScript()->appendFile('/lib/javascript/jquery/plugins/ui.datepicker.js');
    $this->view->headLink()->appendStylesheet('/lib/javascript/jquery/plugins/ui.datepicker.css');

  
    $this->view->headScript()->captureStart(); ?>

$(document).ready(function() {
  $("#<?= $options['linkedDates']; ?>").val($("#<?= $options['yearSelect']; ?>").val() + "-" + 
                       $("#<?= $options['monthSelect']; ?>").val() + "-" + 
                       $("#<?= $options['daySelect']; ?>").val());


  $("#<?= $options['linkedDates']; ?>").datepicker({ 
    minDate: new Date(2001, 1 - 1, 1), 
    maxDate: new Date(2010, 12 - 1, 31), 
    dateFormat: 'yy-mm-dd',
    beforeShow: function() { 
      var selectedDate = $("#<?= $options['yearSelect']; ?>").val() + "-" + 
                       $("#<?= $options['monthSelect']; ?>").val() + "-" + 
                       $("#<?= $options['daySelect']; ?>").val(); 
      $("#<?= $options['linkedDates']; ?>").val(selectedDate);
      return {}; 
    }, 
    onSelect: function (date) { 
      $("#<?= $options['yearSelect']; ?>").val(parseInt(date.substring(0, 4))); 
      $("#<?= $options['monthSelect']; ?>").val(parseInt(date.substring(5, 7))); 
      $("#<?= $options['daySelect']; ?>").val(parseInt(date.substring(8, 10))); 
    }, 
    showOn: "both", 
    buttonImage: "<?= $options['icon']; ?>", 
    buttonImageOnly: true 
  }); 

  $("#<?= $options['yearSelect']; ?>, #<?= $options['monthSelect']; ?>").change(
    function() { 
      var daysInMonth = 32 - new Date($("#<?= $options['yearSelect']; ?>").val(), $("#<?= $options['monthSelect']; ?>").val() - 1, 32).getDate(); 
      $("#<?= $options['daySelect']; ?> option").attr("disabled", ""); 
      $("#<?= $options['daySelect']; ?> option:gt(" + (daysInMonth - 1) +")").attr("disabled", "disabled"); 
      if ($("#<?= $options['daySelect']; ?>").val() > daysInMonth) { 
        $("#<?= $options['daySelect']; ?>").val(daysInMonth); 
      } 
    } 
  );
}); <?php 
    $this->view->headScript()->captureEnd();      
  
  
    return;
  }

  public function setView(Zend_View_Interface $view)
  {
      $this->view = $view;
  }

}
