<?php

if(!isset($group)) {
    $group = WebReport_View_Helper_GenericListView::ROOT_FOLDER;
}

$has_sidebar = TRUE;
$is_root = $group == WebReport_View_Helper_GenericListView::ROOT_FOLDER;

$usersDb = new Core_Model_Users();
$companyDb= new Core_Model_Companies();
$user = $usersDb->find(Zend_Auth::getInstance()->getIdentity()->user_id)->current();
$groupsDb = new Core_Model_Folders();
if($is_root) {
    $company = $companyDb->find($user->company_id)->current();
    $children = $groupsDb->getRootGroups($user);
} else {
    $parent = $group->getParent();
    $company = $companyDb->find($group->company_id)->current();
    $children = $group->getChildren();
    $root_children = $groupsDb->getRootGroups($user, $group->company_id);
}

$request = Zend_Controller_Front::getInstance()->getRequest();

$action = array(
    'module' => $request->getModuleName(),
    'controller' => $request->getControllerName(),
    'action' => $request->getActionName(),
    'folder' => 0
    );

$root_url = $view->url($action, null, true);

/*
 * Get list of parents.
 */
$group_positions = array();
$parents = array();
$companies = array();
$showAllCompanies = $is_root && $user->multi_company;
$backToAll = $user->multi_company && !$is_root;
if(!$is_root) {
    $current = $group->getParent();
    $cache = array($company->company_id =>  array('folders' => $children, 'name' => $company->name));
    while(!is_null($current) && $current->canView($user)) {
        array_unshift($parents, $current);
        $current = $current->getParent();
    }
    if($parent && $parent->canView($user))
        $group_positions[] = array_search($parents[0], $root_children);
    else
        $group_positions[] = array_search($group, $root_children);

    $folders_to_draw = array();
    $folders_to_draw[] = $root_children;

    foreach($parents as $p){
        $p_parent = $p->getParent();
        if(!is_null($p_parent)){
            $p_siblings = iterator_to_array($p_parent->getChildren());
            $folders_to_draw[] = $p_siblings;
            $group_positions[] = array_search($p, $p_siblings);
        }
    }
    if($parent){
        $siblings = iterator_to_array($parent->getChildren());
        $group_positions[] = array_search($group, $siblings);
        $folders_to_draw[] = $siblings;
    }
} else if($user->multi_company){
    $allCompanies = $companyDb->fetchAllActive();
    $cache = array();
    foreach($allCompanies as $c){
        $cache[$c->company_id] = array('folders' => array(), 'name' => $c->name);
    }
    foreach($children as $child){
        $cache[$child->company_id]['folders'][] = $child;
    }
} else {
    $cache = array($company->company_id =>  array('folders' => $children, 'name' => $company->name));
}

/* For debugging
$count = 0;
foreach($folders_to_draw as $ftd){
    r_log($count, "folder level: ");
    foreach($ftd as $f){
        r_log($f->name, "draw: ");
    }
    $count = $count + 1;
}
r_log($group_positions,"group positions: ");
*/
?>
        <div class="directory-listing-container">
            <ul class="directory-listing" id="folder-root">
                <? if($user->multi_company && !$is_root): ?>
                    <a href="<?= $root_url ?>">
                        <li class="folder-all-companies">
                            <p><?= $view->translate("SHOW_ALL_COMPANIES") ?></p>
                        </li>
                    </a>
                <? endif; ?>
                <? foreach($cache as $cid => $comp) : ?>
                    <? if(!$is_root && !$user->multi_company) : ?>
                        <a href="<?= $root_url ?>">
                    <? endif ?>
                    <li class="folder-company<?=$is_root ? "-current" : ( $user->multi_company ? "-current-no-hover" : "")?>">
                        <p><?= false && $backToAll ? $view->translate("SHOW_ALL_COMPANIES"): $comp['name'] ?></p>
                    </li>
                    <? if(!$is_root) : ?>
                        </a>
                    <? endif ?>
                    <? if(!$is_root): ?>
                        <? foreach($folders_to_draw as $index => $ftd): ?>
                            <ul>
                            <? //parent + current level ?>
                                <? foreach ($ftd as $key => $f) : ?>
                                    <?if($key <= $group_positions[$index]): ?>
                                        <? //Draw parent levels folder before current ?>
                                        <?php
                                        $action['folder'] = $f->group_id;
                                        $url = $view->url($action, null, true);
                                        ?>
                                        <? if($f->group_id == $group->group_id): ?>
                                            <a title="<?= $f->name?>" href="<?= $url ?>"><li class="folder-current"><p><?= $f->name ?></p></li></a>
                                                <? //children ?>
                                                <ul>
                                                <? foreach ($children as $c) : ?>
                                                <?php
                                                $action['folder'] = $c->group_id;
                                                $url = $view->url($action, null, true);
                                                ?>
                                                <a href="<?= $url ?>"><li class="folder-child"><p><?= $c->name ?></p></li></a>
                                            <? endforeach; ?>
                                        <? elseif  (in_array($f, $parents)) : ?>
                                            <a title="<?= $f->name?>" href="<?= $url ?>"><li class="folder-parent"><p><?= $f->name ?></p></li></a>
                                        <? else :?>
                                            <a title="<?= $f->name?>" href="<?= $url ?>"><li class="folder-other"><p><?= $f->name ?></p></li></a>
                                        <? endif; ?>
                                    <? endif; ?>
                                <? endforeach; ?>
                        <? endforeach; ?>
                        <? foreach(array_reverse($folders_to_draw,true) as $index => $ftd): ?>
                            </ul>
                            <? foreach ($ftd as $key => $f) : ?>
                                <?if($key > $group_positions[$index]): ?>
                                    <?php
                                    $action['folder'] = $f->group_id;
                                    $url = $view->url($action, null, true);
                                    ?>
                                    <a title="<?= $f->name?>" href="<?= $url ?>"><li class="folder-other"><p><?= $f->name ?></p></li></a>
                                <?endif;?>
                            <? endforeach; ?>
                        <? endforeach; ?>
                    <? else : ?>
                    <ul>
                        <? foreach($cache[$cid]['folders'] as $c): ?>
                            <?php
                            $action['folder'] = $c->group_id;
                            $url = $view->url($action, null, true);
                            ?>
                            <a title="<?= $c->name?>" href="<?= $url ?>"><li class="folder-child"><p><?= $c->name ?></p></li></a>
                        <? endforeach; ?>
                    <? endif; ?>
                        </ul>
                <? endforeach; ?>

        <?php
            $controller = Zend_Controller_Front::getInstance()->getRequest()->getControllerName();
            $showEdit = true;
            if ($controller=="folders"){
                $return_action = "browse";
                $showEdit = false;
            } elseif ($controller=="index"){
                $return_action = "index";
            }
            if (!isset($group) || $group == "root" || $group->group_id == 0) {
                $group_id = 0;
                $showEdit = false;
            } else {
                $group_id = $group->group_id;
            }
        ?>
        <li class="bottom-spacer"></li>
        </ul>
            <div class="directory-listing-options">
                <ul class="options-list">
                    <li>
                    <? if(!$is_root) :?>
                        <a class="awesome gray small" href="<?= $view->url(array('module'=>'sources','controller' => 'folders', 'action' => 'add', 'folder' => $group_id,'return_to'=>$controller,'return_action'=>$return_action)); ?>"><?= $view->translate("ADD_SUBFOLDER") ?></a>
                    <? else :?>
                        <a class="awesome gray small" href="<?= $view->url(array('module'=>'sources','controller' => 'folders', 'action' => 'add', 'folder' => $group_id,'return_to'=>$controller,'return_action'=>$return_action)); ?>"><?= $view->translate("ADD_ROOT_FOLDER") ?></a>
                    </li>
                <? endif; ?>
                    <? if ($showEdit) :?>
                        <li>
                            <a class="awesome gray small" href="<?= $view->url(array('module'=>'sources','controller' => 'folders', 'action' => 'browse', 'folder' => $group_id)); ?>"><?= $view->translate("EDIT_FOLDER") ?></a>
                        </li>
                    <? endif; ?>
                    <? if(!$is_root) :?>
                        <li>
                            <a class="awesome gray small" href="<?= $view->url(array(
                                'controller' => 'data-storage-management',
                                'module' => 'sources',
                                'action' => 'import-cnt-files',
                                )); ?> "><?= $view->translate(_T('IMPORT_TO_FOLDER')) ?></a>
                        </li>
                        <li>
                            <a class="awesome gray small" href="<?= $view->url(array(
                                'controller' => 'data-storage-management',
                                'module' => 'sources',
                                'action' => 'dump-camera-group',
                                )); ?> "><?= $view->translate(_T('EXPORT_FOLDER')) ?></a>
                        </li>
                    <? endif; ?>
                </ul>
            </div>
        </div>
