<?php

class WebReport_View_Helper_GenericListView
{
    const ROOT_FOLDER = 'root';
    const NO_FOLDERS = 'nofolders';

    public $view;

    public function genericListView($list = null, $includeFolderView = true, $skipInitDataTables = false)
    {
        if ($list == null) {
            $list = $this->view->list;
        }
        if (is_array($list)) {
            $this->genericListViews($list, $includeFolderView, $skipInitDataTables);
        } else {
            $translate = Zend_Registry::get('Zend_Translate');
            $view = $this->view;
            if (($group = $list->getGroup()) && $includeFolderView) {
                echo "<table id='directory-layout-table'><tr><td class='directory-listing-cell'>";
                include('GenericFolderViewGenerator.php');
                $this->moveForm = new Admin_Form_MoveDocument($group);
                echo '</td><td class="lists-cell">';
            }
            if (!$skipInitDataTables) {
                $initDataTables = true;
            } else {
                $initDataTables = false;
            }
            if ($list->isEmpty()) {
                echo "<table class='list-empty'><tr class='header'><td></td></tr><tr><td>".$list->translatedNoDataInformation()."</td></tr></table>";
            } else {
                include('GenericListViewGenerator.php');
            }
            if (($group = $list->getGroup()) && $includeFolderView) {
                echo "</td></tr></table>";
            }
        }
    }

	public function genericListViews(array $lists = null, $includeFolderView, $skipInitDataTables = false)
	{
            if($lists == null) {
                $lists = $this->view->list;
            }
            $translate = Zend_Registry::get('Zend_Translate');
            $view = $this->view;
            $empty = true;

            $cnt = count($lists) - 2;

            $first_value = reset($lists);
            $first_key = key($lists);
            if($first_key != "__type"){
                $group = $first_value->getGroup();
            } else {
                $group = $lists['__group'];
            }

            if ($includeFolderView) {
                echo "<table id='directory-layout-table'><tr><td class='directory-listing-cell'>";
                $this->moveForm = new Admin_Form_MoveDocument($group);
                include('GenericFolderViewGenerator.php');
                echo '</td><td class="lists-cell">';
            }

            foreach($lists as $key => $list) {
                if($key == "__type" || $key == "__group") continue;
                $empty = $empty && $list->isEmpty();
                $header = $key;
                if (!$skipInitDataTables) {
                    $initDataTables = ($cnt-- == 1);
                } else {
                    $initDataTables = false;
                }
                include('GenericListViewGenerator.php');
            }

            $dummy = new $lists['__type'];
            if($empty) echo "<table class='list-empty'><tr class='header'><td></td></tr><tr><td>".$dummy->translatednodatainformation()."</td></tr></table>";

            if ($includeFolderView) {
                echo "</td></tr></table>";
            }
	}

	public function setView(Zend_View_Interface $view)
	{
		$this->view = $view;
	}

}
