<?php

class WebReport_View_Helper_Logo
{
	public $view;

	public function logo() {
		$companiesDb = new Core_Model_Companies();
        $company = $companiesDb->find(Zend_Auth::getInstance()->getIdentity()->company_id)->current();
	
        $logoFilename = false;
        $alt = "";
        $width = 0;        

        $config = Zend_Registry::get('config');
        
        if (isset($config->logo) && 
            isset($config->logo->logo_enable) && 
            (bool)$config->logo->logo_enable && 
            isset($config->logo->logo)) {
            $imgPath = APPLICATION_PATH . "/../public/logos/" . $config->logo->logo;
            if (file_exists($imgPath)) {
                $logoFilename = $config->logo->logo;
                list($width, $height) = getimagesize($imgPath);
            }
        } 
        
        // override with ev company logo
        $imgPath = APPLICATION_PATH . "/../public/logos/" . $company->logo_filename;
		if ($company->logo_enable == "1" && file_exists($imgPath)) {
		    list($width, $height) = getimagesize($imgPath);
		    $alt = $company->name . ' ' . $this->view->translate("LOGO");
		    $logoFilename = basename($imgPath);
		}

        $img = "";
        if ($logoFilename) {		
            $img = '<img src="' . $this->view->baseUrl("logos/" . $logoFilename) . '" alt="' . $alt . '" id="company-logo" height="' . min($height, 50) . '" /> ';
        }
		return $img;
	}

	public function setView(Zend_View_Interface $view) {
		$this->view = $view;
	}
}