<?php

class Zend_Config_Writer_IniNice extends Zend_Config_Writer_Ini
{
    private $_allowCreateClean = false;
    public function allowCreateClean() {
        $this->_allowCreateClean = true;
        return $this;
    }
    public function write() {
        $mutex = new Core_Model_Mutex();
        $mutex->init(Core_Model_Mutex::MUTEX_MODIFY_CONFIG);
        
        if($mutex->acquire() == FALSE) throw new WebReport_Exception("Could not require semaphore");
        Zend_Config_Writer_Ini::write();
        if($mutex->release() == FALSE) throw new WebReport_Exception("Could not release semaphore");
    }

    public function render()
    {
        $extends = $this->_config->getExtends();
        $sectionName = $this->_config->getSectionName();
        if(!$sectionName) $sectionName = APPLICATION_ENVIRONMENT;
        // If the current section used is inherited, lets use the inherited instead.
        if(isset($extends[$sectionName])) $sectionName = $extends[$sectionName];
        try {
        $config = new Zend_Config_Ini($this->_filename, null,
            array(
                'skipExtends'=> true,
                'allowModifications' => true
            )
        );
        } catch(Zend_Config_Exception $e) {
            if($this->_allowCreateClean) {
                $config = new Zend_Config(array(), true);
            } else {
                throw $e;
            }
        }

        $config->$sectionName = $this->_config;
        $this->_config = $config;

        $ret = parent::render();

        return $ret;
    }

}
