<?php

define('APPLICATION_ENVIRONMENT', 'development');
// use development to disable cache


// Define path to application directory
defined('APPLICATION_PATH')
    || define('APPLICATION_PATH',
              realpath(dirname(__FILE__) . '/../../application'));

include_once APPLICATION_PATH . '/index-common.php';

try {

	$application->bootstrap(array("db", "modules"));

} catch (Exception $exception) {

	if (defined('APPLICATION_ENVIRONMENT') && APPLICATION_ENVIRONMENT != 'production'  ) {
		echo '<br /><br />' . $exception->getMessage() . '<br />'
		. '<div align="left">Stack Trace:'
		. '<pre>' . $exception->getTraceAsString() . '</pre></div>';
	}

//	exit(1);
}

$autoloader = Zend_Loader_Autoloader::getInstance();
$resourceLoader = new Zend_Loader_Autoloader_Resource(array(
         'basePath' => APPLICATION_PATH . "/modules/installation",
         'namespace' => ucfirst("Installation")
     ));

$resourceLoader->addResourceType('model', 'models/', 'Model');

$db = Zend_Registry::get('db');
$conn = $db->getConnection();

echo Zend_Json::prettyPrint(Installation_Model_AclDbSync::generateJsonFromDb(), array("indent" => " "));
