<?php

// define('APPLICATION_ENVIRONMENT', 'development');
// use development to disable cache

// Define path to application directory
defined('APPLICATION_PATH')
    || define('APPLICATION_PATH',
              realpath(dirname(__FILE__) . '/../../application'));

header("Content-type: text/plain");

include_once APPLICATION_PATH . '/index-common.php';

try {
	$application->bootstrap(array("db", "modules", "translate"));
} catch (Exception $exception) {
	echo '<br /><br />' . $exception->getMessage() . '<br />'
	. '<div align="left">Stack Trace:'
	. '<pre>' . $exception->getTraceAsString() . '</pre></div>';
	exit(1);
}

$cli = php_sapi_name() == 'cli' && !array_key_exists('REMOTE_ADDR', $_SERVER);
$force = false;
if(array_key_exists('argv',$_SERVER)) {
    foreach ($_SERVER['argv'] as $arg){
        $force |= $arg == '-f' || $arg == '--force';
    }
}
if($cli && !$force) {
    echo "You can't run this script using CLI.\n";
    echo "This should be triggered by a http call. Add -f to force.\n";
    return;
}

echo "Sending emails.." . ($force ? "(forced)" : "") . "\n";

$db = Zend_Registry::get('db');
$t = Zend_Registry::get('Zend_Translate');

$users = new Core_Model_Users();
$identity = Zend_Auth::getInstance()->getIdentity();
if($identity && $identity->multi_company != 1){
    echo "You are not a multi company user.\n";
    return;
}
if(!$identity){
    Zend_Auth::getInstance()->getStorage()->write($users->getFirstSuperUser());
    $identity = Zend_Auth::getInstance()->getIdentity();
}


echo "Running script as " . $identity->email . ".\n";
try{
    $conn = $db->getConnection();

    $logger= new Zend_Log();
    $logger->addWriter(new Zend_Log_Writer_Stream('php://output'));

    $a = new Reports_Model_SubscriptionScheduler();
    $a->run($logger);

    Zend_Auth::getInstance()->clearIdentity();
} catch(Exception $e) {
    Zend_Auth::getInstance()->clearIdentity();
    throw $e;
}
echo "Done.\n";
