#!/usr/bin/python
import ConfigParser
import sys

class dict_in_order(dict):
    _mykeys = []
    def __setitem__(self, key, val):
        if not key in self._mykeys:
            self._mykeys.append(key)
        dict.__setitem__(self, key, val)

    def __iter__(self):
        for k in self._mykeys:
            if k in self:
                yield k

    keys=__iter__

    def items(self):
         for k in self:
              yield k, self[k]



def sync(base):
    fn, template_fn = base + '.ini', base + '.template.ini'
    print "Syncing %s with %s" % (fn, template_fn)
    old_config = ConfigParser.ConfigParser(dict_type = dict_in_order)
    old_config.optionxform = str;
    try:
        old_config.readfp(open(fn))
        old_config.write(open(base + '.bak.ini', 'w'))
    except IOError as e:
        pass

    new_config = ConfigParser.ConfigParser(dict_type = dict_in_order)
    new_config.optionxform = str;
    new_config.readfp(open(template_fn, 'r'))

    for sec in new_config.sections():
        if not old_config.has_section(sec):
            print "Adding [%s]" %(sec)
            old_config.add_section(sec)

        try:
            old_keys, unused_ = zip(*old_config.items(sec))
        except ValueError as e:
            old_keys = []

        for new_key, new_value in new_config.items(sec):
            if not new_key in old_keys:
                print "Adding [%s] %s = '%s'" %(sec, new_key, new_value)
                if not new_value: new_value = ""
                old_config.set(sec, new_key, new_value)

    old_config.write(open(fn,'w'))
    print "Wrote %s" %(fn)


if __name__ == '__main__':
    try:
        base = sys.argv[1]
    except IndexError:
        base = '../../application'

    sync(base + '/config')
    sync(base + '/license')

