<?php
//define('APPLICATION_ENVIRONMENT', 'development');
// use development to disable cache

$fail_ok = 0;
$testing = 0;
while(count($argv) > 0) {
    $arg = array_shift($argv);
    switch($arg) {
        case '-t':
          define('APPLICATION_ENVIRONMENT', 'testing');
          $testing = true;
        case '-f':
          $fail_ok = true;
    }
}
// Define path to application directory
defined('APPLICATION_PATH')
    || define('APPLICATION_PATH',
              realpath(dirname(__FILE__) . '/../../application'));

header("Content-type: text/plain");
include_once APPLICATION_PATH . '/index-common.php';


try {
	$application->bootstrap(array("db", "modules", "translate"));
} catch (Exception $exception) {
	echo '<br /><br />' . $exception->getMessage() . '<br />'
	. '<div align="left">Stack Trace:'
	. '<pre>' . $exception->getTraceAsString() . '</pre></div>';
	exit(1);
}

$autoloader = Zend_Loader_Autoloader::getInstance();
$resourceLoader = new Zend_Loader_Autoloader_Resource(array(
         'basePath' => APPLICATION_PATH . "/modules/installation",
         'namespace' => ucfirst("Installation")
     ));

$resourceLoader->addResourceType('model', 'models/', 'Model');

$db = Zend_Registry::get('db');
$t = Zend_Registry::get('Zend_Translate');

$conn = $db->getConnection();

$todos = array('TODO: assert that the connection exists, ie existing database',
                'TODO: check that is is installed');


$logger= new Zend_Log();
$logger->addWriter(new Zend_Log_Writer_Stream('php://output'));
$logger->notice("Lets start updating.");

foreach($todos as $todo)
    $logger->notice($todo);

if(!isset($argv))  $argv = array_keys($_GET);

if($fail_ok) $logger->notice('FAILING_IS_ACCEPTED');
if($testing) $logger->notice('USING_TESTING_ENVIRONMENT');
// update config file
$config = Zend_Registry::get('config');
try {
    $writer = new Zend_Config_Writer_IniNice();
    $writer->setConfig($config)
        ->setFilename(APPLICATION_CONFIG_PATH);
    
    $writer->write();
    $logger->notice("UPDATED_CONFIG_INI");
} catch (Zend_Config_Exception $e) {
    $logger->err("FAILED_UPDATING_CONFIG_INI");
    exit(1);
}
$u = new Installation_Model_DatabaseUpdate($conn, $t, $logger);
$u->sync($logger,$fail_ok);


$logger->notice("RUNNING_ACL_SYNC");
$json_file = APPLICATION_PATH . '/modules/installation/acl/acl.json';

$a = new Installation_Model_AclDbSync($json_file);
$a->sync($logger);
