<?php


define('APPLICATION_ENVIRONMENT', 'development');
// use development to disable cache

// Define path to application directory
defined('APPLICATION_PATH')
    || define('APPLICATION_PATH',
              realpath(dirname(__FILE__) . '/../../application'));

include_once APPLICATION_PATH . '/index-common.php';

try {
        $application->bootstrap(array("db", "modules", "translate"));
} catch (Exception $exception) {
        echo '<br /><br />' . $exception->getMessage() . '<br />'
        . '<div align="left">Stack Trace:'
        . '<pre>' . $exception->getTraceAsString() . '</pre></div>';
        exit(1);
}

$autoloader = Zend_Loader_Autoloader::getInstance();
$resourceLoader = new Zend_Loader_Autoloader_Resource(array(
         'basePath' => APPLICATION_PATH . "/modules/installation",
         'namespace' => ucfirst("Installation")
     ));

$resourceLoader->addResourceType('model', 'models/', 'Model');
$logger= new Zend_Log();
$logger->addWriter(new Zend_Log_Writer_Stream('php://stdout'));

$db = Zend_Registry::get('db');

$conn = $db->getConnection();

$acl = new Core_Model_AclRoles();
$mod = new Core_Model_Modules();

$mod->fixModuleBelonging($logger);
$mod->fixModuleOrder($logger);
$acl->setUpRolesForAllCompanies($logger);




