(function($){

	$.fn.countDataFilters = function(options)
	{

		options = $.extend({
			stringHide : 'Hide',
			stringShow : 'Show',
			stringAdd : 'Add',
			stringRemove : 'Remove',
			stringShowHideFilter : 'Show/Hide filter',
			stringAddFilter : 'Add filter',
			stringRemoveFilter : 'Remove filter',
			stringAddFilterPart : 'Add filter part',
			stringRemoveFilterPart : 'Remove filter part',
			stringFilter : 'Filter',
			stringFilters : 'Filters',
			descriptionsUrl : '/admin/filter-group/get-filters-descriptions/',
			companyId : 0,
			applicationId : 0,
			filters : {}
		}, options);

		$form = $("form.uniForm");
		$wrapperFieldset = $(document.createElement('fieldset-filters')).attr("id", "fieldset-filters").insertAfter("form.uniForm fieldset:last");
		
		$(document.createElement('h3')).text(options.stringFilters).appendTo($wrapperFieldset);

		var $addFilterLink = $(document.createElement('a'))
				.attr({href : "#", id : "add-filter", title : options.stringAddFilter})
				.addClass("awesome")
				.addClass("blue")
				.html("<span>" + options.stringAddFilter + "</span>")
				.click(function(e) {
					e.preventDefault();
					addFilter(e);
					return false;
				});//.appendTo($wrapperFieldset);

		var $addFilterLinkPara = $(document.createElement('p')).css({'position':'relative'}).append($addFilterLink);
		$addFilterLinkPara.appendTo($wrapperFieldset);

		var $filtersDiv = $(document.createElement('div')).attr("id", "filters");
		$filtersDiv.appendTo($wrapperFieldset)

        function setFilterRemoveState() {
            removeclass = 'remove-filter';
            if( $("#filters").children().length <= 1 )
                removeclass += '-disabled';
            $('[class^=remove]').removeClass().addClass(removeclass);
        }

		function addFilter(e) {
			
			var $legend = $(document.createElement('legend')).text(options.stringFilter).prepend(
				$(document.createElement('a')).attr({href : "#", title : options.stringShowHideFilter}).toggle(
					function (e) {
						e.preventDefault();
						$(this).text(options.stringHide).removeClass("show-filter").addClass("hide-filter").parent().parent().find("div.filter-row").slideDown(500);
					},
					function(e) {
						e.preventDefault();
						$(this).text(options.stringShow).removeClass("hide-filter").addClass("show-filter").parent().parent().find("div.filter-row").slideUp(500);
					}
					).trigger('click')
				);

			var $fieldset = $(document.createElement('fieldset')).append($legend).append(
				$(document.createElement('a')).attr("href", "#").addClass("remove-filter").text(options.stringRemove).click(
					function (e) {
						e.preventDefault();
						if ($("fieldset", $(this).parent().parent()).length > 1) {
							$(this).parent().remove();
                            setFilterRemoveState();
						}
					}
				)
			).data("filterId", $.fn.countDataFilters.currentFilterId);
            
			$("#filters").append($fieldset);
            setFilterRemoveState();
            
			$filterRow = createFilterRow($.fn.countDataFilters.currentFilterId, $.fn.countDataFilters.currentFilterRowId);
			$filterRow.appendTo($fieldset);
			
			$.fn.countDataFilters.currentFilterId++;
			return $fieldset;

		}

		function createFilterRow(filterId, rowId) {
			var $filterRow;
			$.ajax({
				cache : false,
				async : false,
				type: "post",
				data : {
					applicationId : options.applicationId,
					companyId : options.companyId
				},
				url: options.descriptionsUrl,
				dataType: "json",
				success: function(filtersDescriptions) {
					$filterRow = _createFilterRow(filtersDescriptions, filterId, rowId);
				}
			});
			$.fn.countDataFilters.currentFilterRowId++;
			return $filterRow;
		
		}


		function _createFilterRow(filtersDescriptions, filterId, rowId) {
			var $filterRow = $(document.createElement('div')).addClass("filter-row");
			var $filterId = createFilterSelect(filtersDescriptions, filterId, rowId).appendTo($filterRow);
			var $conditionId = createConditionsSelect(filtersDescriptions[0].conditions, filterId, rowId).appendTo($filterRow);
			var $conditions = createConditionElements(filtersDescriptions[0].conditions[0].elements, filterId, rowId).appendTo($filterRow);

			$filterId.change(function(e) {
				$.ajax({
					cache : false,
					async : false,
					type: "post",
					url: options.conditionsUrl,
					dataType: "json",
					data : {
						applicationId : options.applicationId,
						companyId : options.companyId,
						filterId : $(this).val()
					},
					success: function(conditions) {
						var $_conditionId = createConditionsSelect(conditions, $(this).data("filterId"), $(this).data("rowId"));
						$("option", $conditionId).remove();
						$("option", $_conditionId).each(function() {
							$(this).clone().appendTo($conditionId);
							$(this).remove();
						});
						$_conditionId.remove();

						var $_conditions = createConditionElements(conditions[0].elements, $filterId.data("filterId"), $filterId.data("rowId")).insertBefore($conditions);
						$conditions.remove();
						$conditions = $_conditions;

					}
				});
			});

			$conditionId.change(function(e) {
				$.ajax({
					cache : false,
					async : false,
					type : "post",
					url : options.conditionElementsUrl,
					dataType : "json",
					data : {
						applicationId : options.applicationId,
						companyId : options.companyId,
						filterId : $filterId.val(),
						conditionId : $(this).val()
					},
					success: function(conditionElements) {
						$_conditions = createConditionElements(conditionElements, $conditionId.prev().data("filterId"), $conditionId.prev().data("rowId")).insertBefore($conditions);
						$conditions.replaceWith($_conditions);
						$conditions = $_conditions;

					}
				});
			});


			var $minusAnchor =  $(document.createElement("a")).text(options.stringRemoveFilterPart).addClass("delete-filterpart").attr({
				href: "#", title: options.stringRemoveFilterPart
			}).click(function(e) {
				e.preventDefault();

				if (!$(this).hasClass("inactive") && $("div.filter-row", $(this).parent().parent()).length > 1) {
					$(this).parent().remove();
				}


				return false;
			});

			var $plusAnchor = $(document.createElement("a")).text(options.stringAddFilterPart).addClass("add-filterpart").attr({
				href: "#", title: options.stringAddFilterPart
			}).click(function(e) {
				e.preventDefault();
				$filterRow = createFilterRow($filterId.data("filterId"), $.fn.countDataFilters.currentFilterRowId++);
				$filterRow.insertAfter($(this).parent());

				$("a.delete-filterpart", $filterRow.parent()).removeClass("inactive");

				return false;
			});

			$filterRow.append($minusAnchor).append($plusAnchor);

			return $filterRow;
		}

		function createFilterSelect(filtersDescriptions, filterId, rowId) {
			var $filterId = $(document.createElement("select"))
			.attr("name", "filters[" + filterId + "][" + rowId + "][filterPartId]")
			$filterId.data("filterId", filterId);
			$filterId.data("rowId", rowId);

			$(filtersDescriptions).each(function(key, val) {
				$filterId.append(
					$(document.createElement("option")).text(val.description).val(val.id).appendTo($filterId)
					);
			});

			return $filterId;
		}

		function createConditionsSelect(conditions, filterId, rowId) {
			var $conditionId = $(document.createElement("select")).attr("name", "filters[" + filterId + "][" + rowId + "][conditionId]");
			$(conditions).each(function(key, val) {
				$(document.createElement("option")).text(val.description).val(val.id).appendTo($conditionId);
			});

			return $conditionId;

		}

		function createConditionElements(elements, filterId, rowId) {
			var elementArr = new Array();
			$(elements).each(function() {
				
				var $cond;
				switch (this.type) {
					case "input":
						$cond = $(document.createElement("input")).attr("name", "filters[" + filterId + "][" + rowId + "][values][]").addClass("textInput");

						break;
					case "select":
						$cond = $(document.createElement("select")).attr("name", "filters[" + filterId + "][" + rowId + "][values][]");
						
						$(this.data).each(function(i, value) {
							var $option = $(document.createElement("option")).text(value.text).val(value.value);
							$cond.append($option);
						});
						break;
					default:
						$cond = $(document.createElement("input"));
						break;
				}
				elementArr.push($cond);
			});

			var $span = $(document.createElement('span'));

			$(elementArr).each(function() {
				$(this).appendTo($span);
			});


			return $span;
		}


		if (!$.isArray(options.filters)) {
			$addFilterLink.trigger('click');
		} else {
			$.each(options.filters, function(i, filter) {
				var $fieldset = addFilter();

				var count = 0;
				$.each(filter, function(i, part) {
					if (count == 0) {
					} else {
						$("a.add-filterpart:last", $fieldset).trigger("click");
					}

					$("div.filter-row:last select:eq(0)", $fieldset).val(part.filterPartId).trigger('change');
					$("div.filter-row:last select:eq(1)", $fieldset).val(part.conditionId).trigger('change');
					var $span = $("div.filter-row:last span", $fieldset);

					$.each(part.values, function(i, val) {
						var $dataElement = $("input, select", $span).eq(i);
						if ($dataElement.get(0).nodeName == "SELECT") {
							if ($("option[value=" + val + "]", $dataElement).length == 0) {
								$(document.createElement("option")).text(val).appendTo($dataElement);
							} 
							$dataElement.val(val);
							
						} else {
							$dataElement.val(val);
						}
					});

					count++;
				});

			});
		}

		$form.submit(function(e) {
			var inputOk = true;
			$("#filters div.filter-row span input").each(function(i, val) {
				var inputValue = $(val).val();
				if ($.trim(inputValue) == '') {
					inputOk = false;
				}
			});

			if (inputOk) {
				return true;
			} else {
				alert('One or more values in your filters are empty.');
				return false;
			}

		});


	}

	$.fn.countDataFilters.currentFilterId = 0;
	$.fn.countDataFilters.currentFilterRowId = 0;

})(jQuery);


