(function($){

	$.fn.formulaEditor = function(options)
	{

		options = $.extend({
			cameras : {},
			types : {},
			form : $("form"),
			missedElementsString : "Some elements are missing, they are marked red in the formula.",
			okString : "Ok",
			errorString : "Error",
			addMore : false,
			nameInputs : false,
            createEmptyElement : true,
			addNewFormulaString : "Add new formula",
			clearFormulaString : "Clear formula",
			deleteFormulaString : "Delete formula",
			formulaNameString : "Formula name"
		}, options);

		element = this;

		options.form.submit(function(e) {
			//e.preventDefault();

			var dialogOpened = false;
			$formulaHolders = $(".formulaHolder");
			$formulaHolders.each(function(formulaNbr) {
				var $this = $(this);
				var $checkEmpty = $(".element", $this);
				var $empty = $checkEmpty.filter(function() {return $(this).html() == '&nbsp;';});
				var namesFilled = true;
				if (options.nameInputs) {
					var name = $.trim($this.next('input').val());
					if (name == "" || $this.next().hasClass('formula-name-dim')) {
						namesFilled = false;
					}
				}
				if ($empty.length > 0 || !namesFilled) {
					if (!namesFilled) {
						$this.next('input').addClass('empty');
					}
					$empty.addClass('emptyElement');
					var dOpts = {};
					dOpts[options.okString] = function() {$(this).dialog("close");}

					if (!dialogOpened) {
						$("<div>" + options.missedElementsString + "</div>").dialog({
							buttons: dOpts,
							title : options.errorString,
							resizable : false,
							draggable : false,
							modal : true
						});
						dialogOpened = true;
					}
				}
			});

			if (!dialogOpened) {
				$formulaHolders.each(function(formulaNbr) {
					var $this = $(this);
					var ret = "";
					$("span", $this).each(function() {
						if ($(this).html() != '&nbsp;') {
							if ($(this).hasClass('element')) {
								var info = $(this).data('info');
								ret += "c" + info.cameraId + "_" + info.type + " ";
							} else {
								ret += $(this).html() + " ";
							}
						}
					});
					var type = '';
					if ($this.attr("type")) {
						type = $this.attr("type");
					}
					$(document.createElement('input')).attr({type : "hidden", name : "formulas[" + type + "]"}).val(ret).appendTo(options.form);
					if (options.nameInputs) {
						var name = $this.next('input').val();
						$(document.createElement('input')).attr({type : "hidden", name : "formulaNames[" + type + "]"}).val(name).appendTo(options.form);
					}

				});
			}
			return !dialogOpened;
		});

		$operators = $(document.createElement('ul')).attr("id", "operators")
				.append($(document.createElement('li')).addClass('ui-state-default ui-corner-all').text('+').attr("rel", "draggable"))
				.append($(document.createElement('li')).addClass('ui-state-default ui-corner-all').text('-').attr("rel", "draggable"))
				.append($(document.createElement('li')).addClass('ui-state-default ui-corner-all').text('/').attr("rel", "draggable"))
				.append($(document.createElement('li')).addClass('ui-state-default ui-corner-all par').text('( )'));
		$operators.appendTo("body").dialog({
			closeOnEscape : false,
			resizable : false,
			title : 'Op.',
			width : 50,
			position : [200, 350],
			dialogClass : 'formula-dialog'
		});


		var $entities = $(document.createElement('ul')).attr("id", "entities");

		$.each(options.cameras, function(i) {
			$.each(options.types, function(j) {
				var $li = $(document.createElement('li')).text(options.cameras[i] + " (" + options.types[j] + ")").data('info', {cameraId : i, type : j});
				$entities.append($li);
			});
		});
		$entities.appendTo("body").dialog({
			closeOnEscape : false,
			resizable : false,
			title : 'Cameras',
			width : 300,
			position : [300, 350],
			dialogClass : 'formula-dialog'
		});

		$("li", $entities).draggable({
			cursor: 'move',
			helper: 'clone',
			snap : '.element',
			snapMode : 'inner',
			appendTo: 'body',
                        cursorAt: {'bottom': 0, 'right': 0},
			start : function() {$.fn.formulaEditor.lastEntity = $(this).data('info');},
			stop : function() {$(".formulaHolder .operation").filter(function() {return ($(this).html() == '&nbsp;');}).hide();}

		});


		$("li", $operators).filter(function() {return !$(this).hasClass('par');}).draggable({
			cursor: 'move',
			helper: 'clone',
			snap : '.operation',
			snapMode : 'inner',
			appendTo: 'body',
                        cursorAt: {'bottom': 0, 'right': 0},
			start : function() {$(".formulaHolder .operation").show();},
			stop : function() {$(".formulaHolder .operation").filter(function() {return ($(this).html() == '&nbsp;');}).hide();}
		});

		$("li.par", $operators).draggable({
			cursor: 'move',
			helper: 'clone',
			snap : '.element',
			snapMode : 'inner',
			appendTo: 'body',
                        cursorAt: {'bottom': 0, 'right': 0},
			stop : function() {$(".formulaHolder .operation").filter(function() {return ($(this).html() == '&nbsp;');}).hide();}
		});


		return this.each(function() {
			var $this = $(this);
            if( options.createEmptyElement )
                $this.append($(document.createElement('span')).addClass('element').html('&nbsp;'));


			$(".formulaHolder .element").livequery(function() {
				$(this).droppable({
					accept: '#entities li, #operators li.par',
					activeClass: 'ui-state-hover',
					drop: function(e, ui) {
						$drag = ui.draggable;
						var cla = $drag.attr("class");

						if ($drag.hasClass('par')) { // paranthesis
							var $leftPara = $(document.createElement('span')).addClass('left-paranthesis').text('(');
							$leftPara.insertBefore(this);
							var $rightPara = $(document.createElement('span')).addClass('right-paranthesis').text(')');
							$rightPara.insertAfter(this);

							if (!$(this).html() != '&nbsp;') { // no element is here
								$(document.createElement('span')).addClass('operation').html('&nbsp;').insertAfter(this);
								$(document.createElement('span')).addClass('operation').html('&nbsp;').insertBefore(this);
							}

							if (!$leftPara.prev().hasClass('operation') && !$leftPara.prev().hasClass('left-paranthesis') && !$leftPara.prev().hasClass('right-paranthesis')) {
								$(document.createElement('span')).addClass('operation').html('&nbsp;').insertBefore($leftPara);
							}
							if (!$rightPara.next().hasClass('operation') && !$leftPara.prev().hasClass('left-paranthesis') && !$leftPara.prev().hasClass('right-paranthesis')) {
								$(document.createElement('span')).addClass('operation').html('&nbsp;').insertAfter($rightPara);
							}

						} else {
							$(this).removeClass('emptyElement');
							$(this).data('info', $.fn.formulaEditor.lastEntity);
							$(this).text($drag.text());

							if (!$(this).prev().hasClass('operation')) {
								$(document.createElement('span')).addClass('operation').html('&nbsp;').insertBefore(this);
							}

							if (!$(this).next().hasClass('operation')) {
								$(document.createElement('span')).addClass('operation').html('&nbsp;').insertAfter(this);
							}
						}

					}
				})
			});


			$(".formulaHolder .operation").livequery(function() {
				$(this).droppable({
					accept : '#operators li[rel=draggable]',
					activeClass: 'ui-state-hover',
					drop : function(e, ui) {
						var $drag = ui.draggable;
						$(this).text($drag.text());

						if (!$(this).prev().hasClass('element')) {
							var $el = $(document.createElement('span')).addClass('element').html('&nbsp;');
							$el.insertBefore(this);
							if ($el.prev().hasClass('right-paranthesis')) {
								var $op = $(document.createElement('span')).addClass('operation').html('+');
								$op.insertBefore($el);
							}
						}

						if (!$(this).next().hasClass('element')) {
							var $el = $(document.createElement('span')).addClass('element').html('&nbsp;');
							$el.insertAfter(this);
							if ($el.next().hasClass('left-paranthesis')) {
								var $op = $(document.createElement('span')).addClass('operation').html('+');
								$op.insertAfter($el);
							}

						}

					}
				});
			});

			var $actionsUl = $(document.createElement('ul')).addClass("formula-actions").addClass("clearfix");
			if (options.addMore) {
				$actionsUl.append($(document.createElement('li')).addClass("add")
					.append($(document.createElement('a')).attr("href", "#").text(options.addNewFormulaString).attr("title", options.addNewFormulaString)
					.click(function(e) {
						e.preventDefault();
						var $clone = $(this).parent().parent().prevAll(".formulaHolder").eq(0).clone();
						$clone.empty().insertAfter($(this).parent().parent()).append($(document.createElement('span')).addClass('element').html('&nbsp;'));
						$(this).parent().parent().clone(true).insertAfter($clone);
						if (options.nameInputs) {
							var $nameInput = $(document.createElement('input')).attr("type", "text").addClass('formula-name').addClass('formula-name-dim').val(options.formulaNameString).focus(function() {$(this).removeClass('empty');if ($(this).hasClass('formula-name-dim')) {$(this).removeClass('formula-name-dim').val('');}}).insertAfter($clone);
						}

					})));
				$actionsUl.append($(document.createElement('li')).addClass("delete").addClass("clearfix")
					.append($(document.createElement('a')).attr("href", "#").text(options.deleteFormulaString).attr("title", options.deleteFormulaString)
					.click(function(e) {
						if ($(".formulaHolder").length > 1) {
							e.preventDefault();
							$(this).parent().parent().prevAll(".formulaHolder").eq(0).remove();
							if (options.nameInputs || !options.createEmptyElement) {
								$(this).parent().parent().prev('input').remove();
							}
							$(this).parent().parent().remove();

						}
					})));

			}
			$actionsUl.append($(document.createElement('li')).addClass("clear").addClass("clearfix")
				.append($(document.createElement('a')).attr("href", "#").text(options.clearFormulaString).text(options.formulaNameString).attr("title", options.clearFormulaString)
				.click(function(e) {
					e.preventDefault();
					$(this).parent().parent().prevAll(".formulaHolder").eq(0).empty().append($(document.createElement('span')).addClass('element').html('&nbsp;'));
				})));

            if( $(this).next('.formula-name').size() == 0 )
                $actionsUl.insertAfter(this);
            else
                $actionsUl.insertAfter($(this).next('.formula-name'));

            
			if (options.nameInputs) {
				var $nameInput = $(document.createElement('input')).attr("type", "text").addClass('formula-name').addClass('formula-name-dim').val(options.formulaNameString).focus(function() {$(this).removeClass('empty');if ($(this).hasClass('formula-name-dim')) {$(this).removeClass('formula-name-dim').val('');}}).insertBefore($actionsUl);
			}
			

		});

	}


$.fn.formulaEditor.lastEntity = {};
}
	
)(jQuery);
