

(function($){
ie7 = false;
if($.browser['msie'] && $.browser['version'] && $.browser['version'].charAt(0) == "7") ie7 = true;

    

    $.fn.hideEffect = function(speed) {
        if (speed == 0) {
            $(this).css("display", "none");
        } else {
            $(this).slideUp(speed);
        }
    }

    $.fn.showEffect = function(speed) {
        if (speed == 0) {
            $(this).css("display", "block");
        } else {
            $(this).slideDown(speed);
        }

    }

    function Page(id, templateId, $table) {

        var page = this;

        this._id = id || false;
        this._landscape = false;
        this._cells = [];
        
        this._templateId = templateId || false;
        if (this._templateId === false) {
            alert('Page: Template id must be set');return;
        }

        this._table = $table || null;
        if (this._table === null) {
            alert('Page: table must be set');return;
        }

        var $tds = $("td", $table);

        $tds.each(function() {
            var $$ = $(this);
            var templateRowCellId = $$.attr("abbr");
            templateRowCellId = parseInt(templateRowCellId.substr(templateRowCellId.lastIndexOf('-')+1), 10);
            var cell = new Cell(false, templateRowCellId, $$);
            page.addCell(cell);
        });

        this._enableTitle = false;
        this._title = "";
        this._titleSize = "medium";
        this._titleAlign = "center";

    }

    Page.prototype = {
        constructor: Page,
        id: (function(){
            function id(_id) {
                return _id == null ? get(this) : set(this, _id);
            }
            function set(self, _id) {
                self._id = _id;
                return self;
            }
            function get(self) {
                return self._id;
            }
            return id;
        }()),
        enableTitle: (function(){
            function enableTitle(_enableTitle) {
                return _enableTitle == null ? get(this) : set(this, _enableTitle);
            }
            function set(self, _enableTitle) {
                self._enableTitle = Boolean(_enableTitle);
                return self;
            }
            function get(self) {
                return self._enableTitle;
            }
            return enableTitle;
        }()),
        
        title: (function(){
            function title(_title) {
                return _title == null ? get(this) : set(this, _title);
            }
            function set(self, _title) {
                self._title = _title;
                return self;
            }
            function get(self) {
                return self._title;
            }
            return title;
        }()),
        titleAlign: (function(){
            function titleAlign(_align) {
                return _align == null ? get(this) : set(this, _align);
            }
            function set(self, _align) {
                self._titleAlign = _align;
                return self;
            }
            function get(self) {
                return self._titleAlign;
            }
            return titleAlign;
        }()),
        titleSize: (function(){
            function titleSize(_size) {
                return _size == null ? get(this) : set(this, _size);
            }
            function set(self, _size) {
                self._titleSize = _size;
                return self;
            }
            function get(self) {
                return self._titleSize;
            }
            return titleSize;
        }()),
        templateId: (function(){
            function templateId(_templateId) {
                return _templateId == null ? get(this) : set(this, _templateId);
            }
            function set(self, _templateId) {
                self._templateId = _templateId;
                return self;
            }
            function get(self) {
                return self._templateId;
            }
            return templateId;
        }()),
        addCell : function(cell) {
            this._cells.push(cell);
            return this;
        },

        cells : function() {
            return this._cells;
        },
        cell : function(templateRowCellId) {
            var ret = false;
            $.each(this._cells, function(i, val) {
                if (this.templateRowCellId() == templateRowCellId) {
                    ret = this;
                    return;
                }
            });
            if (ret === false) {
                alert('Warning! No such cell with template row cell id: ' + templateRowCellId);
            }
            return ret;
        },
        toObject : function() {

            var c = [];
            var cd = this.cells();
            for (var i = 0; i < cd.length; i++) {
                c.push(cd[i].toObject());
            }
            return {
                id : this.id(),
                landscape : this._landscape,
                templateId : this.templateId(),
                enableTitle : this.enableTitle(),
                title : this.title(),
                titleAlign : this.titleAlign(),
                titleSize : this.titleSize(),
                cells : c
            }
        }
    };
    var CHART = 'chart';
    var TEXT = 'text';
    var TABLE = 'table';
    var WARNINGS = 'warnings';
    var DATASOURCE = 'datasource';

    function Cell(id, templateRowCellId, $td) {

        var cell = this;

        this._id = id || 0;

        this._templateRowCellId = templateRowCellId || 0;

        if (this._templateRowCellId === 0) {
            alert('Cell: Template row cell id must be set');return;
        }

        this._td = $td || null;
        if (this._td === null) {
            alert('Cell: td must be set');return;
        }

        this._enableTitle = false;
        this._title = "";
        this._titleSize = "medium";
        this._titleAlign = "center";
        this._countDataSetId = 0;
        this._dateTimeInterval = 0;
        this._manualTimeInterval = 0;
        this._text = "";
        this._aggregator = -1;
        this._type = DATASOURCE;
        this._chartType = "line";
        this._dataSourceId = 0;
        this._includeTable = false;
        this._hasWeather = false;    
        this._weatherEnabled = false;
        this._weatherLocation = "";
        this._weatherTimePeriod = "";
        this._fixedDateIntervalFrom = 0;
        this._tableId = 0;
        this._fixedDateIntervalTo = 0;
    }

    Cell.prototype = {
        constructor: Cell,
        id: (function(){
            function id(_id) {
                return _id == null ? get(this) : set(this, _id);
            }
            function set(self, _id) {
                self._id = _id;
                return self;
            }
            function get(self) {
                return self._id;
            }
            return id;
        }()),
        templateRowCellId : function() {
            return this._templateRowCellId;
        },
        tableId : (function(id) {
            if (id === undefined) {
                return this._tableId;
            } else {
                this._tableId = id;
                return this;
            }
        }),
        type: (function(){
            function type(_type) {
                return _type == null ? get(this) : set(this, _type);
            }
            function set(self, _type) {
                self._type = _type;
                return self;
            }
            function get(self) {
                return self._type;
            }
            return type;
        }()),
        aggregator: (function () {
            function aggregator(_aggregator) {
                return _aggregator == null ? get(this) : set(this, _aggregator);
            }
            function set(self, _aggregator) {
                self._aggregator = _aggregator;
                return self;
            }
            function get(self) {
                return self._aggregator;
            }
            return aggregator;
        }()),
        timeFilter: (function () {
            function timeFilter(_timeFilter) {
                return _timeFilter == null ? get(this) : set(this, _timeFilter);
            }
            function set(self, _timeFilter) {
                self._timeFilter = _timeFilter;
                return self;
            }
            function get(self) {
                return self._timeFilter;
            }
            return timeFilter;
        }()),
        enableTitle: (function(){
            function enableTitle(_enableTitle) {
                return _enableTitle == null ? get(this) : set(this, _enableTitle);
            }
            function set(self, _enableTitle) {
                self._enableTitle = _enableTitle;
                return self;
            }
            function get(self) {
                return self._enableTitle;
            }
            return enableTitle;
        }()),
        title: (function(){
            function title(_title) {
                return _title == null ? get(this) : set(this, _title);
            }
            function set(self, _title) {
                self._title = _title;
                return self;
            }
            function get(self) {
                return self._title;
            }
            return title;
        }()),
        countDataSetId: (function(){
            function countDataSetId(_countDataSetId) {
                return _countDataSetId == null ? get(this) : set(this, _countDataSetId);
            }
            function set(self, _countDataSetId) {
                self._countDataSetId = _countDataSetId;
                return self;
            }
            function get(self) {
                return self._countDataSetId;
            }
            return countDataSetId;
        }()),
        dataSourceId: (function(){
            function dataSourceId(_dataSourceId) {
                return _dataSourceId == null ? get(this) : set(this, _dataSourceId);
            }
            function set(self, _dataSourceId) {
                self._dataSourceId = _dataSourceId;
                return self;
            }
            function get(self) {
                return self._dataSourceId;
            }
            return dataSourceId;
        }()),
        includeTable: (function() {
            function includeTable(_includeTable) {
                return _includeTable == null ? get(this) : set(this, _includeTable);
            }
            function set(self, _includeTable) {
                self._includeTable = _includeTable;
                return self;
            }
            function get(self) {
                return self._includeTable;
            }
            return includeTable;
        }()),
        hasWeather: (function() {
            function hasWeather(_hasWeather) {
                return _hasWeather == null ? get(this) : set(this, _hasWeather);
            }
            function set(self, _hasWeather) {
                self._hasWeather = _hasWeather;
                return self;
            }
            function get(self) {
                return self._hasWeather;
            }
            return hasWeather;
        }()),
        weatherLocation: (function() {
            function weatherLocation(_weatherLocation) {
                return _weatherLocation == null ? get(this) : set(this, _weatherLocation);
            }
            function set(self, _weatherLocation) {
                self._weatherLocation = _weatherLocation;
                return self;
            }
            function get(self) {
                return self._weatherLocation;
            }
            return weatherLocation;
        }()),
        weatherTimePeriod: (function() {
            function weatherTimePeriod(_weatherTimePeriod) {
                return _weatherTimePeriod == null ? get(this) : set(this, _weatherTimePeriod);
            }
            function set(self, _weatherTimePeriod) {
                self._weatherTimePeriod = _weatherTimePeriod;
                return self;
            }
            function get(self) {
                return self._weatherTimePeriod;
            }
            return weatherTimePeriod;
        }()),
        weatherEnabled: (function () {
            function weatherEnabled(_weatherEnabled) {
                return _weatherEnabled == null ? get(this) : set(this, _weatherEnabled);
            }
            function set(self, _weatherEnabled) {
                self._weatherEnabled = _weatherEnabled;
                return self;
            }
            function get(self) {
                return self._weatherEnabled;
            }
            return weatherEnabled;
        }()),
        chartType: (function(){
            function chartType(_chartType) {
                return _chartType == null ? get(this) : set(this, _chartType);
            }
            function set(self, _chartType) {
                self._chartType = _chartType;
                return self;
            }
            function get(self) {
                return self._chartType;
            }
            return chartType;
        }()),
        dateTimeInterval: (function(){
            function dateTimeInterval(_dateTimeInterval) {
                return _dateTimeInterval == null ? get(this) : set(this, _dateTimeInterval);
            }
            function set(self, _dateTimeInterval) {
                self._dateTimeInterval = _dateTimeInterval;
                return self;
            }
            function get(self) {
                return self._dateTimeInterval;
            }
            return dateTimeInterval;
        }()),
        fixedDateIntervalFrom : (function(){
            function fixedDateIntervalFrom(_fixedDateIntervalFrom) {
                return _fixedDateIntervalFrom == null ? get(this) : set(this, _fixedDateIntervalFrom);
            }
            function set(self, _fixedDateIntervalFrom) {
                self._fixedDateIntervalFrom = _fixedDateIntervalFrom;
                return self;
            }
            function get(self) {
                return self._fixedDateIntervalFrom;
            }
            return fixedDateIntervalFrom;
        }()),
        fixedDateIntervalTo : (function(){
            function fixedDateIntervalTo(_fixedDateIntervalTo) {
                return _fixedDateIntervalTo == null ? get(this) : set(this, _fixedDateIntervalTo);
            }
            function set(self, _fixedDateIntervalTo) {
                self._fixedDateIntervalTo = _fixedDateIntervalTo;
                return self;
            }
            function get(self) {
                return self._fixedDateIntervalTo;
            }
            return fixedDateIntervalTo;
        }()),
        manualTimeInterval : (function () {
            function manualTimeInterval(_manualTimeInterval) {
                return _manualTimeInterval == null ? get(this) : set(this, _manualTimeInterval);
            }
            function set(self, _manualTimeInterval) {
                self._manualTimeInterval = _manualTimeInterval;
                return self;
            }
            function get(self) {
                return self._manualTimeInterval;
            }
            return manualTimeInterval;
        }()),
        /* Text functions */
        text: (function(){
            function text(_text) {
                return _text == null ? get(this) : set(this, _text);
            }
            function set(self, _text) {
                self._text = _text;
                return self;
            }
            function get(self) {
                return self._text;
            }
            return text;
        }()),
        $$: (function(){
            function $$(_$$) {
                return _$$ == null ? get(this) : set(this, _$$);
            }
            function set(self, _$$) {
                self._$$ = _$$;
                return self;
            }
            function get(self) {
                return self._$$;
            }
            return $$;
        }()),
        toObject : function() {
            return {
                id : this.id(),
                templateRowCellId : this.templateRowCellId(),
                type : this.type(),
                enableTitle : this.enableTitle(),
                title : this.title(),
                tableId : this.tableId(),
                dataSourceId : this.dataSourceId(),
                includeTable: this.includeTable(),
                hasWeather: this.hasWeather(),
                weatherLocation: this.weatherLocation(),
                weatherTimePeriod: this.weatherTimePeriod(),
                chartType : this.chartType(),
                text : this.text()
            }
        }
    };

    var pages = {};

    var uniqid = (function () {
        var id = 0;return function () {return id++;};
    })();

    function setupGeneralForm(options)
    {
        var strings = options.strings,
        $headerEnable = $("#header_enabled"),
        $headerText = $("#header_text"),
        $includeTable = $("#include_table"),
        $hasWeather = $("#has_weather"),
        $weatherLocation = $("#weather_location"),
        $weatherTimePeriod = $("#weather_time_period"),
        animationSpeed = 0;

        $headerEnable.bind('toggleHeaderEnabled', function() {
            var c = $(this).attr("checked");
            var $els = $headerText.add("#header_align-left").closest("div.ctrlHolder")
                .add("#header_align-label");
            if (c) {
                $els.slideDown(animationSpeed);
            } else {
                $els.slideUp(animationSpeed);
            }
        });
        
        $headerEnable
            .trigger('toggleHeaderEnabled')
            .click(function() {
                $(this).trigger('toggleHeaderEnabled');
            });

        $includeTable.bind('toggleIncludeTable', function() {
            var type = $("input[name=cell_type]:checked").val();

            var c = $(this).attr("checked");
        });

        $includeTable
            .trigger('toggleIncludeTable')
            .click(function () {
                $(this).trigger('toggleIncludeTable');
            });


        $hasWeather.bind('toggleHasWeather', function() {
            var type = $("input[name=cell_type]:checked").val();

            var c = $(this).attr("checked");
            var $loc = $weatherLocation.parent();
            var $tp = $weatherTimePeriod.parent();

            if(c && type == DATASOURCE) {
                $loc.slideDown(animationSpeed);
                $tp.slideDown(animationSpeed);
            } else {
                $loc.slideUp(animationSpeed);
                $tp.slideUp(animationSpeed);
            }    
        });

        $hasWeather
            .trigger('toggleHasWeather')
            .click(function () {
                $(this).trigger('toggleHasWeather');
            });

        var $footerText = $("#footer_text");
        var $footerEnable = $("#footer_enabled")
            .bind('toggleFooterEnabled', function() {

                var c = $(this).attr("checked");
                var $els = $footerText.add("#footer_align-left").closest("div.ctrlHolder")
                    .add("#footer_align-label");
                if (c) {
                    $els.slideDown(animationSpeed);
                } else {
                    $els.slideUp(animationSpeed);
                }
            });
        $footerEnable
            .trigger('toggleFooterEnabled')
            .click(function() {
                $footerEnable.trigger('toggleFooterEnabled');
            });
        var $logo_align = $("[name=logo_align]").parent().parent().parent();
        $logo_align = $logo_align.add($("[name=logo_text]").parent());
        function toggleLogo() {
            if ( $(this).is(":checked") ) {
                $logo_align.slideDown();
            } else {
                $logo_align.slideUp();
            }
        }
        var $logoEnabled = $("#logo_enabled").click(toggleLogo);
        if ( !$logoEnabled.is(":checked") ) {
            $logo_align.hide();
        }
        function disableLogoAlign() {
            var currentHeader = false;
            if ( $("[name=header_enabled]").is(":checked") ) {
                currentHeader = $("[name=header_align]:checked").val();
            }
            var $disabled = $("[name=logo_align]")
                .removeAttr("disabled")
                .filter(function() {
                    return $(this).val() == currentHeader;
                }).attr("disabled","disabled");
            if ( $disabled.is(":checked") ) {
                $disabled.parent().removeClass("selected");
                if ( $disabled.val() == "left") {
                    $("[name=logo_align][value=center]").attr("checked", "checked").parent().addClass("selected");
                } else {
                    $("[name=logo_align][value=left]").attr("checked", "checked").parent().addClass("selected");
                }
            }
        }
        $("[name=logo_align],[name=header_align],[name=logo_enabled],[name=header_enabled]").click(function() {
            disableLogoAlign();
        });
        disableLogoAlign();

        var animationSpeed = 'medium';
    }

    function setupTemplates(options)
    {
        var strings = options.strings;

        // Init new page adder
        var $templates = $("#page-templates").dialog({
            autoOpen : false,
            draggable : false,
            resizable : false,
            modal : true,
            width : 500
        });

        if(ie7) $("td",$templates).css("background-color","#ededed");
        // add new page when clicking on a template table
        $("table", $templates).click(function(e) {
            e.preventDefault();
            var $$ = $(this);
            var templateId = $$.attr("id");
            templateId = parseInt(templateId.substr(templateId.indexOf('-')+1));

            $templates.dialog('close');

            var uid = uniqid();

            var $table = $$.clone().data("uid", uid);
            if(ie7) $("td",$table).css("background-color","eeeeee");
            if(!ie7) $table.removeAttr("id")
            $("td", $table).addClass("empty").each(function() {
                var $td  = $(this).attr("abbr", $(this).attr("id"));
                if(!ie7) $td.removeAttr("id");

            }); // add class that will be removed when populating the cell
            if(!ie7) $("tr").removeAttr("id");


            var page = new Page(false, templateId, $table);

            pages[uid] = page;

            var $pagesList = $("#pages-list");
            if (!$pagesList.length) { // if pages <ul> doesn't exist, create it first
                $pagesList = $("<ul />", {"id" : "pages-list"}).appendTo($("#pages"));
                if(ie7) $("#pages").css("padding-bottom","40px");
                /* FIXME uncomment
                   $pagesList.sortable({
                   placeholder : 'ui-state-highlight',
                   forceHelperSize : true,
                   start : function(e, ui) {
                   $("ul.page-actions", ui.item).slideUp('fast');
                   },
                   stop : function(e, ui) {
                   $("ul.page-actions", ui.item).slideDown('fast');
                   }
                   });*/
            }
            $table.hide();
            var $li = $('<li />').append($table).appendTo($pagesList);

            var $pageActions = $('<ul />', {"class" : "page-actions"})
            //.append($('<li />', {"class" : "edit"}).append($('<a />', {"href" : "#", "title" : strings.Edit, "text" : strings.Edit})))
            //.append($('<li />', {"class" : "preview"}).append($('<a />', {"href" : "#", "title" : strings.Preview, "text" : strings.Preview})))
                .append($('<li />', {"class" : "delete"}).append($('<a />', {"href" : "#", "title" : strings.Delete, "text" : strings.Delete})))
                .append($('<li />', {"class" : "landscape", "style" : "display:none"}).append($('<a />', {"href" : "#", "title" : strings.Landscape, "text" : strings.Landscape, "id" : "landscape"})))
                .append($('<li />', {"class" : "portrait", "style" : "display:none"}).append($('<a />', {"href" : "#", "title" : strings.Portrait, "text" : strings.Portrait, "id" : "landscape"})))
                .appendTo($li).hide();

            if(page._landscape){
                $pageActions.find("li.landscape").show();
                rotateToLandscape($li,$table);
            }else{
                $pageActions.find("li.portrait").show();
            }

            $table.fadeIn(function() {$pageActions.slideDown('slow');});

            return false;
        });



        $("#add-new-page").click(function(e) {
            e.preventDefault();
            $templates.dialog("open");
            return false;
        });


    }

    function setupEditPage(options)
    {
        var strings = options.strings;
        $("#edit-page").hide();
        $("#pages-list li ul.page-actions li.delete a").live("click", function(e) {
            e.preventDefault();
            var $$ = $(this);
            var $pageActions = $$.closest('ul');
            var $li = $pageActions.parent();
            var $table = $li.find('table');
            delete pages[$table.data("uid")];
            $pageActions.slideUp('slow', function() {$(this).remove();$li.hide(0,function() {$(this).remove();})});
            return false;
        });

        $("#landscape").live("click",function(e) {
            e.preventDefault();
            var $$ = $(this);
            var $pageActions = $$.closest('ul');
            var $li = $pageActions.parent();
            var $table = $li.find('table');
            var $landscape_icon = $pageActions.find("li.landscape");
            var $portrait_icon = $pageActions.find("li.portrait");
            if(pages[$table.data("uid")]._landscape==true){
                pages[$table.data("uid")]._landscape=false;
                $landscape_icon.hide();
                $portrait_icon.show(); 
                rotateToPortrait($li,$table); 
            }else{
                pages[$table.data("uid")]._landscape=true;           
                $portrait_icon.hide();  
                $landscape_icon.show();
                rotateToLandscape($li,$table);  
            }
            return false;
        });
    }

    function rotateToPortrait($li,$table){
        
        $li.css({'margin-left' : '0px', 'margin-right': '20px'});

        var browser_prefixes = ['-webkit', '-moz', '-o', '-ms'];
            for (var i=0, l=browser_prefixes.length; i<l; i++) {
                var pfx = browser_prefixes[i]; 
                $table.css(pfx+'-transform', 'rotate(0deg)');
        }
        
        $table.css({'margin-top' : '0px' ,'margin-bottom':'0px'});
    }

    function rotateToLandscape($li,$table){
        $li.css({'margin-left' : '30px', 'margin-right': '50px'});

        var browser_prefixes = ['-webkit', '-moz', '-o', '-ms'];
            for (var i=0, l=browser_prefixes.length; i<l; i++) {
                var pfx = browser_prefixes[i]; 
                $table.css(pfx+'-transform', 'rotate(90deg)');
        }

        $table.css({'margin-top' : '30px' ,'margin-bottom':'-30px'});
        
    }


    function setupEditCell(options)
    {
        var strings = options.strings;
        var show_legacy = false;
        var weather_enabled = false;

        var $dialogButtons = {};

        $('button', $form).each(function () {
            $button = $(this);
            //if(window.console) window.console.log($button.text());
            $dialogButtons[$button.text()] = function () {
                $button.trigger('click');
            };
        }).parent().hide();
        var $editCell = $("#edit-cell").dialog({
            autoOpen : false,
            draggable : true,
            resizable : true,
            modal : !ie7,
            hide: 'slideUp',
            show : 'slideDown',
            width : 600,
            height: 500,
            buttons: $dialogButtons
        });
        $editCell.clearForm = function ($form) {
            $form.styleUniForm();
            this.populateForm(null,$form);
            return this;
        };
        $editCell.updateLayout = function (cell,$form) {
            $timeInterval.change();
        };
        $editCell.populateForm = function (cell,$form) {
    
//            weather_enabled = cell ? cell.weatherEnabled() : false;
            weather_enabled = $("#weather_enabled").attr('value') == 1 ? true : false;

            $("input[name=include_table]:checkbox", $form).attr("checked", cell ? cell.includeTable() : false).trigger('toggleIncludeTable');
            $("input[name=has_weather]:checkbox", $form).attr("checked", cell ? cell.hasWeather() : false).trigger('toggleHasWeather');
            $("input[name=weather_location]", $form).val(cell ? cell.weatherLocation() : '');
            $("select[name=weather_time_period]", $form).val(cell ? cell.weatherTimePeriod() : '');
            $("#cell_type-" + (cell ? cell.type() : (show_legacy ? 'chart' : 'datasource')), $form).attr("checked", true).trigger('change');
            $("#cell_chart_type-" + (cell? cell.chartType() : 'line'), $form).attr("checked", true).trigger('change');
            $("input[name=cell_title_enable]:checkbox", $form).attr("checked", cell ? cell.enableTitle() : false).trigger('toggleCellTitleEnabled');
            $("input[name=cell_title]", $form).val(cell ? cell.title() : '');
            $("select[name=cell_count_data_set_id]", $form).val(cell ? cell.countDataSetId() : 0);
            $("select[name=cell_time_interval]", $form).val(cell ? cell.dateTimeInterval() : 0).trigger('change');
            $("input[name=manual_time_interval]", $form).val(cell ? cell.manualTimeInterval() : '');
            $("input[name=cell_date_interval\\[from\\]]", $form).val(cell ? cell.fixedDateIntervalFrom() : '').trigger('change');
            $("input[name=cell_date_interval\\[to\\]]", $form).val(cell ? cell.fixedDateIntervalTo() : '').trigger('change');
            $("select[name=data_aggregator]", $form).val(cell ? cell.aggregator() : -1);
            $("select[name=time_filter]", $form).val(cell ? cell.timeFilter() : 0).trigger('change');
            $("textarea[name=cell_text]", $form).val(cell ? cell.text() : '');
            $("select[name=data_source_id]", $form).val(cell ? cell.dataSourceId() : 0);
            $("select[name=table_id]").val(cell ? cell.tableId() : 0);
            
            return this;
        };
        $editCell.saveForm = function (cell,$form) {
            var type = $("input[name=cell_type]:checked", $form).val(),
            chartType = $("input[name=cell_chart_type]:checked", $form).val(),
            titleEnabled = $("input[name=cell_title_enable]:checked", $form).is(":checked");

            cell.type(type)
                .chartType(chartType)
                .enableTitle(titleEnabled)
                .tableId($("select[name=table_id]", $form).val())
                .title($("input[name=cell_title]", $form).val())
                .dataSourceId($("select[name=data_source_id]", $form).val())
                .includeTable($("input[name=include_table]:checked", $form).is(":checked"))
                .hasWeather($("input[name=has_weather]:checked", $form).is(":checked"))
                .weatherLocation($("input[name=weather_location]", $form).val())
                .weatherTimePeriod($("select[name=weather_time_period]", $form).val())
                .timeFilter($("select[name=time_filter]", $form).val());
            // This fails in IE8 and IE9. 

            if(cell.type(type).text) 
                cell.type(type).text($("textarea[name=cell_text]", $form).val());

            var $$ = currentCell.$$();
            this.clearForm($form);

            $$.removeClass("line-chart column-chart pie-chart warnings text table empty error datasource");
            if (type == TEXT || type == TABLE || type == WARNINGS  || type == DATASOURCE) {
                $$.addClass(type);
            } else {
                $$.addClass(chartType + '-' + type);
            }
            return this;
        };

        var currentCell = null;
        var $form = $("#edit-cell-form");
        $form.find("button").click(function(e) {
            e.preventDefault();
            var d = $form.serialize();
            d += "&_class=Reports_Form_ReportAdd_TemplateCell&_param1=" + options.companyId;

            $.ajax({
                url : options.formValidateUrl,
                type : 'post',
                dataType : 'json',
                cache : false,
                data : d,
                error : function(e) {
                    if(window.console) window.console.log("error");
                },
                success : function(res) {
                    if (res.valid) {
                        $form.styleUniForm(); // to remove all errors
                        $editCell.saveForm(currentCell,$form);
                        $editCell.dialog('close');
                    } else {
                        var errs = (res.errors ? res.errors : {});
                        $form.styleUniForm({errors : errs});
                    }
                }
            });


            return false;
        });

        //weird freaking ff bug
        //$editCell.parent().css('overflow','auto');
        var animationSpeed = 0;

        var $countDataSet   = $("#cell_count_data_set_id"),
        $countDataSetHolder = $("#cell_count_data_set_id").parent(),
        $dataSourceHolder   = $("#data_source_id").parent(),
        $tableHolder        = $("#table_id").parent(),
        $timeInterval       = $("#cell_time_interval"),
        $startTime          = $("#cell_date_interval-from"),
        $endTime            = $("#cell_date_interval-to"),
        $manualTime         = $("#manual_time_interval"),
        $titleEnable        = $("#cell_title_enable"),
        $includeTableHolder = $("#include_table").parent(),
        $hasWeatherHolder   = $("#has_weather").parent(),
        $weatherLocationHolder      = $("#weather_location").parent();
        $weatherTimePeriodHolder    = $("#weather_time_period").parent();
        $titleText          = $("#cell_title");

        /*$countDataSet.change(function(e) {
          e.preventDefault();
          $.ajax({
          url : options.timeIntervalsUrl,
          type : 'post',
          data : {countDataSetId : $(this).val()}
          });
          return false;
          });*/

        $titleEnable.bind('toggleCellTitleEnabled', function() {
            var c = $(this).attr("checked");
            var $els = $titleText.closest("div.ctrlHolder");
            if (c) {
                $els.showEffect(animationSpeed);
            } else {
                $els.hideEffect(animationSpeed);
            }
        });


        $titleEnable
            .trigger('toggleCellTitleEnabled')
            .click(function() {
                $(this).trigger('toggleCellTitleEnabled');
            });


        $timeInterval.change(function(e) {
            if ($(this).val() == 'fix') {
                $startTime.parent().showEffect(0);
            } else {
                $startTime.parent().hideEffect(0);
            }
            if ($(this).val() == 'man') {
                $manualTime.parent().showEffect(0);
            } else {
                $manualTime.parent().hideEffect(0);
            }
            if($(this).is(":visible") == false) {
                $startTime.parent().hideEffect(0);
                $manualTime.parent().hideEffect(0);
            }
        }).trigger('change');

        $startTime.datepicker({
            dateFormat : 'yy-mm-dd',
            minDate : new Date() -  365*24*60*60*1000,
            maxDate : new Date(),
            onClose : function() {
                $endTime.datepicker('option', 'minDate', $startTime.datepicker('getDate'));
            }
        });

        $endTime.datepicker({
            dateFormat : 'yy-mm-dd',
            minDate : new Date() - 365*24*60*60*1000,
            maxDate : new Date(),
            onClose : function() {
                $startTime.datepicker('option', 'maxDate', $(this).datepicker('getDate'));
            }
        });


        var $chartTableHolders = $countDataSet.parent()
            .add($startTime.closest("div.ctrlHolder"))
            .add($timeInterval.parent());

        var $chartHolders = $("#cell_chart_type-line").closest("div.ctrlHolder");
        var $text = $("#cell_text");

        var $textHolders = $text.parent();

        var $aggregator = $("#data_aggregator");
        var $aggregatorHolder = $aggregator.parent();
        var $timefilter = $("#time_filter");
        var $timefilterHolder = $timefilter.parent();
        $("input[name=cell_type]", $form).change(function() {
            var $$ = $(this);
            var v = $$.val();

            if(!weather_enabled) {
                $hasWeatherHolder.hide();
                $weatherLocationHolder.hide();
                $weatherTimePeriodHolder.hide();
            }

            if (v === TEXT) {
                $textHolders.showEffect(animationSpeed);
                $chartTableHolders.add($chartHolders).hideEffect(animationSpeed);
                $aggregatorHolder.hideEffect(animationSpeed);
                $timefilterHolder.hideEffect(animationSpeed);
                $dataSourceHolder.hide();
                $includeTableHolder.hide();
                $tableHolder.hide();                

                if(weather_enabled) {                
                    $hasWeatherHolder.hide();
                    $weatherLocationHolder.hide();
                    $weatherTimePeriodHolder.hide();
                }
            } else if (v === TABLE) {
                $([])
                    .add($dataSourceHolder)
                    .add($includeTableHolder)
                    .add($aggregatorHolder)
                    .add($hasWeatherHolder)
                    .add($textHolders)
                    .add($weatherLocationHolder)
                    .add($weatherTimePeriodHolder)
                    .hide();
                $tableHolder.fadeIn();

            } else if (v === CHART) {
                $timefilterHolder.showEffect(animationSpeed);
                $aggregatorHolder.showEffect(animationSpeed);
                $textHolders.hideEffect(animationSpeed);
                $chartTableHolders.showEffect(animationSpeed);
                $timeInterval.trigger('change');
                $tableHolder.hide();                

                $dataSourceHolder.hide();

                if(weather_enabled) {
                    $hasWeatherHolder.hide();
                    $weatherLocationHolder.hide();
                    $weatherTimePeriodHolder.hide();
                }
                
                show_legacy = true;
                $("label[for=cell_type-chart]").show();
                $chartHolders.showEffect(animationSpeed);
            } else if (v === WARNINGS) {
                $aggregatorHolder.hideEffect(animationSpeed);
                $timefilterHolder.hideEffect(animationSpeed);
                $chartTableHolders.hideEffect(animationSpeed);
                $chartHolders.hideEffect(animationSpeed);
                $textHolders.hideEffect(animationSpeed);
                $dataSourceHolder.hide();
                $includeTableHolder.hide();

                if(weather_enabled) {
                    $hasWeatherHolder.hide();
                    $weatherLocationHolder.hide();
                    $weatherTimePeriodHolder.hide();
                }
                $tableHolder.hide();
            }
            else if (v === DATASOURCE ) {
                $aggregatorHolder.hide();
                $timefilterHolder.hide();
                $chartTableHolders.hide();
                $chartHolders.hide();
                $textHolders.hide();
                $dataSourceHolder.show();
                $includeTableHolder.show();
                $tableHolder.hide();

                if(weather_enabled) {
                    $hasWeatherHolder.show();
                    
                    if($("#has_weather").is(":checked")) {
                        $weatherLocationHolder.show();
                        $weatherTimePeriodHolder.show();
                    } else {
                        $weatherLocationHolder.hide();
                        $weatherTimePeriodHolder.hide();
                    }
                }
                
                if(show_legacy){
                    $("label[for=cell_type-chart]").show();
                }else {
                    $("label[for=cell_type-chart]").hide();
                }
            }
            $timeInterval.trigger('change');
        });


        $("#pages-list li table td").live("click", function(e) {
            
            e.preventDefault();

            var $$ = $(this);
            var $table = $$.closest("table");
            var page = pages[$table.data("uid")];

            var id = $$.attr("abbr");
            templateRowCellId = parseInt(id.substr(id.lastIndexOf("-")+1), 10);
            var cell = page.cell(templateRowCellId);
            cell.$$($$);
            currentCell = cell;
            $editCell.populateForm(cell,$form);
            $editCell.dialog("open");
            
            $editCell.updateLayout(cell,$form);

            /*
             * TODO: make relay
             */

            $("#weather_location").autocomplete({
                source: function( request, response ) {
                    $.ajax({
                        url: "/webreport/api/?method=reports.GetLocations",
                        dataType: "json",
                        data: {
                            key : "0312ed3806144505120407",
                            query: request.term,
                            format: "json"
                        },
                        success: function( data ) {
                            if(data.search_api != null)
                                response( $.map( data.search_api.result, function( item ) {

                                    var areaName = item.areaName[0].value;
                                    
                                    if(item.region)
                                        var region = item.region[0].value;
                                    else
                                        var region = false;
                                    
                                    var country = item.country[0].value;
                                    
                                    var coord =  item.latitude + ',' + item.longitude;
                                    return {
                                        label: areaName + ', ' + (region ? region + ', ' : '') + country,
                                        value: coord + ' (' + areaName + ')'
                                    }
                                }));
                        }
                    });
                }
            });
            
            return false;
        });
    }


    $.reportsEditor = function(opts)
    {
        options = $.extend(true, $.reportsEditor.defaults, opts);

        var strings = options.strings;

        setupGeneralForm(options);
        setupTemplates(options);
        setupEditPage(options);
        setupEditCell(options);


        var $submitForm = $("#submit-form");
        $submitForm.submit(function(e) {
            e.preventDefault();
            var $$ = $submitForm;
            var $form = $("#general-form");
            var values = $form.serialize();
            values += "&_class=Reports_Form_ReportAdd_General&_param1=" + options.companyId;

            $.ajax({
                url : options.formValidateUrl,
                type : 'post',
                cache : false,
                dataType : 'json',
                data : values,
                success : function(d) {
                    var valid = true;

                    if (d.valid) {
                        $form.styleUniForm(); // remove errors
                    } else {
                        $form.styleUniForm({errors : (d.errors ? d.errors : {})});
                        valid = false;
                    }

                    var $emptyCells = $("#pages-list li table td.empty").addClass("error");

                    if ($emptyCells.length != 0) {
                        valid = false;
                    }

                    if (!valid) {
                        alert(strings['SomeReportErrorsLeft']);
                    }

                    var toSave = {};

                    var ps = [];
                    for (var pageuid in pages) {
                        ps.push(pages[pageuid].toObject());
                    }

                    var userIds = [];
                    $("input[name^=user_id]:checked").each(function() {
                        userIds.push(parseInt($(this).val(),10));
                    });

                    toSave['pages'] = ps;
                    var logo_align = 1;
                    if ( $("[name=logo_align]:checked").val() == "center") logo_align = 2;
                    if ( $("[name=logo_align]:checked").val() == "right") logo_align = 3;
                    var general = {
                        "company_id" : $("#company_id").val(),
                        "id" : $("#id").val(),
                        "name" : $("#name").val(),
                        "description" : $("#description").val(),
                        "userIds" : userIds,
                        "size" : $("#size").val(),
                        "header" : {
                            "enabled" : $("#header_enabled").attr("checked")==='checked',
                            "logo" : $("#logo_enabled").attr("checked")==='checked',
                            "logo_align" : logo_align,
                            "align" : $("input[name=header_align]:checked", $form).val(),
                            "text" : $("#header_text").val()
                        },
                        "footer" : {
                            "enabled" : $("#footer_enabled").attr("checked")==='checked',
                            "align" : $("input[name=footer_align]:checked", $form).val(),
                            "text" : $("#footer_text").val()
                        },
                        "coglogo_enabled" : $("#coglogo_enabled").attr("type")==="hidden" ? $("#coglogo_enabled").val() : $("#coglogo_enabled").attr("checked")==='checked'

                    }
                    toSave['general'] = general;
                    if(valid)
                        $.ajax({
                            "url" : $$.attr("action"),
                            "type" : "post",
                            dataType : "json",
                            "data" : {"data" : JSON.stringify(toSave)},
                            success : function(res) {
                                if (res && res.success) {
                                    window.location = options.browseReportsUrl;
                                } else {
                                    // TODO: error
                                }
                            },
                            error : function(e) {
                                // TODO: error
                            }
                        });



                }
            });

            return false;
        });


    }


    $.reportsEditorAddPage = function(jsonPage, $table)
    {
        var p = jsonPage;
        var page = new Page(false, jsonPage.templateId, $table);
        var uid = uniqid();
        $table.data("uid", uid);
        pages[uid] = page;

        page
            .id(p.id)
            .title(p.title)
            .enableTitle(p.enableTitle)
            .titleSize(p.titleSize)
            .titleAlign(p.titleAlign)
            ._landscape=p.landscape;


        if(page._landscape==1){
            $table.siblings().find("li.landscape").show();        
            rotateToLandscape($table.parent(),$table);
        }else{
            $table.siblings().find("li.portrait").show();
        }

        /*  type: (function(){
            enableTitle: (function(){
            title: (function(){
            countDataSetId: (function(){
            chartType: (function(){
            dateTimeInterval: (function(){
            fixedDateIntervalFrom : (function(){
            fixedDateIntervalTo : (function(){
            text: (function(){
        */
        $.each(p.cells, function(i, val) {
            var cell = page.cell(this.templateRowCellId);
            cell
                .id(this.id)
                .type(this.type)
                .enableTitle(this.enableTitle)
                .title(this.title);
            if (this.type == CHART) {
                cell.countDataSetId(this.countDataSetId);
                cell.dateTimeInterval(this.dateTimeInterval);
                cell.aggregator(this.aggregator);
                cell.timeFilter(this.timeFilter);
                cell.manualTimeInterval(this.manualTimeInterval);
                if (this.type == CHART) {
                    cell.chartType(this.chartType);
                }

            } else if (this.type == TEXT) {
                cell.text(this.text);
            } else if(this.type == TABLE) {
                cell.tableId(this.tableId);
            } else if(this.type == WARNINGS) {

            } else if(this.type == DATASOURCE) {
                cell.dataSourceId(this.dataSourceId);
                cell.includeTable(this.includeTable);
                cell.hasWeather(this.hasWeather);
                cell.weatherLocation(this.weatherLocation);
                cell.weatherTimePeriod(this.weatherTimePeriod);
                cell.weatherEnabled(this.weatherEnabled);
            }
        });
        return page;
    }

    $.reportsEditor.defaults = {
        browseReportsUrl : '/webreport/reports/index/browse',
        previewPageUrl : '/webreport/reports/index/preview-page',
        formValidateUrl : '/webreport/admin/validate/form',
        addCountDataSetUrl : '/webreport/admin/count-data-sets/add/layout/clean',
        timeIntervalsUrl : '/webreport/admin/count-data-sets/get-time-resolutions-for-set',
        companyId : 0,
        strings : {
            "CreatePreviewError" : "Couldn't create preview. Temp folder not writable. Contact system administrator.",
            "Edit" : 'Edit',
            "Delete" : 'Delete',
            "Portrait" : 'Rotate to landscape',
            "Landscape" : 'Rotate to portrait',
            "Preview" : 'Preview',
            "FieldIsRequired" : 'Field is required',
            "FillMissingData" : 'Some data are missing (marked in red).',
            "SessionHasExpired" : "Your session has expired. You'll be redirected to the login page.",
            "UnknownErrorOccured" : 'An unknown error occured.',
            "NoPagesAdded" : 'No pages are added. A report must contain at least one page.',
            "AddNewCountDataSet" : "Add new count data set.",
            "SomeReportErrorsLeft" : "There are still some missing items not being filled yet. They are marked in red."
        }
    }



})(jQuery);
