        (function($) {

            $.fn.cogwindow  = function (options) {
                var settings = {
                    "title": "undefined",
                    "icon": undefined, // class of icon to use
                    "minimize": true,
                    "close":true,
                    "slide":"fast",
                    "editTitle": false,
                    "color":"#ffffff",
                    "clickToOpen":true,
                    "upDown": true
                };

                $.extend(settings,options);
                var containers =$([]);
                this.each(function () {
                    var $this = $(this),
                    $container = $("<div />").addClass("cogwindow-container"),
                            $head = $("<h4 />").addClass("ui-widget-header ui-corner-all ui-dialog-titlebar").append($("<span />").text(settings.title).addClass("title"));
                    if(settings.editTitle){
                        $("span.title", $head).addClass("titleEditor");
                    }
                    $("<span />").addClass("title-extra").css({"margin-left" : "10px"}).appendTo($head).hide();
                    if(settings.color != "undefined"){

                    }
                    if(settings.icon){
                        $head.prepend($("<input />").addClass(settings.icon).attr("type","text").addClass("color {pickerMode:'HVS'}").addClass("square ui-corner-all").css({"color":settings.color, "background-color":settings.color}));
                    }
                    if(settings.minimize) {
                        var $toggle = $("<span />").addClass("ctrl").addClass("minimize").text("Minimize").click( function (e) {
                            var $this = $(this);
                            e.preventDefault();
                            e.stopPropagation();
                            $this.toggleClass("minimized");
                            if($this.hasClass("minimized")) {
                                $("div.cogwindow-container", $this.parent().parent()).slideUp(settings.slide);
                                $this.text('Maximize');
                                $container.trigger('minimized');
                            }
                            else {
                                $("div.cogwindow-container", $this.parent().parent()).slideDown(settings.slide);

                                $this.text('Minimize');
                                $container.trigger('maximized');
                            }
                        });
                    if(settings.clickToOpen){
                        $head.click(function(event){
                            var $span = $("span.minimized",$this);
                            if($span.length == 1) { $span.trigger('click'); }
                        });
                    }
                        $head.append($toggle);
                        $container.bind('toggle', function (e) { $toggle.trigger('click'); });
                    }
                    if(settings.close) {
                        var $close = $("<span />").addClass('ctrl').addClass("close").text("Close").click( function (e) {
                            e.preventDefault();
                            e.stopPropagation();
                            // unbind everything
                            var $delete_this = $(this).parent().parent();

                            $delete_this.animate({opacity: 0.01}, function(){
                                $(this).slideUp(350, function() {
                                    $container.trigger('closed'); 
                                    $delete_this.parent().remove();
                                });
                            });


                        }).hover(
                        function() {
                            $container.trigger('markWarning');
                        },
                        function() {
                            $container.trigger('unmark'); 
                        });

                        $head.append($close);
                        $container.bind('close', function(e) { $close.trigger('click'); });
                    }

                    if(settings.upDown) {
                        var $up = $("<span />").addClass('ctrl').addClass("moveUp").text("Up").click( function (e) {
                            var $obj = $container.parents("div.cogwindow").parent();

                            if(!$obj.queue().length) {
                                e.preventDefault();
                                e.stopPropagation();
                                $container.trigger('moveUp');
                            }
                        });
                        var $down = $("<span />").addClass('ctrl').addClass("moveDown").text("Down").click( function (e) {
                            var $obj = $container.parents("div.cogwindow").parent();
                            
                            if(!$obj.queue().length) {
                                e.preventDefault();
                                e.stopPropagation();
                                $container.trigger('moveDown');
                            }
                        });

                        $head.append($up);
                        $head.append($down);
                    }

                    $.extend(containers,$container);
                    $("<div />").addClass("cogwindow ui-widget ui-widget-content ui-corner-all").append($head).append($container).prependTo($this);
                });

                return this.pushStack(containers, "cogwindow", "");
            }
        })(jQuery);

