jQuery.fn.uniform = function(settings) {
  settings = jQuery.extend({
    valid_class    : 'valid',
    invalid_class  : 'invalid',
    focused_class  : 'focused',
    holder_class   : 'ctrlHolder',
	selected_class : 'selected',
    field_selector : 'input, select, textarea'
  }, settings);

  return this.each(function() {
    var form = jQuery(this);
    form.find("p.formHint").each(function() {
            $formHint = $(this);
            hint = $formHint.text();
            $formHint.html("")
            var fadeInSingle;
            $icon = $(this).append(
                $("<i class='formHintIcon fa fa-question-circle'></i>").click(function() {
                    if($(this).hasClass("active")) {
                        $(this).next().fadeOut(200);
                        $(this).removeClass("active").removeClass("stick-active");
                    } else {
                        $(this).next().fadeIn(200);
                        $(this).addClass("active").addClass("stick-active");
                    }
                }).mouseenter(function() {
                    $icon = $(this)
                    fadeInSingle = setTimeout(function() {
                        if (!$icon.hasClass("active")) {
                            $icon.next().fadeIn(100);
                        }
                    },600)
                }).mouseleave(function() {
                    clearTimeout(fadeInSingle);
                    setTimeout(function() {
                        if (!$icon.hasClass("stick-active")) {
                            $icon.next().fadeOut(100);
                        }
                    },400)
                })
            ).append(
                $("<span/>").text(hint).hide()
            );
        });

    $formHintIcons = form.find(".formHintIcon");
    if($formHintIcons.length > 0) {
        var fadeInAll;
        form.prepend($("<div class='formTop'/>").append(
            $("<i class='bigIcon formHintIcon fa-2x fa fa-question-circle'></i>")
                .css({"margin-left":"90%"})
                .click(function() {
                    if($(this).hasClass("active")) {
                        $formHintIcons.not(".bigIcon").each(function() {
                            if ($(this).hasClass("active")) {
                                $(this).removeClass("active").removeClass("stick-active");
                                $(this).next().fadeOut(100);
                            }
                        })
                        $(this).removeClass("active");
                    } else {
                        $formHintIcons.not(".bigIcon").each(function() {
                            if (!$(this).hasClass("active")) {
                                $(this).next().fadeIn(100);
                            }
                            $(this).addClass("active").addClass("stick-active");
                        })
                        $(this).addClass("active");
                    }
                })
                .mouseenter(function() {
                    fadeInAll = setTimeout(function() {
                        $formHintIcons.not(".bigIcon").each(function() {
                            if (!$(this).hasClass("active")) {
                                $(this).next().fadeIn(100);
                                $(this).addClass("active");
                            }
                        })
                    },600)
                }).mouseleave(function() {
                    clearTimeout(fadeInAll);
                    setTimeout(function() {
                        $formHintIcons.not(".bigIcon").each(function() {
                            if ($(this).hasClass("active") && !$(this).hasClass("stick-active")) {
                                $(this).next().fadeOut(100);
                                $(this).removeClass("active");
                            }
                        })
                    },400)
                })
        ));
    }


	form.find("input[type=radio]").each(function() {
		var $this = jQuery(this);
		if ($this.parent().parent().hasClass('multiField')) {
			$this.change(function() {
				$this.parent().parent().find('.' + settings.selected_class).removeClass(settings.selected_class);
				$this.parent().addClass(settings.selected_class);

			});
		}
	});
	form.find("input[type=radio]:checked").trigger('change');

    // Focus specific control holder
    var focusControlHolder = function(element) {
      var parent = element.parent();

      while(typeof(parent) == 'object') {
        if(parent && $(parent).hasClass(settings.holder_class)) { //(parent.className.indexOf(settings.holder_class) >= 0)) {
            parent.addClass(settings.focused_class);
            return;
        } else if ($(parent).hasClass("uniForm")) {
			return;
		}// if

        parent = jQuery(parent.parent());
      } // while
    };

    // Select form fields and attach them higlighter functionality
    initiateFocusBehaviour = function(form) {
        form.find(settings.field_selector).focus(function() {
            form.find('.' + settings.focused_class).removeClass(settings.focused_class);
    	    var $this = jQuery(this);
            focusControlHolder($this);
        	  /*if (this.nodeName.toLowerCase() == "input" && $this.attr("type") == 'radio') {
        		  var $pp = $this.parent().parent();
        		  if ($pp.hasClass('multiField')) {
        			  $pp.find('.' + settings.selected_class).removeClass(settings.selected_class);
        			  $this.parent().addClass(settings.selected_class);
        		  }
        	  };*/
        }).blur(function() {
          form.find('.' + settings.focused_class).removeClass(settings.focused_class);
        });
    }
    initiateFocusBehaviour(form);
  });
};

$(function() {
	/*$("#sidebar dl:last-child").css("margin-bottom", "0");

	$("#content").css('min-height', $("#sidebar").height());
*/
	/*var languageChooserIsOpen = false,
		warningsIsOpen = false;
	$("#language-chooser a:eq(0)").click(function(e) {
		e.preventDefault();
		languageChooserIsOpen = true;
		$(this).parent().addClass("active");
		return false;
	});*/

	/*var $silhouette = $("<span />", { "id" : "silhouette" });

	$("#profilebox span.name-inner").prepend($silhouette);*/

    $(".table-display").children("dt").each(function(){
        $line = $(this).add($(this).next());
        $wrapper = $("<div/>").addClass("table-display-line");
        $line.wrapAll($wrapper);

    });

    $(".view-external.export").click(function(){
        location.reload(); //Reload page (exports has a counter on access no. that should be updated).
    });

	/* Konami code */
	/*var kkeys = [], konami = [38,38,40,40,37,39,37,39,66,65], konamiString = konami.toString();
	$(document).keydown(function(e) {
		var k = e.keyCode;
		kkeys.push( k);
		if ( kkeys.toString().indexOf( konamiString ) >= 0 ) {
			kkeys = [];
			$("<div />", { id : "bacon" }).hide().appendTo("body").fadeIn();
		} else if (kkeys.length > 95 && ((k > 40 && k < 37) || k != 66 || k != 65)) {
			kkeys = [];
		}
	});*/

	/*$(document.body).click(function(e) {
		if (languageChooserIsOpen || warningsIsOpen) {
			$("#language-chooser, #warnings").removeClass("active");
			languageChooserIsOpen = false;
			warningsIsOpen = false;
		}
	});*/

	hideFlashMessages = function () {
        $("#content div.flashmessage").each(function(i) {
		$(this).animate({
    			opacity: 1.0 // trick for delaying the slide up
    		}, 5000).slideUp(700);
	   });
        }
	hideFlashMessages();

	/*$("#sidebar a.tooltip[href][title]").qtip({
		content : {
			text: false
		},
		position: {
			corner: {
				target: 'bottomMiddle',
				tooltip: 'topLeft'
			}
		},
		show: {
			delay : 2000
		},
		style : {
			name: 'dark',
			tip : true,
			width: 175,
			textAlign : 'center',
			border: {
				width: 2
				//radius: 3
			}
		}
	});*/

	 jQuery('form.uniForm').uniform();

	var $actions = $("table tbody td ul.actions").each(function() {
		$(this).parent().width($("li", this).length * $("li:eq(0)", this).width() + 24);
	});


	/*$actions.find("li.view a").each(function(i) {
		var $$ = $(this);
		var url = $$.attr("href");
		$("td:gt(0)", $$.closest("tr")).click(function(e) {
			window.location = url;
		});
	});*/
	
	/*$("#warnings > a").click(function(e) {
		e.preventDefault();
		warningsIsOpen = true;
		$(this).parent().addClass("active");
		return false;
	});*/
	var $warningCount = $("#warning-count");
	$("#top-right-warnings-dropdown a.acknowledge").bind("click", function(e) {
		e.preventDefault();
		var $$ = $(this);
		var $li = $$.closest("li[id^=warning]");
        var $separator = $li.next();
		var id = $li.attr("id");
		var s = id.split("-");
		id = s[s.length-1];
		
		$.ajax({
			url : $$.attr("href"),
			"type" : "post",
			dataType : "json",
			data : { id : id },
			success : function(res) {
				if (res.success) {
                    $li.slideUp(500, function() { $(this).remove() });
                    $separator.remove();
					var count = parseInt($warningCount.text());
					if (count == 1) {

						$("#warnings").fadeOut(500, function() { $(this).remove() });	
                        $("#top-right-warnings-dropdown").fadeOut(500);
					} else {
						$warningCount.text(count-1);	
					}
				} else {
					// TODO: fix translation
					alert('An unknown error occured.');
				}
			}, 
			error : function() {
				// TODO: fix translation
				alert('An unknown error occured.');	
			}
		});
 
		return false;
	});
	
	$("#warnings-acknowledge-all").bind("click", function(e) {
		e.preventDefault();
		var $$ = $(this);
		$.ajax({
			url : $$.attr("href"),
			"type" : "post",
			dataType : "json",
			data : { id : "all" },
			success : function(res) {
				$("#top-right-warnings-dropdown").hide();
                $("#warnings").fadeOut(500, function() { $(this).remove() });
			}, 
			error : function() {
				// TODO: fix translation
				alert('An unknown error occured.');	
			}
		});
		return false;
	});

/*  THIS CODE SHOULD COLLAPSE AND SHOW LEFT MENU BUT DOESN'T WORK WITH THE COOKIES OF SOME UNKNOW REASON */
    var $sidebar = $("#sidebar"),
        collapsed = "collapsed",
        cookie_options = {path: "/", expires: 365};

    var $moduleDts = $sidebar.find("dl dt").each(function() {
        var $$ = $(this),
            $dl = $$.parent(),
            key = $dl.attr("id"),
            val = $.cookie(key);
        if (val === null) {
            $.cookie(key, "no", cookie_options);
        } else if (val == collapsed) {
            $dl.addClass(collapsed);
            $$.nextAll("dd").hide();
        }

        $$.append($("<span />").addClass("toggler").hide());
    });
    $("dl dt span.toggler", $sidebar).click(function(e) {
        var $$ = $(this).parent(),
            $dl = $$.parent(),
            key = $dl.attr("id"),
            v = $.cookie(key);
        e.preventDefault();
        if (v == collapsed) { v = "no"; }
        else { v = collapsed; }
        $.cookie(key,v,cookie_options);
        $dl.toggleClass(collapsed);
        $$.nextAll("dd").slideToggle('fast');
    });

    /*$sidebar.mouseenter(function() {
        $sidebar.find("dl dt span.toggler").fadeIn();
    }).mouseleave(function() {
        $sidebar.find("dl dt span.toggler").fadeOut();
    });*/

    /*var show = $.cookie("show") == "false" ? false: true; //other way around because when not cookie exist

    if(!show) {
        $("#sidebar").css({ left: "-174px", position: "absolute" });
        $("#contentwrapper").css({"marginLeft": "16px"});
        $("body").css({"background-position": "-174px"});
    }
    if(!$.browser.msie || parseInt($.browser.version,10) > 9)
    $sidebar.prepend(
        $("<dl />").attr("id", "mod-pin").append($("<dt/>").append(
              $("<span/>").addClass((show ? 'pinned' : 'pin')).click(function (e) {
                    show = !show;
                    if(show) {
                        $("#sidebar").animate({ left: "0px", position: "absolute" }, 1000);
                        $("#contentwrapper").animate({"marginLeft": "190px"}, 1000);
                        $("body").animate({"background-position": "0px"}, 1000);
                        $(this).addClass('pinned').removeClass('pin');
                    } else {
                        $("#sidebar").animate({ left: "-174px", position: "absolute" }, 1000);
                        $("#contentwrapper").animate({"marginLeft": "16px"}, 1000);
                        $("body").animate({"background-position": "-174px"}, 1000);
                        $(this).removeClass('pinned').addClass('pin');
		    }
                    $.cookie("show",show,cookie_options);
              })
            )
        )
    );*/

    var ellipsisLoader = setInterval(function() {
        var $span = $("span.loading-ellipsis");

        if(!$span.length) {
            clearInterval(ellipsisLoader);
        } else {
            var lth = $span.html().length;
            var ellipsis = Array(((lth+1)%4)+1).join(".");

            $span.html(ellipsis);
        }
    }, 450);
});
