<?php

error_reporting(E_ALL | E_STRICT);

// Define path to application directory
if (!defined('APPLICATION_PATH')) {
  if (getenv('INSTANCE_PATH')) {
    define('APPLICATION_PATH', getenv('INSTANCE_PATH') . '/application');
  } else {
    define('APPLICATION_PATH', realpath(dirname(__FILE__) . '/../../application'));
  }
}

// Define application environment
defined('APPLICATION_ENVIRONMENT')
    || define('APPLICATION_ENVIRONMENT',
              (getenv('APPLICATION_ENVIRONMENT') ? getenv('APPLICATION_ENVIRONMENT')
                                         : 'production'));

defined('MODULES_PATH') or define('MODULES_PATH', APPLICATION_PATH . '/modules');
defined('APPLICATION_REALM') or define('APPLICATION_REALM', 'TrueView Web Report'); // do not change
defined('STATIC_SALT') or define('STATIC_SALT', 'qvUReYOddaOWw7qkb6QfHAd3kgUAo6'); // to use when salting user password, DON'T CHANGE

//define('SHOW_IDS', true);

set_include_path(implode(PATH_SEPARATOR, array(
	MODULES_PATH,
    dirname(dirname(__FILE__)) . '/../library/php',
    get_include_path(),
)));

/** Zend_Application */
require_once 'Zend/Loader.php';
require_once 'Zend/Exception.php';
require_once 'Zend/Loader/Autoloader.php';
require_once 'Zend/Config/Exception.php';
require_once 'Zend/Application.php';
require_once 'Zend/Config.php';
require_once 'Zend/Config/Ini.php';
require_once 'Zend/Registry.php';
require_once 'Zend/Application/Bootstrap/ResourceBootstrapper.php';
require_once 'Zend/Application/Bootstrap/Bootstrapper.php';
require_once 'Zend/Application/Bootstrap/BootstrapAbstract.php';
require_once 'Zend/Application/Bootstrap/Bootstrap.php';

require_once APPLICATION_PATH . '/InstallationBootstrap.php';

$config = new Zend_Config_Ini(APPLICATION_PATH . '/config.ini', APPLICATION_ENVIRONMENT,
                              array('allowModifications' => true));
$config_license = new Zend_Config_Ini(APPLICATION_PATH . '/license.ini', APPLICATION_ENVIRONMENT,
                              array('allowModifications' => true));

date_default_timezone_set($config->general->defaultTimezone);
ini_set('memory_limit', $config->php->memory_limit);
		
Zend_Registry::set('config', $config);
Zend_Registry::set('config-license', $config_license);



// Create application, bootstrap, and run
$application = new Zend_Application(
    APPLICATION_ENVIRONMENT,
    $config
);


try {
	$bootstrap = $application->getBootstrap();
	$bootstrap->bootstrap();
    $application->run();
} catch (Exception $exception) {
	echo "<pre>";
	echo $exception->getMessage();
	echo "\n\n";
	echo $exception->getTraceAsString();
	echo "</pre>";

}
